## 2024-02-07, Version 0.37.0
* **feature** :
    * addons:
      - support napi_make_callback.(xicilion)
      - support napi_module_register addons module.(xicilion)
      - support Buffer Finalizer.(xicilion)
      - support buffer api.(xicilion)
    * build - build shared library.(xicilion)
    * child_process:
      - support spawnSync.(xicilion)
      - support inherit mode in execFile.(xicilion)
    * console - support complex parameters in console.trace.(xicilion)
    * core:
      - suooprt DisallowGarbageCollection.(xicilion)
      - support execute scripts in package.json.(xicilion)
    * crypto:
      - support Bls12381Shake256 bbs suite.(xicilion)
      - support shake.(xicilion)
      - support sha3.(xicilion)
      - support bbs signacture.(xicilion)
      - support computeSecret in BlsKey.(xicilion)
      - support undefined in randomBytes.(xicilion)
    * dgram - support multicast function.(xicilion)
    * Digest - support update string.(xicilion)
    * encoding - support encode/decode with codec.(xicilion)
    * fasttext:
      - support more api.(xicilion)
      - ad fasttext module.(xicilion)
    * fs - support recursive option in fs.readdir.(xicilion)
    * http - add maxHeaderLength in http/HttpClient/HttpRequest/HttpResponse/HttpServer/HttpsServer/HttpHandler.(xicilion)
    * icu - support Intl.Segmenter.(xicilion)
    * LevelDB - add firstKey and lastKey methods, enhancements to forEach.(xicilion)
    * module - support require(.node).(xicilion)
    * options - support install addons binary module.(xicilion)
    * process:
      - : support process.dlopen.(xicilion)
      - support emitWarning.(xicilion)
    * SandBox:
      - support async import.(xicilion)
      - simple support for loading ES modules.(xicilion)
    * SQLite - update sqlite.(xicilion)
    * test:
      - support muslCall/mustNotCall.(xicilion)
      - enable g_track_native_object in test.setup to support using process.memoryUsage to count the use of built-in objects.(xicilion)
    * tty - support cursorTo and moveCursor.(xicilion)
    * url - support fileURLToPath and pathToFileURL.(xicilion)
    * util:
      - support symbol key in util.format.(xicilion)
      - support maxStringLength in inspect. (#766)(PinelliaC)
      - support max_array_length in inspect. (#765)(PinelliaC)
    * v8 - update v8 to v11.5.151.(xicilion)
    * vector - support vec_distance function.(xicilion)
    * vm - support vm.Script and context.(xicilion)
    * worker_threads:
      - support workerData in worker_threads.(xicilion)
      - support parentPort in worker_threads.(xicilion)

* **bugfix** :
    * addons:
      - fibjs api crashed in addons callback.(xicilion)
      - callback error on linux.(xicilion)
      - compile error on Windfows.(xicilion)
    * buffer - Buffer.from(Date) result error.(xicilion)
    * build:
      - fix conversion issue in app.cpp on Windows.(xicilion)
      - fix UTF-8 to UTF-16 conversion on Windows.(xicilion)
      - compile error on linux.(xicilion)
      - update glibc_config.h include in encoding_iconv.cpp and encoding_iconv_ucs.cpp.(xicilion)
      - build script mistake.(xicilion)
      - build unicode error,(xicilion)
      - update vender to fix compile error.(xicilion)
    * child_process - encoding/env/output error.(xicilion)
    * core:
      - Exception object crash.(xicilion)
      - RunMicrotasks will deadlock due to reentry.(xicilion)
      - the ineffective iteration over m_keys (#762)(PinelliaC)
      - update the associative relationship between m_keys and m_values (#761)(PinelliaC)
      - crash when loading so in python.(xicilion)
      - unordered_map compile error on android.(xicilion)
      - runtime error in debug mode.(xicilion)
      - incorrect handling of kJSSpecialApiObjectType objects in get_instance_pointer causes fibjs crash.(xicilion)
      - compile error on WIndows.(xicilion)
    * crypto:
      - crash in PKey.toJSON().(xicilion)
      - crash when new PKey with empty string.(xicilion)
      - digest returns the wrong result when update is called multiple times in shake256.(xicilion)
      - remove dependency on std::span to fix compilation errors in low versions of gcc.(xicilion)
    * db - the db connection in odbc was not closed properly before being released.(xicilion)
    * docs:
      - URL typo (#764)(PinelliaC)
      - update docs (#760)(PinelliaC)
    * fasttext - predict has an error in recognizing a single word.(xicilion)
    * fs - 64 bits seek error on Linux i386&arm.(xicilion)
    * iconv - decode error when iconv does not exist.(xicilion)
    * jemalloc - runtime error on kunpeng arch.(xicilion)
    * mysql - conn.execute throws a "broken pipe" error when the sql statement size is greater than 16M.(xicilion)
    * net - pipe is incorrectly allowing multiple binds on Linux.(xicilion)
    * options:
      - fix prefix filename error in untar.(xicilion)
      - alias name package install error.(xicilion)
      - fix addon file path issue.(xicilion)
      - fix binary file installation path issue.(xicilion)
    * process:
      - not set return value when env key not exists.(xicilion)
      - crash in process.memoryUsage.(xicilion)
      - missing files.(xicilion)
    * SandBox - cannot find promises module by require("node:fs/promises") on Windows.(xicilion)
    * test - child_process test error on linux.(xicilion)
    * timers - timers.call may fail after multiple sleeps.(xicilion)
    * util - crash in util.promisify.(xicilion)

* **refactor** :
    * addons:
      - add more api support.(xicilion)
      - Implement node_napi_env__ to support Finalizer for fixing object leaks within addons.(xicilion)
      - Update include directory for addons.(xicilion)
      - fix addon test on ubuntu 10.04.(xicilion)
      - remove unused code.(xicilion)
      - not check executable flag of .node.(xicilion)
      - enable addons to be loaded by fibjs.exe and node.exe.(xicilion)
      - throw dlerror in posix.(xicilion)
      - add init order test.(xicilion)
      - refactor promises test.(xicilion)
      - refactor code.(xicilion)
    * Buffer:
      - fix data type check in Buffer.concat.(xicilion)
      - use encoding.encode to build Bufer from string.(xicilion)
      - improving the performance of Buffer.from(string).(xicilion)
      - fix error in util.table.(xicilion)
      - adding missing scripts.(xicilion)
      - rewrite Buffer.write to improve performance.(xicilion)
      - optimising Buffer performance with primordials.(xicilion)
      - remove unused deleter.(xicilion)
      - refactor Buffer's data processing methods in native code.(xicilion)
      - inject the buffer module in the sandbox of the shared global.(xicilion)
      - define the Buffer type in a separate global sandbox.(xicilion)
      - implement the JavaScript version of Buffer.(xicilion)
      - not save ArrayBuffer into Global.(xicilion)
      - refactoring Buffer's built-in object binding model to optimize the performance of Buffer member method calls.(xicilion)
      - use InstanceOf to detect Buffer type.(xicilion)
      - only unwrap Buffer when ArrayBuffer is fully mapped.(xicilion)
      - compile error on Windows.(xicilion)
      - implement new Buffer(size) and Buffer.length to be compatible with the previous api.(xicilion)
      - refactor Buffer to inherit from Uint8Array.(xicilion)
    * build:
      - refactor build docker.(xicilion)
      - include CI environment variable in test docker.(xicilion)
      - fix openssl compile error on windows ia32.(xicilion)
      - enable ci test for macOS-14 arm64 in build.yml.(xicilion)
      - fix compile error on linux ia32.(xicilion)
      - update macOS versions in build.yml.(xicilion)
      - clear new_args before process arguments.(xicilion)
      - handle user permissions in Docker container.(xicilion)
      - add support for loong64ow architecture.(xicilion)
      - correct website link.(xicilion)
      - add USE_VENDER_DIST flag to build.cmd.(xicilion)
      - remove unnecessary environment variable in build.yml.(xicilion)
      - update build.sh script to include safe.directory in docker run command.(xicilion)
      - Remove gd module and related code.(xicilion)
      - Add -rdynamic flag for non-Windows systems(xicilion)
      - update cmake minimum required.(xicilion)
      - update CMakeLists.txt to read HEAD reference.(xicilion)
      - update build scripts and submodule initialization.(xicilion)
      - update vender tag retrieval in CMakeLists.txt.(xicilion)
      - refactor build.cmd and CMakeLists.txt(xicilion)
      - add dev argument in tasks.json.(xicilion)
      - add dev argument.(xicilion)
      - rename config.h to glibc_config.h.(xicilion)
      - delete logo folder.(xicilion)
      - delete perf folder.(xicilion)
      - delete unused variable.(xicilion)
      - fix compile warning in debug mode.(xicilion)
      - use the pre-compiled vender on github for compiling when the USE_VENDER_DIST environment variable is set.(xicilion)
      - remove unused path.(xicilion)
      - fetch current tag in vender.(xicilion)
      - refactor BUILD_OPTION.(xicilion)
      - merge flags with CMAKE_C_FLAGS.(xicilion)
      - not link stdc++ on Darwin.(xicilion)
      - set LINK_FLAGS in setup_result_library.(xicilion)
      - detect BUILD_OS and BUILD_ARCH in cmake script.(xicilion)
      - refactor build script.(xicilion)
      - refactor release workflow.(xicilion)
      - fix ci build script error.(xicilion)
      - script path error.(xicilion)
      - refactor build dockerfiles.(xicilion)
      - refactor ci workflow.(xicilion)
      - rename x86 to ia32.(xicilion)
      - not setup env in sub script.(xicilion)
      - refactor build script.(xicilion)
      - change amd64/i386 to x64/x86.(xicilion)
      - refactor shell build script.(xicilion)
      - link options error on alpine.(xicilion)
      - remove git from depend list.(xicilion)
      - update docker image to clang-12.(xicilion)
      - support amd64 on iphone.(xicilion)
      - fix compile error on windows.(xicilion)
      - add android ci item.(xicilion)
      - add android ci for arm and i386.(xicilion)
      - remove libmongo from cmake.(xicilion)
    * child_process:
      - fix test error on Windows.(xicilion)
      - process error in spawnSync.(xicilion)
    * ci - remove deprecating commands (#758)(PinelliaC)
    * core:
      - update heap limit in options.cpp.(xicilion)
      - set @toStringTag property with DontEnum attribute.(xicilion)
      - update vendor and fix character types in multiple files.(xicilion)
      - refactor node api include files.(xicilion)
      - refactor addon api source code.(xicilion)
      - convert date to ISOString in argument.(xicilion)
      - remove support for top-level async in common modules.(xicilion)
      - add musl flag in process.versions.(xicilion)
      - fill error code in callback.(xicilion)
      - reenable fasttext.(xicilion)
      - remove unused variable.(xicilion)
      - pass the global module via context.SetEmbedderData.(xicilion)
      - remove Master, argv from global.(xicilion)
      - allow passing null to ignore parameters.(xicilion)
      - patch glibc function.(xicilion)
      - optimise reference counting caused by unnecessary obj_ptr.(xicilion)
      - enable isolate scope.(xicilion)
      - replace #include "map".(xicilion)
      - change std::map to std::unordered_map.(xicilion)
      - remove unused variable.(xicilion)
      - deprecate VariantEx.(xicilion)
      - identify if it is a built-in object by checking InternalFieldCount.(xicilion)
      - use ::operator new/delete instead of new uint8_t[].(xicilion)
      - remove unused code.(xicilion)
      - define kObjectPrototype to refer to the prototype of a common object.(xicilion)
      - disable instance counter by default and allowed to be turned on by option.(xicilion)
      - assign the value to p directly in the constructor of obj_ptr to avoid unnecessary initialization that introduces extra load.(xicilion)
      - direct access to the data in the Buffer to avoid the cost of copying data.(xicilion)
      - refactor class cache init.(xicilion)
      - reduce calls to Isolate::current.(xicilion)
      - rename v8 instance api.(xicilion)
      - merge allocations of data blocks and BackingStore objects.(xicilion)
      - check pointer in getInstance.(xicilion)
      - refactoring getInstance to improve the speed of calling member methods of built-in objects.(xicilion)
      - not lock the object before calling the synchronization method.(xicilion)
      - discontinuation of support for native code to boost running performance.(xicilion)
      - break the script in ~SnapshotJsScope().(xicilion)
      - remove EscapableHandleScope in native function.(xicilion)
      - expanded memory usage limits.(xicilion)
      - use External to keep netive object pointer.(xicilion)
    * crypto:
      - rename BLS12381_G1/BLS12381_G2 to Bls12381G1/Bls12381G2.(xicilion)
      - move fips202 to vender.(xicilion)
      - update bbs signature to draft-irtf-cfrg-bbs-signatures-03.(xicilion)
      - refactor the api for bbs signature.(xicilion)
      - fix compile error on low version gcc.(xicilion)
      - remove unused code.(xicilion)
      - remove ecsdsa.(xicilion)
      - deprecation "sign to" function in ecc.(xicilion)
    * db:
      - document LevelDB.forEach.(xicilion)
      - enable sqlite test.(xicilion)
      - update sqlite to v3.45.1.(xicilion)
      - refactor LevelDB for improved performance.(xicilion)
      - support binary vector in vec_index.(xicilion)
      - remove the mongo module.(xicilion)
      - performance tuning for SQLite.(xicilion)
    * dgram - add test for multicast.(xicilion)
    * docs:
      - fix document format.(xicilion)
      - add star history.(响马)
      - translate comments in source code into english.(xicilion)
      - add document for bbs signature.(xicilion)
      - make it clear that SandBox is an isolation sandbox and not a security sandbox.(xicilion)
      - update missing ts files.(xicilion)
    * encoding:
      - use icu built-in encoding for iconv if icu built-in encoding.(xicilion)
      - disable iconv encode/decode in safe_isolate.(xicilion)
    * exlib:
      - refactor string.(xicilion)
      - fix the TLS issue on iPhone, implement local storage using pthread_key.(xicilion)
    * fasttext:
      - remove fasttext module.(xicilion)
      - change source code folder.(xicilion)
    * fs:
      - update writeFile function, support encoding for Buffer.(xicilion)
      - add writeFile() method options.(xicilion)
      - using unordered_map to speed up zip file lookups.(xicilion)
      - support FileHandle promisify in fs.promises.open.(xicilion)
    * global - Fix capitalization of GC function.(xicilion)
    * http:
      - rename maxHeaderLength to maxHeaderSize.(xicilion)
      - HttpHandler ends processing when HttpRequest detects a network shutdown.(xicilion)
      - when setting a custom Content-Type header, json/pack/body does not set the Content-Type.(xicilion)
      - add status to HttpResponse as an alias for statusCode.(xicilion)
      - cache STATUS_CODES in Isolate.(xicilion)
      - fix compile warning in debug mode.(xicilion)
    * Isolate - refactor isolate to minimize access to thread-local storage.(xicilion)
    * isolate:
      - add safe_current() method to Isolate class.(xicilion)
      - support Isolate::main() to get first isolate.(xicilion)
    * module - support exports in package.json.(xicilion)
    * net:
      - detects port arguments passed as strings in new TcpServer to avoid incorrect handling.(xicilion)
      - support timeout in Socket.connect.(xicilion)
    * option:
      - regenerate the opt_tools.cpp file.(xicilion)
      - refactor file download logic in install.js(xicilion)
      - fix dependency module tree.(xicilion)
    * options:
      - refactor install.js to save memory usage.(xicilion)
      - refactor module installation code.(xicilion)
      - update string helper function to handle paths correctly.(xicilion)
      - fix installation errors for symbolic link files in tar.gz.(xicilion)
      - fix addon filename on alpine.(xicilion)
    * os:
      - remove printer-related functions from os module.(xicilion)
      - use uv_os_uname to get os.arch.(xicilion)
    * PKey - fix compile warning in debug mode.(xicilion)
    * process:
      - add version of node and modules into process.versions.(xicilion)
      - support property attribute in process.env.(xicilion)
      - use handler to get env variable.(xicilion)
      - force exit in process.exit.(xicilion)
    * Routing - clear HttpRequest.params before process url.(xicilion)
    * sandbox - convert the result of readFile to Buffer directly to avoid introducing multiple type conversions.(xicilion)
    * SandBox:
      - remove unused header file.(xicilion)
      - not check stat for script file.(xicilion)
      - only lock require from same SandBox.(xicilion)
      - check file stat before load file.(xicilion)
      - compile warning on WIndows.(xicilion)
      - set resource_line_offset to -1 to enable v8 to report the correct line number.(xicilion)
      - support require('fs/promises').(xicilion)
      - deprecate the argv argument to SandBox.run.(xicilion)
      - modify the parameter order of the module wrapper to be compatible with node.js.(xicilion)
      - support builtin module's alias with prefix `node:`.(xicilion)
    * Sandbox - refactor SandBox lock handling to improve module loading flexibility.(xicilion)
    * test:
      - refactor test for child_process and gui.(xicilion)
      - fix file system and timer tests.(xicilion)
      - reduce memory usage in tests to avoid memory overflow in Windows ia32.(xicilion)
      - remove unused test file.(xicilion)
      - add missing document about return of test.mustCall/mustNotCall.(xicilion)
      - use localhost to test dns.resolve.(xicilion)
      - timeout in LruCache may error in ci.(xicilion)
      - test mey error on ci.(xicilion)
      - relaxing the time of testing avoids misjudgment during testing.(xicilion)
      - increase the timeout test time to avoid test misclassification.(xicilion)
      - run workerData test on load event.(xicilion)
      - reduce time judgment in testing to avoid misjudgment.(xicilion)
      - require garbage collection before enabling track_native_object.(xicilion)
    * tools - change split rule.(xicilion)
    * util:
      - add unicode version in util.info.(xicilion)
      - fix key collection mode in json_format function.(xicilion)
      - fix symbol formatting in util_format.(xicilion)
      - support util.types.(xicilion)
      - simplifying function calls with parameter defaults in inspect.(xicilion)
      - use u_getIntPropertyValue to refactor console.table.(xicilion)
    * uv - export uv functions in the symbol table to support being referenced in addons.(xicilion)
    * v8:
      - fix compile error in loong64 debug mode.(xicilion)
      - update to v11.8.173.(xicilion)
      - enable turbofan.(xicilion)
      - Disable V8_HAS_PKU_JIT_WRITE_PROTECT globally.(xicilion)
    * vender - update vender.(xicilion)
    * vm:
      - revert Sandbox.freeze.(xicilion)
      - remove Sandbox.freeze.(xicilion)
      - use proxy to isolate sandbox from host and share the global's data between them.(xicilion)
    * xml:
      - not close self-clsing tag in html.(xicilion)
      - refactors documentElement into an XmlElement node with tagName html.(xicilion)
      - implements XmlElement.outerHTML, mapping it to the function XmlElement.toString().(xicilion)

* **others** :
    * addons. feat - support async work.(xicilion)
    * core - refactor: move SetAlignedPointerInInternalField of Buffer into object_base::wrap.(xicilion)

* **refator** :
    * docs - Update PKey.idl function “sign” comment (#763)(yaoqiaofeng)

* **fix** :
    * core - eliminate the key within the remove function. (#759)(PinelliaC)

* **reactor** :
    * core - refactoring the object recognition model to improve the performance of calling Buffer object member methods.(xicilion)

### Commits
* [[`1168986a41`](https://github.com/fibjs/fibjs/commit/1168986a41)] - **util, refactor**: add unicode version in util.info.(xicilion)
* [[`0ffdab302b`](https://github.com/fibjs/fibjs/commit/0ffdab302b)] - **build, refactor**: refactor build docker.(xicilion)
* [[`8347822a28`](https://github.com/fibjs/fibjs/commit/8347822a28)] - Merge remote-tracking branch 'origin/dev' into dev(xicilion)
* [[`2114096f69`](https://github.com/fibjs/fibjs/commit/2114096f69)] - **test, refactor**: refactor test for child_process and gui.(xicilion)
* [[`53304c029a`](https://github.com/fibjs/fibjs/commit/53304c029a)] - **db, refactor**: document LevelDB.forEach.(xicilion)
* [[`a945fb830d`](https://github.com/fibjs/fibjs/commit/a945fb830d)] - **db, refactor**: enable sqlite test.(xicilion)
* [[`7abb5f97ee`](https://github.com/fibjs/fibjs/commit/7abb5f97ee)] - **db, refactor**: update sqlite to v3.45.1.(xicilion)
* [[`18a858a10e`](https://github.com/fibjs/fibjs/commit/18a858a10e)] - **core, refactor**: update heap limit in options.cpp.(xicilion)
* [[`44e6bba626`](https://github.com/fibjs/fibjs/commit/44e6bba626)] - **options, refactor**: refactor install.js to save memory usage.(xicilion)
* [[`7eb5e7babf`](https://github.com/fibjs/fibjs/commit/7eb5e7babf)] - **options, refactor**: refactor module installation code.(xicilion)
* [[`1741353c5f`](https://github.com/fibjs/fibjs/commit/1741353c5f)] - **build, refactor**: include CI environment variable in test docker.(xicilion)
* [[`6f492f781b`](https://github.com/fibjs/fibjs/commit/6f492f781b)] - **options, bugfix**: fix prefix filename error in untar.(xicilion)
* [[`48ea0141c9`](https://github.com/fibjs/fibjs/commit/48ea0141c9)] - **options, refactor**: update string helper function to handle paths correctly.(xicilion)
* [[`188b2a41f5`](https://github.com/fibjs/fibjs/commit/188b2a41f5)] - **options, bugfix**: alias name package install error.(xicilion)
* [[`1206531a5e`](https://github.com/fibjs/fibjs/commit/1206531a5e)] - **test, refactor**: fix file system and timer tests.(xicilion)
* [[`be79e1d334`](https://github.com/fibjs/fibjs/commit/be79e1d334)] - **build, refactor**: fix openssl compile error on windows ia32.(xicilion)
* [[`528b9d5dd5`](https://github.com/fibjs/fibjs/commit/528b9d5dd5)] - **build, refactor**: enable ci test for macOS-14 arm64 in build.yml.(xicilion)
* [[`7dd518fb69`](https://github.com/fibjs/fibjs/commit/7dd518fb69)] - **build, refactor**: fix compile error on linux ia32.(xicilion)
* [[`4b79b6a7bf`](https://github.com/fibjs/fibjs/commit/4b79b6a7bf)] - **build, refactor**: update macOS versions in build.yml.(xicilion)
* [[`4c3daa428d`](https://github.com/fibjs/fibjs/commit/4c3daa428d)] - **build, refactor**: clear new_args before process arguments.(xicilion)
* [[`c24194cad6`](https://github.com/fibjs/fibjs/commit/c24194cad6)] - **build, refactor**: handle user permissions in Docker container.(xicilion)
* [[`62b0d1fa16`](https://github.com/fibjs/fibjs/commit/62b0d1fa16)] - **fs, feat**: support recursive option in fs.readdir.(xicilion)
* [[`3a1fe5c6fd`](https://github.com/fibjs/fibjs/commit/3a1fe5c6fd)] - **v8, refactor**: fix compile error in loong64 debug mode.(xicilion)
* [[`c4f5ac1dfd`](https://github.com/fibjs/fibjs/commit/c4f5ac1dfd)] - **build, refactor**: add support for loong64ow architecture.(xicilion)
* [[`865eafa901`](https://github.com/fibjs/fibjs/commit/865eafa901)] - **build, refactor**: correct website link.(xicilion)
* [[`75742a186e`](https://github.com/fibjs/fibjs/commit/75742a186e)] - **fs, refactor**: update writeFile function, support encoding for Buffer.(xicilion)
* [[`7af243ea9e`](https://github.com/fibjs/fibjs/commit/7af243ea9e)] - **fs, refactor**: add writeFile() method options.(xicilion)
* [[`ff40f87cab`](https://github.com/fibjs/fibjs/commit/ff40f87cab)] - **build, refactor**: add USE_VENDER_DIST flag to build.cmd.(xicilion)
* [[`2bef21094c`](https://github.com/fibjs/fibjs/commit/2bef21094c)] - **os, refactor**: remove printer-related functions from os module.(xicilion)
* [[`b12e600f89`](https://github.com/fibjs/fibjs/commit/b12e600f89)] - **build, refactor**: remove unnecessary environment variable in build.yml.(xicilion)
* [[`6b37d5ba9f`](https://github.com/fibjs/fibjs/commit/6b37d5ba9f)] - **test, refactor**: reduce memory usage in tests to avoid memory overflow in Windows ia32.(xicilion)
* [[`845e4d5f86`](https://github.com/fibjs/fibjs/commit/845e4d5f86)] - **LevelDB, feat**: add firstKey and lastKey methods, enhancements to forEach.(xicilion)
* [[`14d029dde0`](https://github.com/fibjs/fibjs/commit/14d029dde0)] - **db, refactor**: refactor LevelDB for improved performance.(xicilion)
* [[`20d07789b0`](https://github.com/fibjs/fibjs/commit/20d07789b0)] - **build, refactor**: update build.sh script to include safe.directory in docker run command.(xicilion)
* [[`f8c5da798a`](https://github.com/fibjs/fibjs/commit/f8c5da798a)] - **option, refactor**: regenerate the opt_tools.cpp file.(xicilion)
* [[`4427498108`](https://github.com/fibjs/fibjs/commit/4427498108)] - **option, refactor**: refactor file download logic in install.js(xicilion)
* [[`f66e5a9ac3`](https://github.com/fibjs/fibjs/commit/f66e5a9ac3)] - **test, refactor**: remove unused test file.(xicilion)
* [[`159805ce56`](https://github.com/fibjs/fibjs/commit/159805ce56)] - **build, refactor**: Remove gd module and related code.(xicilion)
* [[`36dd66bab9`](https://github.com/fibjs/fibjs/commit/36dd66bab9)] - **build, refactor**: Add -rdynamic flag for non-Windows systems(xicilion)
* [[`127c6af8b4`](https://github.com/fibjs/fibjs/commit/127c6af8b4)] - **module, refactor**: support exports in package.json.(xicilion)
* [[`ef71aafa5b`](https://github.com/fibjs/fibjs/commit/ef71aafa5b)] - **build, refactor**: update cmake minimum required.(xicilion)
* [[`3ed13dc69d`](https://github.com/fibjs/fibjs/commit/3ed13dc69d)] - **build, refactor**: update CMakeLists.txt to read HEAD reference.(xicilion)
* [[`ab6a9d3168`](https://github.com/fibjs/fibjs/commit/ab6a9d3168)] - **options, refactor**: fix installation errors for symbolic link files in tar.gz.(xicilion)
* [[`734028da17`](https://github.com/fibjs/fibjs/commit/734028da17)] - **options, bugfix**: fix addon file path issue.(xicilion)
* [[`1b650bb11b`](https://github.com/fibjs/fibjs/commit/1b650bb11b)] - **core, refactor**: set @toStringTag property with DontEnum attribute.(xicilion)
* [[`9bcd64997e`](https://github.com/fibjs/fibjs/commit/9bcd64997e)] - **util, refactor**: fix key collection mode in json_format function.(xicilion)
* [[`bca8c1f24a`](https://github.com/fibjs/fibjs/commit/bca8c1f24a)] - **util, refactor**: fix symbol formatting in util_format.(xicilion)
* [[`a760a3557e`](https://github.com/fibjs/fibjs/commit/a760a3557e)] - **util, feat**: support symbol key in util.format.(xicilion)
* [[`26eebc39ef`](https://github.com/fibjs/fibjs/commit/26eebc39ef)] - **options, bugfix**: fix binary file installation path issue.(xicilion)
* [[`265aa27031`](https://github.com/fibjs/fibjs/commit/265aa27031)] - **http, refactor**: rename maxHeaderLength to maxHeaderSize.(xicilion)
* [[`bbb0b594c0`](https://github.com/fibjs/fibjs/commit/bbb0b594c0)] - **http, feat**: add maxHeaderLength in http/HttpClient/HttpRequest/HttpResponse/HttpServer/HttpsServer/HttpHandler.(xicilion)
* [[`a29e19b43a`](https://github.com/fibjs/fibjs/commit/a29e19b43a)] - **build, refactor**: update build scripts and submodule initialization.(xicilion)
* [[`255f912ad4`](https://github.com/fibjs/fibjs/commit/255f912ad4)] - **build, refactor**: update vender tag retrieval in CMakeLists.txt.(xicilion)
* [[`a70f2a116c`](https://github.com/fibjs/fibjs/commit/a70f2a116c)] - **build, bugfix**: fix conversion issue in app.cpp on Windows.(xicilion)
* [[`48ef6589f7`](https://github.com/fibjs/fibjs/commit/48ef6589f7)] - **build, refactor**: refactor build.cmd and CMakeLists.txt(xicilion)
* [[`b51fda601e`](https://github.com/fibjs/fibjs/commit/b51fda601e)] - **build, bugfix**: fix UTF-8 to UTF-16 conversion on Windows.(xicilion)
* [[`a7469ca774`](https://github.com/fibjs/fibjs/commit/a7469ca774)] - **build, refactor**: add dev argument in tasks.json.(xicilion)
* [[`86cee67089`](https://github.com/fibjs/fibjs/commit/86cee67089)] - **build, refactor**: add dev argument.(xicilion)
* [[`90e282f41a`](https://github.com/fibjs/fibjs/commit/90e282f41a)] - **isolate, refactor**: add safe_current() method to Isolate class.(xicilion)
* [[`7bae20993c`](https://github.com/fibjs/fibjs/commit/7bae20993c)] - **build, bugfix**: compile error on linux.(xicilion)
* [[`3ec5cef967`](https://github.com/fibjs/fibjs/commit/3ec5cef967)] - **build, bugfix**: update glibc_config.h include in encoding_iconv.cpp and encoding_iconv_ucs.cpp.(xicilion)
* [[`755cecc0f4`](https://github.com/fibjs/fibjs/commit/755cecc0f4)] - **core, refactor**: update vendor and fix character types in multiple files.(xicilion)
* [[`1ef60f3ae4`](https://github.com/fibjs/fibjs/commit/1ef60f3ae4)] - **build, refactor**: rename config.h to glibc_config.h.(xicilion)
* [[`539a916ca4`](https://github.com/fibjs/fibjs/commit/539a916ca4)] - **exlib, refactor**: refactor string.(xicilion)
* [[`bc4b8f11d0`](https://github.com/fibjs/fibjs/commit/bc4b8f11d0)] - **addons, refactor**: add more api support.(xicilion)
* [[`2a9a1a79bc`](https://github.com/fibjs/fibjs/commit/2a9a1a79bc)] - **addons, refactor**: Implement node_napi_env__ to support Finalizer for fixing object leaks within addons.(xicilion)
* [[`4c8c1441e6`](https://github.com/fibjs/fibjs/commit/4c8c1441e6)] - **global, refactor**: Fix capitalization of GC function.(xicilion)
* [[`7b53c2c2a6`](https://github.com/fibjs/fibjs/commit/7b53c2c2a6)] - **addons, refactor**: Update include directory for addons.(xicilion)
* [[`dae8dc51b9`](https://github.com/fibjs/fibjs/commit/dae8dc51b9)] - **core, refactor**: refactor node api include files.(xicilion)
* [[`9b4e5a4b18`](https://github.com/fibjs/fibjs/commit/9b4e5a4b18)] - **core, refactor**: refactor addon api source code.(xicilion)
* [[`a49d789d53`](https://github.com/fibjs/fibjs/commit/a49d789d53)] - **Sandbox, refactor**: refactor SandBox lock handling to improve module loading flexibility.(xicilion)
* [[`0de2e1eef6`](https://github.com/fibjs/fibjs/commit/0de2e1eef6)] - **xml, refactor**: not close self-clsing tag in html.(xicilion)
* [[`bc2a39a90c`](https://github.com/fibjs/fibjs/commit/bc2a39a90c)] - **xml, refactor**: refactors documentElement into an XmlElement node with tagName html.(xicilion)
* [[`80ddca82e2`](https://github.com/fibjs/fibjs/commit/80ddca82e2)] - **xml, refactor**: implements XmlElement.outerHTML, mapping it to the function XmlElement.toString().(xicilion)
* [[`cd69b3c984`](https://github.com/fibjs/fibjs/commit/cd69b3c984)] - **console, feat**: support complex parameters in console.trace.(xicilion)
* [[`7739a738a7`](https://github.com/fibjs/fibjs/commit/7739a738a7)] - **core, refactor**: convert date to ISOString in argument.(xicilion)
* [[`8730b4d319`](https://github.com/fibjs/fibjs/commit/8730b4d319)] - **buffer, bugfix**: Buffer.from(Date) result error.(xicilion)
* [[`4ed90ece17`](https://github.com/fibjs/fibjs/commit/4ed90ece17)] - **build, refactor**: delete logo folder.(xicilion)
* [[`ea478bb07f`](https://github.com/fibjs/fibjs/commit/ea478bb07f)] - **build, refactor**: delete perf folder.(xicilion)
* [[`6ac95a10bb`](https://github.com/fibjs/fibjs/commit/6ac95a10bb)] - **http, refactor**: HttpHandler ends processing when HttpRequest detects a network shutdown.(xicilion)
* [[`4be9147fa2`](https://github.com/fibjs/fibjs/commit/4be9147fa2)] - **net, refactor**: detects port arguments passed as strings in new TcpServer to avoid incorrect handling.(xicilion)
* [[`f035fad07d`](https://github.com/fibjs/fibjs/commit/f035fad07d)] - **crypto, bugfix**: crash in PKey.toJSON().(xicilion)
* [[`afa75b74da`](https://github.com/fibjs/fibjs/commit/afa75b74da)] - **http, refactor**: when setting a custom Content-Type header, json/pack/body does not set the Content-Type.(xicilion)
* [[`eb40809988`](https://github.com/fibjs/fibjs/commit/eb40809988)] - **build, refactor**: delete unused variable.(xicilion)
* [[`3ebce2d423`](https://github.com/fibjs/fibjs/commit/3ebce2d423)] - **crypto, bugfix**: crash when new PKey with empty string.(xicilion)
* [[`c2e9dc74ca`](https://github.com/fibjs/fibjs/commit/c2e9dc74ca)] - **test, refactor**: add missing document about return of test.mustCall/mustNotCall.(xicilion)
* [[`6897bb2288`](https://github.com/fibjs/fibjs/commit/6897bb2288)] - **SandBox, refactor**: remove unused header file.(xicilion)
* [[`fb336699ec`](https://github.com/fibjs/fibjs/commit/fb336699ec)] - **Routing, refactor**: clear HttpRequest.params before process url.(xicilion)
* [[`31befe5382`](https://github.com/fibjs/fibjs/commit/31befe5382)] - **SandBox, feat**: support async import.(xicilion)
* [[`6081d128a6`](https://github.com/fibjs/fibjs/commit/6081d128a6)] - **option, refactor**: fix dependency module tree.(xicilion)
* [[`f9fc0f6cd6`](https://github.com/fibjs/fibjs/commit/f9fc0f6cd6)] - **Buffer, refactor**: fix data type check in Buffer.concat.(xicilion)
* [[`28e1e52d6c`](https://github.com/fibjs/fibjs/commit/28e1e52d6c)] - **http, refactor**: add status to HttpResponse as an alias for statusCode.(xicilion)
* [[`8b2def964a`](https://github.com/fibjs/fibjs/commit/8b2def964a)] - **http, refactor**: cache STATUS_CODES in Isolate.(xicilion)
* [[`a5e9b5af07`](https://github.com/fibjs/fibjs/commit/a5e9b5af07)] - **Digest, feat**: support update string.(xicilion)
* [[`fea27a89d1`](https://github.com/fibjs/fibjs/commit/fea27a89d1)] - **test, refactor**: use localhost to test dns.resolve.(xicilion)
* [[`44463b0ccc`](https://github.com/fibjs/fibjs/commit/44463b0ccc)] - **vm, refactor**: revert Sandbox.freeze.(xicilion)
* [[`30a319ed9d`](https://github.com/fibjs/fibjs/commit/30a319ed9d)] - **build, refactor**: fix compile warning in debug mode.(xicilion)
* [[`73a929819c`](https://github.com/fibjs/fibjs/commit/73a929819c)] - **SandBox, refactor**: not check stat for script file.(xicilion)
* [[`7dda8c254c`](https://github.com/fibjs/fibjs/commit/7dda8c254c)] - **fs, refactor**: using unordered_map to speed up zip file lookups.(xicilion)
* [[`d90731f1dd`](https://github.com/fibjs/fibjs/commit/d90731f1dd)] - **build, refactor**: use the pre-compiled vender on github for compiling when the USE_VENDER_DIST environment variable is set.(xicilion)
* [[`65134aeb04`](https://github.com/fibjs/fibjs/commit/65134aeb04)] - **core, refactor**: remove support for top-level async in common modules.(xicilion)
* [[`cb8336d772`](https://github.com/fibjs/fibjs/commit/cb8336d772)] - **vector, feat**: support vec_distance function.(xicilion)
* [[`ac60f9c95d`](https://github.com/fibjs/fibjs/commit/ac60f9c95d)] - **build, refactor**: remove unused path.(xicilion)
* [[`679f888444`](https://github.com/fibjs/fibjs/commit/679f888444)] - **fasttext, refactor**: remove fasttext module.(xicilion)
* [[`8b8f471405`](https://github.com/fibjs/fibjs/commit/8b8f471405)] - **build, refactor**: fetch current tag in vender.(xicilion)
* [[`1953c8e547`](https://github.com/fibjs/fibjs/commit/1953c8e547)] - **SQLite, feat**: update sqlite.(xicilion)
* [[`d797c0f057`](https://github.com/fibjs/fibjs/commit/d797c0f057)] - **addons, bugfix**: fibjs api crashed in addons callback.(xicilion)
* [[`356bd77883`](https://github.com/fibjs/fibjs/commit/356bd77883)] - **test, refactor**: timeout in LruCache may error in ci.(xicilion)
* [[`b11c1922da`](https://github.com/fibjs/fibjs/commit/b11c1922da)] - **test, refactor**: test mey error on ci.(xicilion)
* [[`53e4756054`](https://github.com/fibjs/fibjs/commit/53e4756054)] - **addons, refactor**: fix addon test on ubuntu 10.04.(xicilion)
* [[`050512c83d`](https://github.com/fibjs/fibjs/commit/050512c83d)] - **build, refactor**: refactor BUILD_OPTION.(xicilion)
* [[`10435ed5be`](https://github.com/fibjs/fibjs/commit/10435ed5be)] - **build, refactor**: merge flags with CMAKE_C_FLAGS.(xicilion)
* [[`574503820f`](https://github.com/fibjs/fibjs/commit/574503820f)] - **build, refactor**: not link stdc++ on Darwin.(xicilion)
* [[`8f50c1ec1d`](https://github.com/fibjs/fibjs/commit/8f50c1ec1d)] - **build, refactor**: set LINK_FLAGS in setup_result_library.(xicilion)
* [[`ed7cca3350`](https://github.com/fibjs/fibjs/commit/ed7cca3350)] - **build, refactor**: detect BUILD_OS and BUILD_ARCH in cmake script.(xicilion)
* [[`5bda216824`](https://github.com/fibjs/fibjs/commit/5bda216824)] - **build, refactor**: refactor build script.(xicilion)
* [[`ab7a5c8a7f`](https://github.com/fibjs/fibjs/commit/ab7a5c8a7f)] - **build, refactor**: refactor release workflow.(xicilion)
* [[`ff42a6ddee`](https://github.com/fibjs/fibjs/commit/ff42a6ddee)] - **build, refactor**: fix ci build script error.(xicilion)
* [[`e8b1b1ffc2`](https://github.com/fibjs/fibjs/commit/e8b1b1ffc2)] - **build, refactor**: script path error.(xicilion)
* [[`056a5e74ca`](https://github.com/fibjs/fibjs/commit/056a5e74ca)] - **build, refactor**: refactor build dockerfiles.(xicilion)
* [[`46684e849d`](https://github.com/fibjs/fibjs/commit/46684e849d)] - **build, refactor**: refactor ci workflow.(xicilion)
* [[`debcdb71f9`](https://github.com/fibjs/fibjs/commit/debcdb71f9)] - **options, refactor**: fix addon filename on alpine.(xicilion)
* [[`66323a953e`](https://github.com/fibjs/fibjs/commit/66323a953e)] - **core, refactor**: add musl flag in process.versions.(xicilion)
* [[`03999427ed`](https://github.com/fibjs/fibjs/commit/03999427ed)] - **build, refactor**: rename x86 to ia32.(xicilion)
* [[`824c7e64b5`](https://github.com/fibjs/fibjs/commit/824c7e64b5)] - **build, refactor**: not setup env in sub script.(xicilion)
* [[`fc9034620a`](https://github.com/fibjs/fibjs/commit/fc9034620a)] - **build, refactor**: refactor build script.(xicilion)
* [[`91d86d6aab`](https://github.com/fibjs/fibjs/commit/91d86d6aab)] - **SandBox, refactor**: only lock require from same SandBox.(xicilion)
* [[`bd998ec315`](https://github.com/fibjs/fibjs/commit/bd998ec315)] - **build, refactor**: change amd64/i386 to x64/x86.(xicilion)
* [[`669504d1f8`](https://github.com/fibjs/fibjs/commit/669504d1f8)] - Merge remote-tracking branch 'origin/dev' into dev(xicilion)
* [[`5fe6b4e436`](https://github.com/fibjs/fibjs/commit/5fe6b4e436)] - **os, refactor**: use uv_os_uname to get os.arch.(xicilion)
* [[`ad5f673b74`](https://github.com/fibjs/fibjs/commit/ad5f673b74)] - **addons, bugfix**: callback error on linux.(xicilion)
* [[`41287cc441`](https://github.com/fibjs/fibjs/commit/41287cc441)] - **uv, refactor**: export uv functions in the symbol table to support being referenced in addons.(xicilion)
* [[`1455a04564`](https://github.com/fibjs/fibjs/commit/1455a04564)] - **addons, refactor**: remove unused code.(xicilion)
* [[`8bae75b6d1`](https://github.com/fibjs/fibjs/commit/8bae75b6d1)] - **addons, feat**: support napi_make_callback.(xicilion)
* [[`a8ad9d4a3e`](https://github.com/fibjs/fibjs/commit/a8ad9d4a3e)] - **test, feat**: support muslCall/mustNotCall.(xicilion)
* [[`d018d37b3c`](https://github.com/fibjs/fibjs/commit/d018d37b3c)] - **addons, refactor**: not check executable flag of .node.(xicilion)
* [[`997729954c`](https://github.com/fibjs/fibjs/commit/997729954c)] - **build, refactor**: refactor shell build script.(xicilion)
* [[`bde0f038f2`](https://github.com/fibjs/fibjs/commit/bde0f038f2)] - **addons, refactor**: enable addons to be loaded by fibjs.exe and node.exe.(xicilion)
* [[`bee0fa2ed7`](https://github.com/fibjs/fibjs/commit/bee0fa2ed7)] - **child_process, refactor**: fix test error on Windows.(xicilion)
* [[`9b1abae97d`](https://github.com/fibjs/fibjs/commit/9b1abae97d)] - **addons, refactor**: throw dlerror in posix.(xicilion)
* [[`464db8bc9a`](https://github.com/fibjs/fibjs/commit/464db8bc9a)] - **core, refactor**: fill error code in callback.(xicilion)
* [[`ae8a37b7e1`](https://github.com/fibjs/fibjs/commit/ae8a37b7e1)] - **core, refactor**: reenable fasttext.(xicilion)
* [[`0a0e5db757`](https://github.com/fibjs/fibjs/commit/0a0e5db757)] - **process, refactor**: add version of node and modules into process.versions.(xicilion)
* [[`7bea7ec7eb`](https://github.com/fibjs/fibjs/commit/7bea7ec7eb)] - **child_process, bugfix**: encoding/env/output error.(xicilion)
* [[`9c681b9fe9`](https://github.com/fibjs/fibjs/commit/9c681b9fe9)] - **build, bugfix**: build script mistake.(xicilion)
* [[`9a653e0655`](https://github.com/fibjs/fibjs/commit/9a653e0655)] - **addons, feat**: support napi_module_register addons module.(xicilion)
* [[`87bf8a6c93`](https://github.com/fibjs/fibjs/commit/87bf8a6c93)] - **options, feat**: support install addons binary module.(xicilion)
* [[`749785e49d`](https://github.com/fibjs/fibjs/commit/749785e49d)] - **addons, refactor**: add init order test.(xicilion)
* [[`d42a7f2ffa`](https://github.com/fibjs/fibjs/commit/d42a7f2ffa)] - **addons, refactor**: refactor promises test.(xicilion)
* [[`8129eb2df0`](https://github.com/fibjs/fibjs/commit/8129eb2df0)] - **util, refactor**: support util.types.(xicilion)
* [[`5e5da20277`](https://github.com/fibjs/fibjs/commit/5e5da20277)] - **addons, bugfix**: compile error on Windfows.(xicilion)
* [[`6b0c5821b5`](https://github.com/fibjs/fibjs/commit/6b0c5821b5)] - **addons, feat**: support Buffer Finalizer.(xicilion)
* [[`5665592ceb`](https://github.com/fibjs/fibjs/commit/5665592ceb)] - **addons. feat**: support async work.(xicilion)
* [[`e493096aae`](https://github.com/fibjs/fibjs/commit/e493096aae)] - **addons, feat**: support buffer api.(xicilion)
* [[`c610073335`](https://github.com/fibjs/fibjs/commit/c610073335)] - **addons, refactor**: refactor code.(xicilion)
* [[`77b1db23eb`](https://github.com/fibjs/fibjs/commit/77b1db23eb)] - **module, feat**: support require(.node).(xicilion)
* [[`5ab4d91549`](https://github.com/fibjs/fibjs/commit/5ab4d91549)] - **SandBox, refactor**: check file stat before load file.(xicilion)
* [[`004d3dd45e`](https://github.com/fibjs/fibjs/commit/004d3dd45e)] - **build, refactor**: link options error on alpine.(xicilion)
* [[`949d31027c`](https://github.com/fibjs/fibjs/commit/949d31027c)] - **process, feat**: : support process.dlopen.(xicilion)
* [[`b18cd2b5ba`](https://github.com/fibjs/fibjs/commit/b18cd2b5ba)] - **vm, feat**: support vm.Script and context.(xicilion)
* [[`3aab45d980`](https://github.com/fibjs/fibjs/commit/3aab45d980)] - **test, refactor**: relaxing the time of testing avoids misjudgment during testing.(xicilion)
* [[`fc1ebd32eb`](https://github.com/fibjs/fibjs/commit/fc1ebd32eb)] - **vm, refactor**: remove Sandbox.freeze.(xicilion)
* [[`2fab5661fe`](https://github.com/fibjs/fibjs/commit/2fab5661fe)] - **util, refactor**: simplifying function calls with parameter defaults in inspect.(xicilion)
* [[`f6fbe99d2a`](https://github.com/fibjs/fibjs/commit/f6fbe99d2a)] - **util, feat**: support maxStringLength in inspect. (#766)(PinelliaC)
* [[`17a43539bb`](https://github.com/fibjs/fibjs/commit/17a43539bb)] - **core, refactor**: remove unused variable.(xicilion)
* [[`7ee9aea4cf`](https://github.com/fibjs/fibjs/commit/7ee9aea4cf)] - **core, refactor**: pass the global module via context.SetEmbedderData.(xicilion)
* [[`77c928fddd`](https://github.com/fibjs/fibjs/commit/77c928fddd)] - **vm, refactor**: use proxy to isolate sandbox from host and share the global's data between them.(xicilion)
* [[`9855cf869b`](https://github.com/fibjs/fibjs/commit/9855cf869b)] - **core, refactor**: remove Master, argv from global.(xicilion)
* [[`af24410259`](https://github.com/fibjs/fibjs/commit/af24410259)] - **test, refactor**: increase the timeout test time to avoid test misclassification.(xicilion)
* [[`4f71ae16da`](https://github.com/fibjs/fibjs/commit/4f71ae16da)] - **util, feat**: support max_array_length in inspect. (#765)(PinelliaC)
* [[`96ca1cfbd0`](https://github.com/fibjs/fibjs/commit/96ca1cfbd0)] - **iconv, bugfix**: decode error when iconv does not exist.(xicilion)
* [[`4cb10ebeb7`](https://github.com/fibjs/fibjs/commit/4cb10ebeb7)] - **encoding, refactor**: use icu built-in encoding for iconv if icu built-in encoding.(xicilion)
* [[`5e16d74084`](https://github.com/fibjs/fibjs/commit/5e16d74084)] - **core, bugfix**: Exception object crash.(xicilion)
* [[`3e438ef56d`](https://github.com/fibjs/fibjs/commit/3e438ef56d)] - **dgram, refactor**: add test for multicast.(xicilion)
* [[`63b29c51ec`](https://github.com/fibjs/fibjs/commit/63b29c51ec)] - **dgram, feat**: support multicast function.(xicilion)
* [[`30c7be3dc9`](https://github.com/fibjs/fibjs/commit/30c7be3dc9)] - **build, refactor**: remove git from depend list.(xicilion)
* [[`8a88c7d2f9`](https://github.com/fibjs/fibjs/commit/8a88c7d2f9)] - **v8, refactor**: update to v11.8.173.(xicilion)
* [[`687243d0ba`](https://github.com/fibjs/fibjs/commit/687243d0ba)] - **build, refactor**: update docker image to clang-12.(xicilion)
* [[`c526167a66`](https://github.com/fibjs/fibjs/commit/c526167a66)] - **docs, bugfix**: URL typo (#764)(PinelliaC)
* [[`2828fd18f5`](https://github.com/fibjs/fibjs/commit/2828fd18f5)] - **core, refactor**: allow passing null to ignore parameters.(xicilion)
* [[`3e25a8f82d`](https://github.com/fibjs/fibjs/commit/3e25a8f82d)] - **tty, feat**: support cursorTo and moveCursor.(xicilion)
* [[`65d4f77c63`](https://github.com/fibjs/fibjs/commit/65d4f77c63)] - **net, bugfix**: pipe is incorrectly allowing multiple binds on Linux.(xicilion)
* [[`67af61a307`](https://github.com/fibjs/fibjs/commit/67af61a307)] - **fasttext, feat**: support more api.(xicilion)
* [[`d70604139f`](https://github.com/fibjs/fibjs/commit/d70604139f)] - **core, refactor**: patch glibc function.(xicilion)
* [[`19f293e1ec`](https://github.com/fibjs/fibjs/commit/19f293e1ec)] - **fasttext, refactor**: change source code folder.(xicilion)
* [[`1248efa613`](https://github.com/fibjs/fibjs/commit/1248efa613)] - **fasttext, bugfix**: predict has an error in recognizing a single word.(xicilion)
* [[`de5ad3a85e`](https://github.com/fibjs/fibjs/commit/de5ad3a85e)] - **fasttext, feat**: ad fasttext module.(xicilion)
* [[`aa7333ff0d`](https://github.com/fibjs/fibjs/commit/aa7333ff0d)] - **build, bugfix**: build unicode error,(xicilion)
* [[`1f5100dcaa`](https://github.com/fibjs/fibjs/commit/1f5100dcaa)] - **util, refactor**: use u_getIntPropertyValue to refactor console.table.(xicilion)
* [[`f41fcfbca3`](https://github.com/fibjs/fibjs/commit/f41fcfbca3)] - **icu, feat**: support Intl.Segmenter.(xicilion)
* [[`6daf638fc2`](https://github.com/fibjs/fibjs/commit/6daf638fc2)] - **core, bugfix**: RunMicrotasks will deadlock due to reentry.(xicilion)
* [[`37c35ef809`](https://github.com/fibjs/fibjs/commit/37c35ef809)] - **test, refactor**: run workerData test on load event.(xicilion)
* [[`e26ae8b614`](https://github.com/fibjs/fibjs/commit/e26ae8b614)] - **worker_threads, feat**: support workerData in worker_threads.(xicilion)
* [[`b7c8f96ec1`](https://github.com/fibjs/fibjs/commit/b7c8f96ec1)] - **test, refactor**: reduce time judgment in testing to avoid misjudgment.(xicilion)
* [[`5881ac6b10`](https://github.com/fibjs/fibjs/commit/5881ac6b10)] - **worker_threads, feat**: support parentPort in worker_threads.(xicilion)
* [[`b239efcee9`](https://github.com/fibjs/fibjs/commit/b239efcee9)] - **url, feat**: support fileURLToPath and pathToFileURL.(xicilion)
* [[`d3969df26a`](https://github.com/fibjs/fibjs/commit/d3969df26a)] - **db, bugfix**: the db connection in odbc was not closed properly before being released.(xicilion)
* [[`90e483b7a4`](https://github.com/fibjs/fibjs/commit/90e483b7a4)] - **mysql, bugfix**: conn.execute throws a "broken pipe" error when the sql statement size is greater than 16M.(xicilion)
* [[`50c0e6f942`](https://github.com/fibjs/fibjs/commit/50c0e6f942)] - **fs, refactor**: support FileHandle promisify in fs.promises.open.(xicilion)
* [[`a2eb1b5bf4`](https://github.com/fibjs/fibjs/commit/a2eb1b5bf4)] - **crypto, refactor**: rename BLS12381_G1/BLS12381_G2 to Bls12381G1/Bls12381G2.(xicilion)
* [[`1943c78124`](https://github.com/fibjs/fibjs/commit/1943c78124)] - **vender, refactor**: update vender.(xicilion)
* [[`f588c3a5c3`](https://github.com/fibjs/fibjs/commit/f588c3a5c3)] - **crypto, feat**: support Bls12381Shake256 bbs suite.(xicilion)
* [[`405af45c4a`](https://github.com/fibjs/fibjs/commit/405af45c4a)] - **crypto, refactor**: move fips202 to vender.(xicilion)
* [[`3b5a0e001e`](https://github.com/fibjs/fibjs/commit/3b5a0e001e)] - **crypto, bugfix**: digest returns the wrong result when update is called multiple times in shake256.(xicilion)
* [[`a8eeddc977`](https://github.com/fibjs/fibjs/commit/a8eeddc977)] - **crypto, refactor**: update bbs signature to draft-irtf-cfrg-bbs-signatures-03.(xicilion)
* [[`c70083653b`](https://github.com/fibjs/fibjs/commit/c70083653b)] - **timers, bugfix**: timers.call may fail after multiple sleeps.(xicilion)
* [[`3b7d8a9bd8`](https://github.com/fibjs/fibjs/commit/3b7d8a9bd8)] - **crypto, feat**: support shake.(xicilion)
* [[`9ae4816099`](https://github.com/fibjs/fibjs/commit/9ae4816099)] - **crypto, feat**: support sha3.(xicilion)
* [[`8ea81c9ec9`](https://github.com/fibjs/fibjs/commit/8ea81c9ec9)] - **docs, refactor**: fix document format.(xicilion)
* [[`6ba15c025b`](https://github.com/fibjs/fibjs/commit/6ba15c025b)] - **docs, refator**: Update PKey.idl function “sign” comment (#763)(yaoqiaofeng)
* [[`7889f44128`](https://github.com/fibjs/fibjs/commit/7889f44128)] - **db, refactor**: support binary vector in vec_index.(xicilion)
* [[`66e8ea3b0e`](https://github.com/fibjs/fibjs/commit/66e8ea3b0e)] - **net, refactor**: support timeout in Socket.connect.(xicilion)
* [[`36d0d3211a`](https://github.com/fibjs/fibjs/commit/36d0d3211a)] - **exlib, refactor**: fix the TLS issue on iPhone, implement local storage using pthread_key.(xicilion)
* [[`b912ee5495`](https://github.com/fibjs/fibjs/commit/b912ee5495)] - **core, bugfix**: the ineffective iteration over m_keys (#762)(PinelliaC)
* [[`ccfe88c0a3`](https://github.com/fibjs/fibjs/commit/ccfe88c0a3)] - **jemalloc, bugfix**: runtime error on kunpeng arch.(xicilion)
* [[`ee081c2395`](https://github.com/fibjs/fibjs/commit/ee081c2395)] - **core, bugfix**: update the associative relationship between m_keys and m_values (#761)(PinelliaC)
* [[`dacab81695`](https://github.com/fibjs/fibjs/commit/dacab81695)] - **docs, refactor**: add star history.(响马)
* [[`46ab52cce2`](https://github.com/fibjs/fibjs/commit/46ab52cce2)] - **docs, refactor**: translate comments in source code into english.(xicilion)
* [[`db5da8f20c`](https://github.com/fibjs/fibjs/commit/db5da8f20c)] - **crypto, refactor**: refactor the api for bbs signature.(xicilion)
* [[`4e28733a03`](https://github.com/fibjs/fibjs/commit/4e28733a03)] - **docs, refactor**: add document for bbs signature.(xicilion)
* [[`684f54383a`](https://github.com/fibjs/fibjs/commit/684f54383a)] - **build, refactor**: support amd64 on iphone.(xicilion)
* [[`83d7a87846`](https://github.com/fibjs/fibjs/commit/83d7a87846)] - **build, refactor**: fix compile error on windows.(xicilion)
* [[`9172dcfecd`](https://github.com/fibjs/fibjs/commit/9172dcfecd)] - **crypto, refactor**: fix compile error on low version gcc.(xicilion)
* [[`0bb927794d`](https://github.com/fibjs/fibjs/commit/0bb927794d)] - **crypto, bugfix**: remove dependency on std::span to fix compilation errors in low versions of gcc.(xicilion)
* [[`b121842e37`](https://github.com/fibjs/fibjs/commit/b121842e37)] - **crypto, feat**: support bbs signacture.(xicilion)
* [[`03fd0ffadb`](https://github.com/fibjs/fibjs/commit/03fd0ffadb)] - **core, refactor**: optimise reference counting caused by unnecessary obj_ptr.(xicilion)
* [[`db30d57f93`](https://github.com/fibjs/fibjs/commit/db30d57f93)] - **fs, bugfix**: 64 bits seek error on Linux i386&arm.(xicilion)
* [[`2aecba53a7`](https://github.com/fibjs/fibjs/commit/2aecba53a7)] - **build, refactor**: add android ci item.(xicilion)
* [[`a645f6a74d`](https://github.com/fibjs/fibjs/commit/a645f6a74d)] - **docs, bugfix**: update docs (#760)(PinelliaC)
* [[`6ec5eb0704`](https://github.com/fibjs/fibjs/commit/6ec5eb0704)] - **build, refactor**: add android ci for arm and i386.(xicilion)
* [[`1716e519e5`](https://github.com/fibjs/fibjs/commit/1716e519e5)] - **core, bugfix**: crash when loading so in python.(xicilion)
* [[`da4f8e18ea`](https://github.com/fibjs/fibjs/commit/da4f8e18ea)] - **core, fix**: eliminate the key within the remove function. (#759)(PinelliaC)
* [[`2373c4c26d`](https://github.com/fibjs/fibjs/commit/2373c4c26d)] - **Buffer, refactor**: use encoding.encode to build Bufer from string.(xicilion)
* [[`f7adbc0588`](https://github.com/fibjs/fibjs/commit/f7adbc0588)] - **build, feat**: build shared library.(xicilion)
* [[`cd9bfed872`](https://github.com/fibjs/fibjs/commit/cd9bfed872)] - **SandBox, refactor**: compile warning on WIndows.(xicilion)
* [[`1701ed46a1`](https://github.com/fibjs/fibjs/commit/1701ed46a1)] - **crypto, refactor**: remove unused code.(xicilion)
* [[`1038489915`](https://github.com/fibjs/fibjs/commit/1038489915)] - **crypto, refactor**: remove ecsdsa.(xicilion)
* [[`5c75fba734`](https://github.com/fibjs/fibjs/commit/5c75fba734)] - **http, refactor**: fix compile warning in debug mode.(xicilion)
* [[`5983e7d3e2`](https://github.com/fibjs/fibjs/commit/5983e7d3e2)] - **PKey, refactor**: fix compile warning in debug mode.(xicilion)
* [[`39d1578ab4`](https://github.com/fibjs/fibjs/commit/39d1578ab4)] - **crypto, refactor**: deprecation "sign to" function in ecc.(xicilion)
* [[`24da7f5a14`](https://github.com/fibjs/fibjs/commit/24da7f5a14)] - **crypto, feat**: support computeSecret in BlsKey.(xicilion)
* [[`3cd018c4d3`](https://github.com/fibjs/fibjs/commit/3cd018c4d3)] - **util, bugfix**: crash in util.promisify.(xicilion)
* [[`e12cb3348f`](https://github.com/fibjs/fibjs/commit/e12cb3348f)] - **SandBox, feat**: simple support for loading ES modules.(xicilion)
* [[`740da800ab`](https://github.com/fibjs/fibjs/commit/740da800ab)] - **Buffer, refactor**: improving the performance of Buffer.from(string).(xicilion)
* [[`40ab37648c`](https://github.com/fibjs/fibjs/commit/40ab37648c)] - **Buffer, refactor**: fix error in util.table.(xicilion)
* [[`6a4c2474bd`](https://github.com/fibjs/fibjs/commit/6a4c2474bd)] - **Buffer, refactor**: adding missing scripts.(xicilion)
* [[`8cdc37df35`](https://github.com/fibjs/fibjs/commit/8cdc37df35)] - **core, refactor**: enable isolate scope.(xicilion)
* [[`6bce235f8b`](https://github.com/fibjs/fibjs/commit/6bce235f8b)] - **Buffer, refactor**: rewrite Buffer.write to improve performance.(xicilion)
* [[`234e78b2ad`](https://github.com/fibjs/fibjs/commit/234e78b2ad)] - **Buffer, refactor**: optimising Buffer performance with primordials.(xicilion)
* [[`665a69dabe`](https://github.com/fibjs/fibjs/commit/665a69dabe)] - **core, refactor**: replace #include "map".(xicilion)
* [[`d76e9162dd`](https://github.com/fibjs/fibjs/commit/d76e9162dd)] - **core, bugfix**: unordered_map compile error on android.(xicilion)
* [[`e5cfac7139`](https://github.com/fibjs/fibjs/commit/e5cfac7139)] - **process, refactor**: support property attribute in process.env.(xicilion)
* [[`492c44169b`](https://github.com/fibjs/fibjs/commit/492c44169b)] - **core, refactor**: change std::map to std::unordered_map.(xicilion)
* [[`fc05e1173e`](https://github.com/fibjs/fibjs/commit/fc05e1173e)] - **process, bugfix**: not set return value when env key not exists.(xicilion)
* [[`61ccbebe57`](https://github.com/fibjs/fibjs/commit/61ccbebe57)] - **SandBox, refactor**: set resource_line_offset to -1 to enable v8 to report the correct line number.(xicilion)
* [[`8f363b3aec`](https://github.com/fibjs/fibjs/commit/8f363b3aec)] - **core, refactor**: remove unused variable.(xicilion)
* [[`ee0c8e95d0`](https://github.com/fibjs/fibjs/commit/ee0c8e95d0)] - **process, refactor**: use handler to get env variable.(xicilion)
* [[`9740865581`](https://github.com/fibjs/fibjs/commit/9740865581)] - **v8, refactor**: enable turbofan.(xicilion)
* [[`1dff34944c`](https://github.com/fibjs/fibjs/commit/1dff34944c)] - **Buffer, refactor**: remove unused deleter.(xicilion)
* [[`1ed2b476f4`](https://github.com/fibjs/fibjs/commit/1ed2b476f4)] - **core, feat**: suooprt DisallowGarbageCollection.(xicilion)
* [[`3bff2dec43`](https://github.com/fibjs/fibjs/commit/3bff2dec43)] - **core, refactor**: deprecate VariantEx.(xicilion)
* [[`b47dc02d61`](https://github.com/fibjs/fibjs/commit/b47dc02d61)] - **v8, refactor**: Disable V8_HAS_PKU_JIT_WRITE_PROTECT globally.(xicilion)
* [[`c04a310212`](https://github.com/fibjs/fibjs/commit/c04a310212)] - **core, bugfix**: runtime error in debug mode.(xicilion)
* [[`ad5b53a72b`](https://github.com/fibjs/fibjs/commit/ad5b53a72b)] - **v8, feat**: update v8 to v11.5.151.(xicilion)
* [[`f679016c5b`](https://github.com/fibjs/fibjs/commit/f679016c5b)] - **process, refactor**: force exit in process.exit.(xicilion)
* [[`bb362a650d`](https://github.com/fibjs/fibjs/commit/bb362a650d)] - **isolate, refactor**: support Isolate::main() to get first isolate.(xicilion)
* [[`e8b066865d`](https://github.com/fibjs/fibjs/commit/e8b066865d)] - **encoding, refactor**: disable iconv encode/decode in safe_isolate.(xicilion)
* [[`d603cf2750`](https://github.com/fibjs/fibjs/commit/d603cf2750)] - **core, refactor**: identify if it is a built-in object by checking InternalFieldCount.(xicilion)
* [[`e13657cda2`](https://github.com/fibjs/fibjs/commit/e13657cda2)] - **build, refactor**: remove libmongo from cmake.(xicilion)
* [[`cf794b49c5`](https://github.com/fibjs/fibjs/commit/cf794b49c5)] - **core, refactor**: use ::operator new/delete instead of new uint8_t[].(xicilion)
* [[`32c0c2d1cc`](https://github.com/fibjs/fibjs/commit/32c0c2d1cc)] - **core, refactor**: remove unused code.(xicilion)
* [[`1392b262a7`](https://github.com/fibjs/fibjs/commit/1392b262a7)] - **Buffer, refactor**: refactor Buffer's data processing methods in native code.(xicilion)
* [[`af4b8a2260`](https://github.com/fibjs/fibjs/commit/af4b8a2260)] - **Buffer, refactor**: inject the buffer module in the sandbox of the shared global.(xicilion)
* [[`5c0ace24ca`](https://github.com/fibjs/fibjs/commit/5c0ace24ca)] - **Buffer, refactor**: define the Buffer type in a separate global sandbox.(xicilion)
* [[`cb83f32ec9`](https://github.com/fibjs/fibjs/commit/cb83f32ec9)] - **db, refactor**: remove the mongo module.(xicilion)
* [[`f1789617cf`](https://github.com/fibjs/fibjs/commit/f1789617cf)] - **Buffer, refactor**: implement the JavaScript version of Buffer.(xicilion)
* [[`ecf693c1e0`](https://github.com/fibjs/fibjs/commit/ecf693c1e0)] - **test, refactor**: require garbage collection before enabling track_native_object.(xicilion)
* [[`f0a90eaca3`](https://github.com/fibjs/fibjs/commit/f0a90eaca3)] - **core, refactor**: define kObjectPrototype to refer to the prototype of a common object.(xicilion)
* [[`e35d929253`](https://github.com/fibjs/fibjs/commit/e35d929253)] - **encoding, feat**: support encode/decode with codec.(xicilion)
* [[`1d3353bb84`](https://github.com/fibjs/fibjs/commit/1d3353bb84)] - **sandbox, refactor**: convert the result of readFile to Buffer directly to avoid introducing multiple type conversions.(xicilion)
* [[`64ea150c3f`](https://github.com/fibjs/fibjs/commit/64ea150c3f)] - **Buffer, refactor**: not save ArrayBuffer into Global.(xicilion)
* [[`32fc76f88d`](https://github.com/fibjs/fibjs/commit/32fc76f88d)] - **build, bugfix**: update vender to fix compile error.(xicilion)
* [[`ef7dc23b34`](https://github.com/fibjs/fibjs/commit/ef7dc23b34)] - **core, bugfix**: incorrect handling of kJSSpecialApiObjectType objects in get_instance_pointer causes fibjs crash.(xicilion)
* [[`f1af68f8b4`](https://github.com/fibjs/fibjs/commit/f1af68f8b4)] - **test, feat**: enable g_track_native_object in test.setup to support using process.memoryUsage to count the use of built-in objects.(xicilion)
* [[`666ea31fc5`](https://github.com/fibjs/fibjs/commit/666ea31fc5)] - **process, bugfix**: crash in process.memoryUsage.(xicilion)
* [[`3b954fe1d6`](https://github.com/fibjs/fibjs/commit/3b954fe1d6)] - **core, refactor**: disable instance counter by default and allowed to be turned on by option.(xicilion)
* [[`1fe90c0722`](https://github.com/fibjs/fibjs/commit/1fe90c0722)] - **core, refactor**: assign the value to p directly in the constructor of obj_ptr to avoid unnecessary initialization that introduces extra load.(xicilion)
* [[`c246353501`](https://github.com/fibjs/fibjs/commit/c246353501)] - **core, refactor**: direct access to the data in the Buffer to avoid the cost of copying data.(xicilion)
* [[`37b26579a9`](https://github.com/fibjs/fibjs/commit/37b26579a9)] - **core, refactor**: refactor class cache init.(xicilion)
* [[`607adb4b83`](https://github.com/fibjs/fibjs/commit/607adb4b83)] - **core**: refactor: move SetAlignedPointerInInternalField of Buffer into object_base::wrap.(xicilion)
* [[`4bec0a807b`](https://github.com/fibjs/fibjs/commit/4bec0a807b)] - **core, refactor**: reduce calls to Isolate::current.(xicilion)
* [[`aaa204beaf`](https://github.com/fibjs/fibjs/commit/aaa204beaf)] - **Buffer, refactor**: refactoring Buffer's built-in object binding model to optimize the performance of Buffer member method calls.(xicilion)
* [[`b9cfd31d64`](https://github.com/fibjs/fibjs/commit/b9cfd31d64)] - **core, refactor**: rename v8 instance api.(xicilion)
* [[`0c78a2a615`](https://github.com/fibjs/fibjs/commit/0c78a2a615)] - **core, reactor**: refactoring the object recognition model to improve the performance of calling Buffer object member methods.(xicilion)
* [[`5482491e29`](https://github.com/fibjs/fibjs/commit/5482491e29)] - **core, bugfix**: compile error on WIndows.(xicilion)
* [[`90b04aa12a`](https://github.com/fibjs/fibjs/commit/90b04aa12a)] - **core, refactor**: merge allocations of data blocks and BackingStore objects.(xicilion)
* [[`250c3ee5dc`](https://github.com/fibjs/fibjs/commit/250c3ee5dc)] - **core, refactor**: check pointer in getInstance.(xicilion)
* [[`f887fa4e82`](https://github.com/fibjs/fibjs/commit/f887fa4e82)] - **core, refactor**: refactoring getInstance to improve the speed of calling member methods of built-in objects.(xicilion)
* [[`f2ac34ad94`](https://github.com/fibjs/fibjs/commit/f2ac34ad94)] - **core, refactor**: not lock the object before calling the synchronization method.(xicilion)
* [[`7d78fbc2c7`](https://github.com/fibjs/fibjs/commit/7d78fbc2c7)] - **core, refactor**: discontinuation of support for native code to boost running performance.(xicilion)
* [[`0cfa14a463`](https://github.com/fibjs/fibjs/commit/0cfa14a463)] - **core, refactor**: break the script in ~SnapshotJsScope().(xicilion)
* [[`36ea24e4bb`](https://github.com/fibjs/fibjs/commit/36ea24e4bb)] - **core, refactor**: remove EscapableHandleScope in native function.(xicilion)
* [[`7bd598cd9b`](https://github.com/fibjs/fibjs/commit/7bd598cd9b)] - **Isolate, refactor**: refactor isolate to minimize access to thread-local storage.(xicilion)
* [[`0ba556fa7f`](https://github.com/fibjs/fibjs/commit/0ba556fa7f)] - **core, refactor**: expanded memory usage limits.(xicilion)
* [[`594699df10`](https://github.com/fibjs/fibjs/commit/594699df10)] - **Buffer, refactor**: use InstanceOf to detect Buffer type.(xicilion)
* [[`d523eab118`](https://github.com/fibjs/fibjs/commit/d523eab118)] - **Buffer, refactor**: only unwrap Buffer when ArrayBuffer is fully mapped.(xicilion)
* [[`7b07101b94`](https://github.com/fibjs/fibjs/commit/7b07101b94)] - **Buffer, refactor**: compile error on Windows.(xicilion)
* [[`311c41a4aa`](https://github.com/fibjs/fibjs/commit/311c41a4aa)] - **Buffer, refactor**: implement new Buffer(size) and Buffer.length to be compatible with the previous api.(xicilion)
* [[`012a79a2db`](https://github.com/fibjs/fibjs/commit/012a79a2db)] - **Buffer, refactor**: refactor Buffer to inherit from Uint8Array.(xicilion)
* [[`e12db17af7`](https://github.com/fibjs/fibjs/commit/e12db17af7)] - **core, refactor**: use External to keep netive object pointer.(xicilion)
* [[`d305a445d2`](https://github.com/fibjs/fibjs/commit/d305a445d2)] - **crypto, feat**: support undefined in randomBytes.(xicilion)
* [[`62b38177b0`](https://github.com/fibjs/fibjs/commit/62b38177b0)] - **tools, refactor**: change split rule.(xicilion)
* [[`018915a17a`](https://github.com/fibjs/fibjs/commit/018915a17a)] - **docs, refactor**: make it clear that SandBox is an isolation sandbox and not a security sandbox.(xicilion)
* [[`8a50cb1a62`](https://github.com/fibjs/fibjs/commit/8a50cb1a62)] - **ci, refactor**: remove deprecating commands (#758)(PinelliaC)
* [[`0961a987e0`](https://github.com/fibjs/fibjs/commit/0961a987e0)] - **db, refactor**: performance tuning for SQLite.(xicilion)
* [[`f38fe11575`](https://github.com/fibjs/fibjs/commit/f38fe11575)] - **SandBox, refactor**: support require('fs/promises').(xicilion)
* [[`4298510016`](https://github.com/fibjs/fibjs/commit/4298510016)] - **SandBox, refactor**: deprecate the argv argument to SandBox.run.(xicilion)
* [[`c051529be5`](https://github.com/fibjs/fibjs/commit/c051529be5)] - **SandBox, refactor**: modify the parameter order of the module wrapper to be compatible with node.js.(xicilion)
* [[`dbd3041ac7`](https://github.com/fibjs/fibjs/commit/dbd3041ac7)] - **SandBox, bugfix**: cannot find promises module by require("node:fs/promises") on Windows.(xicilion)
* [[`a060c3e0a7`](https://github.com/fibjs/fibjs/commit/a060c3e0a7)] - **SandBox, refactor**: support builtin module's alias with prefix `node:`.(xicilion)
* [[`07ad422e07`](https://github.com/fibjs/fibjs/commit/07ad422e07)] - **core, feat**: support execute scripts in package.json.(xicilion)
* [[`f80980f5dd`](https://github.com/fibjs/fibjs/commit/f80980f5dd)] - **process, bugfix**: missing files.(xicilion)
* [[`320be42336`](https://github.com/fibjs/fibjs/commit/320be42336)] - **process, feat**: support emitWarning.(xicilion)
* [[`22f7f5061a`](https://github.com/fibjs/fibjs/commit/22f7f5061a)] - **test, bugfix**: child_process test error on linux.(xicilion)
* [[`04dec0d131`](https://github.com/fibjs/fibjs/commit/04dec0d131)] - **child_process, refactor**: process error in spawnSync.(xicilion)
* [[`3a0588bb64`](https://github.com/fibjs/fibjs/commit/3a0588bb64)] - **child_process, feat**: support spawnSync.(xicilion)
* [[`fc54e7c38b`](https://github.com/fibjs/fibjs/commit/fc54e7c38b)] - **docs, refactor**: update missing ts files.(xicilion)
* [[`97309cb752`](https://github.com/fibjs/fibjs/commit/97309cb752)] - **child_process, feat**: support inherit mode in execFile.(xicilion)

## 2023-04-10, Version 0.36.0
* **feature** :
    * blst - update to v0.3.10.(xicilion)
    * build:
      - add riscv64 docker file.(xicilion)
      - build for iPhone.(xicilion)
      - compile for iPhone.(xicilion)
      - add apline ppc64 dockerfile.(xicilion)
      - support loong64.(xicilion)
      - update dockerfiles.(xicilion)
      - enable ctrl-c to break build in docker.(xicilion)
      - use current user name in docker.(xicilion)
      - support android in ci.(xicilion)
      - support cross build for android/linux.(xicilion)
      - build alpine in ci.(xicilion)
      - support alipine build.(xicilion)
      - automatically create /usr/local/bin folder during installation.(xicilion)
    * child_process:
      - set the error exit code when the child process is aborted.(xicilion)
      - return process exit code in join. #736(xicilion)
    * ci - support riscv64 ci build.(xicilion)
    * core:
      - support riscv64.(xicilion)
      - process background tasks.(xicilion)
      - support ppc64.(xicilion)
      - type error in WebAssembly.(xicilion)
    * coroutine - support timeout.(xicilion)
    * crypto:
      - support loadPKey.(xicilion)
      - update doc of crypto.(xicilion)
      - update root ca.(xicilion)
      - implement BlaKey.(xicilion)
      - support aggregate on BLS12381_G1/BLS12381_G2.(xicilion)
    * db:
      - support for multi-core concurrent vector queries.(xicilion)
      - support vector search.(xicilion)
      - use system codec in odbc.(xicilion)
    * docs:
      - update docs submodule.(xicilion)
      - building an index of documents and test cases with OpenAI.(xicilion)
      - update doc.(xicilion)
      - update module documents.(xicilion)
      - update docs.(xicilion)
      - update docs.(xicilion)
    * encoding - set binary/latin1 to native codec.(xicilion)
    * exlib - support Apple M1.(xicilion)
    * fs - support fs.write.(xicilion)
    * global - add performance module.(xicilion)
    * http:
      - support http.request(opts).(xicilion)
      - support for ignoring method parameters in http.request.(xicilion)
    * icu - support change TZ/LANG env inside process.(xicilion)
    * msgpack - support Set and Map (#751)(lhkzh)
    * option:
      - to specify the path of package.json, use --target in --install (#756)(PinelliaC)
      - support -e on command line.(xicilion)
      - Use http_proxy to proxy https requests when https_proxy is not set.(xicilion)
      - --install script support uppercase HTTP_PROXY environment variable.(xicilion)
    * options - support * in package.json.(xicilion)
    * os:
      - support os.platform on android.(xicilion)
      - support ppc64.(xicilion)
    * process - support uid/gui in process.(xicilion)
    * repl - support javascript statements beginning with .. in the repl. #738(xicilion)
    * SandBox - support addNativeModule.(xicilion)
    * Sandbox - support builtin module's alias with prefix `fibjs:`.(richardo2016)
    * ssl - automatically load the root certificate at startup.(xicilion)
    * test:
      - add icu test.(xicilion)
      - return test result in test.run.(xicilion)
      - support todo item.(xicilion)
    * uv - update to v1.44.2.(xicilion)
    * v8:
      - update to v11.2.129.(xicilion)
      - support icu.(xicilion)
      - update to v10.9.194.4.(xicilion)
    * vender - update packages.(xicilion)
    * vm - rename `Sandbox::addNativeModule` to `Sandbox::addBuiltinModules`.(richardo2016)
    * xml:
      - support element methods.(xicilion)
      - support XmlNode.children.(xicilion)
    * zip - support codec in ZipFile.(xicilion)

* **bugfix** :
    * build:
      - missing files.(xicilion)
      - compile error in mips64 debug.(xicilion)
      - alpine test error in ci.(xicilion)
      - test error in ci.(xicilion)
      - test docker name error on linux.(响马)
      - fix build error on win32 clang.(richardo2016)
      - build option error in docker on mac.(xicilion)
      - build error in ci.(xicilion)
      - compile error on android.(xicilion)
      - compile warning on Windows.(xicilion)
    * child_process - do not pass environment variables when the variable is undefined.(xicilion)
    * console - unicode characters not supported by the codepage return wrong characters in readline on Windows. #741(xicilion)
    * core:
      - deadlock on backgroud task in worker isolate.(xicilion)
      - deadlock in wasm async compile.(xicilion)
      - create HttpClient when building Isolate to avoid memory access errors caused by dynamic creation.(xicilion)
      - Object.prototype.toString.call(native object) return [object Object].(xicilion)
      - refactor fcntl64.(xicilion)
      - missing include file.(xicilion)
    * crypto - crash when dumping uninitialized X509Cert object.(xicilion)
    * db:
      - fix Redis.incr/decr (#755)(lhkzh)
      - use utf8 codec on windows.(xicilion)
    * docs - update websocket doc (#754)(PinelliaC)
    * exlib - ConditionVariable deadlock.(xicilion)
    * gui - webview missing in macos.(xicilion)
    * hash - keccak384 hash error.(xicilion)
    * http:
      - the abbreviation for file size has been displayed incorrectly. (#757)(PinelliaC)
      - query.all causes wrong memoryUsage count.(xicilion)
      - HttpClient.sslVerification does not working.(xicilion)
      - encoding error when Cookie value in HttpResponse is empty. #743(xicilion)
    * os - result of os.cpus() does not change.(xicilion)
    * process - wasm compiler worker holds fibjs process.(xicilion)
    * repl - The wrong repl path causes require to not reach the modules in the current directory. #735(xicilion)
    * Sandbox - module initialization script timeout will cause fibjs crash.(xicilion)
    * ssl - default client crt and key not work.(xicilion)
    * test:
      - test error in CI.(xicilion)
      - util test error.(xicilion)
      - util test error when compile with gcc.(xicilion)
      - child_process test error in CI.(xicilion)
      - iconv test error in CI.(xicilion)
      - test error in CI.(xicilion)
      - test error in CI.(xicilion)
      - some test error.(xicilion)
      - some test error.(xicilion)
      - getter test error.(xicilion)
    * util - compile error on Windows.(xicilion)
    * uuid - compile error on Linux.(xicilion)
    * uv:
      - link error in debug mode.(xicilion)
      - fix uv issue.(xicilion)
    * v8:
      - v8 crashed when load wasm module on linux x64.(xicilion)
      - compile error in debug mode.(xicilion)
    * vm - missing idl file.(xicilion)
    * xml - release children cause crash.(xicilion)

* **refactor** :
    * BlsKey - assign first point.(xicilion)
    * Buffer:
      - do not assert isolate locker status in Buffer::is_safe_codec.(xicilion)
      - Fix some functions of Buffer for compatibility with node.js. #696(xicilion)
    * build:
      - install xz-utils in alpine-build-env.(xicilion)
      - upgrade ci to ubuntu 20.04.(xicilion)
      - patch powf.(xicilion)
      - use userid in docker.(xicilion)
      - not patch first version of glibc.(xicilion)
      - do not patch math function on loongarch64.(xicilion)
      - change compiler to vec version on loongarch64.(xicilion)
      - compress qemu binary file.(xicilion)
      - refactor docker file for loong64.(xicilion)
      - file mode for qemu on mac.(xicilion)
      - fix glibc_2.17 on arm.(xicilion)
      - update compiler to 8.3.novec for loongarch64.(xicilion)
      - only patch memcpy&time on x86.(xicilion)
      - refactor glibc detect function.(xicilion)
      - fix expf argument type.(xicilion)
      - build loong64 docker image for release.(xicilion)
      - print shared libraries used.(xicilion)
      - detect vc in vs.net.(xicilion)
      - remove out/bin directly in `build clean`.(xicilion)
      - enable CXX compile options.(xicilion)
      - skip iPhone test on ci.(响马)
      - test ubuntu 10.04 only on amd64.(xicilion)
      - add ubuntu 10.04 test in ci.(xicilion)
      - remove arm alpine ci.(xicilion)
      - enable PIC in posix.(xicilion)
      - enable gc-sections link option.(xicilion)
      - compile error on alpine for arm.(xicilion)
      - add i385&arm docker.(xicilion)
      - remove SLOW_DCHECKS option.(xicilion)
      - detect musl compiler.(xicilion)
      - update loong64 dockerfile.(xicilion)
      - revert some comments.(xicilion)
      - set CI env in test.sh.(xicilion)
      - change ci to docker.(xicilion)
      - refactor dockerfiles, support loong64.(xicilion)
      - skip some test in CI.(xicilion)
      - change docker os to ubuntu 18.04.(xicilion)
      - refactor build script.(xicilion)
      - not build gui module when using llvm on mac.(xicilion)
      - map work folder to same path in docker.(xicilion)
      - use ansi code in build script.(xicilion)
      - auto detect brew folder.(xicilion)
    * console - deprecate key&mouse operation.(xicilion)
    * core:
      - PumpMessageLoop only when there are background tasks.(xicilion)
      - use IsJust instead of Check to prevent MeyBe crash.(xicilion)
      - use FromMaybe instead of ToChecked to prevent MeyBe crash.(xicilion)
      - use FromMaybe instead of FromJust to prevent MeyBe crash.(xicilion)
      - use Global.Get to convert Value.(xicilion)
      - use dynamic_cast to check class type of object.(xicilion)
      - init class before first create.(xicilion)
      - remove unused code.(xicilion)
      - use default dcheck error handler.(xicilion)
      - refactor native module list.(xicilion)
      - refactor platform creator.(xicilion)
      - set native async function name.(xicilion)
      - Simplify the delivery of events in callbacks and promises.(xicilion)
    * coroutine:
      - resume task outside of lock.(xicilion)
      - revert Sleep.cancel.(xicilion)
    * crypto:
      - refactor PKey class.(xicilion)
      - compile warning.(xicilion)
      - rename more secp256k1 api name.(xicilion)
    * db:
      - optimizing the database structure for vector search.(xicilion)
      - refactor vector index plugin.(xicilion)
      - use a single table to store indexed data in the vector search plugin.(xicilion)
      - change labeltype type to int32_t.(xicilion)
      - remove fulltext search in sqlite.(xicilion)
      - use PostgreSQL unicode driver.(xicilion)
    * docs:
      - update document for HttpCookie.(xicilion)
      - update docs.(xicilion)
      - update document in idl.(xicilion)
      - update ws docs.(xicilion)
      - update docs.(xicilion)
      - add nl language.(xicilion)
      - update collect.json.(xicilion)
      - use viz.js to render graph.(xicilion)
    * ECCKey - refactor ECCKey.(xicilion)
    * encoding - deprecate custom encode in encoding.json.(xicilion)
    * exlib:
      - refactor context switch on posix.(xicilion)
      - refactor sleep.cancel.(xicilion)
    * gd - enable filter test on loongarch64.(xicilion)
    * global - add URL to global.(xicilion)
    * gui - disable gui on ios.(xicilion)
    * http:
      - add get as an alias for first in HttpCollection.(xicilion)
      - throw error if the connection is closed by peer when Httprequest/HttpResponse readFrom.(xicilion)
      - missing files.(xicilion)
      - support http_proxy and https_proxy in HttpClient.(xicilion)
    * iconv:
      - refactor code.(xicilion)
      - refactor code.(xicilion)
    * icu - support TZ and LANG env on Windows.(xicilion)
    * isolate - refactor code of background task.(xicilion)
    * option - save package.json when update module.(xicilion)
    * options - use JSON.stringify to generate package.json.(xicilion)
    * PKey - refactor ECCKey, separate Ed25519Key.(xicilion)
    * process:
      - use uv to set os env.(xicilion)
      - reset thread signal mask.(xicilion)
    * SandBox:
      - refactor repl.(xicilion)
      - deprecate SandBox.refresh.(xicilion)
    * sandbox - support relative path in internal script.(xicilion)
    * test:
      - test of wasm load crash.(xicilion)
      - use different name in selfzip test.(xicilion)
      - os test fail on ubuntu 10.04.(xicilion)
      - remove console.keyDown case.(xicilion)
      - skip unsupported tests.(xicilion)
      - change gb2312 to EUC-JP in test.(xicilion)
      - hide ignored items in normal mode.(xicilion)
      - stable os.cpus tests.(xicilion)
      - deprecated setting loglevel in test.(xicilion)
      - change http test url.(xicilion)
    * tools:
      - update fib-spliter to v1.4.0.(xicilion)
      - change document index table name.(xicilion)
      - update fib-spliter.(xicilion)
      - remove unused prompt.(xicilion)
      - update prompt to avoid unexpected question.(xicilion)
      - update prompt for ask.(xicilion)
      - optimize document indexing and disable useless fragments.(xicilion)
      - format docs hash json file.(xicilion)
      - use devtools to translate docs.(xicilion)
    * url - keep other variables in sync when setting host, hostname and port.(xicilion)
    * util - add icu version.(xicilion)
    * v8:
      - revert to 10.9.194.9.(xicilion)
      - disable code gc in wasm.(xicilion)
    * xml:
      - set ownerDocument tp child Nodes.(xicilion)
      - init m_document.(xicilion)
      - move TextContext to XmlNode.(xicilion)

* **others** :
    * Merge branch 'dev' of github.com - fibjs/fibjs into dev(xicilion)
    * Merge remote-tracking branch 'origin/dev' into dev(xicilion)
    * Merge remote-tracking branch 'origin/dev' into dev(xicilion)
    * Merge remote-tracking branch 'origin/dev' into dev(xicilion)
    * v0.37.0-dev.(xicilion)
    * Release 0.36.0.(xicilion)
    * Merge remote-tracking branch 'origin/dev' into dev(xicilion)

* **refator** :
    * build - fix GLIBC_2.27 issue.(xicilion)

* **bigfix** :
    * build - compile warning and runtime error in debug mode.(xicilion)

### Commits
* [[`fb770ed822`](https://github.com/fibjs/fibjs/commit/fb770ed822)] - **v8, bugfix**: v8 crashed when load wasm module on linux x64.(xicilion)
* [[`939235436b`](https://github.com/fibjs/fibjs/commit/939235436b)] - **tools, refactor**: update fib-spliter to v1.4.0.(xicilion)
* [[`9134f642b4`](https://github.com/fibjs/fibjs/commit/9134f642b4)] - **docs, refactor**: update document for HttpCookie.(xicilion)
* [[`e84b7036d3`](https://github.com/fibjs/fibjs/commit/e84b7036d3)] - **tools, refactor**: change document index table name.(xicilion)
* [[`7875ba8a4c`](https://github.com/fibjs/fibjs/commit/7875ba8a4c)] - **http, refactor**: add get as an alias for first in HttpCollection.(xicilion)
* [[`7fb22f0eab`](https://github.com/fibjs/fibjs/commit/7fb22f0eab)] - **tools, refactor**: update fib-spliter.(xicilion)
* [[`2c12f0cf5e`](https://github.com/fibjs/fibjs/commit/2c12f0cf5e)] - **http, refactor**: throw error if the connection is closed by peer when Httprequest/HttpResponse readFrom.(xicilion)
* [[`3dddcccaa9`](https://github.com/fibjs/fibjs/commit/3dddcccaa9)] - **docs, refactor**: update docs.(xicilion)
* [[`868507eb15`](https://github.com/fibjs/fibjs/commit/868507eb15)] - **docs, feat**: update docs submodule.(xicilion)
* [[`64999c0473`](https://github.com/fibjs/fibjs/commit/64999c0473)] - **docs, refactor**: update document in idl.(xicilion)
* [[`1da5183482`](https://github.com/fibjs/fibjs/commit/1da5183482)] - **build, refactor**: install xz-utils in alpine-build-env.(xicilion)
* [[`25540eb6df`](https://github.com/fibjs/fibjs/commit/25540eb6df)] - **tools, refactor**: remove unused prompt.(xicilion)
* [[`eaf07530c6`](https://github.com/fibjs/fibjs/commit/eaf07530c6)] - **tools, refactor**: update prompt to avoid unexpected question.(xicilion)
* [[`f2d3543640`](https://github.com/fibjs/fibjs/commit/f2d3543640)] - **tools, refactor**: update prompt for ask.(xicilion)
* [[`8b4869f32f`](https://github.com/fibjs/fibjs/commit/8b4869f32f)] - **tools, refactor**: optimize document indexing and disable useless fragments.(xicilion)
* [[`a80336feff`](https://github.com/fibjs/fibjs/commit/a80336feff)] - **docs, feat**: building an index of documents and test cases with OpenAI.(xicilion)
* [[`cebf95fe8e`](https://github.com/fibjs/fibjs/commit/cebf95fe8e)] - **docs, feat**: update doc.(xicilion)
* [[`08aa0d58a7`](https://github.com/fibjs/fibjs/commit/08aa0d58a7)] - **db, refactor**: optimizing the database structure for vector search.(xicilion)
* [[`852c79f214`](https://github.com/fibjs/fibjs/commit/852c79f214)] - **db, feat**: support for multi-core concurrent vector queries.(xicilion)
* [[`209fe50df5`](https://github.com/fibjs/fibjs/commit/209fe50df5)] - **ci, feat**: support riscv64 ci build.(xicilion)
* [[`91737af6f0`](https://github.com/fibjs/fibjs/commit/91737af6f0)] - **build, feat**: add riscv64 docker file.(xicilion)
* [[`9de7187022`](https://github.com/fibjs/fibjs/commit/9de7187022)] - **core, feat**: support riscv64.(xicilion)
* [[`3633d7a598`](https://github.com/fibjs/fibjs/commit/3633d7a598)] - **build, refactor**: upgrade ci to ubuntu 20.04.(xicilion)
* [[`cee2e2f583`](https://github.com/fibjs/fibjs/commit/cee2e2f583)] - **db, refactor**: refactor vector index plugin.(xicilion)
* [[`d7dd7fb6c3`](https://github.com/fibjs/fibjs/commit/d7dd7fb6c3)] - **db, refactor**: use a single table to store indexed data in the vector search plugin.(xicilion)
* [[`cd98bebb29`](https://github.com/fibjs/fibjs/commit/cd98bebb29)] - **db, refactor**: change labeltype type to int32_t.(xicilion)
* [[`0523387b79`](https://github.com/fibjs/fibjs/commit/0523387b79)] - **db, feat**: support vector search.(xicilion)
* [[`9fdc80f364`](https://github.com/fibjs/fibjs/commit/9fdc80f364)] - **crypto, feat**: support loadPKey.(xicilion)
* [[`90e1d9c8ff`](https://github.com/fibjs/fibjs/commit/90e1d9c8ff)] - **test, bugfix**: test error in CI.(xicilion)
* [[`8886e3e1f4`](https://github.com/fibjs/fibjs/commit/8886e3e1f4)] - **zip, feat**: support codec in ZipFile.(xicilion)
* [[`ca16c7fb57`](https://github.com/fibjs/fibjs/commit/ca16c7fb57)] - **xml, refactor**: set ownerDocument tp child Nodes.(xicilion)
* [[`34a30535ef`](https://github.com/fibjs/fibjs/commit/34a30535ef)] - **xml, refactor**: init m_document.(xicilion)
* [[`585a80c1e5`](https://github.com/fibjs/fibjs/commit/585a80c1e5)] - **xml, refactor**: move TextContext to XmlNode.(xicilion)
* [[`5c9a01577a`](https://github.com/fibjs/fibjs/commit/5c9a01577a)] - **xml, bugfix**: release children cause crash.(xicilion)
* [[`cc3001684e`](https://github.com/fibjs/fibjs/commit/cc3001684e)] - **http, bugfix**: the abbreviation for file size has been displayed incorrectly. (#757)(PinelliaC)
* [[`9ec2832c56`](https://github.com/fibjs/fibjs/commit/9ec2832c56)] - **xml, feat**: support element methods.(xicilion)
* [[`ade605171f`](https://github.com/fibjs/fibjs/commit/ade605171f)] - **xml, feat**: support XmlNode.children.(xicilion)
* [[`cd3e5917e5`](https://github.com/fibjs/fibjs/commit/cd3e5917e5)] - **global, refactor**: add URL to global.(xicilion)
* [[`f730008a57`](https://github.com/fibjs/fibjs/commit/f730008a57)] - Merge remote-tracking branch 'origin/dev' into dev(xicilion)
* [[`194b585686`](https://github.com/fibjs/fibjs/commit/194b585686)] - **docs, refactor**: update ws docs.(xicilion)
* [[`b3eebcdfef`](https://github.com/fibjs/fibjs/commit/b3eebcdfef)] - **options, feat**: support * in package.json.(xicilion)
* [[`7a4cfbefa7`](https://github.com/fibjs/fibjs/commit/7a4cfbefa7)] - **sandbox, refactor**: support relative path in internal script.(xicilion)
* [[`971acea875`](https://github.com/fibjs/fibjs/commit/971acea875)] - **core, refactor**: PumpMessageLoop only when there are background tasks.(xicilion)
* [[`3188324aba`](https://github.com/fibjs/fibjs/commit/3188324aba)] - **core, bugfix**: deadlock on backgroud task in worker isolate.(xicilion)
* [[`66b4d90af5`](https://github.com/fibjs/fibjs/commit/66b4d90af5)] - **isolate, refactor**: refactor code of background task.(xicilion)
* [[`1611981f72`](https://github.com/fibjs/fibjs/commit/1611981f72)] - **core, bugfix**: deadlock in wasm async compile.(xicilion)
* [[`2b426aef2f`](https://github.com/fibjs/fibjs/commit/2b426aef2f)] - Merge remote-tracking branch 'origin/dev' into dev(xicilion)
* [[`ef270ca10d`](https://github.com/fibjs/fibjs/commit/ef270ca10d)] - **core, feat**: process background tasks.(xicilion)
* [[`89349dcce9`](https://github.com/fibjs/fibjs/commit/89349dcce9)] - **test, refactor**: test of wasm load crash.(xicilion)
* [[`2805641941`](https://github.com/fibjs/fibjs/commit/2805641941)] - **http, refactor**: missing files.(xicilion)
* [[`ae8d599746`](https://github.com/fibjs/fibjs/commit/ae8d599746)] - **http, refactor**: support http_proxy and https_proxy in HttpClient.(xicilion)
* [[`3a2976d7d1`](https://github.com/fibjs/fibjs/commit/3a2976d7d1)] - **build, bugfix**: missing files.(xicilion)
* [[`ee4f6d5a3a`](https://github.com/fibjs/fibjs/commit/ee4f6d5a3a)] - **url, refactor**: keep other variables in sync when setting host, hostname and port.(xicilion)
* [[`ea8e92c39c`](https://github.com/fibjs/fibjs/commit/ea8e92c39c)] - **http, feat**: support http.request(opts).(xicilion)
* [[`ae15d579ef`](https://github.com/fibjs/fibjs/commit/ae15d579ef)] - **http, feat**: support for ignoring method parameters in http.request.(xicilion)
* [[`37d8d19c52`](https://github.com/fibjs/fibjs/commit/37d8d19c52)] - **core, refactor**: use IsJust instead of Check to prevent MeyBe crash.(xicilion)
* [[`e11a2d0ef8`](https://github.com/fibjs/fibjs/commit/e11a2d0ef8)] - Merge remote-tracking branch 'origin/dev' into dev(xicilion)
* [[`fe2e314e76`](https://github.com/fibjs/fibjs/commit/fe2e314e76)] - **docs, feat**: update module documents.(xicilion)
* [[`440c8fb67a`](https://github.com/fibjs/fibjs/commit/440c8fb67a)] - **core, refactor**: use FromMaybe instead of ToChecked to prevent MeyBe crash.(xicilion)
* [[`e0011153cc`](https://github.com/fibjs/fibjs/commit/e0011153cc)] - **core, refactor**: use FromMaybe instead of FromJust to prevent MeyBe crash.(xicilion)
* [[`e23c0e12fb`](https://github.com/fibjs/fibjs/commit/e23c0e12fb)] - **exlib, refactor**: refactor context switch on posix.(xicilion)
* [[`eced2f947c`](https://github.com/fibjs/fibjs/commit/eced2f947c)] - **v8, refactor**: revert to 10.9.194.9.(xicilion)
* [[`f418e1b749`](https://github.com/fibjs/fibjs/commit/f418e1b749)] - **v8, refactor**: disable code gc in wasm.(xicilion)
* [[`0a9ca0dc84`](https://github.com/fibjs/fibjs/commit/0a9ca0dc84)] - **build, refactor**: patch powf.(xicilion)
* [[`285d656db5`](https://github.com/fibjs/fibjs/commit/285d656db5)] - **build, bugfix**: compile error in mips64 debug.(xicilion)
* [[`9b675a1d92`](https://github.com/fibjs/fibjs/commit/9b675a1d92)] - **build, refactor**: use userid in docker.(xicilion)
* [[`9bcbbc03ee`](https://github.com/fibjs/fibjs/commit/9bcbbc03ee)] - **v8, bugfix**: compile error in debug mode.(xicilion)
* [[`3cedc77065`](https://github.com/fibjs/fibjs/commit/3cedc77065)] - **v8, feat**: update to v11.2.129.(xicilion)
* [[`52888f3ab5`](https://github.com/fibjs/fibjs/commit/52888f3ab5)] - v0.37.0-dev.(xicilion)
* [[`f68b575150`](https://github.com/fibjs/fibjs/commit/f68b575150)] - Release 0.36.0.(xicilion)
* [[`1379403f96`](https://github.com/fibjs/fibjs/commit/1379403f96)] - **option, feat**: to specify the path of package.json, use --target in --install (#756)(PinelliaC)
* [[`4c3a5a6754`](https://github.com/fibjs/fibjs/commit/4c3a5a6754)] - **gd, refactor**: enable filter test on loongarch64.(xicilion)
* [[`dd4686ab02`](https://github.com/fibjs/fibjs/commit/dd4686ab02)] - **build, refactor**: not patch first version of glibc.(xicilion)
* [[`013b88c9cb`](https://github.com/fibjs/fibjs/commit/013b88c9cb)] - **build, refactor**: do not patch math function on loongarch64.(xicilion)
* [[`40e07c6e6b`](https://github.com/fibjs/fibjs/commit/40e07c6e6b)] - **build, refactor**: change compiler to vec version on loongarch64.(xicilion)
* [[`7fb3a848c4`](https://github.com/fibjs/fibjs/commit/7fb3a848c4)] - **db, bugfix**: fix Redis.incr/decr (#755)(lhkzh)
* [[`13e94d63ec`](https://github.com/fibjs/fibjs/commit/13e94d63ec)] - **core, bugfix**: create HttpClient when building Isolate to avoid memory access errors caused by dynamic creation.(xicilion)
* [[`eb8c20c643`](https://github.com/fibjs/fibjs/commit/eb8c20c643)] - **docs, feat**: update docs.(xicilion)
* [[`04141000a1`](https://github.com/fibjs/fibjs/commit/04141000a1)] - **child_process, feat**: set the error exit code when the child process is aborted.(xicilion)
* [[`72d179e35f`](https://github.com/fibjs/fibjs/commit/72d179e35f)] - **docs, bugfix**: update websocket doc (#754)(PinelliaC)
* [[`8d216fe155`](https://github.com/fibjs/fibjs/commit/8d216fe155)] - **docs, refactor**: update docs.(xicilion)
* [[`630c47822b`](https://github.com/fibjs/fibjs/commit/630c47822b)] - **docs, refactor**: add nl language.(xicilion)
* [[`df892fec6b`](https://github.com/fibjs/fibjs/commit/df892fec6b)] - **tools, refactor**: format docs hash json file.(xicilion)
* [[`6b53042314`](https://github.com/fibjs/fibjs/commit/6b53042314)] - **build, refactor**: compress qemu binary file.(xicilion)
* [[`5ed783e598`](https://github.com/fibjs/fibjs/commit/5ed783e598)] - **build, refactor**: refactor docker file for loong64.(xicilion)
* [[`c5b12c534f`](https://github.com/fibjs/fibjs/commit/c5b12c534f)] - **build, refactor**: file mode for qemu on mac.(xicilion)
* [[`917a463827`](https://github.com/fibjs/fibjs/commit/917a463827)] - **build, refactor**: fix glibc_2.17 on arm.(xicilion)
* [[`4b07e6e758`](https://github.com/fibjs/fibjs/commit/4b07e6e758)] - **build, refactor**: update compiler to 8.3.novec for loongarch64.(xicilion)
* [[`067183f043`](https://github.com/fibjs/fibjs/commit/067183f043)] - **build, refactor**: only patch memcpy&time on x86.(xicilion)
* [[`542383d9a6`](https://github.com/fibjs/fibjs/commit/542383d9a6)] - **build, refactor**: refactor glibc detect function.(xicilion)
* [[`a151ddd598`](https://github.com/fibjs/fibjs/commit/a151ddd598)] - **build, refactor**: fix expf argument type.(xicilion)
* [[`6b5451036d`](https://github.com/fibjs/fibjs/commit/6b5451036d)] - **option, refactor**: save package.json when update module.(xicilion)
* [[`894334f331`](https://github.com/fibjs/fibjs/commit/894334f331)] - **build, refactor**: build loong64 docker image for release.(xicilion)
* [[`4bc90a40b6`](https://github.com/fibjs/fibjs/commit/4bc90a40b6)] - **build, refactor**: print shared libraries used.(xicilion)
* [[`4456b3de6e`](https://github.com/fibjs/fibjs/commit/4456b3de6e)] - **tools, refactor**: use devtools to translate docs.(xicilion)
* [[`3fc3722255`](https://github.com/fibjs/fibjs/commit/3fc3722255)] - **crypto, feat**: update doc of crypto.(xicilion)
* [[`bdd5f944af`](https://github.com/fibjs/fibjs/commit/bdd5f944af)] - **crypto, feat**: update root ca.(xicilion)
* [[`40f96eedac`](https://github.com/fibjs/fibjs/commit/40f96eedac)] - **build, refactor**: detect vc in vs.net.(xicilion)
* [[`5ca9be48bb`](https://github.com/fibjs/fibjs/commit/5ca9be48bb)] - **build, refactor**: remove out/bin directly in `build clean`.(xicilion)
* [[`25627df46d`](https://github.com/fibjs/fibjs/commit/25627df46d)] - **uuid, bugfix**: compile error on Linux.(xicilion)
* [[`bd04ddd34f`](https://github.com/fibjs/fibjs/commit/bd04ddd34f)] - **build, feat**: build for iPhone.(xicilion)
* [[`88b7903933`](https://github.com/fibjs/fibjs/commit/88b7903933)] - **build, refactor**: enable CXX compile options.(xicilion)
* [[`09ec22794b`](https://github.com/fibjs/fibjs/commit/09ec22794b)] - **os, feat**: support os.platform on android.(xicilion)
* [[`6c8c19e785`](https://github.com/fibjs/fibjs/commit/6c8c19e785)] - **BlsKey, refactor**: assign first point.(xicilion)
* [[`25104043b6`](https://github.com/fibjs/fibjs/commit/25104043b6)] - **crypto, feat**: implement BlaKey.(xicilion)
* [[`d6d49c10da`](https://github.com/fibjs/fibjs/commit/d6d49c10da)] - **ECCKey, refactor**: refactor ECCKey.(xicilion)
* [[`fde99ef6be`](https://github.com/fibjs/fibjs/commit/fde99ef6be)] - **docs, refactor**: update collect.json.(xicilion)
* [[`39f899ef5e`](https://github.com/fibjs/fibjs/commit/39f899ef5e)] - **PKey, refactor**: refactor ECCKey, separate Ed25519Key.(xicilion)
* [[`81a93fdff6`](https://github.com/fibjs/fibjs/commit/81a93fdff6)] - **process, refactor**: use uv to set os env.(xicilion)
* [[`cbef657464`](https://github.com/fibjs/fibjs/commit/cbef657464)] - **crypto, refactor**: refactor PKey class.(xicilion)
* [[`14228072ac`](https://github.com/fibjs/fibjs/commit/14228072ac)] - **core, refactor**: use Global.Get to convert Value.(xicilion)
* [[`393812a202`](https://github.com/fibjs/fibjs/commit/393812a202)] - **SandBox, refactor**: refactor repl.(xicilion)
* [[`ca6e65a121`](https://github.com/fibjs/fibjs/commit/ca6e65a121)] - **core, bugfix**: Object.prototype.toString.call(native object) return [object Object].(xicilion)
* [[`4cffff9741`](https://github.com/fibjs/fibjs/commit/4cffff9741)] - **test, refactor**: use different name in selfzip test.(xicilion)
* [[`19207ca7c1`](https://github.com/fibjs/fibjs/commit/19207ca7c1)] - **build, refactor**: skip iPhone test on ci.(响马)
* [[`95ed0141cb`](https://github.com/fibjs/fibjs/commit/95ed0141cb)] - **build, refactor**: test ubuntu 10.04 only on amd64.(xicilion)
* [[`34287e9c07`](https://github.com/fibjs/fibjs/commit/34287e9c07)] - **test, refactor**: os test fail on ubuntu 10.04.(xicilion)
* [[`1852240a01`](https://github.com/fibjs/fibjs/commit/1852240a01)] - **build, refactor**: add ubuntu 10.04 test in ci.(xicilion)
* [[`b312b02245`](https://github.com/fibjs/fibjs/commit/b312b02245)] - **msgpack, feat**: support Set and Map (#751)(lhkzh)
* [[`e020ab3329`](https://github.com/fibjs/fibjs/commit/e020ab3329)] - **build, refactor**: remove arm alpine ci.(xicilion)
* [[`34db5c9442`](https://github.com/fibjs/fibjs/commit/34db5c9442)] - **build, refactor**: enable PIC in posix.(xicilion)
* [[`b90c114508`](https://github.com/fibjs/fibjs/commit/b90c114508)] - **uv, bugfix**: link error in debug mode.(xicilion)
* [[`69e166480c`](https://github.com/fibjs/fibjs/commit/69e166480c)] - **icu, feat**: support change TZ/LANG env inside process.(xicilion)
* [[`6e407d5cf8`](https://github.com/fibjs/fibjs/commit/6e407d5cf8)] - **iconv, refactor**: refactor code.(xicilion)
* [[`105cf9558f`](https://github.com/fibjs/fibjs/commit/105cf9558f)] - **iconv, refactor**: refactor code.(xicilion)
* [[`3b743854e7`](https://github.com/fibjs/fibjs/commit/3b743854e7)] - **util, bugfix**: compile error on Windows.(xicilion)
* [[`31dff6d899`](https://github.com/fibjs/fibjs/commit/31dff6d899)] - **uv, bugfix**: fix uv issue.(xicilion)
* [[`0fb9a61577`](https://github.com/fibjs/fibjs/commit/0fb9a61577)] - **vender, feat**: update packages.(xicilion)
* [[`09736b8ccd`](https://github.com/fibjs/fibjs/commit/09736b8ccd)] - **uv, feat**: update to v1.44.2.(xicilion)
* [[`c86a015eb4`](https://github.com/fibjs/fibjs/commit/c86a015eb4)] - **util, refactor**: add icu version.(xicilion)
* [[`1339429c07`](https://github.com/fibjs/fibjs/commit/1339429c07)] - **icu, refactor**: support TZ and LANG env on Windows.(xicilion)
* [[`58d9f585f1`](https://github.com/fibjs/fibjs/commit/58d9f585f1)] - **build, refator**: fix GLIBC_2.27 issue.(xicilion)
* [[`c1e8169bc4`](https://github.com/fibjs/fibjs/commit/c1e8169bc4)] - **test, feat**: add icu test.(xicilion)
* [[`ebbbc90baa`](https://github.com/fibjs/fibjs/commit/ebbbc90baa)] - **option, feat**: support -e on command line.(xicilion)
* [[`e9efa07259`](https://github.com/fibjs/fibjs/commit/e9efa07259)] - **core, refactor**: use dynamic_cast to check class type of object.(xicilion)
* [[`a9384c8e25`](https://github.com/fibjs/fibjs/commit/a9384c8e25)] - **build, refactor**: enable gc-sections link option.(xicilion)
* [[`bd7ae9f15c`](https://github.com/fibjs/fibjs/commit/bd7ae9f15c)] - **v8, feat**: support icu.(xicilion)
* [[`1596f13298`](https://github.com/fibjs/fibjs/commit/1596f13298)] - **db, refactor**: remove fulltext search in sqlite.(xicilion)
* [[`cc15203d9c`](https://github.com/fibjs/fibjs/commit/cc15203d9c)] - **build, refactor**: compile error on alpine for arm.(xicilion)
* [[`1fc1008a5a`](https://github.com/fibjs/fibjs/commit/1fc1008a5a)] - **gui, bugfix**: webview missing in macos.(xicilion)
* [[`738d954087`](https://github.com/fibjs/fibjs/commit/738d954087)] - **test, refactor**: remove console.keyDown case.(xicilion)
* [[`c2e7f8ce13`](https://github.com/fibjs/fibjs/commit/c2e7f8ce13)] - **build, feat**: compile for iPhone.(xicilion)
* [[`a512d63b13`](https://github.com/fibjs/fibjs/commit/a512d63b13)] - **gui, refactor**: disable gui on ios.(xicilion)
* [[`2c00b695aa`](https://github.com/fibjs/fibjs/commit/2c00b695aa)] - **build, refactor**: add i385&arm docker.(xicilion)
* [[`c6aaa7ee06`](https://github.com/fibjs/fibjs/commit/c6aaa7ee06)] - **console, refactor**: deprecate key&mouse operation.(xicilion)
* [[`a48f63b015`](https://github.com/fibjs/fibjs/commit/a48f63b015)] - **process, refactor**: reset thread signal mask.(xicilion)
* [[`878aecd995`](https://github.com/fibjs/fibjs/commit/878aecd995)] - **core, refactor**: init class before first create.(xicilion)
* [[`a35bc2dafd`](https://github.com/fibjs/fibjs/commit/a35bc2dafd)] - **build, bugfix**: alpine test error in ci.(xicilion)
* [[`f86260ec52`](https://github.com/fibjs/fibjs/commit/f86260ec52)] - **Sandbox, bugfix**: module initialization script timeout will cause fibjs crash.(xicilion)
* [[`e36cc83abd`](https://github.com/fibjs/fibjs/commit/e36cc83abd)] - **build, refactor**: remove SLOW_DCHECKS option.(xicilion)
* [[`e7ef8fe2d5`](https://github.com/fibjs/fibjs/commit/e7ef8fe2d5)] - **build, bugfix**: test error in ci.(xicilion)
* [[`f26e89f035`](https://github.com/fibjs/fibjs/commit/f26e89f035)] - **build, refactor**: detect musl compiler.(xicilion)
* [[`d418ff8eb7`](https://github.com/fibjs/fibjs/commit/d418ff8eb7)] - **encoding, refactor**: deprecate custom encode in encoding.json.(xicilion)
* [[`22056b69cd`](https://github.com/fibjs/fibjs/commit/22056b69cd)] - **core, refactor**: remove unused code.(xicilion)
* [[`b7dc7eef04`](https://github.com/fibjs/fibjs/commit/b7dc7eef04)] - **core, refactor**: use default dcheck error handler.(xicilion)
* [[`5e0b9f1306`](https://github.com/fibjs/fibjs/commit/5e0b9f1306)] - **build, bigfix**: compile warning and runtime error in debug mode.(xicilion)
* [[`e5e44cd803`](https://github.com/fibjs/fibjs/commit/e5e44cd803)] - **hash, bugfix**: keccak384 hash error.(xicilion)
* [[`c2220e6549`](https://github.com/fibjs/fibjs/commit/c2220e6549)] - **build, refactor**: update loong64 dockerfile.(xicilion)
* [[`e887fbd536`](https://github.com/fibjs/fibjs/commit/e887fbd536)] - **Buffer, refactor**: do not assert isolate locker status in Buffer::is_safe_codec.(xicilion)
* [[`e9d6410160`](https://github.com/fibjs/fibjs/commit/e9d6410160)] - **build, refactor**: revert some comments.(xicilion)
* [[`4afa4ac790`](https://github.com/fibjs/fibjs/commit/4afa4ac790)] - **build, feat**: add apline ppc64 dockerfile.(xicilion)
* [[`438dc1ab6c`](https://github.com/fibjs/fibjs/commit/438dc1ab6c)] - **build, refactor**: set CI env in test.sh.(xicilion)
* [[`4395fc6c38`](https://github.com/fibjs/fibjs/commit/4395fc6c38)] - **build, feat**: support loong64.(xicilion)
* [[`e42df18f94`](https://github.com/fibjs/fibjs/commit/e42df18f94)] - **build, bugfix**: test docker name error on linux.(响马)
* [[`b71f7d8a1c`](https://github.com/fibjs/fibjs/commit/b71f7d8a1c)] - **build, refactor**: change ci to docker.(xicilion)
* [[`c077329dba`](https://github.com/fibjs/fibjs/commit/c077329dba)] - **build, refactor**: refactor dockerfiles, support loong64.(xicilion)
* [[`0a392fe8d1`](https://github.com/fibjs/fibjs/commit/0a392fe8d1)] - **process, feat**: support uid/gui in process.(xicilion)
* [[`92d5d8c2bb`](https://github.com/fibjs/fibjs/commit/92d5d8c2bb)] - **build, feat**: update dockerfiles.(xicilion)
* [[`0f8b328a73`](https://github.com/fibjs/fibjs/commit/0f8b328a73)] - **test, refactor**: skip unsupported tests.(xicilion)
* [[`75727a8792`](https://github.com/fibjs/fibjs/commit/75727a8792)] - **test, bugfix**: util test error.(xicilion)
* [[`853f972079`](https://github.com/fibjs/fibjs/commit/853f972079)] - **test, bugfix**: util test error when compile with gcc.(xicilion)
* [[`2f2ef490ee`](https://github.com/fibjs/fibjs/commit/2f2ef490ee)] - **test, refactor**: change gb2312 to EUC-JP in test.(xicilion)
* [[`59642cc40c`](https://github.com/fibjs/fibjs/commit/59642cc40c)] - **build, refactor**: skip some test in CI.(xicilion)
* [[`aa9ba9366c`](https://github.com/fibjs/fibjs/commit/aa9ba9366c)] - **child_process, bugfix**: do not pass environment variables when the variable is undefined.(xicilion)
* [[`a50a6858bd`](https://github.com/fibjs/fibjs/commit/a50a6858bd)] - **test, bugfix**: child_process test error in CI.(xicilion)
* [[`9168703da3`](https://github.com/fibjs/fibjs/commit/9168703da3)] - **test, bugfix**: iconv test error in CI.(xicilion)
* [[`66ca55d383`](https://github.com/fibjs/fibjs/commit/66ca55d383)] - **encoding, feat**: set binary/latin1 to native codec.(xicilion)
* [[`0dbce21d05`](https://github.com/fibjs/fibjs/commit/0dbce21d05)] - **test, bugfix**: test error in CI.(xicilion)
* [[`c875c6428e`](https://github.com/fibjs/fibjs/commit/c875c6428e)] - **test, bugfix**: test error in CI.(xicilion)
* [[`1fd2e3b94a`](https://github.com/fibjs/fibjs/commit/1fd2e3b94a)] - **test, bugfix**: some test error.(xicilion)
* [[`3a9fb60928`](https://github.com/fibjs/fibjs/commit/3a9fb60928)] - **test, bugfix**: some test error.(xicilion)
* [[`d79e46bd9d`](https://github.com/fibjs/fibjs/commit/d79e46bd9d)] - **exlib, feat**: support Apple M1.(xicilion)
* [[`17a2c7251b`](https://github.com/fibjs/fibjs/commit/17a2c7251b)] - **os, feat**: support ppc64.(xicilion)
* [[`c8cb277111`](https://github.com/fibjs/fibjs/commit/c8cb277111)] - **core, bugfix**: refactor fcntl64.(xicilion)
* [[`c3dfa7110e`](https://github.com/fibjs/fibjs/commit/c3dfa7110e)] - **core, feat**: support ppc64.(xicilion)
* [[`987aa5b100`](https://github.com/fibjs/fibjs/commit/987aa5b100)] - **v8, feat**: update to v10.9.194.4.(xicilion)
* [[`b5416dd152`](https://github.com/fibjs/fibjs/commit/b5416dd152)] - **crypto, refactor**: compile warning.(xicilion)
* [[`7480ba5486`](https://github.com/fibjs/fibjs/commit/7480ba5486)] - **ssl, bugfix**: default client crt and key not work.(xicilion)
* [[`7c5f4bb35d`](https://github.com/fibjs/fibjs/commit/7c5f4bb35d)] - **http, bugfix**: query.all causes wrong memoryUsage count.(xicilion)
* [[`06869e1ef3`](https://github.com/fibjs/fibjs/commit/06869e1ef3)] - **test, refactor**: hide ignored items in normal mode.(xicilion)
* [[`1d1a4fd9be`](https://github.com/fibjs/fibjs/commit/1d1a4fd9be)] - **build, refactor**: change docker os to ubuntu 18.04.(xicilion)
* [[`f337abcd2b`](https://github.com/fibjs/fibjs/commit/f337abcd2b)] - **build, refactor**: refactor build script.(xicilion)
* [[`3bdac1fb3f`](https://github.com/fibjs/fibjs/commit/3bdac1fb3f)] - **test, refactor**: stable os.cpus tests.(xicilion)
* [[`bfeccc6879`](https://github.com/fibjs/fibjs/commit/bfeccc6879)] - **SandBox, refactor**: deprecate SandBox.refresh.(xicilion)
* [[`8b54b5b8d0`](https://github.com/fibjs/fibjs/commit/8b54b5b8d0)] - Merge remote-tracking branch 'origin/dev' into dev(xicilion)
* [[`4657268096`](https://github.com/fibjs/fibjs/commit/4657268096)] - **os, bugfix**: result of os.cpus() does not change.(xicilion)
* [[`58b681ebfc`](https://github.com/fibjs/fibjs/commit/58b681ebfc)] - **ssl, feat**: automatically load the root certificate at startup.(xicilion)
* [[`61d60a1347`](https://github.com/fibjs/fibjs/commit/61d60a1347)] - **Sandbox, feat**: support builtin module's alias with prefix `fibjs:`.(richardo2016)
* [[`f0232f1175`](https://github.com/fibjs/fibjs/commit/f0232f1175)] - **vm, feat**: rename `Sandbox::addNativeModule` to `Sandbox::addBuiltinModules`.(richardo2016)
* [[`37eb225ebd`](https://github.com/fibjs/fibjs/commit/37eb225ebd)] - **blst, feat**: update to v0.3.10.(xicilion)
* [[`13eaa0bdfc`](https://github.com/fibjs/fibjs/commit/13eaa0bdfc)] - **build, refactor**: not build gui module when using llvm on mac.(xicilion)
* [[`4a756c2f97`](https://github.com/fibjs/fibjs/commit/4a756c2f97)] - **build, bugfix**: fix build error on win32 clang.(richardo2016)
* [[`921877a3a6`](https://github.com/fibjs/fibjs/commit/921877a3a6)] - **Merge branch 'dev' of github.com**: fibjs/fibjs into dev(xicilion)
* [[`6e6ddedc10`](https://github.com/fibjs/fibjs/commit/6e6ddedc10)] - **build, refactor**: map work folder to same path in docker.(xicilion)
* [[`1de4558f16`](https://github.com/fibjs/fibjs/commit/1de4558f16)] - **http, bugfix**: HttpClient.sslVerification does not working.(xicilion)
* [[`102655ed41`](https://github.com/fibjs/fibjs/commit/102655ed41)] - **build, bugfix**: build option error in docker on mac.(xicilion)
* [[`efd870340e`](https://github.com/fibjs/fibjs/commit/efd870340e)] - **build, feat**: enable ctrl-c to break build in docker.(xicilion)
* [[`7808079934`](https://github.com/fibjs/fibjs/commit/7808079934)] - **build, feat**: use current user name in docker.(xicilion)
* [[`f91648f013`](https://github.com/fibjs/fibjs/commit/f91648f013)] - **build, feat**: support android in ci.(xicilion)
* [[`4fae38cc45`](https://github.com/fibjs/fibjs/commit/4fae38cc45)] - **build, bugfix**: build error in ci.(xicilion)
* [[`d6b61213af`](https://github.com/fibjs/fibjs/commit/d6b61213af)] - **build, bugfix**: compile error on android.(xicilion)
* [[`fa89e88dc8`](https://github.com/fibjs/fibjs/commit/fa89e88dc8)] - **build, feat**: support cross build for android/linux.(xicilion)
* [[`a2f9ec48f8`](https://github.com/fibjs/fibjs/commit/a2f9ec48f8)] - **crypto, bugfix**: crash when dumping uninitialized X509Cert object.(xicilion)
* [[`0ec547494b`](https://github.com/fibjs/fibjs/commit/0ec547494b)] - **options, refactor**: use JSON.stringify to generate package.json.(xicilion)
* [[`a4ead285c3`](https://github.com/fibjs/fibjs/commit/a4ead285c3)] - **console, bugfix**: unicode characters not supported by the codepage return wrong characters in readline on Windows. #741(xicilion)
* [[`787640adc3`](https://github.com/fibjs/fibjs/commit/787640adc3)] - **http, bugfix**: encoding error when Cookie value in HttpResponse is empty. #743(xicilion)
* [[`7f356bd7a8`](https://github.com/fibjs/fibjs/commit/7f356bd7a8)] - **build, feat**: build alpine in ci.(xicilion)
* [[`9165978e41`](https://github.com/fibjs/fibjs/commit/9165978e41)] - **build, feat**: support alipine build.(xicilion)
* [[`4b161a30d2`](https://github.com/fibjs/fibjs/commit/4b161a30d2)] - **build, refactor**: use ansi code in build script.(xicilion)
* [[`4fb16938b8`](https://github.com/fibjs/fibjs/commit/4fb16938b8)] - **repl, bugfix**: The wrong repl path causes require to not reach the modules in the current directory. #735(xicilion)
* [[`ad9185f1bd`](https://github.com/fibjs/fibjs/commit/ad9185f1bd)] - **Buffer, refactor**: Fix some functions of Buffer for compatibility with node.js. #696(xicilion)
* [[`7647e4c9fe`](https://github.com/fibjs/fibjs/commit/7647e4c9fe)] - **repl, feat**: support javascript statements beginning with .. in the repl. #738(xicilion)
* [[`84b4661ded`](https://github.com/fibjs/fibjs/commit/84b4661ded)] - **child_process, feat**: return process exit code in join. #736(xicilion)
* [[`4f9780b80d`](https://github.com/fibjs/fibjs/commit/4f9780b80d)] - **fs, feat**: support fs.write.(xicilion)
* [[`99d7d87bfb`](https://github.com/fibjs/fibjs/commit/99d7d87bfb)] - **db, bugfix**: use utf8 codec on windows.(xicilion)
* [[`3900017ecc`](https://github.com/fibjs/fibjs/commit/3900017ecc)] - **db, refactor**: use PostgreSQL unicode driver.(xicilion)
* [[`ff22c7d504`](https://github.com/fibjs/fibjs/commit/ff22c7d504)] - **option, feat**: Use http_proxy to proxy https requests when https_proxy is not set.(xicilion)
* [[`8fe5b8ec2f`](https://github.com/fibjs/fibjs/commit/8fe5b8ec2f)] - **option, feat**: --install script support uppercase HTTP_PROXY environment variable.(xicilion)
* [[`40fbb3af6e`](https://github.com/fibjs/fibjs/commit/40fbb3af6e)] - **build, bugfix**: compile warning on Windows.(xicilion)
* [[`312fe66247`](https://github.com/fibjs/fibjs/commit/312fe66247)] - **core, feat**: type error in WebAssembly.(xicilion)
* [[`e8763e431b`](https://github.com/fibjs/fibjs/commit/e8763e431b)] - **docs, refactor**: use viz.js to render graph.(xicilion)
* [[`e72404c1ba`](https://github.com/fibjs/fibjs/commit/e72404c1ba)] - **test, feat**: return test result in test.run.(xicilion)
* [[`53fcd5fd77`](https://github.com/fibjs/fibjs/commit/53fcd5fd77)] - **vm, bugfix**: missing idl file.(xicilion)
* [[`6d0cef0288`](https://github.com/fibjs/fibjs/commit/6d0cef0288)] - **SandBox, feat**: support addNativeModule.(xicilion)
* [[`6fa02d7776`](https://github.com/fibjs/fibjs/commit/6fa02d7776)] - **test, refactor**: deprecated setting loglevel in test.(xicilion)
* [[`e9cbbb515b`](https://github.com/fibjs/fibjs/commit/e9cbbb515b)] - **global, feat**: add performance module.(xicilion)
* [[`93b51260c2`](https://github.com/fibjs/fibjs/commit/93b51260c2)] - **test, feat**: support todo item.(xicilion)
* [[`711a915879`](https://github.com/fibjs/fibjs/commit/711a915879)] - **db, feat**: use system codec in odbc.(xicilion)
* [[`4bb099fb0e`](https://github.com/fibjs/fibjs/commit/4bb099fb0e)] - **coroutine, refactor**: resume task outside of lock.(xicilion)
* [[`d3159aa455`](https://github.com/fibjs/fibjs/commit/d3159aa455)] - **test, refactor**: change http test url.(xicilion)
* [[`5f02bda0e6`](https://github.com/fibjs/fibjs/commit/5f02bda0e6)] - **coroutine, refactor**: revert Sleep.cancel.(xicilion)
* [[`0f71967d5f`](https://github.com/fibjs/fibjs/commit/0f71967d5f)] - **build, refactor**: auto detect brew folder.(xicilion)
* [[`7dccc5db73`](https://github.com/fibjs/fibjs/commit/7dccc5db73)] - **core, bugfix**: missing include file.(xicilion)
* [[`9d65205a9e`](https://github.com/fibjs/fibjs/commit/9d65205a9e)] - **core, refactor**: refactor native module list.(xicilion)
* [[`56ff7ddbc9`](https://github.com/fibjs/fibjs/commit/56ff7ddbc9)] - **core, refactor**: refactor platform creator.(xicilion)
* [[`535317cfba`](https://github.com/fibjs/fibjs/commit/535317cfba)] - **exlib, refactor**: refactor sleep.cancel.(xicilion)
* [[`864e77c6db`](https://github.com/fibjs/fibjs/commit/864e77c6db)] - **test, bugfix**: getter test error.(xicilion)
* [[`f644aea660`](https://github.com/fibjs/fibjs/commit/f644aea660)] - **exlib, bugfix**: ConditionVariable deadlock.(xicilion)
* [[`db417069f3`](https://github.com/fibjs/fibjs/commit/db417069f3)] - **coroutine, feat**: support timeout.(xicilion)
* [[`7e07a5e284`](https://github.com/fibjs/fibjs/commit/7e07a5e284)] - **build, feat**: automatically create /usr/local/bin folder during installation.(xicilion)
* [[`656cbeb425`](https://github.com/fibjs/fibjs/commit/656cbeb425)] - **process, bugfix**: wasm compiler worker holds fibjs process.(xicilion)
* [[`739ba59c71`](https://github.com/fibjs/fibjs/commit/739ba59c71)] - **crypto, feat**: support aggregate on BLS12381_G1/BLS12381_G2.(xicilion)
* [[`fe8fe2c8ec`](https://github.com/fibjs/fibjs/commit/fe8fe2c8ec)] - **core, refactor**: set native async function name.(xicilion)
* [[`427a346bf2`](https://github.com/fibjs/fibjs/commit/427a346bf2)] - **core, refactor**: Simplify the delivery of events in callbacks and promises.(xicilion)
* [[`26ae1a8d29`](https://github.com/fibjs/fibjs/commit/26ae1a8d29)] - **crypto, refactor**: rename more secp256k1 api name.(xicilion)
* [[`e64202c225`](https://github.com/fibjs/fibjs/commit/e64202c225)] - **docs, feat**: update docs.(xicilion)

## 2022-08-31, Version 0.35.0
* **feature** :
    * Buffer:
      - support Buffer.forEach.(xicilion)
      - support Buffer.byteOffset for compatibility.(xicilion)
      - support base32 and base58.(xicilion)
    * build:
      - support Fedora.(xicilion)
      - automatically detect and install dependent packages.(xicilion)
      - cross build arm64 installer on windows.(xicilion)
      - add arm64 ci on windows.(xicilion)
      - support arm64 on windows.(xicilion)
      - update env script.(xicilion)
      - upgrade ci env to windows-2019.(xicilion)
      - display built time.(xicilion)
    * child_process - support ipc message.(xicilion)
    * console:
      - support Function property in console.log.(xicilion)
      - output colors string in console.dir by default.(xicilion)
      - support option in console.dir.(xicilion)
    * core:
      - support append array in SimpleArray.(xicilion)
      - suipport array config value.(xicilion)
      - process uncaught promise error.(xicilion)
      - implement promises on built-in modules to support async api.(xicilion)
    * crypto:
      - keep key size in json().(xicilion)
      - support toX25519 on curve Ed25519.(xicilion)
      - support compress public key.(xicilion)
      - support recover in secp256k1.(xicilion)
      - support x25519/x488.(xicilion)
      - support bin format in sign/verify.(xicilion)
      - add alias name for NIST curve.(xicilion)
      - add secp256k1_ec_pubkey_decompress function.(xicilion)
      - support bls curve.(xicilion)
      - support Ed25519 curve.(xicilion)
      - use EC as json kty for SM2.(xicilion)
      - support SM2 curve name.(xicilion)
      - support sign to on sm2.(xicilion)
      - support ecsdsa.(xicilion)
      - support PKey.equal.(xicilion)
      - support randomFill.(xicilion)
      - support P-256K alias.(xicilion)
      - support ecdh computeSecret.(xicilion)
      - suport import private ecc key only json.(xicilion)
    * docs:
      - append docs repo.(xicilion)
      - add docs as submodule.(xicilion)
      - update http document.(xicilion)
    * encoding:
      - support multibase.(xicilion)
      - support base58check encoding.(xicilion)
      - support base58 encode.(xicilion)
    * fs:
      - throw error in fs.watch.(xicilion)
      - add opts in fs.readdir.(xicilion)
      - support options in fs.readFile.(xicilion)
    * gd - update gd.(xicilion)
    * global:
      - support global TextEncoder/TextDecoder.(xicilion)
      - support btoa/atob for compatibility.(xicilion)
      - support globalThis.(xicilion)
    * hash:
      - support blake2.(xicilion)
      - support keccak384/keccak512.(xicilion)
      - support keccak256.(xicilion)
    * http:
      - friendly display of file size larger than 1T.(xicilion)
      - support http.head (#729)(PinelliaC)
      - support json decoding in all messages that contain 'json' in the 'Content-Type' header.(xicilion)
      - support socks5 proxy in HttpClient.(xicilion)
    * mbedtls - update to v3.1.0.(xicilion)
    * option:
      - change file mode when installing npm modules.(xicilion)
      - display error message.(xicilion)
    * options - support http_proxy/https_proxy env in --install.(xicilion)
    * PKey - support curve property.(xicilion)
    * profiler - support v8 statistics.(xicilion)
    * secp256k1:
      - support recovery.(xicilion)
      - enable recovery.(xicilion)
    * smtp - compatible with outlook.office365.com.(xicilion)
    * ssl:
      - specifies to use the secp256k1 curve first in ssl.(xicilion)
      - update root ca.(xicilion)
      - update root certs. (#717)(Ray)
    * test:
      - profiler test.(xicilion)
      - support ctrl_c in test.(xicilion)
    * util:
      - support Map/Set in util.format.(xicilion)
      - support TextEncoder/TextDecoder.(xicilion)
      - support deth in inspect.(xicilion)

* **bugfix** :
    * build:
      - actions ci error.(xicilion)
      - ci link error on Windows.(xicilion)
      - compile warning on Windows.(xicilion)
      - assembly ci error on mac.(xicilion)
      - compile warning on Windows.(xicilion)
      - illegal option of date on MacOS. (#722)(PinelliaC)
      - installer compile error on Windows.(xicilion)
      - comiple error on apple M1.(xicilion)
    * child_process:
      - do not transfer ipc infomation to grandson process.(xicilion)
      - disconnect test case error.(xicilion)
    * core:
      - missing error in async function without await.(xicilion)
      - compile error on arm arch.(xicilion)
    * crypto:
      - fix recoverable signature format.(xicilion)
      - set EdDSA to pk.alg error in ed25519.(xicilion)
      - der decode error.(xicilion)
      - keySize error on ed25519 curve.(xicilion)
      - curve25519 test deadlock on mips64.(xicilion)
      - secp256k1 sign/verify error.(xicilion)
    * db:
      - statement handle not deleted.(xicilion)
      - correct odbc parsing error of data column type on postgresql 14. (#727)(Ray)
    * encoding - base58 compile error om Windows.(xicilion)
    * events - removeAllListeners does not emit removeListener events.(xicilion)
    * fs - stat.size will return a negative number when the file size is greater than 2G.(xicilion)
    * gui - hide icon before open webview on mac.(xicilion)
    * hash - blake2 compile error on Windowds.(xicilion)
    * http:
      - size diplay error on file size.(xicilion)
      - socks5 connect request / response (#723)(gmxyb)
      - some http headers are duplicated when using repeater handlers.(xicilion)
    * installer - compile error on arm windows.(xicilion)
    * mbedtls - embedtls does not work with clang 13 optimization -O2.(xicilion)
    * os - os.networkInterfaces is missing ipv4 information in the query results under linux.(xicilion)
    * smtp - ignore server errors at starttls.(xicilion)
    * ssl - SslSocket.close crashes when called concurrently.(xicilion)
    * test:
      - test error on mips64 linux.(xicilion)
      - test error in util.(xicilion)
      - https test error.(xicilion)
    * tools - missing deprecated attribute.(xicilion)
    * url - allow pass number type `port` to `url.format`. (#728)(Ray)
    * vender - compile on Windows.(xicilion)

* **refactor** :
    * Buffer:
      - not display deprecated message.(xicilion)
      - missing idl file.(xicilion)
      - deprecated new Buffer(n).(xicilion)
    * build:
      - not display process progress.(xicilion)
      - refactor action ci to using native cross compiler.(xicilion)
      - not fix depend in debug mode.(xicilion)
      - fix symbol issue when compiling on ubuntu 20.(xicilion)
      - set bin folder in cmake script.(xicilion)
    * core:
      - trace full stack in callback mode.(xicilion)
      - handle arguments with safe toLocal methods.(xicilion)
      - use v8 built-in strings for longer ansi strings.(xicilion)
      - use v8 built-in strings when creating short ansi strings.(xicilion)
      - refactor Isolate code.(xicilion)
      - refactor Runtime and Isolate code.(xicilion)
    * crypto:
      - rename more secp256k1 api name.(xicilion)
      - rename secp256k1 api.(xicilion)
      - change bin format type to raw format.(xicilion)
      - add random nonce in secp256k1.(xicilion)
      - reorder arguments in PKey.recover.(xicilion)
      - implement x25519 using curve255519 library.(xicilion)
      - use secp256k1 as name default.(xicilion)
      - refactor sign/cerify api.(xicilion)
      - rename PKey.equal to PKey.equals.(xicilion)
      - remove unused code.(xicilion)
      - refactor PKey object.(xicilion)
      - refactor ecp group load code.(xicilion)
      - refactor PKey class.(xicilion)
      - patch to fix RSA public key pem is no longer required.(xicilion)
      - refactor the detection process of pk_type.(xicilion)
      - refactor import/export api.(xicilion)
      - refactor generateKey api.(xicilion)
      - use secp256k1 lib to compute public key.(xicilion)
      - use sep256k1 library to implement sep256k1 curve.(xicilion)
    * encoding - remove padding in base32.encode.(xicilion)
    * gui:
      - remove cef gui module.(xicilion)
      - compatible with newer versions of cef.(xicilion)
    * http - support method property in opts.(xicilion)
    * mbedtls:
      - use mbedtls_mpi_write_binary_le to convert secp256k1 pubkey.(xicilion)
      - use secp256k1 lib to compute shared secret.(xicilion)
      - implement the secp256k1 curve using the secp256k1 library.(xicilion)
    * option - disable wasm code gc.(xicilion)
    * PKey - move secp256k1 public key generation code into function mbedtls_ecp_mul.(xicilion)
    * process - return process.version as `v##.###.##`.(xicilion)
    * url - use GetConfigValue to get config value.(xicilion)
    * util:
      - set async function mark in promisify.(xicilion)
      - keep function name in sync/callbackify/promisify.(xicilion)

* **chore** :
    * build:
      - better changelog generating tool(richardo2016)
      - fetch all branches/tags before find latest vendor tag.(richardo2016)

* **others** :
    * crypto.feat - keep secure key when genrate pub key.(xicilion)
    * feat - Buffer, support base64url (#719)(lhkzh)
    * Create setup_ubuntu.sh(响马)
    * gui, refactor, delete unused files.(xicilion)

* **ci** :
    * build - use ubuntu 18.04 to build on actions(richardo2016)

### Commits
* [[`b950f8c981`](https://github.com/fibjs/fibjs/commit/b950f8c981)] - **build, chore**: better changelog generating tool(richardo2016)
* [[`2e8b25397c`](https://github.com/fibjs/fibjs/commit/2e8b25397c)] - **build, chore**: fetch all branches/tags before find latest vendor tag.(richardo2016)
* [[`cc238f6582`](https://github.com/fibjs/fibjs/commit/cc238f6582)] - **db, bugfix**: statement handle not deleted.(xicilion)
* [[`4a271fbafa`](https://github.com/fibjs/fibjs/commit/4a271fbafa)] - **build, feat**: support Fedora.(xicilion)
* [[`54121a8fd2`](https://github.com/fibjs/fibjs/commit/54121a8fd2)] - **core, feat**: support append array in SimpleArray.(xicilion)
* [[`5f3b07794e`](https://github.com/fibjs/fibjs/commit/5f3b07794e)] - **core, feat**: suipport array config value.(xicilion)
* [[`c8cd954c86`](https://github.com/fibjs/fibjs/commit/c8cd954c86)] - **build, bugfix**: actions ci error.(xicilion)
* [[`5f19897fc4`](https://github.com/fibjs/fibjs/commit/5f19897fc4)] - **http, bugfix**: size diplay error on file size.(xicilion)
* [[`4a0c6269d5`](https://github.com/fibjs/fibjs/commit/4a0c6269d5)] - **http, feat**: friendly display of file size larger than 1T.(xicilion)
* [[`da75d6ee9f`](https://github.com/fibjs/fibjs/commit/da75d6ee9f)] - **fs, bugfix**: stat.size will return a negative number when the file size is greater than 2G.(xicilion)
* [[`26eee17b8a`](https://github.com/fibjs/fibjs/commit/26eee17b8a)] - **build, feat**: automatically detect and install dependent packages.(xicilion)
* [[`c4b782f048`](https://github.com/fibjs/fibjs/commit/c4b782f048)] - **smtp, bugfix**: ignore server errors at starttls.(xicilion)
* [[`372297403a`](https://github.com/fibjs/fibjs/commit/372297403a)] - **smtp, feat**: compatible with outlook.office365.com.(xicilion)
* [[`5dfe3d0d06`](https://github.com/fibjs/fibjs/commit/5dfe3d0d06)] - **crypto, refactor**: rename more secp256k1 api name.(xicilion)
* [[`9484db0fb8`](https://github.com/fibjs/fibjs/commit/9484db0fb8)] - **crypto, refactor**: rename secp256k1 api.(xicilion)
* [[`bd24122a7b`](https://github.com/fibjs/fibjs/commit/bd24122a7b)] - **http, feat**: support http.head (#729)(PinelliaC)
* [[`fa266b6779`](https://github.com/fibjs/fibjs/commit/fa266b6779)] - **url, refactor**: use GetConfigValue to get config value.(xicilion)
* [[`24bbe7e65a`](https://github.com/fibjs/fibjs/commit/24bbe7e65a)] - **url, bugfix**: allow pass number type `port` to `url.format`. (#728)(Ray)
* [[`6db932935c`](https://github.com/fibjs/fibjs/commit/6db932935c)] - **db, bugfix**: correct odbc parsing error of data column type on postgresql 14. (#727)(Ray)
* [[`28a01b0f49`](https://github.com/fibjs/fibjs/commit/28a01b0f49)] - **crypto, refactor**: change bin format type to raw format.(xicilion)
* [[`b41b389a4f`](https://github.com/fibjs/fibjs/commit/b41b389a4f)] - **build, refactor**: not display process progress.(xicilion)
* [[`eb0f860308`](https://github.com/fibjs/fibjs/commit/eb0f860308)] - **build, feat**: cross build arm64 installer on windows.(xicilion)
* [[`b3343f1b63`](https://github.com/fibjs/fibjs/commit/b3343f1b63)] - **build, feat**: add arm64 ci on windows.(xicilion)
* [[`1c90898719`](https://github.com/fibjs/fibjs/commit/1c90898719)] - **build, feat**: support arm64 on windows.(xicilion)
* [[`5accf9d7c8`](https://github.com/fibjs/fibjs/commit/5accf9d7c8)] - **option, refactor**: disable wasm code gc.(xicilion)
* [[`06f1b6d42b`](https://github.com/fibjs/fibjs/commit/06f1b6d42b)] - **global, feat**: support global TextEncoder/TextDecoder.(xicilion)
* [[`0ad2094463`](https://github.com/fibjs/fibjs/commit/0ad2094463)] - **fs, feat**: throw error in fs.watch.(xicilion)
* [[`ff2c8d830f`](https://github.com/fibjs/fibjs/commit/ff2c8d830f)] - **fs, feat**: add opts in fs.readdir.(xicilion)
* [[`9ce3110acf`](https://github.com/fibjs/fibjs/commit/9ce3110acf)] - **util, feat**: support Map/Set in util.format.(xicilion)
* [[`908edb7d3a`](https://github.com/fibjs/fibjs/commit/908edb7d3a)] - **global, feat**: support btoa/atob for compatibility.(xicilion)
* [[`62d782cba0`](https://github.com/fibjs/fibjs/commit/62d782cba0)] - **console, feat**: support Function property in console.log.(xicilion)
* [[`94df7b188a`](https://github.com/fibjs/fibjs/commit/94df7b188a)] - **util, refactor**: set async function mark in promisify.(xicilion)
* [[`87014740c6`](https://github.com/fibjs/fibjs/commit/87014740c6)] - **util, refactor**: keep function name in sync/callbackify/promisify.(xicilion)
* [[`a148e4122a`](https://github.com/fibjs/fibjs/commit/a148e4122a)] - **global, feat**: support globalThis.(xicilion)
* [[`21016ea551`](https://github.com/fibjs/fibjs/commit/21016ea551)] - **crypto, refactor**: add random nonce in secp256k1.(xicilion)
* [[`3e7dd88944`](https://github.com/fibjs/fibjs/commit/3e7dd88944)] - **crypto, bugfix**: fix recoverable signature format.(xicilion)
* [[`cb91923a49`](https://github.com/fibjs/fibjs/commit/cb91923a49)] - **Buffer, feat**: support Buffer.forEach.(xicilion)
* [[`7d3d2fe6f8`](https://github.com/fibjs/fibjs/commit/7d3d2fe6f8)] - **Buffer, refactor**: not display deprecated message.(xicilion)
* [[`d4a4000c7a`](https://github.com/fibjs/fibjs/commit/d4a4000c7a)] - **Buffer, feat**: support Buffer.byteOffset for compatibility.(xicilion)
* [[`345631503e`](https://github.com/fibjs/fibjs/commit/345631503e)] - **core, refactor**: trace full stack in callback mode.(xicilion)
* [[`efc3f9feac`](https://github.com/fibjs/fibjs/commit/efc3f9feac)] - **core, bugfix**: missing error in async function without await.(xicilion)
* [[`56d03818c2`](https://github.com/fibjs/fibjs/commit/56d03818c2)] - **process, refactor**: return process.version as `v##.###.##`.(xicilion)
* [[`7ad39e6ca2`](https://github.com/fibjs/fibjs/commit/7ad39e6ca2)] - **util, feat**: support TextEncoder/TextDecoder.(xicilion)
* [[`ea5147c291`](https://github.com/fibjs/fibjs/commit/ea5147c291)] - **http, refactor**: support method property in opts.(xicilion)
* [[`8dd8a3eaed`](https://github.com/fibjs/fibjs/commit/8dd8a3eaed)] - **crypto, refactor**: reorder arguments in PKey.recover.(xicilion)
* [[`152a52054b`](https://github.com/fibjs/fibjs/commit/152a52054b)] - **test, bugfix**: test error on mips64 linux.(xicilion)
* [[`f1a0157162`](https://github.com/fibjs/fibjs/commit/f1a0157162)] - **hash, bugfix**: blake2 compile error on Windowds.(xicilion)
* [[`dd204b2a90`](https://github.com/fibjs/fibjs/commit/dd204b2a90)] - **hash, feat**: support blake2.(xicilion)
* [[`665a40f267`](https://github.com/fibjs/fibjs/commit/665a40f267)] - **hash, feat**: support keccak384/keccak512.(xicilion)
* [[`87cba05a52`](https://github.com/fibjs/fibjs/commit/87cba05a52)] - **Buffer, refactor**: missing idl file.(xicilion)
* [[`d05aaac3a2`](https://github.com/fibjs/fibjs/commit/d05aaac3a2)] - **Buffer, refactor**: deprecated new Buffer(n).(xicilion)
* [[`e7386baa76`](https://github.com/fibjs/fibjs/commit/e7386baa76)] - **tools, bugfix**: missing deprecated attribute.(xicilion)
* [[`9be09470cd`](https://github.com/fibjs/fibjs/commit/9be09470cd)] - **build, bugfix**: ci link error on Windows.(xicilion)
* [[`6f64eaf9b4`](https://github.com/fibjs/fibjs/commit/6f64eaf9b4)] - **build, refactor**: refactor action ci to using native cross compiler.(xicilion)
* [[`367032bce1`](https://github.com/fibjs/fibjs/commit/367032bce1)] - Create setup_ubuntu.sh(响马)
* [[`237b2f5e7b`](https://github.com/fibjs/fibjs/commit/237b2f5e7b)] - **core, feat**: process uncaught promise error.(xicilion)
* [[`9171f89c9a`](https://github.com/fibjs/fibjs/commit/9171f89c9a)] - **build, refactor**: not fix depend in debug mode.(xicilion)
* [[`87fa35d690`](https://github.com/fibjs/fibjs/commit/87fa35d690)] - gui, refactor, delete unused files.(xicilion)
* [[`1e056a19f5`](https://github.com/fibjs/fibjs/commit/1e056a19f5)] - **gui, bugfix**: hide icon before open webview on mac.(xicilion)
* [[`3252224c44`](https://github.com/fibjs/fibjs/commit/3252224c44)] - **gui, refactor**: remove cef gui module.(xicilion)
* [[`3b959c62e5`](https://github.com/fibjs/fibjs/commit/3b959c62e5)] - **crypto.feat**: keep secure key when genrate pub key.(xicilion)
* [[`4808a5d058`](https://github.com/fibjs/fibjs/commit/4808a5d058)] - **crypto, feat**: keep key size in json().(xicilion)
* [[`5f057f676d`](https://github.com/fibjs/fibjs/commit/5f057f676d)] - **crypto, feat**: support toX25519 on curve Ed25519.(xicilion)
* [[`1a31b3f24a`](https://github.com/fibjs/fibjs/commit/1a31b3f24a)] - **crypto, refactor**: implement x25519 using curve255519 library.(xicilion)
* [[`86ea24127b`](https://github.com/fibjs/fibjs/commit/86ea24127b)] - **crypto, refactor**: use secp256k1 as name default.(xicilion)
* [[`9e308e808a`](https://github.com/fibjs/fibjs/commit/9e308e808a)] - **crypto, feat**: support compress public key.(xicilion)
* [[`d32c92c5fe`](https://github.com/fibjs/fibjs/commit/d32c92c5fe)] - **build, feat**: update env script.(xicilion)
* [[`aa4aae9394`](https://github.com/fibjs/fibjs/commit/aa4aae9394)] - **crypto, feat**: support recover in secp256k1.(xicilion)
* [[`d8783b655f`](https://github.com/fibjs/fibjs/commit/d8783b655f)] - **encoding, feat**: support multibase.(xicilion)
* [[`56e011ea77`](https://github.com/fibjs/fibjs/commit/56e011ea77)] - **build, bugfix**: compile warning on Windows.(xicilion)
* [[`2add80e52f`](https://github.com/fibjs/fibjs/commit/2add80e52f)] - **encoding, refactor**: remove padding in base32.encode.(xicilion)
* [[`c96699d94a`](https://github.com/fibjs/fibjs/commit/c96699d94a)] - **crypto, feat**: support x25519/x488.(xicilion)
* [[`8949a18217`](https://github.com/fibjs/fibjs/commit/8949a18217)] - **Buffer, feat**: support base32 and base58.(xicilion)
* [[`8174b179b9`](https://github.com/fibjs/fibjs/commit/8174b179b9)] - **crypto, feat**: support bin format in sign/verify.(xicilion)
* [[`736aee96f9`](https://github.com/fibjs/fibjs/commit/736aee96f9)] - **crypto, refactor**: refactor sign/cerify api.(xicilion)
* [[`64d281d130`](https://github.com/fibjs/fibjs/commit/64d281d130)] - **crypto, refactor**: rename PKey.equal to PKey.equals.(xicilion)
* [[`64c67e7e50`](https://github.com/fibjs/fibjs/commit/64c67e7e50)] - **crypto, feat**: add alias name for NIST curve.(xicilion)
* [[`fa6a44a2e2`](https://github.com/fibjs/fibjs/commit/fa6a44a2e2)] - **hash, feat**: support keccak256.(xicilion)
* [[`e66a392dab`](https://github.com/fibjs/fibjs/commit/e66a392dab)] - **build, refactor**: fix symbol issue when compiling on ubuntu 20.(xicilion)
* [[`bbb42a2bd6`](https://github.com/fibjs/fibjs/commit/bbb42a2bd6)] - **crypto, refactor**: remove unused code.(xicilion)
* [[`cc9acb5913`](https://github.com/fibjs/fibjs/commit/cc9acb5913)] - **crypto, refactor**: refactor PKey object.(xicilion)
* [[`5fdfa507bf`](https://github.com/fibjs/fibjs/commit/5fdfa507bf)] - **crypto, feat**: add secp256k1_ec_pubkey_decompress function.(xicilion)
* [[`ed225b8c10`](https://github.com/fibjs/fibjs/commit/ed225b8c10)] - **crypto, feat**: support bls curve.(xicilion)
* [[`09c2e26f8e`](https://github.com/fibjs/fibjs/commit/09c2e26f8e)] - **build, feat**: upgrade ci env to windows-2019.(xicilion)
* [[`991926dbde`](https://github.com/fibjs/fibjs/commit/991926dbde)] - **mbedtls, refactor**: use mbedtls_mpi_write_binary_le to convert secp256k1 pubkey.(xicilion)
* [[`9011604e96`](https://github.com/fibjs/fibjs/commit/9011604e96)] - **crypto, refactor**: refactor ecp group load code.(xicilion)
* [[`310170c7a8`](https://github.com/fibjs/fibjs/commit/310170c7a8)] - **build, bugfix**: assembly ci error on mac.(xicilion)
* [[`2223c0a5b6`](https://github.com/fibjs/fibjs/commit/2223c0a5b6)] - **test, bugfix**: test error in util.(xicilion)
* [[`a6320072f4`](https://github.com/fibjs/fibjs/commit/a6320072f4)] - **encoding, feat**: support base58check encoding.(xicilion)
* [[`c8d5fc0dfe`](https://github.com/fibjs/fibjs/commit/c8d5fc0dfe)] - **crypto, bugfix**: set EdDSA to pk.alg error in ed25519.(xicilion)
* [[`3b4b3967e6`](https://github.com/fibjs/fibjs/commit/3b4b3967e6)] - **http, feat**: support json decoding in all messages that contain 'json' in the 'Content-Type' header.(xicilion)
* [[`b565153787`](https://github.com/fibjs/fibjs/commit/b565153787)] - **console, feat**: output colors string in console.dir by default.(xicilion)
* [[`aecad46700`](https://github.com/fibjs/fibjs/commit/aecad46700)] - **console, feat**: support option in console.dir.(xicilion)
* [[`30ca6e4fab`](https://github.com/fibjs/fibjs/commit/30ca6e4fab)] - **util, feat**: support deth in inspect.(xicilion)
* [[`94b7863b75`](https://github.com/fibjs/fibjs/commit/94b7863b75)] - **crypto, bugfix**: der decode error.(xicilion)
* [[`07c45de0e4`](https://github.com/fibjs/fibjs/commit/07c45de0e4)] - **crypto, bugfix**: keySize error on ed25519 curve.(xicilion)
* [[`7a3cb3b969`](https://github.com/fibjs/fibjs/commit/7a3cb3b969)] - **build, bugfix**: compile warning on Windows.(xicilion)
* [[`21f6719bbe`](https://github.com/fibjs/fibjs/commit/21f6719bbe)] - **crypto, bugfix**: curve25519 test deadlock on mips64.(xicilion)
* [[`7b408cfb27`](https://github.com/fibjs/fibjs/commit/7b408cfb27)] - **crypto, feat**: support Ed25519 curve.(xicilion)
* [[`fd6d5d868c`](https://github.com/fibjs/fibjs/commit/fd6d5d868c)] - **crypto, refactor**: refactor PKey class.(xicilion)
* [[`9991d17e8e`](https://github.com/fibjs/fibjs/commit/9991d17e8e)] - **http, bugfix**: socks5 connect request / response (#723)(gmxyb)
* [[`594a00a2c9`](https://github.com/fibjs/fibjs/commit/594a00a2c9)] - **crypto, feat**: use EC as json kty for SM2.(xicilion)
* [[`3bf68748f2`](https://github.com/fibjs/fibjs/commit/3bf68748f2)] - **crypto, refactor**: patch to fix RSA public key pem is no longer required.(xicilion)
* [[`c3cf0a070f`](https://github.com/fibjs/fibjs/commit/c3cf0a070f)] - **crypto, refactor**: refactor the detection process of pk_type.(xicilion)
* [[`4292fcfedf`](https://github.com/fibjs/fibjs/commit/4292fcfedf)] - **crypto, refactor**: refactor import/export api.(xicilion)
* [[`6633be0663`](https://github.com/fibjs/fibjs/commit/6633be0663)] - **crypto, refactor**: refactor generateKey api.(xicilion)
* [[`54318a6d53`](https://github.com/fibjs/fibjs/commit/54318a6d53)] - **crypto, feat**: support SM2 curve name.(xicilion)
* [[`9a7199df18`](https://github.com/fibjs/fibjs/commit/9a7199df18)] - **option, feat**: change file mode when installing npm modules.(xicilion)
* [[`66c08a5a8a`](https://github.com/fibjs/fibjs/commit/66c08a5a8a)] - **core, feat**: implement promises on built-in modules to support async api.(xicilion)
* [[`5fe4138299`](https://github.com/fibjs/fibjs/commit/5fe4138299)] - **docs, feat**: append docs repo.(xicilion)
* [[`6753451641`](https://github.com/fibjs/fibjs/commit/6753451641)] - **docs, feat**: add docs as submodule.(xicilion)
* [[`878fc5cc1d`](https://github.com/fibjs/fibjs/commit/878fc5cc1d)] - **fs, feat**: support options in fs.readFile.(xicilion)
* [[`d83a399345`](https://github.com/fibjs/fibjs/commit/d83a399345)] - **core, refactor**: handle arguments with safe toLocal methods.(xicilion)
* [[`bf418e4a2e`](https://github.com/fibjs/fibjs/commit/bf418e4a2e)] - **docs, feat**: update http document.(xicilion)
* [[`287fe93da4`](https://github.com/fibjs/fibjs/commit/287fe93da4)] - **child_process, bugfix**: do not transfer ipc infomation to grandson process.(xicilion)
* [[`c08ad54adc`](https://github.com/fibjs/fibjs/commit/c08ad54adc)] - **child_process, bugfix**: disconnect test case error.(xicilion)
* [[`f9fd64f7a2`](https://github.com/fibjs/fibjs/commit/f9fd64f7a2)] - **child_process, feat**: support ipc message.(xicilion)
* [[`061f4833fe`](https://github.com/fibjs/fibjs/commit/061f4833fe)] - **events, bugfix**: removeAllListeners does not emit removeListener events.(xicilion)
* [[`5a136fbbe3`](https://github.com/fibjs/fibjs/commit/5a136fbbe3)] - **test, feat**: profiler test.(xicilion)
* [[`493fa37c07`](https://github.com/fibjs/fibjs/commit/493fa37c07)] - **profiler, feat**: support v8 statistics.(xicilion)
* [[`82e53e6417`](https://github.com/fibjs/fibjs/commit/82e53e6417)] - **build, bugfix**: illegal option of date on MacOS. (#722)(PinelliaC)
* [[`60779fb629`](https://github.com/fibjs/fibjs/commit/60779fb629)] - **build, feat**: display built time.(xicilion)
* [[`2ba4c19890`](https://github.com/fibjs/fibjs/commit/2ba4c19890)] - **core, refactor**: use v8 built-in strings for longer ansi strings.(xicilion)
* [[`c640a86179`](https://github.com/fibjs/fibjs/commit/c640a86179)] - **core, refactor**: use v8 built-in strings when creating short ansi strings.(xicilion)
* [[`411204e9e8`](https://github.com/fibjs/fibjs/commit/411204e9e8)] - **core, bugfix**: compile error on arm arch.(xicilion)
* [[`5e5c94bad1`](https://github.com/fibjs/fibjs/commit/5e5c94bad1)] - **core, refactor**: refactor Isolate code.(xicilion)
* [[`53173c93cd`](https://github.com/fibjs/fibjs/commit/53173c93cd)] - **build, ci**: use ubuntu 18.04 to build on actions(richardo2016)
* [[`3a36955d84`](https://github.com/fibjs/fibjs/commit/3a36955d84)] - **core, refactor**: refactor Runtime and Isolate code.(xicilion)
* [[`5c491a3209`](https://github.com/fibjs/fibjs/commit/5c491a3209)] - **build, bugfix**: installer compile error on Windows.(xicilion)
* [[`8fd019be28`](https://github.com/fibjs/fibjs/commit/8fd019be28)] - **build, refactor**: set bin folder in cmake script.(xicilion)
* [[`92df284147`](https://github.com/fibjs/fibjs/commit/92df284147)] - **gui, refactor**: compatible with newer versions of cef.(xicilion)
* [[`888cf2ae18`](https://github.com/fibjs/fibjs/commit/888cf2ae18)] - **http, feat**: support socks5 proxy in HttpClient.(xicilion)
* [[`8144751c0a`](https://github.com/fibjs/fibjs/commit/8144751c0a)] - **test, bugfix**: https test error.(xicilion)
* [[`807f4778d3`](https://github.com/fibjs/fibjs/commit/807f4778d3)] - **vender, bugfix**: compile on Windows.(xicilion)
* [[`55f1bcbec4`](https://github.com/fibjs/fibjs/commit/55f1bcbec4)] - **mbedtls, feat**: update to v3.1.0.(xicilion)
* [[`34a9c600d0`](https://github.com/fibjs/fibjs/commit/34a9c600d0)] - **option, feat**: display error message.(xicilion)
* [[`cc589c63e0`](https://github.com/fibjs/fibjs/commit/cc589c63e0)] - **gd, feat**: update gd.(xicilion)
* [[`c1cd9f4ad9`](https://github.com/fibjs/fibjs/commit/c1cd9f4ad9)] - **crypto, feat**: support sign to on sm2.(xicilion)
* [[`6921da5ca7`](https://github.com/fibjs/fibjs/commit/6921da5ca7)] - **installer, bugfix**: compile error on arm windows.(xicilion)
* [[`4dacf05cf2`](https://github.com/fibjs/fibjs/commit/4dacf05cf2)] - **crypto, feat**: support ecsdsa.(xicilion)
* [[`a63e0ee321`](https://github.com/fibjs/fibjs/commit/a63e0ee321)] - **ssl, bugfix**: SslSocket.close crashes when called concurrently.(xicilion)
* [[`d9029037b0`](https://github.com/fibjs/fibjs/commit/d9029037b0)] - **encoding, bugfix**: base58 compile error om Windows.(xicilion)
* [[`a5e05ac2a8`](https://github.com/fibjs/fibjs/commit/a5e05ac2a8)] - **crypto, feat**: support PKey.equal.(xicilion)
* [[`b98016df01`](https://github.com/fibjs/fibjs/commit/b98016df01)] - **encoding, feat**: support base58 encode.(xicilion)
* [[`1db8a05f9f`](https://github.com/fibjs/fibjs/commit/1db8a05f9f)] - **secp256k1, feat**: support recovery.(xicilion)
* [[`367b198e59`](https://github.com/fibjs/fibjs/commit/367b198e59)] - **build, bugfix**: comiple error on apple M1.(xicilion)
* [[`e44e4490ab`](https://github.com/fibjs/fibjs/commit/e44e4490ab)] - **PKey, refactor**: move secp256k1 public key generation code into function mbedtls_ecp_mul.(xicilion)
* [[`a504e1f809`](https://github.com/fibjs/fibjs/commit/a504e1f809)] - **secp256k1, feat**: enable recovery.(xicilion)
* [[`209f02d283`](https://github.com/fibjs/fibjs/commit/209f02d283)] - **crypto, feat**: support randomFill.(xicilion)
* [[`15bd4d2fa5`](https://github.com/fibjs/fibjs/commit/15bd4d2fa5)] - **options, feat**: support http_proxy/https_proxy env in --install.(xicilion)
* [[`e3b82dae67`](https://github.com/fibjs/fibjs/commit/e3b82dae67)] - **crypto, feat**: support P-256K alias.(xicilion)
* [[`79c0b66a49`](https://github.com/fibjs/fibjs/commit/79c0b66a49)] - **ssl, feat**: specifies to use the secp256k1 curve first in ssl.(xicilion)
* [[`7bf56b2130`](https://github.com/fibjs/fibjs/commit/7bf56b2130)] - **PKey, feat**: support curve property.(xicilion)
* [[`963f9e8f7a`](https://github.com/fibjs/fibjs/commit/963f9e8f7a)] - **crypto, bugfix**: secp256k1 sign/verify error.(xicilion)
* [[`79d19e1a02`](https://github.com/fibjs/fibjs/commit/79d19e1a02)] - **crypto, refactor**: use secp256k1 lib to compute public key.(xicilion)
* [[`3d2ec635a0`](https://github.com/fibjs/fibjs/commit/3d2ec635a0)] - **mbedtls, refactor**: use secp256k1 lib to compute shared secret.(xicilion)
* [[`fb0aab2f9d`](https://github.com/fibjs/fibjs/commit/fb0aab2f9d)] - **crypto, feat**: support ecdh computeSecret.(xicilion)
* [[`c8745667b5`](https://github.com/fibjs/fibjs/commit/c8745667b5)] - **mbedtls, refactor**: implement the secp256k1 curve using the secp256k1 library.(xicilion)
* [[`d3d6a75c05`](https://github.com/fibjs/fibjs/commit/d3d6a75c05)] - **mbedtls, bugfix**: embedtls does not work with clang 13 optimization -O2.(xicilion)
* [[`a6061ab1be`](https://github.com/fibjs/fibjs/commit/a6061ab1be)] - **ssl, feat**: update root ca.(xicilion)
* [[`317a9ecd4f`](https://github.com/fibjs/fibjs/commit/317a9ecd4f)] - **http, bugfix**: some http headers are duplicated when using repeater handlers.(xicilion)
* [[`f120570b9e`](https://github.com/fibjs/fibjs/commit/f120570b9e)] - **crypto, refactor**: use sep256k1 library to implement sep256k1 curve.(xicilion)
* [[`d5db5d915f`](https://github.com/fibjs/fibjs/commit/d5db5d915f)] - **crypto, feat**: suport import private ecc key only json.(xicilion)
* [[`560099c85d`](https://github.com/fibjs/fibjs/commit/560099c85d)] - **feat**: Buffer, support base64url (#719)(lhkzh)
* [[`463ce2f145`](https://github.com/fibjs/fibjs/commit/463ce2f145)] - **test, feat**: support ctrl_c in test.(xicilion)
* [[`53166fef27`](https://github.com/fibjs/fibjs/commit/53166fef27)] - **ssl, feat**: update root certs. (#717)(Ray)
* [[`cf675197e0`](https://github.com/fibjs/fibjs/commit/cf675197e0)] - **os, bugfix**: os.networkInterfaces is missing ipv4 information in the query results under linux.(xicilion)

## 2021-09-03, Version 0.34.0
* **feature** :
    * Buffer:
      - optimize concat() (#709)(gmxyb)
      - support Buffer.buffer.(xicilion)
      - implement Buffer object iterable.(xicilion)
    * build:
      - support armv6 cross compiler.(xicilion)
      - script to switch qemu simulation environment.(xicilion)
      - display dependents of fibjs.exe in release mode.(xicilion)
    * build_tools - upgrade to correct checking for lib atomic on posix.(xicilion)
    * cef - update to v90.(xicilion)
    * child_process:
      - support kill(string).(xicilion)
      - support ChildProcess.usage.(xicilion)
      - fallback to 'pipe' for incomplete 'options.stdio' array on spawn/fork child_process(richardo2016)
      - support pty on posix.(xicilion)
      - add document for options.stdio.(xicilion)
      - support fork.(xicilion)
    * console:
      - simply display objects and arrays in object properties.(xicilion)
      - support console.table.(xicilion)
      - change the color of warn message to YELLOW.(xicilion)
    * constants - add constants.(xicilion)
    * core:
      - enable gc in native api.(xicilion)
      - support jemalloc on Windows.(xicilion)
      - automatically modify the value of max_old_space_size according to the system memory.(xicilion)
      - support for defining iterator operators.(xicilion)
      - support Error.code when throwing uv error.(xicilion)
    * coroutine - support Fiber.stack_usage.(xicilion)
    * crypto:
      - support query sig_md/sig_pk in X509Cert.(xicilion)
      - add document for getHashes.(xicilion)
      - support sign/verify in Digest.(xicilion)
      - add crypto.getHashes()(richardo2016)
    * db:
      - disable fiber free for LevelDB.(xicilion)
      - add document.(xicilion)
      - support custom odbc driver.(xicilion)
      - support PostgreSQL.(xicilion)
      - support null value in odbc driver.(xicilion)
      - support more dara type.(xicilion)
      - rewrite mssql use odbc driver and support mssql on unix.(xicilion)
      - compile error on Windows i386.(xicilion)
      - support odbc.(xicilion)
      - change async mode to long-sync.(xicilion)
    * docs:
      - recollect modules.(xicilion)
      - update collect.json.(xicilion)
      - fix some documents.(xicilion)
      - document HttpCookie.(xicilion)
      - more language.(xicilion)
      - translate only updated document.(xicilion)
    * encoding - do not fill "=" characters in base64-url encode.(xicilion)
    * event - removeAllListeners support remove single event.(xicilion)
    * events - support events.listenerCount(o, ev).(xicilion)
    * fs:
      - disable test for `fs.watch` option `recursive` on Linux.(richardo2016)
      - support recursive option in fs.mkdir.(xicilion)
      - throw system error code.(xicilion)
    * gui:
      - enable hight dpi support on windows. #700(xicilion)
      - add test case for download event.(xicilion)
      - support download event in cef WebView.(xicilion)
      - support to control download behavior in cef webview.(xicilion)
      - not activating the application when the webview is headless.(xicilion)
    * hash:
      - support sm3 prepare.(xicilion)
      - support data as an optional parameter when creating Digest.(xicilion)
    * http:
      - add the enableEncoding option, turn off the encoding support of HttpServer by default.(xicilion)
      - auto return json/msgpack data in HttpMessage.data (#695)(lhkzh)
      - auto return json data in HttpMessage.data.(xicilion)
      - support pack option for msgpack. (#647)(lhkzh)
    * iconv - support built-in ucs2le/ucs2be/ucs4le/ucs4be charset.(xicilion)
    * idlc - support null default value.(xicilion)
    * Isolate - normalize initialization for stdio instance.(richardo2016)
    * leveldb:
      - update to v1.23.(xicilion)
      - support flush.(xicilion)
    * msgpack - support number_safe_int. (#694)(lhkzh)
    * net:
      - support unix socket and Windows pipe.(xicilion)
      - support use-uv-socket option.(xicilion)
      - use uv implement UVSocket.(xicilion)
    * option - update --help message.(xicilion)
    * options - install cli link into .bin folder.(xicilion)
    * os - support to report external memory in memoryUsage.(xicilion)
    * perf_hooks - support simple perf_hooks module.(xicilion)
    * process:
      - support process.cpuUsage.(xicilion)
      - dump full memory information  in debug mode on Windows.(xicilion)
    * Sandbox - support to run scripts in node_modules/.bin folder.(xicilion)
    * sandbox - support require.cache.(xicilion)
    * ssl - update root certs.(xicilion)
    * stdio:
      - support stdout.columns and stdout.rows.(xicilion)
      - support stdout.getWindowSize.(xicilion)
    * Stream:
      - support network package reading mode.(xicilion)
      - allows the close function to be called in a closed stream.(xicilion)
    * test:
      - update files for jsc test.(richardo2016)
      - support passing a callback function to done to handle the asynchronous test.(xicilion)
    * tools:
      - add libx11 to ubuntu_env.sh(xicilion)
      - support generate *.d.ts from fibjs's idl.(richardo2016)
      - upgrade tools/changelog.js, driven by child_process module.(richardo2016)
    * tty - replace stdio stream in process:(richardo2016)
    * types:
      - improvement.(richardo2016)
      - typings change.(richardo2016)
      - adjust, add test about types.(richardo2016)
    * url:
      - support url.resolve.(xicilion)
      - support unix socket and windows pipe host name.(xicilion)
    * util:
      - support util.isDeepEqual.(xicilion)
      - support encode_string option in util.inspect.(xicilion)
      - support output Symbol details.(xicilion)
      - support Promise type in util.format.(xicilion)
      - optimize the output of nested objects, do not collapse empty objects.(xicilion)
      - display different information for one more item and multiple more items.(xicilion)
      - limit the number of items in the Buffer output. #657(xicilion)
      - limit the number of items in the array output.(xicilion)
      - limit the level of obejct output.(xicilion)
      - implement util.callbackify.(xicilion)
      - support util.promisify.(xicilion)
    * v8:
      - enable snapshot.(xicilion)
      - upgrade v8 to v7.8.5.(xicilion)
      - upgrade v8 to 7.4.301.(xicilion)
    * vender:
      - upgrade to use v8 7.8.285 (#707)(Ray)
      - upgrade and adapt.(richardo2016)
      - upgrade to use v8 7.2(richardo2016)
      - update expat&zlib.(xicilion)
    * worker - add worker_threads module, compatible with node.js.(xicilion)
    * ws - ts files for websocket.(xicilion)

* **bugfix** :
    * assert - assert crash when valueOf throw error.(xicilion)
    * bson - crash when decode invaid data type, issue #648.(xicilion)
    * Buffer:
      - remove unnecessary extMemory (#710)(gmxyb)
      - binary encoding error.(xicilion)
      - readNumber/writeNumber error on big-endain arch.(xicilion)
      - querying values() on a very huge Buffer will cause the Buffer to crash, #676(xicilion)
      - passing a large offset to Buffer.writeUInt32BE will cause fibjs to crash, #672(xicilion)
      - passing a large offset to Buffer.readUIntLE will cause fibjs to crash, #667(xicilion)
      - specifying a huge negative number for the offset of Buffer.slice will cause a segmentation fault, #666(xicilion)
      - fibjs will crash when the offset of Buffer.writeXXX is negative, #659(xicilion)
      - fibjs will crash when the offset parameter of Buffer.read is negative, issue 655.(xicilion)
    * build:
      - solve the dependency of glibc 2.17.(xicilion)
      - compile warning on Windows.(xicilion)
      - compile warning on Windows.(xicilion)
      - fibjs build with alpine 3.13 (#643)(Su Yang)
      - compile warning in debug mode on Windows.(xicilion)
      - fibjs build with alpine 3.13 (#643)(Su Yang)
    * child_process:
      - rss test error on arm64/arm.(xicilion)
      - test error on arm64/arm.(xicilion)
      - crash when bad stdio array.(xicilion)
      - the test will not end on a very slow machine.(xicilion)
      - crash when spawn return error.(xicilion)
    * console:
      - use hex as char literal for `console.table`, to avoid compilation error on msvc. (#715)(Ray)
      - on windows, line breaks are output as \n when stdout/stderr is redirected.(xicilion)
    * core:
      - QuickArray does not implement append method.(xicilion)
      - exit code error.(xicilion)
      - capture error stacks in the top-level function call.(xicilion)
      - error report crash when stack trace return empty.(xicilion)
      - cannot parse some string formats of data correctly, #681(xicilion)
      - runtime error in i386 mode on Windows.(xicilion)
      - compile error on Linux.(xicilion)
      - uv_timer_t is not released correctly when the timer ends.(xicilion)
      - compile error on Windows.(xicilion)
      - deleting js objects directly in the uv thread after closing uv_handle will cause fibjs to crash.(xicilion)
      - compile error in debug mode.(xicilion)
    * coroutine:
      - stack_usage error in repl.(xicilion)
      - stack_usage crash on new fiber.(xicilion)
      - compile warning on Windows.(xicilion)
    * crypto:
      - compile warning on Windows.(xicilion)
      - md_alg is not set when in X509Req.sign.(xicilion)
      - make big data block encryption very slow.(xicilion)
      - support ripemd160 and sm3 in rsa/sm2 sign.(xicilion)
      - too large matrix size will cause crypto.randomArt to crash, #677(xicilion)
      - Illegal iterations and size parameters will cause crypto.pbkdf1 or crypto.pbkdf2 to crash, #670 #671(xicilion)
      - specifying a negative size of crypto.randomBytes will cause a segmentation fault, #664 #665(xicilion)
      - specifying the size of crypto.randomArt as 0 will cause a segmentation fault, #662(xicilion)
    * db:
      - the data types of tinytext and text are converted to Buffer on mysql.(xicilion)
      - LevelDB returns wrong data when concurrently read under windows.(xicilion)
      - error message of leveldb is truncated.(xicilion)
      - float type error on mssql.(xicilion)
      - SIZEOF_LONG_INT set to 8 on 32 bits system.(xicilion)
      - levelDB.mget results in a segmentation fault, issue #653.(xicilion)
      - conn.begin error on mysql.(xicilion)
      - conn.begin error on mysql.(xicilion)
    * dgram:
      - tests on systems without IPv6 will report errors.(xicilion)
      - test error on Linux.(xicilion)
      - change test port.(xicilion)
    * docs:
      - some description errors in setClientCert parameters.(xicilion)
      - typo.(xicilion)
    * encode - std::bad_alloc error will be caused when processing strings longer than 2G, #661(xicilion)
    * encoding - compile warning in debug mode.(xicilion)
    * EventEmitter:
      - removeAllListeners() does not remove any listener.(xicilion)
      - removeAllListeners() does not remove any listener.(xicilion)
    * fs:
      - fs.lstat crash on Linux.(xicilion)
      - time error in fs.stat.(xicilion)
      - stat.isSymbolicLink always returns false on Windows.(xicilion)
      - when the path exists, fs.mkdir should not raise an error in recursive mode.(xicilion)
      - fstat mode error when create directory and file.(Yuanhang)
      - correct to emit changed filename for FSWatcher.(richardo2016)
      - compile error in debug mode on Windows.(xicilion)
      - compile error on windows.(xicilion)
    * gui:
      - compile error on Windows.(xicilion)
      - fixup resource request on win32 webview:(richardo2016)
      - cef subprocess does not initialize uv, causing fs.exists to fail.(xicilion)
    * http:
      - larger maxBodySize will cause calculation errors.(xicilion)
      - compile warning on Windows.(xicilion)
      - compile error on linux.(xicilion)
      - request option process error.(xicilion)
    * idl:
      - support method overrides, and rest parameters.(richardo2016)
      - repair missing method params for interface.(richardo2016)
    * io - reading data from rangestream does not change the current position correctly.(xicilion)
    * msgpack - new Boolean(false) encode error.(xicilion)
    * net:
      - add error code CALL_E_NETNAME_DELETED (#711)(gmxyb)
      - ipv6 bind error on UVSocket.(xicilion)
      - access socket on unconnected smtp object causes segmentation fault, issue #654.(xicilion)
    * options - decompression speed is very slow when installing the npm package.(xicilion)
    * os - os.arch return nothing on mips/mips64.(xicilion)
    * path - do not set the drive character when the base path is empty.(xicilion)
    * process:
      - after output log, process.stdio is not implemented as TTYStream on windows.(xicilion)
      - ignore SIGPIPE signal, fix abnormal exit when tcp connection is closed remotely under linux.(xicilion)
    * punycode:
      - punycode.decode results in a segmentation fault, #675(xicilion)
      - punycode.decode results in a floating point exception, issue #652.(xicilion)
    * repl - repl cannot handle incomplete statements normally, issue #651.(xicilion)
    * Routing - the encoded url value is not decoded.(xicilion)
    * ssl - crash on verify ssl.ca, #679(Yuanhang)
    * Stream - read throw error when connection reset by peer.(xicilion)
    * test:
      - error when testing the ssl certificate of registry.npmjs.org.(xicilion)
      - timeout test error under windows sometimes.(xicilion)
      - http test error on Windows.(xicilion)
      - actions test error on Windows.(xicilion)
      - some test error.(xicilion)
      - ws test error on windows.(xicilion)
      - some test error.(xicilion)
    * util:
      - intersection crash when valueOf throw error, #673(xicilion)
      - memory limit causes GC to crash, #658(xicilion)
      - flatten a circular reference object will cause fibjs to crash, #669(xicilion)
      - running util.deepFreeze on Buffer will result in illegal hardware instructions. #663(xicilion)
      - fixup build error on Windows.(richardo2016)
      - static functions of built-in modules are displayed with wrong function names.(xicilion)
    * UVStream - out-of-bounds data operations will occur in get_fd.(xicilion)
    * v8 - wasm crashes when compiling.(xicilion)
    * websocket - message encode error on big-endian arch.(xicilion)
    * zlib - passing an invalid level parameter to zlib.deflate will cause fibjs to crash.(xicilion)

* **refactor** :
    * Buffer - copy memory when get_buffer.(xicilion)
    * console - use uv to output console message.(xicilion)
    * core:
      - enable gc when calling JavaScript functions in a loop.(xicilion)
      - define JSFunction to automatically process the call of async function.(xicilion)
      - refactor fiber local.(xicilion)
      - add isolate to list before init.(xicilion)
      - use the new toString instead of Utf8Value to convert v8 strings.(xicilion)
      - use uint64_t to detect strings to speed up detection.(xicilion)
      - use union to detect big-endian architecture at runtime.(xicilion)
      - use external-resource to implement zero-copy transfer string between fibjs and v8, #678(xicilion)
      - refactor the urf8 encode/decode, improve coding performance.(xicilion)
      - strictly distinguish between access and reference to the elements of string, and eliminate unnecessary memory copy.(xicilion)
      - enable lazy compile.(xicilion)
      - change v8 memory space to 2048.(xicilion)
      - convert utf8 string directly to v8 string.(xicilion)
      - use isolate_ref() instead of holder()->Ref().(xicilion)
      - refactor the error reporting framework to support uv error codes.(xicilion)
      - optimize the implementation of some string methods.(xicilion)
      - add C_ before the const variable name to avoid conflicts between variable names and system variables.(xicilion)
      - add _ before the const variable name to avoid conflicts between variable names and system variables.(xicilion)
    * coroutine - include the stack used by c++ startup in stack_usage.(xicilion)
    * db:
      - refactor db_format.(xicilion)
      - refactor odbc_connect, simplify the implementation of driver.(xicilion)
      - detect null value use SQL_NULL_DATA.(xicilion)
      - remove db.format, refactor db test.(xicilion)
      - move function mssql::error into cpp.(xicilion)
      - use template to refactor db_format.(xicilion)
      - refactor db api use class template.(xicilion)
      - move function use into DBConnection.(xicilion)
      - move db_api.h to db folder.(xicilion)
      - move leveldb test case into group.(xicilion)
    * dgram:
      - bind udp socket in worker fiber.(xicilion)
      - move code to source file.(xicilion)
      - use uv to implement udp socket.(xicilion)
    * docs - use nomnoml to render graph.(xicilion)
    * encoding:
      - deprecate base64vlq.(xicilion)
      - optimize hex/base64 encode/decode performance.(xicilion)
      - deprecated bson module.(xicilion)
    * events - fix param name in EventEmitter.removeAllListeners.(xicilion)
    * exlib - refactor timer thread.(xicilion)
    * fs:
      - use sync uv function to implement fs methods.(xicilion)
      - use uv_call to refactor fs.watch.(xicilion)
      - rewrite fs.stat.(xicilion)
      - define the uv_async function to simplify the implementation of the fs uv async function.(xicilion)
      - use destructor to destroy uv_fs_t structure.(xicilion)
      - use uv to implament fs.readdir function.(xicilion)
      - split fs.cpp.(xicilion)
      - use uv to implament fs.copyFile function.(xicilion)
      - refactor fs.constants and move the SEEK_* flag to fs.constants.(xicilion)
    * gui - use dl_func to wrap x11 function.(xicilion)
    * http - remove unnecessary odescribe restrictions.(xicilion)
    * isolate:
      - use StrictEquals to compare object.(xicilion)
      - use v8::Local<v8::Object>::Cast to convert the data type.(xicilion)
    * NArray - use simpler length syntax.(xicilion)
    * net:
      - compile warning in debug mode on Windows.(xicilion)
      - not remove domain file on Windows.(xicilion)
      - use Socket::_new to create socket.(xicilion)
      - remove udp support from net.Socket.(xicilion)
      - use uv to convert inetAddr.(xicilion)
    * options:
      - use link to install npm cli.(xicilion)
      - install the cli script to .bin in the same directory of the module.(xicilion)
      - remove unused flags.(xicilion)
    * os:
      - deprecated os.uptime/os.execPath/os.memoryUsage.(xicilion)
      - use uv to implament os/process function.(xicilion)
    * path - define os_* api.(xicilion)
    * process:
      - use uv to get hrtime.(xicilion)
      - use exit instead of _exit to quit current process.(xicilion)
    * sandbox - rename argv to __argv.(xicilion)
    * Stream:
      - limit read buffer size.(xicilion)
      - use uv_post(function) to post async function into uv thread.(xicilion)
      - use uv_post to post uv tasks without waiting for execution to finish.(xicilion)
      - use UVStream::create_pipe to create pipe stream.(xicilion)
    * test:
      - enhance the stability of cef test.(xicilion)
      - enable process test.(xicilion)
      - output error message to stdout.(xicilion)
    * util:
      - wrap the async function directly to the sync function without callbackify.(xicilion)
      - move the processing of special types out of object.(xicilion)
    * uv - refactor uv process model.(xicilion)
    * ws - not enable perMessageDeflate by default.(xicilion)

* **bugfox** :
    * exlib - sleep sometimes hangs permanently.(xicilion)

* **others** :
    * fs.refactor - Restore SEEK_* constants defined in fs.(xicilion)
    * Merge branch 'dev' of https - //github.com/fibjs/fibjs into dev(xicilion)
    * sandbox - refactor: call the async function directly in the loader without using the util.sync.(xicilion)
    * dev 0.34.0(richardo2016)
    * Release 0.33.0(richardo2016)
    * Release v0.32.1(richardo2016)

* **chore** :
    * build - merge and resolve conflict.(richardo2016)

### Commits
* [[`315b32208e`](https://github.com/fibjs/fibjs/commit/315b32208e)] - **docs, feat**: recollect modules.(xicilion)
* [[`cacc15761b`](https://github.com/fibjs/fibjs/commit/cacc15761b)] - **docs, feat**: update collect.json.(xicilion)
* [[`9497edc1ac`](https://github.com/fibjs/fibjs/commit/9497edc1ac)] - **docs, feat**: fix some documents.(xicilion)
* [[`311084a738`](https://github.com/fibjs/fibjs/commit/311084a738)] - **console, bugfix**: use hex as char literal for `console.table`, to avoid compilation error on msvc. (#715)(Ray)
* [[`77bc65e498`](https://github.com/fibjs/fibjs/commit/77bc65e498)] - **util, feat**: support util.isDeepEqual.(xicilion)
* [[`4e440bedd5`](https://github.com/fibjs/fibjs/commit/4e440bedd5)] - **child_process, feat**: support kill(string).(xicilion)
* [[`3c81d4add3`](https://github.com/fibjs/fibjs/commit/3c81d4add3)] - **process, bugfix**: after output log, process.stdio is not implemented as TTYStream on windows.(xicilion)
* [[`a3a9d77589`](https://github.com/fibjs/fibjs/commit/a3a9d77589)] - **stdio, feat**: support stdout.columns and stdout.rows.(xicilion)
* [[`5de5918621`](https://github.com/fibjs/fibjs/commit/5de5918621)] - **stdio, feat**: support stdout.getWindowSize.(xicilion)
* [[`28671e8e79`](https://github.com/fibjs/fibjs/commit/28671e8e79)] - **coroutine, bugfix**: stack_usage error in repl.(xicilion)
* [[`7129946b33`](https://github.com/fibjs/fibjs/commit/7129946b33)] - **coroutine, bugfix**: stack_usage crash on new fiber.(xicilion)
* [[`700ce7b0a7`](https://github.com/fibjs/fibjs/commit/700ce7b0a7)] - **util, feat**: support encode_string option in util.inspect.(xicilion)
* [[`52f8d085b0`](https://github.com/fibjs/fibjs/commit/52f8d085b0)] - **console, feat**: simply display objects and arrays in object properties.(xicilion)
* [[`3051272f2f`](https://github.com/fibjs/fibjs/commit/3051272f2f)] - **console, feat**: support console.table.(xicilion)
* [[`3143a4803f`](https://github.com/fibjs/fibjs/commit/3143a4803f)] - **coroutine, bugfix**: compile warning on Windows.(xicilion)
* [[`0d3892ae3c`](https://github.com/fibjs/fibjs/commit/0d3892ae3c)] - **options, refactor**: use link to install npm cli.(xicilion)
* [[`726cf5d17c`](https://github.com/fibjs/fibjs/commit/726cf5d17c)] - **core, bugfix**: QuickArray does not implement append method.(xicilion)
* [[`a7e1282553`](https://github.com/fibjs/fibjs/commit/a7e1282553)] - **options, refactor**: install the cli script to .bin in the same directory of the module.(xicilion)
* [[`41e4cb7118`](https://github.com/fibjs/fibjs/commit/41e4cb7118)] - **exlib, refactor**: refactor timer thread.(xicilion)
* [[`2f535dbec6`](https://github.com/fibjs/fibjs/commit/2f535dbec6)] - **core, refactor**: enable gc when calling JavaScript functions in a loop.(xicilion)
* [[`2d71bec71b`](https://github.com/fibjs/fibjs/commit/2d71bec71b)] - **exlib, bugfox**: sleep sometimes hangs permanently.(xicilion)
* [[`cfb3137670`](https://github.com/fibjs/fibjs/commit/cfb3137670)] - **events, feat**: support events.listenerCount(o, ev).(xicilion)
* [[`222d027c8b`](https://github.com/fibjs/fibjs/commit/222d027c8b)] - **sandbox, feat**: support require.cache.(xicilion)
* [[`7aa618dd40`](https://github.com/fibjs/fibjs/commit/7aa618dd40)] - **leveldb, feat**: update to v1.23.(xicilion)
* [[`41a045bb7f`](https://github.com/fibjs/fibjs/commit/41a045bb7f)] - **child_process, bugfix**: rss test error on arm64/arm.(xicilion)
* [[`f93980a59f`](https://github.com/fibjs/fibjs/commit/f93980a59f)] - **child_process, bugfix**: test error on arm64/arm.(xicilion)
* [[`95dd4a5da5`](https://github.com/fibjs/fibjs/commit/95dd4a5da5)] - **child_process, feat**: support ChildProcess.usage.(xicilion)
* [[`ee6744f67a`](https://github.com/fibjs/fibjs/commit/ee6744f67a)] - **gui, bugfix**: compile error on Windows.(xicilion)
* [[`f698e677cf`](https://github.com/fibjs/fibjs/commit/f698e677cf)] - **os, refactor**: deprecated os.uptime/os.execPath/os.memoryUsage.(xicilion)
* [[`796aefe3bf`](https://github.com/fibjs/fibjs/commit/796aefe3bf)] - **process, feat**: support process.cpuUsage.(xicilion)
* [[`05ed80c9f7`](https://github.com/fibjs/fibjs/commit/05ed80c9f7)] - **test, bugfix**: error when testing the ssl certificate of registry.npmjs.org.(xicilion)
* [[`37e8dfd3ac`](https://github.com/fibjs/fibjs/commit/37e8dfd3ac)] - **core, feat**: enable gc in native api.(xicilion)
* [[`8d65193c04`](https://github.com/fibjs/fibjs/commit/8d65193c04)] - **coroutine, refactor**: include the stack used by c++ startup in stack_usage.(xicilion)
* [[`3c9c214fff`](https://github.com/fibjs/fibjs/commit/3c9c214fff)] - **coroutine, feat**: support Fiber.stack_usage.(xicilion)
* [[`7f1f8c562f`](https://github.com/fibjs/fibjs/commit/7f1f8c562f)] - **core, refactor**: define JSFunction to automatically process the call of async function.(xicilion)
* [[`acf9ca2da7`](https://github.com/fibjs/fibjs/commit/acf9ca2da7)] - **core, bugfix**: exit code error.(xicilion)
* [[`d6469fc1e3`](https://github.com/fibjs/fibjs/commit/d6469fc1e3)] - **core, bugfix**: capture error stacks in the top-level function call.(xicilion)
* [[`e47cbd4af8`](https://github.com/fibjs/fibjs/commit/e47cbd4af8)] - **core, bugfix**: error report crash when stack trace return empty.(xicilion)
* [[`c2d04233d0`](https://github.com/fibjs/fibjs/commit/c2d04233d0)] - **constants, feat**: add constants.(xicilion)
* [[`6e33d8cbed`](https://github.com/fibjs/fibjs/commit/6e33d8cbed)] - **v8, bugfix**: wasm crashes when compiling.(xicilion)
* [[`8c790052da`](https://github.com/fibjs/fibjs/commit/8c790052da)] - **sandbox**: refactor: call the async function directly in the loader without using the util.sync.(xicilion)
* [[`abc9069191`](https://github.com/fibjs/fibjs/commit/abc9069191)] - **util, refactor**: wrap the async function directly to the sync function without callbackify.(xicilion)
* [[`c61fc8c3f7`](https://github.com/fibjs/fibjs/commit/c61fc8c3f7)] - **core, refactor**: refactor fiber local.(xicilion)
* [[`1aff7fe8e9`](https://github.com/fibjs/fibjs/commit/1aff7fe8e9)] - **crypto, bugfix**: compile warning on Windows.(xicilion)
* [[`adbbc26e75`](https://github.com/fibjs/fibjs/commit/adbbc26e75)] - **db, bugfix**: the data types of tinytext and text are converted to Buffer on mysql.(xicilion)
* [[`091806f35e`](https://github.com/fibjs/fibjs/commit/091806f35e)] - **db, bugfix**: LevelDB returns wrong data when concurrently read under windows.(xicilion)
* [[`5dc74a33da`](https://github.com/fibjs/fibjs/commit/5dc74a33da)] - **fs, bugfix**: fs.lstat crash on Linux.(xicilion)
* [[`173859dd10`](https://github.com/fibjs/fibjs/commit/173859dd10)] - **fs, refactor**: use sync uv function to implement fs methods.(xicilion)
* [[`4b34337ad4`](https://github.com/fibjs/fibjs/commit/4b34337ad4)] - **build, bugfix**: solve the dependency of glibc 2.17.(xicilion)
* [[`1fef5d8010`](https://github.com/fibjs/fibjs/commit/1fef5d8010)] - **db, feat**: disable fiber free for LevelDB.(xicilion)
* [[`c8bc2dae60`](https://github.com/fibjs/fibjs/commit/c8bc2dae60)] - **core, feat**: support jemalloc on Windows.(xicilion)
* [[`d23fddacbf`](https://github.com/fibjs/fibjs/commit/d23fddacbf)] - **ws, feat**: ts files for websocket.(xicilion)
* [[`633c19a98e`](https://github.com/fibjs/fibjs/commit/633c19a98e)] - **leveldb, feat**: support flush.(xicilion)
* [[`45e7194126`](https://github.com/fibjs/fibjs/commit/45e7194126)] - **db, bugfix**: error message of leveldb is truncated.(xicilion)
* [[`b7d47c505d`](https://github.com/fibjs/fibjs/commit/b7d47c505d)] - **v8, feat**: enable snapshot.(xicilion)
* [[`09483ab77b`](https://github.com/fibjs/fibjs/commit/09483ab77b)] - **ws, refactor**: not enable perMessageDeflate by default.(xicilion)
* [[`a76ba328b9`](https://github.com/fibjs/fibjs/commit/a76ba328b9)] - **Buffer, refactor**: copy memory when get_buffer.(xicilion)
* [[`52d1f3f6ef`](https://github.com/fibjs/fibjs/commit/52d1f3f6ef)] - **Buffer, bugfix**: remove unnecessary extMemory (#710)(gmxyb)
* [[`bb52186ef2`](https://github.com/fibjs/fibjs/commit/bb52186ef2)] - **net, bugfix**: add error code CALL_E_NETNAME_DELETED (#711)(gmxyb)
* [[`ec98dc5b46`](https://github.com/fibjs/fibjs/commit/ec98dc5b46)] - **Buffer, feat**: optimize concat() (#709)(gmxyb)
* [[`871f60f1eb`](https://github.com/fibjs/fibjs/commit/871f60f1eb)] - **build_tools, feat**: upgrade to correct checking for lib atomic on posix.(xicilion)
* [[`1ee5f61f9c`](https://github.com/fibjs/fibjs/commit/1ee5f61f9c)] - **tools, feat**: add libx11 to ubuntu_env.sh(xicilion)
* [[`ef26e77c34`](https://github.com/fibjs/fibjs/commit/ef26e77c34)] - **options, bugfix**: decompression speed is very slow when installing the npm package.(xicilion)
* [[`0b413eaeb4`](https://github.com/fibjs/fibjs/commit/0b413eaeb4)] - **Buffer, feat**: support Buffer.buffer.(xicilion)
* [[`e8f275a549`](https://github.com/fibjs/fibjs/commit/e8f275a549)] - **options, refactor**: remove unused flags.(xicilion)
* [[`edca22a777`](https://github.com/fibjs/fibjs/commit/edca22a777)] - **vender, feat**: upgrade to use v8 7.8.285 (#707)(Ray)
* [[`0a5f693183`](https://github.com/fibjs/fibjs/commit/0a5f693183)] - **UVStream, bugfix**: out-of-bounds data operations will occur in get_fd.(xicilion)
* [[`83c1f55ca1`](https://github.com/fibjs/fibjs/commit/83c1f55ca1)] - **v8, feat**: upgrade v8 to v7.8.5.(xicilion)
* [[`ef090e5f80`](https://github.com/fibjs/fibjs/commit/ef090e5f80)] - **core, feat**: automatically modify the value of max_old_space_size according to the system memory.(xicilion)
* [[`6522012e60`](https://github.com/fibjs/fibjs/commit/6522012e60)] - **http, feat**: add the enableEncoding option, turn off the encoding support of HttpServer by default.(xicilion)
* [[`d644375948`](https://github.com/fibjs/fibjs/commit/d644375948)] - **perf_hooks, feat**: support simple perf_hooks module.(xicilion)
* [[`4e45b73193`](https://github.com/fibjs/fibjs/commit/4e45b73193)] - **fs, bugfix**: time error in fs.stat.(xicilion)
* [[`14c630745b`](https://github.com/fibjs/fibjs/commit/14c630745b)] - **process, refactor**: use uv to get hrtime.(xicilion)
* [[`2354b92a87`](https://github.com/fibjs/fibjs/commit/2354b92a87)] - **worker, feat**: add worker_threads module, compatible with node.js.(xicilion)
* [[`f339c118e1`](https://github.com/fibjs/fibjs/commit/f339c118e1)] - **sandbox, refactor**: rename argv to __argv.(xicilion)
* [[`2d7be5ec77`](https://github.com/fibjs/fibjs/commit/2d7be5ec77)] - **http, bugfix**: larger maxBodySize will cause calculation errors.(xicilion)
* [[`2d583676f1`](https://github.com/fibjs/fibjs/commit/2d583676f1)] - **Routing, bugfix**: the encoded url value is not decoded.(xicilion)
* [[`8b44bd106c`](https://github.com/fibjs/fibjs/commit/8b44bd106c)] - **hash, feat**: support sm3 prepare.(xicilion)
* [[`ce4d856220`](https://github.com/fibjs/fibjs/commit/ce4d856220)] - **vender, feat**: upgrade and adapt.(richardo2016)
* [[`ab24888311`](https://github.com/fibjs/fibjs/commit/ab24888311)] - **crypto, bugfix**: md_alg is not set when in X509Req.sign.(xicilion)
* [[`469bff06c4`](https://github.com/fibjs/fibjs/commit/469bff06c4)] - **crypto, feat**: support query sig_md/sig_pk in X509Cert.(xicilion)
* [[`c1b8faacd5`](https://github.com/fibjs/fibjs/commit/c1b8faacd5)] - **msgpack, bugfix**: new Boolean(false) encode error.(xicilion)
* [[`5cd7e694f1`](https://github.com/fibjs/fibjs/commit/5cd7e694f1)] - **gui, feat**: enable hight dpi support on windows. #700(xicilion)
* [[`8a5cc9f6df`](https://github.com/fibjs/fibjs/commit/8a5cc9f6df)] - **crypto, bugfix**: make big data block encryption very slow.(xicilion)
* [[`c1fd710c69`](https://github.com/fibjs/fibjs/commit/c1fd710c69)] - **gui, feat**: add test case for download event.(xicilion)
* [[`df38b529c7`](https://github.com/fibjs/fibjs/commit/df38b529c7)] - **test, refactor**: enhance the stability of cef test.(xicilion)
* [[`927da0dffa`](https://github.com/fibjs/fibjs/commit/927da0dffa)] - **encoding, bugfix**: compile warning in debug mode.(xicilion)
* [[`c0c91a3163`](https://github.com/fibjs/fibjs/commit/c0c91a3163)] - **core, refactor**: add isolate to list before init.(xicilion)
* [[`cdde8d8ec0`](https://github.com/fibjs/fibjs/commit/cdde8d8ec0)] - **v8, feat**: upgrade v8 to 7.4.301.(xicilion)
* [[`12ce6a5765`](https://github.com/fibjs/fibjs/commit/12ce6a5765)] - **gui, feat**: support download event in cef WebView.(xicilion)
* [[`3566ae8fa5`](https://github.com/fibjs/fibjs/commit/3566ae8fa5)] - **gui, feat**: support to control download behavior in cef webview.(xicilion)
* [[`aba24d0240`](https://github.com/fibjs/fibjs/commit/aba24d0240)] - **encoding, feat**: do not fill "=" characters in base64-url encode.(xicilion)
* [[`b82b818cb5`](https://github.com/fibjs/fibjs/commit/b82b818cb5)] - dev 0.34.0(richardo2016)
* [[`c5325283bd`](https://github.com/fibjs/fibjs/commit/c5325283bd)] - Release 0.33.0(richardo2016)
* [[`8db48bc23e`](https://github.com/fibjs/fibjs/commit/8db48bc23e)] - **child_process, feat**: fallback to 'pipe' for incomplete 'options.stdio' array on spawn/fork child_process(richardo2016)
* [[`d88d9661c3`](https://github.com/fibjs/fibjs/commit/d88d9661c3)] - **child_process, bugfix**: crash when bad stdio array.(xicilion)
* [[`123b40f220`](https://github.com/fibjs/fibjs/commit/123b40f220)] - **db, feat**: add document.(xicilion)
* [[`af64d0aaec`](https://github.com/fibjs/fibjs/commit/af64d0aaec)] - **db, refactor**: refactor db_format.(xicilion)
* [[`6f80cac57a`](https://github.com/fibjs/fibjs/commit/6f80cac57a)] - **http, feat**: auto return json/msgpack data in HttpMessage.data (#695)(lhkzh)
* [[`e7327b31e4`](https://github.com/fibjs/fibjs/commit/e7327b31e4)] - **encoding, refactor**: deprecate base64vlq.(xicilion)
* [[`ce181e6fff`](https://github.com/fibjs/fibjs/commit/ce181e6fff)] - **Buffer, bugfix**: binary encoding error.(xicilion)
* [[`fb65ed023c`](https://github.com/fibjs/fibjs/commit/fb65ed023c)] - **test, feat**: update files for jsc test.(richardo2016)
* [[`58a60cb3da`](https://github.com/fibjs/fibjs/commit/58a60cb3da)] - **child_process, feat**: support pty on posix.(xicilion)
* [[`7566d7f266`](https://github.com/fibjs/fibjs/commit/7566d7f266)] - **msgpack, feat**: support number_safe_int. (#694)(lhkzh)
* [[`aaba4b1ce3`](https://github.com/fibjs/fibjs/commit/aaba4b1ce3)] - **vender, feat**: upgrade to use v8 7.2(richardo2016)
* [[`52eb452ccb`](https://github.com/fibjs/fibjs/commit/52eb452ccb)] - **db, refactor**: refactor odbc_connect, simplify the implementation of driver.(xicilion)
* [[`75bb1981c9`](https://github.com/fibjs/fibjs/commit/75bb1981c9)] - **db, feat**: support custom odbc driver.(xicilion)
* [[`8cd4648e42`](https://github.com/fibjs/fibjs/commit/8cd4648e42)] - **db, feat**: support PostgreSQL.(xicilion)
* [[`c4401579a3`](https://github.com/fibjs/fibjs/commit/c4401579a3)] - **db, refactor**: detect null value use SQL_NULL_DATA.(xicilion)
* [[`84a22e53ea`](https://github.com/fibjs/fibjs/commit/84a22e53ea)] - **db, feat**: support null value in odbc driver.(xicilion)
* [[`30bb46a1bd`](https://github.com/fibjs/fibjs/commit/30bb46a1bd)] - **db, refactor**: remove db.format, refactor db test.(xicilion)
* [[`941b17428f`](https://github.com/fibjs/fibjs/commit/941b17428f)] - **db, bugfix**: float type error on mssql.(xicilion)
* [[`ed98f5873a`](https://github.com/fibjs/fibjs/commit/ed98f5873a)] - **types, feat**: improvement.(richardo2016)
* [[`e795200e2a`](https://github.com/fibjs/fibjs/commit/e795200e2a)] - **db, feat**: support more dara type.(xicilion)
* [[`205d76a781`](https://github.com/fibjs/fibjs/commit/205d76a781)] - **db, feat**: rewrite mssql use odbc driver and support mssql on unix.(xicilion)
* [[`1b80c7208e`](https://github.com/fibjs/fibjs/commit/1b80c7208e)] - **db, refactor**: move function mssql::error into cpp.(xicilion)
* [[`864b9cf873`](https://github.com/fibjs/fibjs/commit/864b9cf873)] - **db, refactor**: use template to refactor db_format.(xicilion)
* [[`25b486a503`](https://github.com/fibjs/fibjs/commit/25b486a503)] - **db, refactor**: refactor db api use class template.(xicilion)
* [[`f86676bc77`](https://github.com/fibjs/fibjs/commit/f86676bc77)] - **build, bugfix**: compile warning on Windows.(xicilion)
* [[`9415776df3`](https://github.com/fibjs/fibjs/commit/9415776df3)] - **db, refactor**: move function use into DBConnection.(xicilion)
* [[`8b3a9f42c8`](https://github.com/fibjs/fibjs/commit/8b3a9f42c8)] - **db, bugfix**: SIZEOF_LONG_INT set to 8 on 32 bits system.(xicilion)
* [[`b0df74d32a`](https://github.com/fibjs/fibjs/commit/b0df74d32a)] - **crypto, bugfix**: support ripemd160 and sm3 in rsa/sm2 sign.(xicilion)
* [[`3411a5a003`](https://github.com/fibjs/fibjs/commit/3411a5a003)] - **db, feat**: compile error on Windows i386.(xicilion)
* [[`c9e9c00acd`](https://github.com/fibjs/fibjs/commit/c9e9c00acd)] - **db, feat**: support odbc.(xicilion)
* [[`d5d21032f7`](https://github.com/fibjs/fibjs/commit/d5d21032f7)] - **db, refactor**: move db_api.h to db folder.(xicilion)
* [[`2a08577eae`](https://github.com/fibjs/fibjs/commit/2a08577eae)] - **NArray, refactor**: use simpler length syntax.(xicilion)
* [[`125b8b0049`](https://github.com/fibjs/fibjs/commit/125b8b0049)] - **db, feat**: change async mode to long-sync.(xicilion)
* [[`bc91b3a2b9`](https://github.com/fibjs/fibjs/commit/bc91b3a2b9)] - **types, feat**: typings change.(richardo2016)
* [[`731793b775`](https://github.com/fibjs/fibjs/commit/731793b775)] - **gui, refactor**: use dl_func to wrap x11 function.(xicilion)
* [[`b110035b53`](https://github.com/fibjs/fibjs/commit/b110035b53)] - **crypto, feat**: add document for getHashes.(xicilion)
* [[`7a1ec0e88f`](https://github.com/fibjs/fibjs/commit/7a1ec0e88f)] - **hash, feat**: support data as an optional parameter when creating Digest.(xicilion)
* [[`027b3feed5`](https://github.com/fibjs/fibjs/commit/027b3feed5)] - **idlc, feat**: support null default value.(xicilion)
* [[`9cf9b1c279`](https://github.com/fibjs/fibjs/commit/9cf9b1c279)] - **crypto, feat**: support sign/verify in Digest.(xicilion)
* [[`e755aa25e4`](https://github.com/fibjs/fibjs/commit/e755aa25e4)] - **crypto, feat**: add crypto.getHashes()(richardo2016)
* [[`12793e8bd6`](https://github.com/fibjs/fibjs/commit/12793e8bd6)] - **types, feat**: adjust, add test about types.(richardo2016)
* [[`f994085b64`](https://github.com/fibjs/fibjs/commit/f994085b64)] - **fs, bugfix**: stat.isSymbolicLink always returns false on Windows.(xicilion)
* [[`cd1413ba10`](https://github.com/fibjs/fibjs/commit/cd1413ba10)] - **fs, bugfix**: when the path exists, fs.mkdir should not raise an error in recursive mode.(xicilion)
* [[`2594b18f72`](https://github.com/fibjs/fibjs/commit/2594b18f72)] - **gui, bugfix**: fixup resource request on win32 webview:(richardo2016)
* [[`394ac7b3be`](https://github.com/fibjs/fibjs/commit/394ac7b3be)] - **idl, bugfix**: support method overrides, and rest parameters.(richardo2016)
* [[`47dc757286`](https://github.com/fibjs/fibjs/commit/47dc757286)] - **idl, bugfix**: repair missing method params for interface.(richardo2016)
* [[`943fe32e6e`](https://github.com/fibjs/fibjs/commit/943fe32e6e)] - **process, refactor**: use exit instead of _exit to quit current process.(xicilion)
* [[`261b7b6063`](https://github.com/fibjs/fibjs/commit/261b7b6063)] - **test, feat**: support passing a callback function to done to handle the asynchronous test.(xicilion)
* [[`d4eb14a3b9`](https://github.com/fibjs/fibjs/commit/d4eb14a3b9)] - **encoding, refactor**: optimize hex/base64 encode/decode performance.(xicilion)
* [[`69de147f98`](https://github.com/fibjs/fibjs/commit/69de147f98)] - **tools, feat**: support generate *.d.ts from fibjs's idl.(richardo2016)
* [[`230be65408`](https://github.com/fibjs/fibjs/commit/230be65408)] - **core, refactor**: use the new toString instead of Utf8Value to convert v8 strings.(xicilion)
* [[`2b363dc2c9`](https://github.com/fibjs/fibjs/commit/2b363dc2c9)] - **core, refactor**: use uint64_t to detect strings to speed up detection.(xicilion)
* [[`b315a7c7a5`](https://github.com/fibjs/fibjs/commit/b315a7c7a5)] - **options, feat**: install cli link into .bin folder.(xicilion)
* [[`04a49c0a63`](https://github.com/fibjs/fibjs/commit/04a49c0a63)] - **cef, feat**: update to v90.(xicilion)
* [[`c8c4f1ff15`](https://github.com/fibjs/fibjs/commit/c8c4f1ff15)] - **build, feat**: support armv6 cross compiler.(xicilion)
* [[`45e7f93228`](https://github.com/fibjs/fibjs/commit/45e7f93228)] - **core, refactor**: use union to detect big-endian architecture at runtime.(xicilion)
* [[`851bb90a76`](https://github.com/fibjs/fibjs/commit/851bb90a76)] - **core, bugfix**: cannot parse some string formats of data correctly, #681(xicilion)
* [[`3e210b23c5`](https://github.com/fibjs/fibjs/commit/3e210b23c5)] - **iconv, feat**: support built-in ucs2le/ucs2be/ucs4le/ucs4be charset.(xicilion)
* [[`7f5e7c45f5`](https://github.com/fibjs/fibjs/commit/7f5e7c45f5)] - **child_process, bugfix**: the test will not end on a very slow machine.(xicilion)
* [[`416e3c7584`](https://github.com/fibjs/fibjs/commit/416e3c7584)] - **websocket, bugfix**: message encode error on big-endian arch.(xicilion)
* [[`186f9994cc`](https://github.com/fibjs/fibjs/commit/186f9994cc)] - **Buffer, bugfix**: readNumber/writeNumber error on big-endain arch.(xicilion)
* [[`90a55c9170`](https://github.com/fibjs/fibjs/commit/90a55c9170)] - **fs, bugfix**: fstat mode error when create directory and file.(Yuanhang)
* [[`4c87328b40`](https://github.com/fibjs/fibjs/commit/4c87328b40)] - **os, bugfix**: os.arch return nothing on mips/mips64.(xicilion)
* [[`2d2d659daf`](https://github.com/fibjs/fibjs/commit/2d2d659daf)] - **build, feat**: script to switch qemu simulation environment.(xicilion)
* [[`a0054383b8`](https://github.com/fibjs/fibjs/commit/a0054383b8)] - **ssl, bugfix**: crash on verify ssl.ca, #679(Yuanhang)
* [[`48511dc2c0`](https://github.com/fibjs/fibjs/commit/48511dc2c0)] - **docs, bugfix**: some description errors in setClientCert parameters.(xicilion)
* [[`7a6a7ece85`](https://github.com/fibjs/fibjs/commit/7a6a7ece85)] - **option, feat**: update --help message.(xicilion)
* [[`52ba9f89f6`](https://github.com/fibjs/fibjs/commit/52ba9f89f6)] - **core, bugfix**: runtime error in i386 mode on Windows.(xicilion)
* [[`f438eef266`](https://github.com/fibjs/fibjs/commit/f438eef266)] - **core, bugfix**: compile error on Linux.(xicilion)
* [[`a9fe8b16b7`](https://github.com/fibjs/fibjs/commit/a9fe8b16b7)] - **os, feat**: support to report external memory in memoryUsage.(xicilion)
* [[`253c0e3a5c`](https://github.com/fibjs/fibjs/commit/253c0e3a5c)] - **core, refactor**: use external-resource to implement zero-copy transfer string between fibjs and v8, #678(xicilion)
* [[`3730764753`](https://github.com/fibjs/fibjs/commit/3730764753)] - **core, refactor**: refactor the urf8 encode/decode, improve coding performance.(xicilion)
* [[`080386f5cb`](https://github.com/fibjs/fibjs/commit/080386f5cb)] - **Sandbox, feat**: support to run scripts in node_modules/.bin folder.(xicilion)
* [[`81e5a4e30c`](https://github.com/fibjs/fibjs/commit/81e5a4e30c)] - **util, refactor**: move the processing of special types out of object.(xicilion)
* [[`8c4e458221`](https://github.com/fibjs/fibjs/commit/8c4e458221)] - **util, feat**: support output Symbol details.(xicilion)
* [[`a7bdeaaf8d`](https://github.com/fibjs/fibjs/commit/a7bdeaaf8d)] - **Buffer, feat**: implement Buffer object iterable.(xicilion)
* [[`174d450f99`](https://github.com/fibjs/fibjs/commit/174d450f99)] - **core, feat**: support for defining iterator operators.(xicilion)
* [[`da0b4fe233`](https://github.com/fibjs/fibjs/commit/da0b4fe233)] - **punycode, bugfix**: punycode.decode results in a segmentation fault, #675(xicilion)
* [[`02e53f350a`](https://github.com/fibjs/fibjs/commit/02e53f350a)] - **build, feat**: display dependents of fibjs.exe in release mode.(xicilion)
* [[`1939e082aa`](https://github.com/fibjs/fibjs/commit/1939e082aa)] - **path, bugfix**: do not set the drive character when the base path is empty.(xicilion)
* [[`6a5f74ab29`](https://github.com/fibjs/fibjs/commit/6a5f74ab29)] - **core, refactor**: strictly distinguish between access and reference to the elements of string, and eliminate unnecessary memory copy.(xicilion)
* [[`5e660884eb`](https://github.com/fibjs/fibjs/commit/5e660884eb)] - **Buffer, bugfix**: querying values() on a very huge Buffer will cause the Buffer to crash, #676(xicilion)
* [[`4f44ea3d5e`](https://github.com/fibjs/fibjs/commit/4f44ea3d5e)] - **events, refactor**: fix param name in EventEmitter.removeAllListeners.(xicilion)
* [[`d48deedfbd`](https://github.com/fibjs/fibjs/commit/d48deedfbd)] - **crypto, bugfix**: too large matrix size will cause crypto.randomArt to crash, #677(xicilion)
* [[`6c6be87584`](https://github.com/fibjs/fibjs/commit/6c6be87584)] - **http, feat**: auto return json data in HttpMessage.data.(xicilion)
* [[`3492f6299e`](https://github.com/fibjs/fibjs/commit/3492f6299e)] - **url, feat**: support url.resolve.(xicilion)
* [[`a8f7761548`](https://github.com/fibjs/fibjs/commit/a8f7761548)] - **util, feat**: support Promise type in util.format.(xicilion)
* [[`244facf443`](https://github.com/fibjs/fibjs/commit/244facf443)] - **process, feat**: dump full memory information  in debug mode on Windows.(xicilion)
* [[`a4b75ca9cf`](https://github.com/fibjs/fibjs/commit/a4b75ca9cf)] - **http, bugfix**: compile warning on Windows.(xicilion)
* [[`ff189b058a`](https://github.com/fibjs/fibjs/commit/ff189b058a)] - **core, refactor**: enable lazy compile.(xicilion)
* [[`0b6a213813`](https://github.com/fibjs/fibjs/commit/0b6a213813)] - **http, refactor**: remove unnecessary odescribe restrictions.(xicilion)
* [[`4a7b30dbf1`](https://github.com/fibjs/fibjs/commit/4a7b30dbf1)] - **core, bugfix**: uv_timer_t is not released correctly when the timer ends.(xicilion)
* [[`44e75efbb2`](https://github.com/fibjs/fibjs/commit/44e75efbb2)] - **net, bugfix**: ipv6 bind error on UVSocket.(xicilion)
* [[`5d3c404171`](https://github.com/fibjs/fibjs/commit/5d3c404171)] - **build, bugfix**: compile warning on Windows.(xicilion)
* [[`90fd788e6e`](https://github.com/fibjs/fibjs/commit/90fd788e6e)] - **child_process, feat**: add document for options.stdio.(xicilion)
* [[`306b4b75c0`](https://github.com/fibjs/fibjs/commit/306b4b75c0)] - **isolate, refactor**: use StrictEquals to compare object.(xicilion)
* [[`2c575b134c`](https://github.com/fibjs/fibjs/commit/2c575b134c)] - **isolate, refactor**: use v8::Local<v8::Object>::Cast to convert the data type.(xicilion)
* [[`9f72d88805`](https://github.com/fibjs/fibjs/commit/9f72d88805)] - **assert, bugfix**: assert crash when valueOf throw error.(xicilion)
* [[`138f0ad859`](https://github.com/fibjs/fibjs/commit/138f0ad859)] - **util, bugfix**: intersection crash when valueOf throw error, #673(xicilion)
* [[`0f966ac78b`](https://github.com/fibjs/fibjs/commit/0f966ac78b)] - **db, refactor**: move leveldb test case into group.(xicilion)
* [[`b302062e1d`](https://github.com/fibjs/fibjs/commit/b302062e1d)] - **Buffer, bugfix**: passing a large offset to Buffer.writeUInt32BE will cause fibjs to crash, #672(xicilion)
* [[`2317cf6efb`](https://github.com/fibjs/fibjs/commit/2317cf6efb)] - **core, bugfix**: compile error on Windows.(xicilion)
* [[`9fb9876e9e`](https://github.com/fibjs/fibjs/commit/9fb9876e9e)] - **core, bugfix**: deleting js objects directly in the uv thread after closing uv_handle will cause fibjs to crash.(xicilion)
* [[`489dda67b1`](https://github.com/fibjs/fibjs/commit/489dda67b1)] - **core, refactor**: change v8 memory space to 2048.(xicilion)
* [[`cd1d8186c2`](https://github.com/fibjs/fibjs/commit/cd1d8186c2)] - **encoding, refactor**: deprecated bson module.(xicilion)
* [[`f76efac292`](https://github.com/fibjs/fibjs/commit/f76efac292)] - **util, bugfix**: memory limit causes GC to crash, #658(xicilion)
* [[`73a245a856`](https://github.com/fibjs/fibjs/commit/73a245a856)] - **core, refactor**: convert utf8 string directly to v8 string.(xicilion)
* [[`60ecb9e7a2`](https://github.com/fibjs/fibjs/commit/60ecb9e7a2)] - **net, refactor**: compile warning in debug mode on Windows.(xicilion)
* [[`5fd70f87d6`](https://github.com/fibjs/fibjs/commit/5fd70f87d6)] - **util, bugfix**: flatten a circular reference object will cause fibjs to crash, #669(xicilion)
* [[`5958f8ba04`](https://github.com/fibjs/fibjs/commit/5958f8ba04)] - **Buffer, bugfix**: passing a large offset to Buffer.readUIntLE will cause fibjs to crash, #667(xicilion)
* [[`509c63ff7d`](https://github.com/fibjs/fibjs/commit/509c63ff7d)] - **console, feat**: change the color of warn message to YELLOW.(xicilion)
* [[`22757bc361`](https://github.com/fibjs/fibjs/commit/22757bc361)] - **crypto, bugfix**: Illegal iterations and size parameters will cause crypto.pbkdf1 or crypto.pbkdf2 to crash, #670 #671(xicilion)
* [[`f9a274e793`](https://github.com/fibjs/fibjs/commit/f9a274e793)] - **encode, bugfix**: std::bad_alloc error will be caused when processing strings longer than 2G, #661(xicilion)
* [[`31d95a2151`](https://github.com/fibjs/fibjs/commit/31d95a2151)] - **Buffer, bugfix**: specifying a huge negative number for the offset of Buffer.slice will cause a segmentation fault, #666(xicilion)
* [[`087b47648f`](https://github.com/fibjs/fibjs/commit/087b47648f)] - **util, bugfix**: running util.deepFreeze on Buffer will result in illegal hardware instructions. #663(xicilion)
* [[`bfbe361e6e`](https://github.com/fibjs/fibjs/commit/bfbe361e6e)] - **crypto, bugfix**: specifying a negative size of crypto.randomBytes will cause a segmentation fault, #664 #665(xicilion)
* [[`3b1f925493`](https://github.com/fibjs/fibjs/commit/3b1f925493)] - **crypto, bugfix**: specifying the size of crypto.randomArt as 0 will cause a segmentation fault, #662(xicilion)
* [[`b024b3beae`](https://github.com/fibjs/fibjs/commit/b024b3beae)] - **util, feat**: optimize the output of nested objects, do not collapse empty objects.(xicilion)
* [[`4ff211bf01`](https://github.com/fibjs/fibjs/commit/4ff211bf01)] - **util, feat**: display different information for one more item and multiple more items.(xicilion)
* [[`80eb72dbca`](https://github.com/fibjs/fibjs/commit/80eb72dbca)] - **io, bugfix**: reading data from rangestream does not change the current position correctly.(xicilion)
* [[`f64622b64d`](https://github.com/fibjs/fibjs/commit/f64622b64d)] - **util, feat**: limit the number of items in the Buffer output. #657(xicilion)
* [[`a545b7b63d`](https://github.com/fibjs/fibjs/commit/a545b7b63d)] - **util, feat**: limit the number of items in the array output.(xicilion)
* [[`e565772260`](https://github.com/fibjs/fibjs/commit/e565772260)] - **util, feat**: limit the level of obejct output.(xicilion)
* [[`15199a3319`](https://github.com/fibjs/fibjs/commit/15199a3319)] - **Buffer, bugfix**: fibjs will crash when the offset of Buffer.writeXXX is negative, #659(xicilion)
* [[`f78f319693`](https://github.com/fibjs/fibjs/commit/f78f319693)] - **Buffer, bugfix**: fibjs will crash when the offset parameter of Buffer.read is negative, issue 655.(xicilion)
* [[`411413da12`](https://github.com/fibjs/fibjs/commit/411413da12)] - **net, bugfix**: access socket on unconnected smtp object causes segmentation fault, issue #654.(xicilion)
* [[`9109a16b21`](https://github.com/fibjs/fibjs/commit/9109a16b21)] - **db, bugfix**: levelDB.mget results in a segmentation fault, issue #653.(xicilion)
* [[`e01e10eae2`](https://github.com/fibjs/fibjs/commit/e01e10eae2)] - **net, refactor**: not remove domain file on Windows.(xicilion)
* [[`55ee8de1d8`](https://github.com/fibjs/fibjs/commit/55ee8de1d8)] - **punycode, bugfix**: punycode.decode results in a floating point exception, issue #652.(xicilion)
* [[`6d030a7547`](https://github.com/fibjs/fibjs/commit/6d030a7547)] - **repl, bugfix**: repl cannot handle incomplete statements normally, issue #651.(xicilion)
* [[`d824ad7da0`](https://github.com/fibjs/fibjs/commit/d824ad7da0)] - **zlib, bugfix**: passing an invalid level parameter to zlib.deflate will cause fibjs to crash.(xicilion)
* [[`e35a0c24b8`](https://github.com/fibjs/fibjs/commit/e35a0c24b8)] - **bson, bugfix**: crash when decode invaid data type, issue #648.(xicilion)
* [[`0e29a1303b`](https://github.com/fibjs/fibjs/commit/0e29a1303b)] - **event, feat**: removeAllListeners support remove single event.(xicilion)
* [[`d06fe997b0`](https://github.com/fibjs/fibjs/commit/d06fe997b0)] - **fs.refactor**: Restore SEEK_* constants defined in fs.(xicilion)
* [[`e5ab5c3c76`](https://github.com/fibjs/fibjs/commit/e5ab5c3c76)] - **child_process, feat**: support fork.(xicilion)
* [[`f496f3b105`](https://github.com/fibjs/fibjs/commit/f496f3b105)] - **tty, feat**: replace stdio stream in process:(richardo2016)
* [[`74b2ca8bd7`](https://github.com/fibjs/fibjs/commit/74b2ca8bd7)] - **Isolate, feat**: normalize initialization for stdio instance.(richardo2016)
* [[`2d28b7832a`](https://github.com/fibjs/fibjs/commit/2d28b7832a)] - **http, bugfix**: compile error on linux.(xicilion)
* [[`4239ce2435`](https://github.com/fibjs/fibjs/commit/4239ce2435)] - **util, feat**: implement util.callbackify.(xicilion)
* [[`2a8ddc896a`](https://github.com/fibjs/fibjs/commit/2a8ddc896a)] - **http, bugfix**: request option process error.(xicilion)
* [[`4007c40989`](https://github.com/fibjs/fibjs/commit/4007c40989)] - **http, feat**: support pack option for msgpack. (#647)(lhkzh)
* [[`b09f506542`](https://github.com/fibjs/fibjs/commit/b09f506542)] - **net, feat**: support unix socket and Windows pipe.(xicilion)
* [[`cef2d9058b`](https://github.com/fibjs/fibjs/commit/cef2d9058b)] - **url, feat**: support unix socket and windows pipe host name.(xicilion)
* [[`af4c4ba870`](https://github.com/fibjs/fibjs/commit/af4c4ba870)] - **docs, refactor**: use nomnoml to render graph.(xicilion)
* [[`e37047d8da`](https://github.com/fibjs/fibjs/commit/e37047d8da)] - **fs, feat**: disable test for `fs.watch` option `recursive` on Linux.(richardo2016)
* [[`23f0e89ca4`](https://github.com/fibjs/fibjs/commit/23f0e89ca4)] - **fs, bugfix**: correct to emit changed filename for FSWatcher.(richardo2016)
* [[`218e55d98d`](https://github.com/fibjs/fibjs/commit/218e55d98d)] - **console, bugfix**: on windows, line breaks are output as \n when stdout/stderr is redirected.(xicilion)
* [[`3240236b9a`](https://github.com/fibjs/fibjs/commit/3240236b9a)] - **Stream, bugfix**: read throw error when connection reset by peer.(xicilion)
* [[`1023a664c4`](https://github.com/fibjs/fibjs/commit/1023a664c4)] - **util, bugfix**: fixup build error on Windows.(richardo2016)
* [[`2b1bfcbf26`](https://github.com/fibjs/fibjs/commit/2b1bfcbf26)] - **docs, feat**: document HttpCookie.(xicilion)
* [[`32b10e9486`](https://github.com/fibjs/fibjs/commit/32b10e9486)] - **docs, feat**: more language.(xicilion)
* [[`3854a49c10`](https://github.com/fibjs/fibjs/commit/3854a49c10)] - **vender, feat**: update expat&zlib.(xicilion)
* [[`2015bd81aa`](https://github.com/fibjs/fibjs/commit/2015bd81aa)] - **ssl, feat**: update root certs.(xicilion)
* [[`36bff527be`](https://github.com/fibjs/fibjs/commit/36bff527be)] - **docs, bugfix**: typo.(xicilion)
* [[`95e144d78d`](https://github.com/fibjs/fibjs/commit/95e144d78d)] - **util, bugfix**: static functions of built-in modules are displayed with wrong function names.(xicilion)
* [[`6c51123a2e`](https://github.com/fibjs/fibjs/commit/6c51123a2e)] - **util, feat**: support util.promisify.(xicilion)
* [[`fde7a9af92`](https://github.com/fibjs/fibjs/commit/fde7a9af92)] - **core, feat**: support Error.code when throwing uv error.(xicilion)
* [[`364e4000dc`](https://github.com/fibjs/fibjs/commit/364e4000dc)] - **gui, feat**: not activating the application when the webview is headless.(xicilion)
* [[`0a01358b21`](https://github.com/fibjs/fibjs/commit/0a01358b21)] - **docs, feat**: translate only updated document.(xicilion)
* [[`8705463597`](https://github.com/fibjs/fibjs/commit/8705463597)] - **net, feat**: support use-uv-socket option.(xicilion)
* [[`f3d671f5d9`](https://github.com/fibjs/fibjs/commit/f3d671f5d9)] - **console, refactor**: use uv to output console message.(xicilion)
* [[`cd9ea25b95`](https://github.com/fibjs/fibjs/commit/cd9ea25b95)] - **Stream, refactor**: limit read buffer size.(xicilion)
* [[`f0c1a1f66f`](https://github.com/fibjs/fibjs/commit/f0c1a1f66f)] - **test, bugfix**: timeout test error under windows sometimes.(xicilion)
* [[`e1041b6a8c`](https://github.com/fibjs/fibjs/commit/e1041b6a8c)] - **Merge branch 'dev' of https**: //github.com/fibjs/fibjs into dev(xicilion)
* [[`98a036839c`](https://github.com/fibjs/fibjs/commit/98a036839c)] - **process, bugfix**: ignore SIGPIPE signal, fix abnormal exit when tcp connection is closed remotely under linux.(xicilion)
* [[`264805a18c`](https://github.com/fibjs/fibjs/commit/264805a18c)] - **build, chore**: merge and resolve conflict.(richardo2016)
* [[`bebc98d199`](https://github.com/fibjs/fibjs/commit/bebc98d199)] - Release v0.32.1(richardo2016)
* [[`38886c8d8b`](https://github.com/fibjs/fibjs/commit/38886c8d8b)] - **tools, feat**: upgrade tools/changelog.js, driven by child_process module.(richardo2016)
* [[`0c65ff57f9`](https://github.com/fibjs/fibjs/commit/0c65ff57f9)] - **db, bugfix**: conn.begin error on mysql.(xicilion)
* [[`ae2ea1459f`](https://github.com/fibjs/fibjs/commit/ae2ea1459f)] - **EventEmitter, bugfix**: removeAllListeners() does not remove any listener.(xicilion)
* [[`8b9d85f8a4`](https://github.com/fibjs/fibjs/commit/8b9d85f8a4)] - **build, bugfix**: fibjs build with alpine 3.13 (#643)(Su Yang)
* [[`7ad97b7aeb`](https://github.com/fibjs/fibjs/commit/7ad97b7aeb)] - **net, feat**: use uv implement UVSocket.(xicilion)
* [[`897499f400`](https://github.com/fibjs/fibjs/commit/897499f400)] - **Stream, refactor**: use uv_post(function) to post async function into uv thread.(xicilion)
* [[`abe40df47a`](https://github.com/fibjs/fibjs/commit/abe40df47a)] - **Stream, refactor**: use uv_post to post uv tasks without waiting for execution to finish.(xicilion)
* [[`5fc60011b9`](https://github.com/fibjs/fibjs/commit/5fc60011b9)] - **Stream, feat**: support network package reading mode.(xicilion)
* [[`27ac337796`](https://github.com/fibjs/fibjs/commit/27ac337796)] - **Stream, feat**: allows the close function to be called in a closed stream.(xicilion)
* [[`82c6a99a62`](https://github.com/fibjs/fibjs/commit/82c6a99a62)] - **Stream, refactor**: use UVStream::create_pipe to create pipe stream.(xicilion)
* [[`ff071cd2ff`](https://github.com/fibjs/fibjs/commit/ff071cd2ff)] - **core, refactor**: use isolate_ref() instead of holder()->Ref().(xicilion)
* [[`fdc2c7b689`](https://github.com/fibjs/fibjs/commit/fdc2c7b689)] - **fs, bugfix**: compile error in debug mode on Windows.(xicilion)
* [[`92d7d75f9b`](https://github.com/fibjs/fibjs/commit/92d7d75f9b)] - **fs, refactor**: use uv_call to refactor fs.watch.(xicilion)
* [[`4355e53403`](https://github.com/fibjs/fibjs/commit/4355e53403)] - **dgram, refactor**: bind udp socket in worker fiber.(xicilion)
* [[`0e5d6541cf`](https://github.com/fibjs/fibjs/commit/0e5d6541cf)] - **dgram, refactor**: move code to source file.(xicilion)
* [[`47a4e6f0f0`](https://github.com/fibjs/fibjs/commit/47a4e6f0f0)] - **core, refactor**: refactor the error reporting framework to support uv error codes.(xicilion)
* [[`207a8505ce`](https://github.com/fibjs/fibjs/commit/207a8505ce)] - **child_process, bugfix**: crash when spawn return error.(xicilion)
* [[`7db883702e`](https://github.com/fibjs/fibjs/commit/7db883702e)] - **uv, refactor**: refactor uv process model.(xicilion)
* [[`0d1c6d45b7`](https://github.com/fibjs/fibjs/commit/0d1c6d45b7)] - **db, bugfix**: conn.begin error on mysql.(xicilion)
* [[`e2a657af85`](https://github.com/fibjs/fibjs/commit/e2a657af85)] - **net, refactor**: use Socket::_new to create socket.(xicilion)
* [[`b579d8baaa`](https://github.com/fibjs/fibjs/commit/b579d8baaa)] - **net, refactor**: remove udp support from net.Socket.(xicilion)
* [[`2e9d95e18a`](https://github.com/fibjs/fibjs/commit/2e9d95e18a)] - **fs, refactor**: rewrite fs.stat.(xicilion)
* [[`c1d34fb2d0`](https://github.com/fibjs/fibjs/commit/c1d34fb2d0)] - **test, bugfix**: http test error on Windows.(xicilion)
* [[`bf9cbd9c3d`](https://github.com/fibjs/fibjs/commit/bf9cbd9c3d)] - **fs, refactor**: define the uv_async function to simplify the implementation of the fs uv async function.(xicilion)
* [[`0ff0220291`](https://github.com/fibjs/fibjs/commit/0ff0220291)] - **test, bugfix**: actions test error on Windows.(xicilion)
* [[`5931893b65`](https://github.com/fibjs/fibjs/commit/5931893b65)] - **test, bugfix**: some test error.(xicilion)
* [[`f473cbe2a2`](https://github.com/fibjs/fibjs/commit/f473cbe2a2)] - **EventEmitter, bugfix**: removeAllListeners() does not remove any listener.(xicilion)
* [[`34b4cbb072`](https://github.com/fibjs/fibjs/commit/34b4cbb072)] - **test, bugfix**: ws test error on windows.(xicilion)
* [[`e448fe268b`](https://github.com/fibjs/fibjs/commit/e448fe268b)] - **test, bugfix**: some test error.(xicilion)
* [[`d8f6148847`](https://github.com/fibjs/fibjs/commit/d8f6148847)] - **dgram, bugfix**: tests on systems without IPv6 will report errors.(xicilion)
* [[`fb12430ad7`](https://github.com/fibjs/fibjs/commit/fb12430ad7)] - **dgram, bugfix**: test error on Linux.(xicilion)
* [[`bced2f270d`](https://github.com/fibjs/fibjs/commit/bced2f270d)] - **dgram, refactor**: use uv to implement udp socket.(xicilion)
* [[`0cd369caaf`](https://github.com/fibjs/fibjs/commit/0cd369caaf)] - **build, bugfix**: compile warning in debug mode on Windows.(xicilion)
* [[`5b08279735`](https://github.com/fibjs/fibjs/commit/5b08279735)] - **test, refactor**: enable process test.(xicilion)
* [[`48c86a374e`](https://github.com/fibjs/fibjs/commit/48c86a374e)] - **net, refactor**: use uv to convert inetAddr.(xicilion)
* [[`1be12ed80d`](https://github.com/fibjs/fibjs/commit/1be12ed80d)] - **os, refactor**: use uv to implament os/process function.(xicilion)
* [[`46b0eb4233`](https://github.com/fibjs/fibjs/commit/46b0eb4233)] - **test, refactor**: output error message to stdout.(xicilion)
* [[`a49529a050`](https://github.com/fibjs/fibjs/commit/a49529a050)] - **core, bugfix**: compile error in debug mode.(xicilion)
* [[`31f045b37d`](https://github.com/fibjs/fibjs/commit/31f045b37d)] - **fs, bugfix**: compile error on windows.(xicilion)
* [[`a769b360b3`](https://github.com/fibjs/fibjs/commit/a769b360b3)] - **fs, feat**: support recursive option in fs.mkdir.(xicilion)
* [[`7dba59b47b`](https://github.com/fibjs/fibjs/commit/7dba59b47b)] - **path, refactor**: define os_* api.(xicilion)
* [[`df90a7bd99`](https://github.com/fibjs/fibjs/commit/df90a7bd99)] - **core, refactor**: optimize the implementation of some string methods.(xicilion)
* [[`bc4d7699a1`](https://github.com/fibjs/fibjs/commit/bc4d7699a1)] - **fs, feat**: throw system error code.(xicilion)
* [[`3251707458`](https://github.com/fibjs/fibjs/commit/3251707458)] - **gui, bugfix**: cef subprocess does not initialize uv, causing fs.exists to fail.(xicilion)
* [[`907e560fb8`](https://github.com/fibjs/fibjs/commit/907e560fb8)] - **dgram, bugfix**: change test port.(xicilion)
* [[`62be044f11`](https://github.com/fibjs/fibjs/commit/62be044f11)] - **core, refactor**: add C_ before the const variable name to avoid conflicts between variable names and system variables.(xicilion)
* [[`9d86436040`](https://github.com/fibjs/fibjs/commit/9d86436040)] - **fs, refactor**: use destructor to destroy uv_fs_t structure.(xicilion)
* [[`521a493b7f`](https://github.com/fibjs/fibjs/commit/521a493b7f)] - **fs, refactor**: use uv to implament fs.readdir function.(xicilion)
* [[`f4813033cc`](https://github.com/fibjs/fibjs/commit/f4813033cc)] - **fs, refactor**: split fs.cpp.(xicilion)
* [[`ae39cd5e0f`](https://github.com/fibjs/fibjs/commit/ae39cd5e0f)] - **fs, refactor**: use uv to implament fs.copyFile function.(xicilion)
* [[`fc658892ef`](https://github.com/fibjs/fibjs/commit/fc658892ef)] - **core, refactor**: add _ before the const variable name to avoid conflicts between variable names and system variables.(xicilion)
* [[`0fd428dcda`](https://github.com/fibjs/fibjs/commit/0fd428dcda)] - **fs, refactor**: refactor fs.constants and move the SEEK_* flag to fs.constants.(xicilion)
* [[`fe3af88f3a`](https://github.com/fibjs/fibjs/commit/fe3af88f3a)] - **build, bugfix**: fibjs build with alpine 3.13 (#643)(Su Yang)

## 2021-05-30, Version 0.33.0
* **feature** :
    * Buffer - implement Buffer object iterable.(xicilion)
    * build:
      - support armv6 cross compiler.(xicilion)
      - script to switch qemu simulation environment.(xicilion)
      - display dependents of fibjs.exe in release mode.(xicilion)
    * cef - update to v90.(xicilion)
    * child_process:
      - fallback to 'pipe' for incomplete 'options.stdio' array on spawn/fork child_process(richardo2016)
      - support pty on posix.(xicilion)
      - add document for options.stdio.(xicilion)
      - support fork.(xicilion)
    * console - change the color of warn message to YELLOW.(xicilion)
    * core:
      - support for defining iterator operators.(xicilion)
      - support Error.code when throwing uv error.(xicilion)
    * crypto:
      - add document for getHashes.(xicilion)
      - support sign/verify in Digest.(xicilion)
      - add crypto.getHashes()(richardo2016)
    * db:
      - add document.(xicilion)
      - support custom odbc driver.(xicilion)
      - support PostgreSQL.(xicilion)
      - support null value in odbc driver.(xicilion)
      - support more dara type.(xicilion)
      - rewrite mssql use odbc driver and support mssql on unix.(xicilion)
      - compile error on Windows i386.(xicilion)
      - support odbc.(xicilion)
      - change async mode to long-sync.(xicilion)
    * docs:
      - document HttpCookie.(xicilion)
      - more language.(xicilion)
      - translate only updated document.(xicilion)
    * event - removeAllListeners support remove single event.(xicilion)
    * fs:
      - disable test for `fs.watch` option `recursive` on Linux.(richardo2016)
      - support recursive option in fs.mkdir.(xicilion)
      - throw system error code.(xicilion)
    * gui - not activating the application when the webview is headless.(xicilion)
    * hash - support data as an optional parameter when creating Digest.(xicilion)
    * http:
      - auto return json/msgpack data in HttpMessage.data (#695)(lhkzh)
      - auto return json data in HttpMessage.data.(xicilion)
      - support pack option for msgpack. (#647)(lhkzh)
    * iconv - support built-in ucs2le/ucs2be/ucs4le/ucs4be charset.(xicilion)
    * idlc - support null default value.(xicilion)
    * Isolate - normalize initialization for stdio instance.(richardo2016)
    * msgpack - support number_safe_int. (#694)(lhkzh)
    * net:
      - support unix socket and Windows pipe.(xicilion)
      - support use-uv-socket option.(xicilion)
      - use uv implement UVSocket.(xicilion)
    * option - update --help message.(xicilion)
    * options - install cli link into .bin folder.(xicilion)
    * os - support to report external memory in memoryUsage.(xicilion)
    * process - dump full memory information  in debug mode on Windows.(xicilion)
    * Sandbox - support to run scripts in node_modules/.bin folder.(xicilion)
    * ssl - update root certs.(xicilion)
    * Stream:
      - support network package reading mode.(xicilion)
      - allows the close function to be called in a closed stream.(xicilion)
    * test:
      - update files for jsc test.(richardo2016)
      - support passing a callback function to done to handle the asynchronous test.(xicilion)
    * tools:
      - support generate *.d.ts from fibjs's idl.(richardo2016)
      - upgrade tools/changelog.js, driven by child_process module.(richardo2016)
    * tty - replace stdio stream in process:(richardo2016)
    * types:
      - improvement.(richardo2016)
      - typings change.(richardo2016)
      - adjust, add test about types.(richardo2016)
    * url:
      - support url.resolve.(xicilion)
      - support unix socket and windows pipe host name.(xicilion)
    * util:
      - support output Symbol details.(xicilion)
      - support Promise type in util.format.(xicilion)
      - optimize the output of nested objects, do not collapse empty objects.(xicilion)
      - display different information for one more item and multiple more items.(xicilion)
      - limit the number of items in the Buffer output. #657(xicilion)
      - limit the number of items in the array output.(xicilion)
      - limit the level of obejct output.(xicilion)
      - implement util.callbackify.(xicilion)
      - support util.promisify.(xicilion)
    * vender:
      - upgrade to use v8 7.2(richardo2016)
      - update expat&zlib.(xicilion)

* **bugfix** :
    * assert - assert crash when valueOf throw error.(xicilion)
    * bson - crash when decode invaid data type, issue #648.(xicilion)
    * Buffer:
      - binary encoding error.(xicilion)
      - readNumber/writeNumber error on big-endain arch.(xicilion)
      - querying values() on a very huge Buffer will cause the Buffer to crash, #676(xicilion)
      - passing a large offset to Buffer.writeUInt32BE will cause fibjs to crash, #672(xicilion)
      - passing a large offset to Buffer.readUIntLE will cause fibjs to crash, #667(xicilion)
      - specifying a huge negative number for the offset of Buffer.slice will cause a segmentation fault, #666(xicilion)
      - fibjs will crash when the offset of Buffer.writeXXX is negative, #659(xicilion)
      - fibjs will crash when the offset parameter of Buffer.read is negative, issue 655.(xicilion)
    * build:
      - compile warning on Windows.(xicilion)
      - compile warning on Windows.(xicilion)
      - fibjs build with alpine 3.13 (#643)(Su Yang)
      - compile warning in debug mode on Windows.(xicilion)
      - fibjs build with alpine 3.13 (#643)(Su Yang)
    * child_process:
      - crash when bad stdio array.(xicilion)
      - the test will not end on a very slow machine.(xicilion)
      - crash when spawn return error.(xicilion)
    * console - on windows, line breaks are output as \n when stdout/stderr is redirected.(xicilion)
    * core:
      - cannot parse some string formats of data correctly, #681(xicilion)
      - runtime error in i386 mode on Windows.(xicilion)
      - compile error on Linux.(xicilion)
      - uv_timer_t is not released correctly when the timer ends.(xicilion)
      - compile error on Windows.(xicilion)
      - deleting js objects directly in the uv thread after closing uv_handle will cause fibjs to crash.(xicilion)
      - compile error in debug mode.(xicilion)
    * crypto:
      - support ripemd160 and sm3 in rsa/sm2 sign.(xicilion)
      - too large matrix size will cause crypto.randomArt to crash, #677(xicilion)
      - Illegal iterations and size parameters will cause crypto.pbkdf1 or crypto.pbkdf2 to crash, #670 #671(xicilion)
      - specifying a negative size of crypto.randomBytes will cause a segmentation fault, #664 #665(xicilion)
      - specifying the size of crypto.randomArt as 0 will cause a segmentation fault, #662(xicilion)
    * db:
      - float type error on mssql.(xicilion)
      - SIZEOF_LONG_INT set to 8 on 32 bits system.(xicilion)
      - levelDB.mget results in a segmentation fault, issue #653.(xicilion)
      - conn.begin error on mysql.(xicilion)
      - conn.begin error on mysql.(xicilion)
    * dgram:
      - tests on systems without IPv6 will report errors.(xicilion)
      - test error on Linux.(xicilion)
      - change test port.(xicilion)
      - bug message recv error.(xicilion)
    * docs:
      - some description errors in setClientCert parameters.(xicilion)
      - typo.(xicilion)
    * encode - std::bad_alloc error will be caused when processing strings longer than 2G, #661(xicilion)
    * EventEmitter:
      - removeAllListeners() does not remove any listener.(xicilion)
      - removeAllListeners() does not remove any listener.(xicilion)
    * fs:
      - stat.isSymbolicLink always returns false on Windows.(xicilion)
      - when the path exists, fs.mkdir should not raise an error in recursive mode.(xicilion)
      - fstat mode error when create directory and file.(Yuanhang)
      - correct to emit changed filename for FSWatcher.(richardo2016)
      - compile error in debug mode on Windows.(xicilion)
      - compile error on windows.(xicilion)
    * gui:
      - fixup resource request on win32 webview:(richardo2016)
      - cef subprocess does not initialize uv, causing fs.exists to fail.(xicilion)
    * http:
      - compile warning on Windows.(xicilion)
      - compile error on linux.(xicilion)
      - request option process error.(xicilion)
    * idl:
      - support method overrides, and rest parameters.(richardo2016)
      - repair missing method params for interface.(richardo2016)
    * io - reading data from rangestream does not change the current position correctly.(xicilion)
    * net:
      - ipv6 bind error on UVSocket.(xicilion)
      - access socket on unconnected smtp object causes segmentation fault, issue #654.(xicilion)
    * os - os.arch return nothing on mips/mips64.(xicilion)
    * path - do not set the drive character when the base path is empty.(xicilion)
    * process - ignore SIGPIPE signal, fix abnormal exit when tcp connection is closed remotely under linux.(xicilion)
    * punycode:
      - punycode.decode results in a segmentation fault, #675(xicilion)
      - punycode.decode results in a floating point exception, issue #652.(xicilion)
    * repl - repl cannot handle incomplete statements normally, issue #651.(xicilion)
    * ssl - crash on verify ssl.ca, #679(Yuanhang)
    * Stream - read throw error when connection reset by peer.(xicilion)
    * test:
      - timeout test error under windows sometimes.(xicilion)
      - http test error on Windows.(xicilion)
      - actions test error on Windows.(xicilion)
      - some test error.(xicilion)
      - ws test error on windows.(xicilion)
      - some test error.(xicilion)
    * util:
      - intersection crash when valueOf throw error, #673(xicilion)
      - memory limit causes GC to crash, #658(xicilion)
      - flatten a circular reference object will cause fibjs to crash, #669(xicilion)
      - running util.deepFreeze on Buffer will result in illegal hardware instructions. #663(xicilion)
      - fixup build error on Windows.(richardo2016)
      - static functions of built-in modules are displayed with wrong function names.(xicilion)
    * websocket - message encode error on big-endian arch.(xicilion)
    * zlib - passing an invalid level parameter to zlib.deflate will cause fibjs to crash.(xicilion)

* **refactor** :
    * console - use uv to output console message.(xicilion)
    * core:
      - use the new toString instead of Utf8Value to convert v8 strings.(xicilion)
      - use uint64_t to detect strings to speed up detection.(xicilion)
      - use union to detect big-endian architecture at runtime.(xicilion)
      - use external-resource to implement zero-copy transfer string between fibjs and v8, #678(xicilion)
      - refactor the urf8 encode/decode, improve coding performance.(xicilion)
      - strictly distinguish between access and reference to the elements of string, and eliminate unnecessary memory copy.(xicilion)
      - enable lazy compile.(xicilion)
      - change v8 memory space to 2048.(xicilion)
      - convert utf8 string directly to v8 string.(xicilion)
      - use isolate_ref() instead of holder()->Ref().(xicilion)
      - refactor the error reporting framework to support uv error codes.(xicilion)
      - optimize the implementation of some string methods.(xicilion)
      - add C_ before the const variable name to avoid conflicts between variable names and system variables.(xicilion)
      - add _ before the const variable name to avoid conflicts between variable names and system variables.(xicilion)
      - use c++ alloc to enable jemalloc.(xicilion)
    * db:
      - refactor db_format.(xicilion)
      - refactor odbc_connect, simplify the implementation of driver.(xicilion)
      - detect null value use SQL_NULL_DATA.(xicilion)
      - remove db.format, refactor db test.(xicilion)
      - move function mssql::error into cpp.(xicilion)
      - use template to refactor db_format.(xicilion)
      - refactor db api use class template.(xicilion)
      - move function use into DBConnection.(xicilion)
      - move db_api.h to db folder.(xicilion)
      - move leveldb test case into group.(xicilion)
    * dgram:
      - bind udp socket in worker fiber.(xicilion)
      - move code to source file.(xicilion)
      - use uv to implement udp socket.(xicilion)
    * docs - use nomnoml to render graph.(xicilion)
    * encoding:
      - deprecate base64vlq.(xicilion)
      - optimize hex/base64 encode/decode performance.(xicilion)
      - deprecated bson module.(xicilion)
    * events - fix param name in EventEmitter.removeAllListeners.(xicilion)
    * fs:
      - use uv_call to refactor fs.watch.(xicilion)
      - rewrite fs.stat.(xicilion)
      - define the uv_async function to simplify the implementation of the fs uv async function.(xicilion)
      - use destructor to destroy uv_fs_t structure.(xicilion)
      - use uv to implament fs.readdir function.(xicilion)
      - split fs.cpp.(xicilion)
      - use uv to implament fs.copyFile function.(xicilion)
      - refactor fs.constants and move the SEEK_* flag to fs.constants.(xicilion)
      - use uv to implament fs function.(xicilion)
    * gui - use dl_func to wrap x11 function.(xicilion)
    * http - remove unnecessary odescribe restrictions.(xicilion)
    * isolate:
      - use StrictEquals to compare object.(xicilion)
      - use v8::Local<v8::Object>::Cast to convert the data type.(xicilion)
    * NArray - use simpler length syntax.(xicilion)
    * net:
      - compile warning in debug mode on Windows.(xicilion)
      - not remove domain file on Windows.(xicilion)
      - use Socket::_new to create socket.(xicilion)
      - remove udp support from net.Socket.(xicilion)
      - use uv to convert inetAddr.(xicilion)
    * os - use uv to implament os/process function.(xicilion)
    * path - define os_* api.(xicilion)
    * process - use exit instead of _exit to quit current process.(xicilion)
    * Stream:
      - limit read buffer size.(xicilion)
      - use uv_post(function) to post async function into uv thread.(xicilion)
      - use uv_post to post uv tasks without waiting for execution to finish.(xicilion)
      - use UVStream::create_pipe to create pipe stream.(xicilion)
    * test:
      - enable process test.(xicilion)
      - output error message to stdout.(xicilion)
    * util - move the processing of special types out of object.(xicilion)
    * uv - refactor uv process model.(xicilion)

* **others** :
    * fs.refactor - Restore SEEK_* constants defined in fs.(xicilion)
    * Merge branch 'dev' of https - //github.com/fibjs/fibjs into dev(xicilion)
    * Release v0.32.1(richardo2016)

* **chore** :
    * build - merge and resolve conflict.(richardo2016)

### Commits
* [[`8db48bc23e`](https://github.com/fibjs/fibjs/commit/8db48bc23e)] - **child_process, feat**: fallback to 'pipe' for incomplete 'options.stdio' array on spawn/fork child_process(richardo2016)
* [[`d88d9661c3`](https://github.com/fibjs/fibjs/commit/d88d9661c3)] - **child_process, bugfix**: crash when bad stdio array.(xicilion)
* [[`123b40f220`](https://github.com/fibjs/fibjs/commit/123b40f220)] - **db, feat**: add document.(xicilion)
* [[`af64d0aaec`](https://github.com/fibjs/fibjs/commit/af64d0aaec)] - **db, refactor**: refactor db_format.(xicilion)
* [[`6f80cac57a`](https://github.com/fibjs/fibjs/commit/6f80cac57a)] - **http, feat**: auto return json/msgpack data in HttpMessage.data (#695)(lhkzh)
* [[`e7327b31e4`](https://github.com/fibjs/fibjs/commit/e7327b31e4)] - **encoding, refactor**: deprecate base64vlq.(xicilion)
* [[`ce181e6fff`](https://github.com/fibjs/fibjs/commit/ce181e6fff)] - **Buffer, bugfix**: binary encoding error.(xicilion)
* [[`fb65ed023c`](https://github.com/fibjs/fibjs/commit/fb65ed023c)] - **test, feat**: update files for jsc test.(richardo2016)
* [[`58a60cb3da`](https://github.com/fibjs/fibjs/commit/58a60cb3da)] - **child_process, feat**: support pty on posix.(xicilion)
* [[`7566d7f266`](https://github.com/fibjs/fibjs/commit/7566d7f266)] - **msgpack, feat**: support number_safe_int. (#694)(lhkzh)
* [[`aaba4b1ce3`](https://github.com/fibjs/fibjs/commit/aaba4b1ce3)] - **vender, feat**: upgrade to use v8 7.2(richardo2016)
* [[`52eb452ccb`](https://github.com/fibjs/fibjs/commit/52eb452ccb)] - **db, refactor**: refactor odbc_connect, simplify the implementation of driver.(xicilion)
* [[`75bb1981c9`](https://github.com/fibjs/fibjs/commit/75bb1981c9)] - **db, feat**: support custom odbc driver.(xicilion)
* [[`8cd4648e42`](https://github.com/fibjs/fibjs/commit/8cd4648e42)] - **db, feat**: support PostgreSQL.(xicilion)
* [[`c4401579a3`](https://github.com/fibjs/fibjs/commit/c4401579a3)] - **db, refactor**: detect null value use SQL_NULL_DATA.(xicilion)
* [[`84a22e53ea`](https://github.com/fibjs/fibjs/commit/84a22e53ea)] - **db, feat**: support null value in odbc driver.(xicilion)
* [[`30bb46a1bd`](https://github.com/fibjs/fibjs/commit/30bb46a1bd)] - **db, refactor**: remove db.format, refactor db test.(xicilion)
* [[`941b17428f`](https://github.com/fibjs/fibjs/commit/941b17428f)] - **db, bugfix**: float type error on mssql.(xicilion)
* [[`ed98f5873a`](https://github.com/fibjs/fibjs/commit/ed98f5873a)] - **types, feat**: improvement.(richardo2016)
* [[`e795200e2a`](https://github.com/fibjs/fibjs/commit/e795200e2a)] - **db, feat**: support more dara type.(xicilion)
* [[`205d76a781`](https://github.com/fibjs/fibjs/commit/205d76a781)] - **db, feat**: rewrite mssql use odbc driver and support mssql on unix.(xicilion)
* [[`1b80c7208e`](https://github.com/fibjs/fibjs/commit/1b80c7208e)] - **db, refactor**: move function mssql::error into cpp.(xicilion)
* [[`864b9cf873`](https://github.com/fibjs/fibjs/commit/864b9cf873)] - **db, refactor**: use template to refactor db_format.(xicilion)
* [[`25b486a503`](https://github.com/fibjs/fibjs/commit/25b486a503)] - **db, refactor**: refactor db api use class template.(xicilion)
* [[`f86676bc77`](https://github.com/fibjs/fibjs/commit/f86676bc77)] - **build, bugfix**: compile warning on Windows.(xicilion)
* [[`9415776df3`](https://github.com/fibjs/fibjs/commit/9415776df3)] - **db, refactor**: move function use into DBConnection.(xicilion)
* [[`8b3a9f42c8`](https://github.com/fibjs/fibjs/commit/8b3a9f42c8)] - **db, bugfix**: SIZEOF_LONG_INT set to 8 on 32 bits system.(xicilion)
* [[`b0df74d32a`](https://github.com/fibjs/fibjs/commit/b0df74d32a)] - **crypto, bugfix**: support ripemd160 and sm3 in rsa/sm2 sign.(xicilion)
* [[`3411a5a003`](https://github.com/fibjs/fibjs/commit/3411a5a003)] - **db, feat**: compile error on Windows i386.(xicilion)
* [[`c9e9c00acd`](https://github.com/fibjs/fibjs/commit/c9e9c00acd)] - **db, feat**: support odbc.(xicilion)
* [[`d5d21032f7`](https://github.com/fibjs/fibjs/commit/d5d21032f7)] - **db, refactor**: move db_api.h to db folder.(xicilion)
* [[`2a08577eae`](https://github.com/fibjs/fibjs/commit/2a08577eae)] - **NArray, refactor**: use simpler length syntax.(xicilion)
* [[`125b8b0049`](https://github.com/fibjs/fibjs/commit/125b8b0049)] - **db, feat**: change async mode to long-sync.(xicilion)
* [[`bc91b3a2b9`](https://github.com/fibjs/fibjs/commit/bc91b3a2b9)] - **types, feat**: typings change.(richardo2016)
* [[`731793b775`](https://github.com/fibjs/fibjs/commit/731793b775)] - **gui, refactor**: use dl_func to wrap x11 function.(xicilion)
* [[`b110035b53`](https://github.com/fibjs/fibjs/commit/b110035b53)] - **crypto, feat**: add document for getHashes.(xicilion)
* [[`7a1ec0e88f`](https://github.com/fibjs/fibjs/commit/7a1ec0e88f)] - **hash, feat**: support data as an optional parameter when creating Digest.(xicilion)
* [[`027b3feed5`](https://github.com/fibjs/fibjs/commit/027b3feed5)] - **idlc, feat**: support null default value.(xicilion)
* [[`9cf9b1c279`](https://github.com/fibjs/fibjs/commit/9cf9b1c279)] - **crypto, feat**: support sign/verify in Digest.(xicilion)
* [[`e755aa25e4`](https://github.com/fibjs/fibjs/commit/e755aa25e4)] - **crypto, feat**: add crypto.getHashes()(richardo2016)
* [[`12793e8bd6`](https://github.com/fibjs/fibjs/commit/12793e8bd6)] - **types, feat**: adjust, add test about types.(richardo2016)
* [[`f994085b64`](https://github.com/fibjs/fibjs/commit/f994085b64)] - **fs, bugfix**: stat.isSymbolicLink always returns false on Windows.(xicilion)
* [[`cd1413ba10`](https://github.com/fibjs/fibjs/commit/cd1413ba10)] - **fs, bugfix**: when the path exists, fs.mkdir should not raise an error in recursive mode.(xicilion)
* [[`2594b18f72`](https://github.com/fibjs/fibjs/commit/2594b18f72)] - **gui, bugfix**: fixup resource request on win32 webview:(richardo2016)
* [[`394ac7b3be`](https://github.com/fibjs/fibjs/commit/394ac7b3be)] - **idl, bugfix**: support method overrides, and rest parameters.(richardo2016)
* [[`47dc757286`](https://github.com/fibjs/fibjs/commit/47dc757286)] - **idl, bugfix**: repair missing method params for interface.(richardo2016)
* [[`943fe32e6e`](https://github.com/fibjs/fibjs/commit/943fe32e6e)] - **process, refactor**: use exit instead of _exit to quit current process.(xicilion)
* [[`261b7b6063`](https://github.com/fibjs/fibjs/commit/261b7b6063)] - **test, feat**: support passing a callback function to done to handle the asynchronous test.(xicilion)
* [[`d4eb14a3b9`](https://github.com/fibjs/fibjs/commit/d4eb14a3b9)] - **encoding, refactor**: optimize hex/base64 encode/decode performance.(xicilion)
* [[`69de147f98`](https://github.com/fibjs/fibjs/commit/69de147f98)] - **tools, feat**: support generate *.d.ts from fibjs's idl.(richardo2016)
* [[`230be65408`](https://github.com/fibjs/fibjs/commit/230be65408)] - **core, refactor**: use the new toString instead of Utf8Value to convert v8 strings.(xicilion)
* [[`2b363dc2c9`](https://github.com/fibjs/fibjs/commit/2b363dc2c9)] - **core, refactor**: use uint64_t to detect strings to speed up detection.(xicilion)
* [[`b315a7c7a5`](https://github.com/fibjs/fibjs/commit/b315a7c7a5)] - **options, feat**: install cli link into .bin folder.(xicilion)
* [[`04a49c0a63`](https://github.com/fibjs/fibjs/commit/04a49c0a63)] - **cef, feat**: update to v90.(xicilion)
* [[`c8c4f1ff15`](https://github.com/fibjs/fibjs/commit/c8c4f1ff15)] - **build, feat**: support armv6 cross compiler.(xicilion)
* [[`45e7f93228`](https://github.com/fibjs/fibjs/commit/45e7f93228)] - **core, refactor**: use union to detect big-endian architecture at runtime.(xicilion)
* [[`851bb90a76`](https://github.com/fibjs/fibjs/commit/851bb90a76)] - **core, bugfix**: cannot parse some string formats of data correctly, #681(xicilion)
* [[`3e210b23c5`](https://github.com/fibjs/fibjs/commit/3e210b23c5)] - **iconv, feat**: support built-in ucs2le/ucs2be/ucs4le/ucs4be charset.(xicilion)
* [[`7f5e7c45f5`](https://github.com/fibjs/fibjs/commit/7f5e7c45f5)] - **child_process, bugfix**: the test will not end on a very slow machine.(xicilion)
* [[`416e3c7584`](https://github.com/fibjs/fibjs/commit/416e3c7584)] - **websocket, bugfix**: message encode error on big-endian arch.(xicilion)
* [[`186f9994cc`](https://github.com/fibjs/fibjs/commit/186f9994cc)] - **Buffer, bugfix**: readNumber/writeNumber error on big-endain arch.(xicilion)
* [[`90a55c9170`](https://github.com/fibjs/fibjs/commit/90a55c9170)] - **fs, bugfix**: fstat mode error when create directory and file.(Yuanhang)
* [[`4c87328b40`](https://github.com/fibjs/fibjs/commit/4c87328b40)] - **os, bugfix**: os.arch return nothing on mips/mips64.(xicilion)
* [[`2d2d659daf`](https://github.com/fibjs/fibjs/commit/2d2d659daf)] - **build, feat**: script to switch qemu simulation environment.(xicilion)
* [[`a0054383b8`](https://github.com/fibjs/fibjs/commit/a0054383b8)] - **ssl, bugfix**: crash on verify ssl.ca, #679(Yuanhang)
* [[`48511dc2c0`](https://github.com/fibjs/fibjs/commit/48511dc2c0)] - **docs, bugfix**: some description errors in setClientCert parameters.(xicilion)
* [[`7a6a7ece85`](https://github.com/fibjs/fibjs/commit/7a6a7ece85)] - **option, feat**: update --help message.(xicilion)
* [[`52ba9f89f6`](https://github.com/fibjs/fibjs/commit/52ba9f89f6)] - **core, bugfix**: runtime error in i386 mode on Windows.(xicilion)
* [[`f438eef266`](https://github.com/fibjs/fibjs/commit/f438eef266)] - **core, bugfix**: compile error on Linux.(xicilion)
* [[`a9fe8b16b7`](https://github.com/fibjs/fibjs/commit/a9fe8b16b7)] - **os, feat**: support to report external memory in memoryUsage.(xicilion)
* [[`253c0e3a5c`](https://github.com/fibjs/fibjs/commit/253c0e3a5c)] - **core, refactor**: use external-resource to implement zero-copy transfer string between fibjs and v8, #678(xicilion)
* [[`3730764753`](https://github.com/fibjs/fibjs/commit/3730764753)] - **core, refactor**: refactor the urf8 encode/decode, improve coding performance.(xicilion)
* [[`080386f5cb`](https://github.com/fibjs/fibjs/commit/080386f5cb)] - **Sandbox, feat**: support to run scripts in node_modules/.bin folder.(xicilion)
* [[`81e5a4e30c`](https://github.com/fibjs/fibjs/commit/81e5a4e30c)] - **util, refactor**: move the processing of special types out of object.(xicilion)
* [[`8c4e458221`](https://github.com/fibjs/fibjs/commit/8c4e458221)] - **util, feat**: support output Symbol details.(xicilion)
* [[`a7bdeaaf8d`](https://github.com/fibjs/fibjs/commit/a7bdeaaf8d)] - **Buffer, feat**: implement Buffer object iterable.(xicilion)
* [[`174d450f99`](https://github.com/fibjs/fibjs/commit/174d450f99)] - **core, feat**: support for defining iterator operators.(xicilion)
* [[`da0b4fe233`](https://github.com/fibjs/fibjs/commit/da0b4fe233)] - **punycode, bugfix**: punycode.decode results in a segmentation fault, #675(xicilion)
* [[`02e53f350a`](https://github.com/fibjs/fibjs/commit/02e53f350a)] - **build, feat**: display dependents of fibjs.exe in release mode.(xicilion)
* [[`1939e082aa`](https://github.com/fibjs/fibjs/commit/1939e082aa)] - **path, bugfix**: do not set the drive character when the base path is empty.(xicilion)
* [[`6a5f74ab29`](https://github.com/fibjs/fibjs/commit/6a5f74ab29)] - **core, refactor**: strictly distinguish between access and reference to the elements of string, and eliminate unnecessary memory copy.(xicilion)
* [[`5e660884eb`](https://github.com/fibjs/fibjs/commit/5e660884eb)] - **Buffer, bugfix**: querying values() on a very huge Buffer will cause the Buffer to crash, #676(xicilion)
* [[`4f44ea3d5e`](https://github.com/fibjs/fibjs/commit/4f44ea3d5e)] - **events, refactor**: fix param name in EventEmitter.removeAllListeners.(xicilion)
* [[`d48deedfbd`](https://github.com/fibjs/fibjs/commit/d48deedfbd)] - **crypto, bugfix**: too large matrix size will cause crypto.randomArt to crash, #677(xicilion)
* [[`6c6be87584`](https://github.com/fibjs/fibjs/commit/6c6be87584)] - **http, feat**: auto return json data in HttpMessage.data.(xicilion)
* [[`3492f6299e`](https://github.com/fibjs/fibjs/commit/3492f6299e)] - **url, feat**: support url.resolve.(xicilion)
* [[`a8f7761548`](https://github.com/fibjs/fibjs/commit/a8f7761548)] - **util, feat**: support Promise type in util.format.(xicilion)
* [[`244facf443`](https://github.com/fibjs/fibjs/commit/244facf443)] - **process, feat**: dump full memory information  in debug mode on Windows.(xicilion)
* [[`a4b75ca9cf`](https://github.com/fibjs/fibjs/commit/a4b75ca9cf)] - **http, bugfix**: compile warning on Windows.(xicilion)
* [[`ff189b058a`](https://github.com/fibjs/fibjs/commit/ff189b058a)] - **core, refactor**: enable lazy compile.(xicilion)
* [[`0b6a213813`](https://github.com/fibjs/fibjs/commit/0b6a213813)] - **http, refactor**: remove unnecessary odescribe restrictions.(xicilion)
* [[`4a7b30dbf1`](https://github.com/fibjs/fibjs/commit/4a7b30dbf1)] - **core, bugfix**: uv_timer_t is not released correctly when the timer ends.(xicilion)
* [[`44e75efbb2`](https://github.com/fibjs/fibjs/commit/44e75efbb2)] - **net, bugfix**: ipv6 bind error on UVSocket.(xicilion)
* [[`5d3c404171`](https://github.com/fibjs/fibjs/commit/5d3c404171)] - **build, bugfix**: compile warning on Windows.(xicilion)
* [[`90fd788e6e`](https://github.com/fibjs/fibjs/commit/90fd788e6e)] - **child_process, feat**: add document for options.stdio.(xicilion)
* [[`306b4b75c0`](https://github.com/fibjs/fibjs/commit/306b4b75c0)] - **isolate, refactor**: use StrictEquals to compare object.(xicilion)
* [[`2c575b134c`](https://github.com/fibjs/fibjs/commit/2c575b134c)] - **isolate, refactor**: use v8::Local<v8::Object>::Cast to convert the data type.(xicilion)
* [[`9f72d88805`](https://github.com/fibjs/fibjs/commit/9f72d88805)] - **assert, bugfix**: assert crash when valueOf throw error.(xicilion)
* [[`138f0ad859`](https://github.com/fibjs/fibjs/commit/138f0ad859)] - **util, bugfix**: intersection crash when valueOf throw error, #673(xicilion)
* [[`0f966ac78b`](https://github.com/fibjs/fibjs/commit/0f966ac78b)] - **db, refactor**: move leveldb test case into group.(xicilion)
* [[`b302062e1d`](https://github.com/fibjs/fibjs/commit/b302062e1d)] - **Buffer, bugfix**: passing a large offset to Buffer.writeUInt32BE will cause fibjs to crash, #672(xicilion)
* [[`2317cf6efb`](https://github.com/fibjs/fibjs/commit/2317cf6efb)] - **core, bugfix**: compile error on Windows.(xicilion)
* [[`9fb9876e9e`](https://github.com/fibjs/fibjs/commit/9fb9876e9e)] - **core, bugfix**: deleting js objects directly in the uv thread after closing uv_handle will cause fibjs to crash.(xicilion)
* [[`489dda67b1`](https://github.com/fibjs/fibjs/commit/489dda67b1)] - **core, refactor**: change v8 memory space to 2048.(xicilion)
* [[`cd1d8186c2`](https://github.com/fibjs/fibjs/commit/cd1d8186c2)] - **encoding, refactor**: deprecated bson module.(xicilion)
* [[`f76efac292`](https://github.com/fibjs/fibjs/commit/f76efac292)] - **util, bugfix**: memory limit causes GC to crash, #658(xicilion)
* [[`73a245a856`](https://github.com/fibjs/fibjs/commit/73a245a856)] - **core, refactor**: convert utf8 string directly to v8 string.(xicilion)
* [[`60ecb9e7a2`](https://github.com/fibjs/fibjs/commit/60ecb9e7a2)] - **net, refactor**: compile warning in debug mode on Windows.(xicilion)
* [[`5fd70f87d6`](https://github.com/fibjs/fibjs/commit/5fd70f87d6)] - **util, bugfix**: flatten a circular reference object will cause fibjs to crash, #669(xicilion)
* [[`5958f8ba04`](https://github.com/fibjs/fibjs/commit/5958f8ba04)] - **Buffer, bugfix**: passing a large offset to Buffer.readUIntLE will cause fibjs to crash, #667(xicilion)
* [[`509c63ff7d`](https://github.com/fibjs/fibjs/commit/509c63ff7d)] - **console, feat**: change the color of warn message to YELLOW.(xicilion)
* [[`22757bc361`](https://github.com/fibjs/fibjs/commit/22757bc361)] - **crypto, bugfix**: Illegal iterations and size parameters will cause crypto.pbkdf1 or crypto.pbkdf2 to crash, #670 #671(xicilion)
* [[`f9a274e793`](https://github.com/fibjs/fibjs/commit/f9a274e793)] - **encode, bugfix**: std::bad_alloc error will be caused when processing strings longer than 2G, #661(xicilion)
* [[`31d95a2151`](https://github.com/fibjs/fibjs/commit/31d95a2151)] - **Buffer, bugfix**: specifying a huge negative number for the offset of Buffer.slice will cause a segmentation fault, #666(xicilion)
* [[`087b47648f`](https://github.com/fibjs/fibjs/commit/087b47648f)] - **util, bugfix**: running util.deepFreeze on Buffer will result in illegal hardware instructions. #663(xicilion)
* [[`bfbe361e6e`](https://github.com/fibjs/fibjs/commit/bfbe361e6e)] - **crypto, bugfix**: specifying a negative size of crypto.randomBytes will cause a segmentation fault, #664 #665(xicilion)
* [[`3b1f925493`](https://github.com/fibjs/fibjs/commit/3b1f925493)] - **crypto, bugfix**: specifying the size of crypto.randomArt as 0 will cause a segmentation fault, #662(xicilion)
* [[`b024b3beae`](https://github.com/fibjs/fibjs/commit/b024b3beae)] - **util, feat**: optimize the output of nested objects, do not collapse empty objects.(xicilion)
* [[`4ff211bf01`](https://github.com/fibjs/fibjs/commit/4ff211bf01)] - **util, feat**: display different information for one more item and multiple more items.(xicilion)
* [[`80eb72dbca`](https://github.com/fibjs/fibjs/commit/80eb72dbca)] - **io, bugfix**: reading data from rangestream does not change the current position correctly.(xicilion)
* [[`f64622b64d`](https://github.com/fibjs/fibjs/commit/f64622b64d)] - **util, feat**: limit the number of items in the Buffer output. #657(xicilion)
* [[`a545b7b63d`](https://github.com/fibjs/fibjs/commit/a545b7b63d)] - **util, feat**: limit the number of items in the array output.(xicilion)
* [[`e565772260`](https://github.com/fibjs/fibjs/commit/e565772260)] - **util, feat**: limit the level of obejct output.(xicilion)
* [[`15199a3319`](https://github.com/fibjs/fibjs/commit/15199a3319)] - **Buffer, bugfix**: fibjs will crash when the offset of Buffer.writeXXX is negative, #659(xicilion)
* [[`f78f319693`](https://github.com/fibjs/fibjs/commit/f78f319693)] - **Buffer, bugfix**: fibjs will crash when the offset parameter of Buffer.read is negative, issue 655.(xicilion)
* [[`411413da12`](https://github.com/fibjs/fibjs/commit/411413da12)] - **net, bugfix**: access socket on unconnected smtp object causes segmentation fault, issue #654.(xicilion)
* [[`9109a16b21`](https://github.com/fibjs/fibjs/commit/9109a16b21)] - **db, bugfix**: levelDB.mget results in a segmentation fault, issue #653.(xicilion)
* [[`e01e10eae2`](https://github.com/fibjs/fibjs/commit/e01e10eae2)] - **net, refactor**: not remove domain file on Windows.(xicilion)
* [[`55ee8de1d8`](https://github.com/fibjs/fibjs/commit/55ee8de1d8)] - **punycode, bugfix**: punycode.decode results in a floating point exception, issue #652.(xicilion)
* [[`6d030a7547`](https://github.com/fibjs/fibjs/commit/6d030a7547)] - **repl, bugfix**: repl cannot handle incomplete statements normally, issue #651.(xicilion)
* [[`d824ad7da0`](https://github.com/fibjs/fibjs/commit/d824ad7da0)] - **zlib, bugfix**: passing an invalid level parameter to zlib.deflate will cause fibjs to crash.(xicilion)
* [[`e35a0c24b8`](https://github.com/fibjs/fibjs/commit/e35a0c24b8)] - **bson, bugfix**: crash when decode invaid data type, issue #648.(xicilion)
* [[`0e29a1303b`](https://github.com/fibjs/fibjs/commit/0e29a1303b)] - **event, feat**: removeAllListeners support remove single event.(xicilion)
* [[`d06fe997b0`](https://github.com/fibjs/fibjs/commit/d06fe997b0)] - **fs.refactor**: Restore SEEK_* constants defined in fs.(xicilion)
* [[`e5ab5c3c76`](https://github.com/fibjs/fibjs/commit/e5ab5c3c76)] - **child_process, feat**: support fork.(xicilion)
* [[`f496f3b105`](https://github.com/fibjs/fibjs/commit/f496f3b105)] - **tty, feat**: replace stdio stream in process:(richardo2016)
* [[`74b2ca8bd7`](https://github.com/fibjs/fibjs/commit/74b2ca8bd7)] - **Isolate, feat**: normalize initialization for stdio instance.(richardo2016)
* [[`2d28b7832a`](https://github.com/fibjs/fibjs/commit/2d28b7832a)] - **http, bugfix**: compile error on linux.(xicilion)
* [[`4239ce2435`](https://github.com/fibjs/fibjs/commit/4239ce2435)] - **util, feat**: implement util.callbackify.(xicilion)
* [[`2a8ddc896a`](https://github.com/fibjs/fibjs/commit/2a8ddc896a)] - **http, bugfix**: request option process error.(xicilion)
* [[`4007c40989`](https://github.com/fibjs/fibjs/commit/4007c40989)] - **http, feat**: support pack option for msgpack. (#647)(lhkzh)
* [[`b09f506542`](https://github.com/fibjs/fibjs/commit/b09f506542)] - **net, feat**: support unix socket and Windows pipe.(xicilion)
* [[`cef2d9058b`](https://github.com/fibjs/fibjs/commit/cef2d9058b)] - **url, feat**: support unix socket and windows pipe host name.(xicilion)
* [[`af4c4ba870`](https://github.com/fibjs/fibjs/commit/af4c4ba870)] - **docs, refactor**: use nomnoml to render graph.(xicilion)
* [[`e37047d8da`](https://github.com/fibjs/fibjs/commit/e37047d8da)] - **fs, feat**: disable test for `fs.watch` option `recursive` on Linux.(richardo2016)
* [[`23f0e89ca4`](https://github.com/fibjs/fibjs/commit/23f0e89ca4)] - **fs, bugfix**: correct to emit changed filename for FSWatcher.(richardo2016)
* [[`218e55d98d`](https://github.com/fibjs/fibjs/commit/218e55d98d)] - **console, bugfix**: on windows, line breaks are output as \n when stdout/stderr is redirected.(xicilion)
* [[`3240236b9a`](https://github.com/fibjs/fibjs/commit/3240236b9a)] - **Stream, bugfix**: read throw error when connection reset by peer.(xicilion)
* [[`1023a664c4`](https://github.com/fibjs/fibjs/commit/1023a664c4)] - **util, bugfix**: fixup build error on Windows.(richardo2016)
* [[`2b1bfcbf26`](https://github.com/fibjs/fibjs/commit/2b1bfcbf26)] - **docs, feat**: document HttpCookie.(xicilion)
* [[`32b10e9486`](https://github.com/fibjs/fibjs/commit/32b10e9486)] - **docs, feat**: more language.(xicilion)
* [[`3854a49c10`](https://github.com/fibjs/fibjs/commit/3854a49c10)] - **vender, feat**: update expat&zlib.(xicilion)
* [[`2015bd81aa`](https://github.com/fibjs/fibjs/commit/2015bd81aa)] - **ssl, feat**: update root certs.(xicilion)
* [[`36bff527be`](https://github.com/fibjs/fibjs/commit/36bff527be)] - **docs, bugfix**: typo.(xicilion)
* [[`95e144d78d`](https://github.com/fibjs/fibjs/commit/95e144d78d)] - **util, bugfix**: static functions of built-in modules are displayed with wrong function names.(xicilion)
* [[`6c51123a2e`](https://github.com/fibjs/fibjs/commit/6c51123a2e)] - **util, feat**: support util.promisify.(xicilion)
* [[`fde7a9af92`](https://github.com/fibjs/fibjs/commit/fde7a9af92)] - **core, feat**: support Error.code when throwing uv error.(xicilion)
* [[`364e4000dc`](https://github.com/fibjs/fibjs/commit/364e4000dc)] - **gui, feat**: not activating the application when the webview is headless.(xicilion)
* [[`0a01358b21`](https://github.com/fibjs/fibjs/commit/0a01358b21)] - **docs, feat**: translate only updated document.(xicilion)
* [[`8705463597`](https://github.com/fibjs/fibjs/commit/8705463597)] - **net, feat**: support use-uv-socket option.(xicilion)
* [[`f3d671f5d9`](https://github.com/fibjs/fibjs/commit/f3d671f5d9)] - **console, refactor**: use uv to output console message.(xicilion)
* [[`cd9ea25b95`](https://github.com/fibjs/fibjs/commit/cd9ea25b95)] - **Stream, refactor**: limit read buffer size.(xicilion)
* [[`f0c1a1f66f`](https://github.com/fibjs/fibjs/commit/f0c1a1f66f)] - **test, bugfix**: timeout test error under windows sometimes.(xicilion)
* [[`e1041b6a8c`](https://github.com/fibjs/fibjs/commit/e1041b6a8c)] - **Merge branch 'dev' of https**: //github.com/fibjs/fibjs into dev(xicilion)
* [[`98a036839c`](https://github.com/fibjs/fibjs/commit/98a036839c)] - **process, bugfix**: ignore SIGPIPE signal, fix abnormal exit when tcp connection is closed remotely under linux.(xicilion)
* [[`264805a18c`](https://github.com/fibjs/fibjs/commit/264805a18c)] - **build, chore**: merge and resolve conflict.(richardo2016)
* [[`bebc98d199`](https://github.com/fibjs/fibjs/commit/bebc98d199)] - Release v0.32.1(richardo2016)
* [[`38886c8d8b`](https://github.com/fibjs/fibjs/commit/38886c8d8b)] - **tools, feat**: upgrade tools/changelog.js, driven by child_process module.(richardo2016)
* [[`0c65ff57f9`](https://github.com/fibjs/fibjs/commit/0c65ff57f9)] - **db, bugfix**: conn.begin error on mysql.(xicilion)
* [[`ae2ea1459f`](https://github.com/fibjs/fibjs/commit/ae2ea1459f)] - **EventEmitter, bugfix**: removeAllListeners() does not remove any listener.(xicilion)
* [[`8b9d85f8a4`](https://github.com/fibjs/fibjs/commit/8b9d85f8a4)] - **build, bugfix**: fibjs build with alpine 3.13 (#643)(Su Yang)
* [[`7ad97b7aeb`](https://github.com/fibjs/fibjs/commit/7ad97b7aeb)] - **net, feat**: use uv implement UVSocket.(xicilion)
* [[`897499f400`](https://github.com/fibjs/fibjs/commit/897499f400)] - **Stream, refactor**: use uv_post(function) to post async function into uv thread.(xicilion)
* [[`abe40df47a`](https://github.com/fibjs/fibjs/commit/abe40df47a)] - **Stream, refactor**: use uv_post to post uv tasks without waiting for execution to finish.(xicilion)
* [[`5fc60011b9`](https://github.com/fibjs/fibjs/commit/5fc60011b9)] - **Stream, feat**: support network package reading mode.(xicilion)
* [[`27ac337796`](https://github.com/fibjs/fibjs/commit/27ac337796)] - **Stream, feat**: allows the close function to be called in a closed stream.(xicilion)
* [[`82c6a99a62`](https://github.com/fibjs/fibjs/commit/82c6a99a62)] - **Stream, refactor**: use UVStream::create_pipe to create pipe stream.(xicilion)
* [[`ff071cd2ff`](https://github.com/fibjs/fibjs/commit/ff071cd2ff)] - **core, refactor**: use isolate_ref() instead of holder()->Ref().(xicilion)
* [[`fdc2c7b689`](https://github.com/fibjs/fibjs/commit/fdc2c7b689)] - **fs, bugfix**: compile error in debug mode on Windows.(xicilion)
* [[`92d7d75f9b`](https://github.com/fibjs/fibjs/commit/92d7d75f9b)] - **fs, refactor**: use uv_call to refactor fs.watch.(xicilion)
* [[`4355e53403`](https://github.com/fibjs/fibjs/commit/4355e53403)] - **dgram, refactor**: bind udp socket in worker fiber.(xicilion)
* [[`0e5d6541cf`](https://github.com/fibjs/fibjs/commit/0e5d6541cf)] - **dgram, refactor**: move code to source file.(xicilion)
* [[`47a4e6f0f0`](https://github.com/fibjs/fibjs/commit/47a4e6f0f0)] - **core, refactor**: refactor the error reporting framework to support uv error codes.(xicilion)
* [[`207a8505ce`](https://github.com/fibjs/fibjs/commit/207a8505ce)] - **child_process, bugfix**: crash when spawn return error.(xicilion)
* [[`7db883702e`](https://github.com/fibjs/fibjs/commit/7db883702e)] - **uv, refactor**: refactor uv process model.(xicilion)
* [[`0d1c6d45b7`](https://github.com/fibjs/fibjs/commit/0d1c6d45b7)] - **db, bugfix**: conn.begin error on mysql.(xicilion)
* [[`e2a657af85`](https://github.com/fibjs/fibjs/commit/e2a657af85)] - **net, refactor**: use Socket::_new to create socket.(xicilion)
* [[`b579d8baaa`](https://github.com/fibjs/fibjs/commit/b579d8baaa)] - **net, refactor**: remove udp support from net.Socket.(xicilion)
* [[`2e9d95e18a`](https://github.com/fibjs/fibjs/commit/2e9d95e18a)] - **fs, refactor**: rewrite fs.stat.(xicilion)
* [[`c1d34fb2d0`](https://github.com/fibjs/fibjs/commit/c1d34fb2d0)] - **test, bugfix**: http test error on Windows.(xicilion)
* [[`bf9cbd9c3d`](https://github.com/fibjs/fibjs/commit/bf9cbd9c3d)] - **fs, refactor**: define the uv_async function to simplify the implementation of the fs uv async function.(xicilion)
* [[`0ff0220291`](https://github.com/fibjs/fibjs/commit/0ff0220291)] - **test, bugfix**: actions test error on Windows.(xicilion)
* [[`5931893b65`](https://github.com/fibjs/fibjs/commit/5931893b65)] - **test, bugfix**: some test error.(xicilion)
* [[`f473cbe2a2`](https://github.com/fibjs/fibjs/commit/f473cbe2a2)] - **EventEmitter, bugfix**: removeAllListeners() does not remove any listener.(xicilion)
* [[`34b4cbb072`](https://github.com/fibjs/fibjs/commit/34b4cbb072)] - **test, bugfix**: ws test error on windows.(xicilion)
* [[`e448fe268b`](https://github.com/fibjs/fibjs/commit/e448fe268b)] - **test, bugfix**: some test error.(xicilion)
* [[`d8f6148847`](https://github.com/fibjs/fibjs/commit/d8f6148847)] - **dgram, bugfix**: tests on systems without IPv6 will report errors.(xicilion)
* [[`fb12430ad7`](https://github.com/fibjs/fibjs/commit/fb12430ad7)] - **dgram, bugfix**: test error on Linux.(xicilion)
* [[`bced2f270d`](https://github.com/fibjs/fibjs/commit/bced2f270d)] - **dgram, refactor**: use uv to implement udp socket.(xicilion)
* [[`0cd369caaf`](https://github.com/fibjs/fibjs/commit/0cd369caaf)] - **build, bugfix**: compile warning in debug mode on Windows.(xicilion)
* [[`5b08279735`](https://github.com/fibjs/fibjs/commit/5b08279735)] - **test, refactor**: enable process test.(xicilion)
* [[`48c86a374e`](https://github.com/fibjs/fibjs/commit/48c86a374e)] - **net, refactor**: use uv to convert inetAddr.(xicilion)
* [[`1be12ed80d`](https://github.com/fibjs/fibjs/commit/1be12ed80d)] - **os, refactor**: use uv to implament os/process function.(xicilion)
* [[`46b0eb4233`](https://github.com/fibjs/fibjs/commit/46b0eb4233)] - **test, refactor**: output error message to stdout.(xicilion)
* [[`a49529a050`](https://github.com/fibjs/fibjs/commit/a49529a050)] - **core, bugfix**: compile error in debug mode.(xicilion)
* [[`31f045b37d`](https://github.com/fibjs/fibjs/commit/31f045b37d)] - **fs, bugfix**: compile error on windows.(xicilion)
* [[`a769b360b3`](https://github.com/fibjs/fibjs/commit/a769b360b3)] - **fs, feat**: support recursive option in fs.mkdir.(xicilion)
* [[`7dba59b47b`](https://github.com/fibjs/fibjs/commit/7dba59b47b)] - **path, refactor**: define os_* api.(xicilion)
* [[`df90a7bd99`](https://github.com/fibjs/fibjs/commit/df90a7bd99)] - **core, refactor**: optimize the implementation of some string methods.(xicilion)
* [[`bc4d7699a1`](https://github.com/fibjs/fibjs/commit/bc4d7699a1)] - **fs, feat**: throw system error code.(xicilion)
* [[`3251707458`](https://github.com/fibjs/fibjs/commit/3251707458)] - **gui, bugfix**: cef subprocess does not initialize uv, causing fs.exists to fail.(xicilion)
* [[`907e560fb8`](https://github.com/fibjs/fibjs/commit/907e560fb8)] - **dgram, bugfix**: change test port.(xicilion)
* [[`62be044f11`](https://github.com/fibjs/fibjs/commit/62be044f11)] - **core, refactor**: add C_ before the const variable name to avoid conflicts between variable names and system variables.(xicilion)
* [[`9d86436040`](https://github.com/fibjs/fibjs/commit/9d86436040)] - **fs, refactor**: use destructor to destroy uv_fs_t structure.(xicilion)
* [[`521a493b7f`](https://github.com/fibjs/fibjs/commit/521a493b7f)] - **fs, refactor**: use uv to implament fs.readdir function.(xicilion)
* [[`f4813033cc`](https://github.com/fibjs/fibjs/commit/f4813033cc)] - **fs, refactor**: split fs.cpp.(xicilion)
* [[`ae39cd5e0f`](https://github.com/fibjs/fibjs/commit/ae39cd5e0f)] - **fs, refactor**: use uv to implament fs.copyFile function.(xicilion)
* [[`fc658892ef`](https://github.com/fibjs/fibjs/commit/fc658892ef)] - **core, refactor**: add _ before the const variable name to avoid conflicts between variable names and system variables.(xicilion)
* [[`0fd428dcda`](https://github.com/fibjs/fibjs/commit/0fd428dcda)] - **fs, refactor**: refactor fs.constants and move the SEEK_* flag to fs.constants.(xicilion)
* [[`fe3af88f3a`](https://github.com/fibjs/fibjs/commit/fe3af88f3a)] - **build, bugfix**: fibjs build with alpine 3.13 (#643)(Su Yang)
* [[`e4c2eacfb4`](https://github.com/fibjs/fibjs/commit/e4c2eacfb4)] - **dgram, bugfix**: bug message recv error.(xicilion)
* [[`a5dc1e8a36`](https://github.com/fibjs/fibjs/commit/a5dc1e8a36)] - **fs, refactor**: use uv to implament fs function.(xicilion)
* [[`b0ba38ed8e`](https://github.com/fibjs/fibjs/commit/b0ba38ed8e)] - **core, refactor**: use c++ alloc to enable jemalloc.(xicilion)

## 2021-03-30, Version 0.32.1
* **feature** :
    * tools - upgrade tools/changelog.js, driven by child_process module.(richardo2016)

* **bugfix** :
    * build - fibjs build with alpine 3.13 (#643)(Su Yang)
    * db - conn.begin error on mysql.(xicilion)
    * EventEmitter - removeAllListeners() does not remove any listener.(xicilion)

### Commits
* [[`38886c8d8b`](https://github.com/fibjs/fibjs/commit/38886c8d8b)] - **tools, feat**: upgrade tools/changelog.js, driven by child_process module.(richardo2016)
* [[`0c65ff57f9`](https://github.com/fibjs/fibjs/commit/0c65ff57f9)] - **db, bugfix**: conn.begin error on mysql.(xicilion)
* [[`ae2ea1459f`](https://github.com/fibjs/fibjs/commit/ae2ea1459f)] - **EventEmitter, bugfix**: removeAllListeners() does not remove any listener.(xicilion)
* [[`8b9d85f8a4`](https://github.com/fibjs/fibjs/commit/8b9d85f8a4)] - **build, bugfix**: fibjs build with alpine 3.13 (#643)(Su Yang)

## 2021-03-21, Version 0.32.0
* **feature** :
    * build:
      - support `USE_VENDER_DIST` env for build.cmd(richardo2016)
      - setup format style.(xicilion)
      - output red logo on Windows.(xicilion)
      - add `check_env` as cmake function(richardo2016)
      - upgrade vender revision(richardo2016)
    * child_process:
      - add more test case.(xicilion)
      - document encoding options.(xicilion)
      - more detailed documentation.(xicilion)
      - support child_process module.(xicilion)
    * ci:
      - configure github actions workflow to support product release in fork repo.(richardo2016)
      - never abort other running jobs as one job failed.(richardo2016)
      - deprecate support for mips/mips64(richardo2016)
      - deprecate appveyor/travis, use github actions.(richardo2016)
      - upgrade to xcode 10.1 when TARGET_ARCH=i386 for os osx(Ray Chan)
    * console:
      - support require console module.(xicilion)
      - output warn and error to stderr.(xicilion)
      - use COLOR_LIGHTYELLOW  to output warning message.(xicilion)
      - output ANSI colors directly on Windows 10.(xicilion)
    * core:
      - support type conversion to date.(xicilion)
      - support VT_JSON type in Variant.(xicilion)
      - use utf16to8String directly instead of UTF8_A.(xicilion)
      - add new status code 'CALL_E_CLOSED', apply it for closable Stream. (#608)(Ray)
    * crypto:
      - update mbedtls to v2.7.18.(xicilion)
      - generate PKey directly in the crypto module.(xicilion)
    * db:
      - support savepoint.(xicilion)
      - pass conn as a parameter to the function.(xicilion)
      - unify the parameters of order and index.(xicilion)
      - support createIndex and dropIndex.(xicilion)
      - support conn.create and conn.drop.(xicilion)
    * doc - upgrade BUILDING.md(richardo2016)
    * docs:
      - document cef options.(xicilion)
      - refer to Chrome DevTools Protocol document.(xicilion)
      - keep url in document.(xicilion)
      - some missing document.(xicilion)
    * editor - adapt to the new version of clang-format.(xicilion)
    * encoding - support msgpack encode in Message/HttpRequest/HttpResponse/WebSocketMessage/WorkerMessage.(xicilion)
    * gui:
      - support config type when open WebView.(xicilion)
      - support open blank WebView window.(xicilion)
      - support config proxy.(xicilion)
      - add key/mouse event test.(xicilion)
      - show dock icon on Mac.(xicilion)
      - bring window to front and activate keyboard on the Mac.(xicilion)
      - support config cef_path on mac.(xicilion)
      - specify fixed executable file name for helper on mac.(xicilion)
      - add devtools event test.(xicilion)
      - set background color to white.(xicilion)
      - support config headless view size.(xicilion)
      - add screenshot test .(xicilion)
      - support fullscreen window.(xicilion)
      - support config default properties of WebView.(xicilion)
      - disable popup window in headless mode.(xicilion)
      - hold the process until the last WebView is closed.(xicilion)
      - support post body in scheme.(xicilion)
      - add backend test.(xicilion)
      - basic test case.(xicilion)
      - show window after set position on Windows.(xicilion)
      - support config global headless.(xicilion)
      - support config backend handler for cef WebView.(xicilion)
      - support specifying the directory of cef runtime.(xicilion)
      - hide the window before closing it.(xicilion)
      - support config cache_path to save cache data.(xicilion)
      - flush cache data before exit process.(xicilion)
      - use mock keychain to save data on Mac.(xicilion)
      - support getUrl.(xicilion)
      - support disable content menu.(xicilion)
      - force headless mode to open the window when --headless is specified in the command line parameter.(xicilion)
      - add dev object, wrap DevTools protocol functions and events.(xicilion)
      - update option document.(xicilion)
      - decode json string in the result of executeDevToolsMethod.(xicilion)
      - support executeDevToolsMethod.(xicilion)
      - support headless mode in cef webview.(xicilion)
      - support popup control in cef webview.(xicilion)
      - implatement opt on Linux.(xicilion)
      - support debug option in cef webview.(xicilion)
      - support opt/event on Windows.(xicilion)
      - support opt and event on Mac.(xicilion)
      - support executeJavaScript.(xicilion)
      - support printToPDF.(xicilion)
      - support reload, goBack, goForward.(xicilion)
      - support cef webview.(xicilion)
      - change property name in move event on osx.(xicilion)
      - use blocking-awake mode for NSAppMainRunLoopThread (#593)(Ray)
    * http:
      - support specifying the body object for response, which is used to receive response data.(xicilion)
      - add test cases for httpClient whose 'sslVerification' set.(Ray Chan)
    * httpClient - support 307 redirect.(xicilion)
    * HttpFileHandler - support http partial content request.(Ray Chan)
    * HttpResponse - support 301, 302, 307 redirect.(xicilion)
    * idl:
      - clean idl files about child_process.(richardo2016)
      - support generate back `.idls` from its parsed results, normalize root idl source files(zh-cn). (#604)(Ray)
    * idlc - support for defining self-referenced modules.(xicilion)
    * installer - display error message.(xicilion)
    * io:
      - support default whence in SeekableStream.seek.(xicilion)
      - support io.RangeStream. (#603)(Ray)
    * msgpack:
      - support bigint pack.  (#632)(lhkzh)
      - fix bug int/uint decode to null (#598)(lhkzh)
    * option - support ssldump.(xicilion)
    * process:
      - test 'fd' property in process.std[in|out|err] (#607)(Ray)
      - use uv to implement stdio stream.(xicilion)
    * RangeStream:
      - no check bytes unit token when parse range string.(Ray Chan)
      - use `Long` type for arguments for begin/end position.(Ray Chan)
    * ssl:
      - update certdata. (#613)(Ray)
      - update root certs.(xicilion)
    * Stat:
      - reduce members in Stat, support APIs about detecting device type.(richardo2016)
      - use uv* api to normalize query to stats from file system.(Ray Chan)
    * stdio - parallel io in stdio.(xicilion)
    * SubProcess - remove pointless SubProcess::ppid. (#599)(Ray)
    * test:
      - generate test/vm_test/*.jsc from ci.(richardo2016)
      - generate unexisted vm_test/*.jsc when test only.(richardo2016)
      - wait for event in watch test.(xicilion)
    * tools:
      - display constructors and external objects in different syntax.(xicilion)
      - add trans script.(xicilion)
    * util:
      - add cef version information.(xicilion)
      - add `uv` version to vender information.(Ray Chan)
      - support util.parseArgs.(xicilion)
    * uv - support uv_call.(xicilion)
    * UVStream - close fd before deleting the object.(xicilion)
    * vender:
      - use latest vender.(richardo2016)
      - upgrade vender.(richardo2016)
      - upgrade vender, use sqlite 3.34.1(richardo2016)
      - use latest vender, adapt to v8 7.1(richardo2016)
      - upgrade vender, support compiling to target darwin arm64 (on Apple silcon)(richardo2016)
      - adapt to v8 7.0.276.42. (#628)(Ray)
    * WebView - support address/title event.(xicilion)

* **bugfix** :
    * asyncIO - compile error on windows.(xicilion)
    * build:
      - check the build script in vender.(xicilion)
      - fixup condition about USE_VENDER_DIST in build.cmd(richardo2016)
      - give fullpath of `makecab.exe` for gen_install.js on windows build.(richardo2016)
      - installer build error on Windows.(xicilion)
      - build error on Windows.(xicilion)
      - custom folder build error on Windows.(xicilion)
      - script error on Ubuntu16.(xicilion)
      - not set link_frags if it is empty.(xicilion)
      - link error when compile fibjs_gui.(xicilion)
      - fixup compilation error on windows, use real uv's pipe fileno on windows.(Ray Chan)
    * child_process:
      - ChildProcess cannot display error messages.(xicilion)
      - use default uv env settings.(xicilion)
      - correct environ string passed to child process.(Ray Chan)
    * ChildProcess:
      - error during spawn will cause memory leak.(xicilion)
      - memory leak when processing env string.(xicilion)
      - remove unused variable.(xicilion)
    * console:
      - console.readLine error after accessing process.stdin.(xicilion)
      - ansi color not enable on Windows 10.(xicilion)
    * core - compile warning on Windows.(xicilion)
    * db:
      - leveldb error displays garbled characters on windows.(xicilion)
      - transaction error on mssql.(xicilion)
      - syntax error on mssql.(xicilion)
      - test error in mysql.(xicilion)
      - skip/limit syntax error.(xicilion)
      - use IsJSObject to test Object argument.(xicilion)
    * dgram - crash in dgram.send.(xicilion)
    * doc - fix format of some `.idl` files, never replace special tokens when `gen_docs` from .idl.(Ray Chan)
    * docs:
      - use new child_process.(xicilion)
      - update to new api.(xicilion)
      - typo.(xicilion)
    * fibjs - compile warning on Windows.(xicilion)
    * gui:
      - compile error on Windows.(xicilion)
      - maximize and fullscreen style not work in some case.(xicilion)
      - executeDevToolsMethod does not return when the parameter is wrong.(xicilion)
      - missing code.(xicilion)
      - releasing GuiApp when the abnormal process exits will cause a crash.(xicilion)
      - when no one is holding the object, GC will cause WebView to not respond to events.(xicilion)
      - hold handlers to keep JavaScript binding.(xicilion)
      - style mistake on Windows.(xicilion)
      - window size wrong after change style on Windows.(xicilion)
      - force close borderless window on mac.(xicilion)
      - missing open event on linux.(xicilion)
      - delay shutdown on all platform.(xicilion)
      - render process not exit after shutdown on Mac.(xicilion)
      - printToPDF error on Linux.(xicilion)
      - cef window can not be closed.(xicilion)
      - crash on Mac.(xicilion)
      - use inline function in include file.(xicilion)
    * http - missing queryString in http.Repeater.(xicilion)
    * httpClient - resend request when disconnected.(xicilion)
    * module - some require errors were not caught.(xicilion)
    * msgpack:
      - error when converting type to bigint.(xicilion)
      - stringObject and BooleanObject are incorrectly encoded as Object (#596)(Ray)
    * process - output to console process.stdout causes error on Windows.(xicilion)
    * RangeStream - correct local `asyncStat` request for `RangeStream::stat`. (#614)(Ray)
    * smtp - new smtp protocol.(xicilion)
    * StatsWatcher - fixup unexpected thread holding occured on calling `fs.watchFile`. (#624)(Ray)
    * test:
      - use os.EOL as line break to fix test errors on Windows.(xicilion)
      - upgrade test cases in 'opt_tools_test/'(Ray Chan)
      - test error in process.run/process.open.(xicilion)
    * utils - correct local variable `s_errors` in `getResultMessage`. (#625)(Ray)
    * UVStream - make fd of stdio work in blocking mode. (#623)(Ray)
    * watch - vs2017 compilation error.(xicilion)
    * ws - websocket gc test unstable on Windows.(xicilion)

* **refactor** :
    * build:
      - [bugfix] use llvm-rc when compiling with clang only.(richardo2016)
      - upgrade and adapt to vender, re-support use clang on windows.(richardo2016)
      - use the src_list built in option.cmake.(xicilion)
      - update vender.(xicilion)
      - delete unused msvc project file.(xicilion)
      - display logo after successful build.(xicilion)
      - rewrite build.cmd, not depend on bash.(xicilion)
      - compile with msvc on Windows.(xicilion)
      - build installer.sh in cmake.(xicilion)
      - refactor cmake build script, unify compilation flags.(xicilion)
      - query GIT_INFO in CMakeLists.txt.(xicilion)
      - use cmake as workflow driver.(richardo2016)
      - cmake build script.(xicilion)
      - refactor build script.(xicilion)
    * core:
      - use #pragma once instead of #ifndef.(xicilion)
      - inherit ValueHolder from obj_base to simplify object implementation.(xicilion)
      - support object::Delete.(xicilion)
      - refactor uv_call to support return result.(xicilion)
      - fix compile warning in debug mode.(xicilion)
      - refactor the implementation of callbacks to support returning context.(xicilion)
    * global - deprecate global.repl.(xicilion)
    * gui:
      - throw error when DevTools return error message.(xicilion)
      - deprecate g_cefheadless.(xicilion)
      - test backend in headless mode.(xicilion)
      - use headless in test.(xicilion)
      - using fibjs itself as a child process under Mac, optimizing the cef runtime directory structure.(xicilion)
      - rewrite window style on Windows.(xicilion)
      - use c++11 syntax to iterate the map.(xicilion)
      - remove experimental domain and method in DevTools.(xicilion)
      - use XMoveResizeWindow to set window position on linux.(xicilion)
      - separate out gui_app.h.(xicilion)
      - refactor GuiApp.(xicilion)
      - optimize the window display under windows and solve the window flicker problem.(xicilion)
      - only bind observer when DevTools is used.(xicilion)
      - remove visible value.(xicilion)
      - use os_config_window to implement opt/event on Mac.(xicilion)
      - try close in os_config_window.(xicilion)
      - use os_config_window to implement opt/event.(xicilion)
      - abstract the platform-related config_window interface.(xicilion)
      - remove unused code.(xicilion)
    * installer - use cmake to build installer.(xicilion)
    * process - deprecated SubProcess.(xicilion)
    * test - remove unused process test case.(xicilion)
    * util - use v8::Promise process async function.(xicilion)
    * UVStream - process UV_EOF and UV_PIPE.(xicilion)

* **chore** :
    * build - remove useless ci configuration files.(richardo2016)

* **others** :
    * ChildProcess - refactor: not actively close the stream before destroying the ChildProcess object.(xicilion)
    * Merge branch 'dev' of github.com - fibjs/fibjs into dev(xicilion)

### Commits
* [[`c66841bbee`](https://github.com/fibjs/fibjs/commit/c66841bbee)] - **ci, feat**: configure github actions workflow to support product release in fork repo.(richardo2016)
* [[`5dde868d74`](https://github.com/fibjs/fibjs/commit/5dde868d74)] - **tools, feat**: display constructors and external objects in different syntax.(xicilion)
* [[`094ebcf4ee`](https://github.com/fibjs/fibjs/commit/094ebcf4ee)] - **tools, feat**: add trans script.(xicilion)
* [[`c9c1b8e027`](https://github.com/fibjs/fibjs/commit/c9c1b8e027)] - **console, feat**: support require console module.(xicilion)
* [[`d49d25448b`](https://github.com/fibjs/fibjs/commit/d49d25448b)] - **idlc, feat**: support for defining self-referenced modules.(xicilion)
* [[`3dd99975a2`](https://github.com/fibjs/fibjs/commit/3dd99975a2)] - **installer, feat**: display error message.(xicilion)
* [[`8b0aa07a96`](https://github.com/fibjs/fibjs/commit/8b0aa07a96)] - **gui, feat**: support config type when open WebView.(xicilion)
* [[`113c39ae4f`](https://github.com/fibjs/fibjs/commit/113c39ae4f)] - **core, feat**: support type conversion to date.(xicilion)
* [[`966cede218`](https://github.com/fibjs/fibjs/commit/966cede218)] - **vender, feat**: use latest vender.(richardo2016)
* [[`00fc5ddca8`](https://github.com/fibjs/fibjs/commit/00fc5ddca8)] - **build, chore**: remove useless ci configuration files.(richardo2016)
* [[`0da26d0fe0`](https://github.com/fibjs/fibjs/commit/0da26d0fe0)] - **core, refactor**: use #pragma once instead of #ifndef.(xicilion)
* [[`995870ef5e`](https://github.com/fibjs/fibjs/commit/995870ef5e)] - **crypto, feat**: update mbedtls to v2.7.18.(xicilion)
* [[`7858b6fa49`](https://github.com/fibjs/fibjs/commit/7858b6fa49)] - **WebView, feat**: support address/title event.(xicilion)
* [[`c37282d87e`](https://github.com/fibjs/fibjs/commit/c37282d87e)] - **gui, refactor**: throw error when DevTools return error message.(xicilion)
* [[`e54b759d3a`](https://github.com/fibjs/fibjs/commit/e54b759d3a)] - **console, feat**: output warn and error to stderr.(xicilion)
* [[`2f0f333539`](https://github.com/fibjs/fibjs/commit/2f0f333539)] - **global, refactor**: deprecate global.repl.(xicilion)
* [[`7d1466145d`](https://github.com/fibjs/fibjs/commit/7d1466145d)] - **gui, refactor**: deprecate g_cefheadless.(xicilion)
* [[`18012aff51`](https://github.com/fibjs/fibjs/commit/18012aff51)] - **gui, feat**: support open blank WebView window.(xicilion)
* [[`7ea941955a`](https://github.com/fibjs/fibjs/commit/7ea941955a)] - **gui, bugfix**: compile error on Windows.(xicilion)
* [[`66b1e2741e`](https://github.com/fibjs/fibjs/commit/66b1e2741e)] - **docs, bugfix**: use new child_process.(xicilion)
* [[`c1afa6d144`](https://github.com/fibjs/fibjs/commit/c1afa6d144)] - **docs, feat**: document cef options.(xicilion)
* [[`d6d87368d7`](https://github.com/fibjs/fibjs/commit/d6d87368d7)] - **gui, feat**: support config proxy.(xicilion)
* [[`433bd290c2`](https://github.com/fibjs/fibjs/commit/433bd290c2)] - **gui, refactor**: test backend in headless mode.(xicilion)
* [[`351c82e419`](https://github.com/fibjs/fibjs/commit/351c82e419)] - **gui, refactor**: use headless in test.(xicilion)
* [[`eee1c25f77`](https://github.com/fibjs/fibjs/commit/eee1c25f77)] - **gui, feat**: add key/mouse event test.(xicilion)
* [[`80bd67dead`](https://github.com/fibjs/fibjs/commit/80bd67dead)] - **gui, refactor**: using fibjs itself as a child process under Mac, optimizing the cef runtime directory structure.(xicilion)
* [[`4fb379b2ae`](https://github.com/fibjs/fibjs/commit/4fb379b2ae)] - **util, feat**: add cef version information.(xicilion)
* [[`b26384e431`](https://github.com/fibjs/fibjs/commit/b26384e431)] - **gui, feat**: show dock icon on Mac.(xicilion)
* [[`569689e761`](https://github.com/fibjs/fibjs/commit/569689e761)] - **gui, feat**: bring window to front and activate keyboard on the Mac.(xicilion)
* [[`a9c0600eac`](https://github.com/fibjs/fibjs/commit/a9c0600eac)] - **gui, feat**: support config cef_path on mac.(xicilion)
* [[`f85c50f579`](https://github.com/fibjs/fibjs/commit/f85c50f579)] - **gui, feat**: specify fixed executable file name for helper on mac.(xicilion)
* [[`71b85e5b6b`](https://github.com/fibjs/fibjs/commit/71b85e5b6b)] - **gui, bugfix**: maximize and fullscreen style not work in some case.(xicilion)
* [[`930ec81c8d`](https://github.com/fibjs/fibjs/commit/930ec81c8d)] - **gui, feat**: add devtools event test.(xicilion)
* [[`f98b19cc3f`](https://github.com/fibjs/fibjs/commit/f98b19cc3f)] - **vender, feat**: upgrade vender.(richardo2016)
* [[`c40fade957`](https://github.com/fibjs/fibjs/commit/c40fade957)] - **test, feat**: generate test/vm_test/*.jsc from ci.(richardo2016)
* [[`83315c648e`](https://github.com/fibjs/fibjs/commit/83315c648e)] - **test, feat**: generate unexisted vm_test/*.jsc when test only.(richardo2016)
* [[`2d06218b57`](https://github.com/fibjs/fibjs/commit/2d06218b57)] - **ci, feat**: never abort other running jobs as one job failed.(richardo2016)
* [[`90d0e24d44`](https://github.com/fibjs/fibjs/commit/90d0e24d44)] - **gui, bugfix**: executeDevToolsMethod does not return when the parameter is wrong.(xicilion)
* [[`deeae31ae5`](https://github.com/fibjs/fibjs/commit/deeae31ae5)] - **build, bugfix**: check the build script in vender.(xicilion)
* [[`14c9fb8052`](https://github.com/fibjs/fibjs/commit/14c9fb8052)] - **build, bugfix**: fixup condition about USE_VENDER_DIST in build.cmd(richardo2016)
* [[`92fe0634d7`](https://github.com/fibjs/fibjs/commit/92fe0634d7)] - **idl, feat**: clean idl files about child_process.(richardo2016)
* [[`ed4538cccc`](https://github.com/fibjs/fibjs/commit/ed4538cccc)] - **build, bugfix**: give fullpath of `makecab.exe` for gen_install.js on windows build.(richardo2016)
* [[`9d5dea33cc`](https://github.com/fibjs/fibjs/commit/9d5dea33cc)] - **build, feat**: support `USE_VENDER_DIST` env for build.cmd(richardo2016)
* [[`5796ff94fc`](https://github.com/fibjs/fibjs/commit/5796ff94fc)] - **gui, feat**: set background color to white.(xicilion)
* [[`cf9d2525c5`](https://github.com/fibjs/fibjs/commit/cf9d2525c5)] - **gui, feat**: support config headless view size.(xicilion)
* [[`909b38f361`](https://github.com/fibjs/fibjs/commit/909b38f361)] - **gui, feat**: add screenshot test .(xicilion)
* [[`418fd789d1`](https://github.com/fibjs/fibjs/commit/418fd789d1)] - **vender, feat**: upgrade vender, use sqlite 3.34.1(richardo2016)
* [[`18b26e9d29`](https://github.com/fibjs/fibjs/commit/18b26e9d29)] - **child_process, bugfix**: ChildProcess cannot display error messages.(xicilion)
* [[`0ecc8f3818`](https://github.com/fibjs/fibjs/commit/0ecc8f3818)] - **gui, feat**: support fullscreen window.(xicilion)
* [[`b7cae072a8`](https://github.com/fibjs/fibjs/commit/b7cae072a8)] - **gui, refactor**: rewrite window style on Windows.(xicilion)
* [[`530c928f91`](https://github.com/fibjs/fibjs/commit/530c928f91)] - **gui, bugfix**: missing code.(xicilion)
* [[`6ba974d7bd`](https://github.com/fibjs/fibjs/commit/6ba974d7bd)] - **ci, feat**: deprecate support for mips/mips64(richardo2016)
* [[`b2b3e37da9`](https://github.com/fibjs/fibjs/commit/b2b3e37da9)] - **vender, feat**: use latest vender, adapt to v8 7.1(richardo2016)
* [[`f1e1d48342`](https://github.com/fibjs/fibjs/commit/f1e1d48342)] - **core, feat**: support VT_JSON type in Variant.(xicilion)
* [[`8edc4ca96a`](https://github.com/fibjs/fibjs/commit/8edc4ca96a)] - **http, feat**: support specifying the body object for response, which is used to receive response data.(xicilion)
* [[`6cc864ab0b`](https://github.com/fibjs/fibjs/commit/6cc864ab0b)] - **io, feat**: support default whence in SeekableStream.seek.(xicilion)
* [[`c745aaf982`](https://github.com/fibjs/fibjs/commit/c745aaf982)] - **gui, bugfix**: releasing GuiApp when the abnormal process exits will cause a crash.(xicilion)
* [[`d4dd00e87b`](https://github.com/fibjs/fibjs/commit/d4dd00e87b)] - **gui, feat**: support config default properties of WebView.(xicilion)
* [[`df8cbaa88c`](https://github.com/fibjs/fibjs/commit/df8cbaa88c)] - **gui, feat**: disable popup window in headless mode.(xicilion)
* [[`00abc57c87`](https://github.com/fibjs/fibjs/commit/00abc57c87)] - **gui, feat**: hold the process until the last WebView is closed.(xicilion)
* [[`713ec19f67`](https://github.com/fibjs/fibjs/commit/713ec19f67)] - **gui, bugfix**: when no one is holding the object, GC will cause WebView to not respond to events.(xicilion)
* [[`4dc7d15cd6`](https://github.com/fibjs/fibjs/commit/4dc7d15cd6)] - **gui, refactor**: use c++11 syntax to iterate the map.(xicilion)
* [[`8f09167cdf`](https://github.com/fibjs/fibjs/commit/8f09167cdf)] - **gui, feat**: support post body in scheme.(xicilion)
* [[`ded1c0a8bd`](https://github.com/fibjs/fibjs/commit/ded1c0a8bd)] - **gui, bugfix**: hold handlers to keep JavaScript binding.(xicilion)
* [[`51a815ea2d`](https://github.com/fibjs/fibjs/commit/51a815ea2d)] - **gui, feat**: add backend test.(xicilion)
* [[`a84a7b9f53`](https://github.com/fibjs/fibjs/commit/a84a7b9f53)] - **gui, refactor**: remove experimental domain and method in DevTools.(xicilion)
* [[`632e4212d7`](https://github.com/fibjs/fibjs/commit/632e4212d7)] - **gui, feat**: basic test case.(xicilion)
* [[`2916c41db5`](https://github.com/fibjs/fibjs/commit/2916c41db5)] - **gui, bugfix**: style mistake on Windows.(xicilion)
* [[`99ecaae6ae`](https://github.com/fibjs/fibjs/commit/99ecaae6ae)] - **gui, feat**: show window after set position on Windows.(xicilion)
* [[`23e59a17f7`](https://github.com/fibjs/fibjs/commit/23e59a17f7)] - **gui, bugfix**: window size wrong after change style on Windows.(xicilion)
* [[`420b99a381`](https://github.com/fibjs/fibjs/commit/420b99a381)] - **gui, bugfix**: force close borderless window on mac.(xicilion)
* [[`37203bb56d`](https://github.com/fibjs/fibjs/commit/37203bb56d)] - **gui, refactor**: use XMoveResizeWindow to set window position on linux.(xicilion)
* [[`8e62253884`](https://github.com/fibjs/fibjs/commit/8e62253884)] - **gui, bugfix**: missing open event on linux.(xicilion)
* [[`e4c8c69a01`](https://github.com/fibjs/fibjs/commit/e4c8c69a01)] - **gui, bugfix**: delay shutdown on all platform.(xicilion)
* [[`bdf7c21987`](https://github.com/fibjs/fibjs/commit/bdf7c21987)] - **gui, bugfix**: render process not exit after shutdown on Mac.(xicilion)
* [[`a9e02d0a5e`](https://github.com/fibjs/fibjs/commit/a9e02d0a5e)] - **gui, feat**: support config global headless.(xicilion)
* [[`437624e6b7`](https://github.com/fibjs/fibjs/commit/437624e6b7)] - **docs, feat**: refer to Chrome DevTools Protocol document.(xicilion)
* [[`af08e0a20d`](https://github.com/fibjs/fibjs/commit/af08e0a20d)] - **docs, feat**: keep url in document.(xicilion)
* [[`b4892c1895`](https://github.com/fibjs/fibjs/commit/b4892c1895)] - **gui, feat**: support config backend handler for cef WebView.(xicilion)
* [[`468418b927`](https://github.com/fibjs/fibjs/commit/468418b927)] - **gui, refactor**: separate out gui_app.h.(xicilion)
* [[`38b4fc97cd`](https://github.com/fibjs/fibjs/commit/38b4fc97cd)] - **build, feat**: setup format style.(xicilion)
* [[`31ad9f84a2`](https://github.com/fibjs/fibjs/commit/31ad9f84a2)] - **gui, feat**: support specifying the directory of cef runtime.(xicilion)
* [[`8c921bacfb`](https://github.com/fibjs/fibjs/commit/8c921bacfb)] - **gui, feat**: hide the window before closing it.(xicilion)
* [[`92a1605d50`](https://github.com/fibjs/fibjs/commit/92a1605d50)] - **gui, refactor**: refactor GuiApp.(xicilion)
* [[`44aa91218a`](https://github.com/fibjs/fibjs/commit/44aa91218a)] - **docs, feat**: some missing document.(xicilion)
* [[`d0cf5da732`](https://github.com/fibjs/fibjs/commit/d0cf5da732)] - **gui, refactor**: optimize the window display under windows and solve the window flicker problem.(xicilion)
* [[`1fd888cdb1`](https://github.com/fibjs/fibjs/commit/1fd888cdb1)] - **gui, feat**: support config cache_path to save cache data.(xicilion)
* [[`b4c8a2c7dd`](https://github.com/fibjs/fibjs/commit/b4c8a2c7dd)] - **gui, feat**: flush cache data before exit process.(xicilion)
* [[`097ecca3a7`](https://github.com/fibjs/fibjs/commit/097ecca3a7)] - **gui, feat**: use mock keychain to save data on Mac.(xicilion)
* [[`5ea59a86e8`](https://github.com/fibjs/fibjs/commit/5ea59a86e8)] - **util, refactor**: use v8::Promise process async function.(xicilion)
* [[`2f59895573`](https://github.com/fibjs/fibjs/commit/2f59895573)] - **gui, feat**: support getUrl.(xicilion)
* [[`08f95993a4`](https://github.com/fibjs/fibjs/commit/08f95993a4)] - **gui, feat**: support disable content menu.(xicilion)
* [[`158beabb1b`](https://github.com/fibjs/fibjs/commit/158beabb1b)] - **gui, feat**: force headless mode to open the window when --headless is specified in the command line parameter.(xicilion)
* [[`aea540c2e3`](https://github.com/fibjs/fibjs/commit/aea540c2e3)] - **gui, refactor**: only bind observer when DevTools is used.(xicilion)
* [[`be2a91a20c`](https://github.com/fibjs/fibjs/commit/be2a91a20c)] - **core, bugfix**: compile warning on Windows.(xicilion)
* [[`4f59dd4b29`](https://github.com/fibjs/fibjs/commit/4f59dd4b29)] - **gui, feat**: add dev object, wrap DevTools protocol functions and events.(xicilion)
* [[`1b2f86a530`](https://github.com/fibjs/fibjs/commit/1b2f86a530)] - **gui, bugfix**: printToPDF error on Linux.(xicilion)
* [[`0b27abcdd5`](https://github.com/fibjs/fibjs/commit/0b27abcdd5)] - **gui, feat**: update option document.(xicilion)
* [[`07fe2a5f14`](https://github.com/fibjs/fibjs/commit/07fe2a5f14)] - **gui, feat**: decode json string in the result of executeDevToolsMethod.(xicilion)
* [[`aa83c5133e`](https://github.com/fibjs/fibjs/commit/aa83c5133e)] - **gui, feat**: support executeDevToolsMethod.(xicilion)
* [[`ee604711d5`](https://github.com/fibjs/fibjs/commit/ee604711d5)] - **gui, feat**: support headless mode in cef webview.(xicilion)
* [[`ca8197fa95`](https://github.com/fibjs/fibjs/commit/ca8197fa95)] - **gui, feat**: support popup control in cef webview.(xicilion)
* [[`281bcff9a3`](https://github.com/fibjs/fibjs/commit/281bcff9a3)] - **gui, feat**: implatement opt on Linux.(xicilion)
* [[`a537ec8e17`](https://github.com/fibjs/fibjs/commit/a537ec8e17)] - **gui, feat**: support debug option in cef webview.(xicilion)
* [[`f93846b7b7`](https://github.com/fibjs/fibjs/commit/f93846b7b7)] - **gui, bugfix**: cef window can not be closed.(xicilion)
* [[`6486d5bb5b`](https://github.com/fibjs/fibjs/commit/6486d5bb5b)] - **gui, refactor**: remove visible value.(xicilion)
* [[`efd600a949`](https://github.com/fibjs/fibjs/commit/efd600a949)] - **gui, refactor**: use os_config_window to implement opt/event on Mac.(xicilion)
* [[`c91683c8d2`](https://github.com/fibjs/fibjs/commit/c91683c8d2)] - **gui, refactor**: try close in os_config_window.(xicilion)
* [[`2ef636e087`](https://github.com/fibjs/fibjs/commit/2ef636e087)] - **gui, refactor**: use os_config_window to implement opt/event.(xicilion)
* [[`299640f519`](https://github.com/fibjs/fibjs/commit/299640f519)] - **gui, feat**: support opt/event on Windows.(xicilion)
* [[`d9ac7d22a8`](https://github.com/fibjs/fibjs/commit/d9ac7d22a8)] - **console, feat**: use COLOR_LIGHTYELLOW  to output warning message.(xicilion)
* [[`59cc7d02f5`](https://github.com/fibjs/fibjs/commit/59cc7d02f5)] - **gui, refactor**: abstract the platform-related config_window interface.(xicilion)
* [[`10ae5e2ddd`](https://github.com/fibjs/fibjs/commit/10ae5e2ddd)] - **gui, feat**: support opt and event on Mac.(xicilion)
* [[`a2d4c38e02`](https://github.com/fibjs/fibjs/commit/a2d4c38e02)] - **gui, feat**: support executeJavaScript.(xicilion)
* [[`19718d1c9e`](https://github.com/fibjs/fibjs/commit/19718d1c9e)] - **gui, feat**: support printToPDF.(xicilion)
* [[`2342a4071d`](https://github.com/fibjs/fibjs/commit/2342a4071d)] - **gui, refactor**: remove unused code.(xicilion)
* [[`a454aa9e6d`](https://github.com/fibjs/fibjs/commit/a454aa9e6d)] - **gui, feat**: support reload, goBack, goForward.(xicilion)
* [[`ccee0c05a7`](https://github.com/fibjs/fibjs/commit/ccee0c05a7)] - **gui, feat**: support cef webview.(xicilion)
* [[`bf0f4f5caf`](https://github.com/fibjs/fibjs/commit/bf0f4f5caf)] - **vender, feat**: upgrade vender, support compiling to target darwin arm64 (on Apple silcon)(richardo2016)
* [[`61d00cdf2d`](https://github.com/fibjs/fibjs/commit/61d00cdf2d)] - **build, refactor**: [bugfix] use llvm-rc when compiling with clang only.(richardo2016)
* [[`243d493cc1`](https://github.com/fibjs/fibjs/commit/243d493cc1)] - **build, refactor**: upgrade and adapt to vender, re-support use clang on windows.(richardo2016)
* [[`635af1b828`](https://github.com/fibjs/fibjs/commit/635af1b828)] - **test, refactor**: remove unused process test case.(xicilion)
* [[`c15b8aa6e9`](https://github.com/fibjs/fibjs/commit/c15b8aa6e9)] - **UVStream, refactor**: process UV_EOF and UV_PIPE.(xicilion)
* [[`abda28e1a4`](https://github.com/fibjs/fibjs/commit/abda28e1a4)] - **build, bugfix**: installer build error on Windows.(xicilion)
* [[`4ea501be5f`](https://github.com/fibjs/fibjs/commit/4ea501be5f)] - **stdio, feat**: parallel io in stdio.(xicilion)
* [[`3babd67a4c`](https://github.com/fibjs/fibjs/commit/3babd67a4c)] - **console, bugfix**: console.readLine error after accessing process.stdin.(xicilion)
* [[`cf788ee029`](https://github.com/fibjs/fibjs/commit/cf788ee029)] - **Merge branch 'dev' of github.com**: fibjs/fibjs into dev(xicilion)
* [[`cea14bab20`](https://github.com/fibjs/fibjs/commit/cea14bab20)] - **build, bugfix**: build error on Windows.(xicilion)
* [[`11a8d4c6f5`](https://github.com/fibjs/fibjs/commit/11a8d4c6f5)] - **process, refactor**: deprecated SubProcess.(xicilion)
* [[`015b29d161`](https://github.com/fibjs/fibjs/commit/015b29d161)] - **build, refactor**: use the src_list built in option.cmake.(xicilion)
* [[`0e7359f03d`](https://github.com/fibjs/fibjs/commit/0e7359f03d)] - **build, bugfix**: custom folder build error on Windows.(xicilion)
* [[`2841b85e6c`](https://github.com/fibjs/fibjs/commit/2841b85e6c)] - **build, refactor**: update vender.(xicilion)
* [[`882f8cf5fc`](https://github.com/fibjs/fibjs/commit/882f8cf5fc)] - **build, bugfix**: script error on Ubuntu16.(xicilion)
* [[`5dad3b3923`](https://github.com/fibjs/fibjs/commit/5dad3b3923)] - **ChildProcess**: refactor: not actively close the stream before destroying the ChildProcess object.(xicilion)
* [[`a1a64ad571`](https://github.com/fibjs/fibjs/commit/a1a64ad571)] - **ChildProcess, bugfix**: error during spawn will cause memory leak.(xicilion)
* [[`74ac01480f`](https://github.com/fibjs/fibjs/commit/74ac01480f)] - **build, refactor**: delete unused msvc project file.(xicilion)
* [[`a300f1dedf`](https://github.com/fibjs/fibjs/commit/a300f1dedf)] - **gui, bugfix**: crash on Mac.(xicilion)
* [[`ada77d7cc2`](https://github.com/fibjs/fibjs/commit/ada77d7cc2)] - **fibjs, bugfix**: compile warning on Windows.(xicilion)
* [[`fb4dae2baf`](https://github.com/fibjs/fibjs/commit/fb4dae2baf)] - **build, bugfix**: not set link_frags if it is empty.(xicilion)
* [[`a2482cd43e`](https://github.com/fibjs/fibjs/commit/a2482cd43e)] - **ws, bugfix**: websocket gc test unstable on Windows.(xicilion)
* [[`9dc012f5d0`](https://github.com/fibjs/fibjs/commit/9dc012f5d0)] - **process, bugfix**: output to console process.stdout causes error on Windows.(xicilion)
* [[`cae13d4b12`](https://github.com/fibjs/fibjs/commit/cae13d4b12)] - **test, bugfix**: use os.EOL as line break to fix test errors on Windows.(xicilion)
* [[`ff3bac589d`](https://github.com/fibjs/fibjs/commit/ff3bac589d)] - **child_process, bugfix**: use default uv env settings.(xicilion)
* [[`d14b3e7d08`](https://github.com/fibjs/fibjs/commit/d14b3e7d08)] - **test, feat**: wait for event in watch test.(xicilion)
* [[`72b309cad4`](https://github.com/fibjs/fibjs/commit/72b309cad4)] - **core, feat**: use utf16to8String directly instead of UTF8_A.(xicilion)
* [[`57348766b4`](https://github.com/fibjs/fibjs/commit/57348766b4)] - **db, bugfix**: leveldb error displays garbled characters on windows.(xicilion)
* [[`692d87d774`](https://github.com/fibjs/fibjs/commit/692d87d774)] - **HttpResponse, feat**: support 301, 302, 307 redirect.(xicilion)
* [[`f0d9a85e17`](https://github.com/fibjs/fibjs/commit/f0d9a85e17)] - **httpClient, feat**: support 307 redirect.(xicilion)
* [[`012bc364cc`](https://github.com/fibjs/fibjs/commit/012bc364cc)] - **httpClient, bugfix**: resend request when disconnected.(xicilion)
* [[`6bd1bf1d31`](https://github.com/fibjs/fibjs/commit/6bd1bf1d31)] - **docs, bugfix**: update to new api.(xicilion)
* [[`33809ab2ce`](https://github.com/fibjs/fibjs/commit/33809ab2ce)] - **ChildProcess, bugfix**: memory leak when processing env string.(xicilion)
* [[`7df6f94d01`](https://github.com/fibjs/fibjs/commit/7df6f94d01)] - **build, feat**: output red logo on Windows.(xicilion)
* [[`df9286665e`](https://github.com/fibjs/fibjs/commit/df9286665e)] - **editor, feat**: adapt to the new version of clang-format.(xicilion)
* [[`591059c1b8`](https://github.com/fibjs/fibjs/commit/591059c1b8)] - **build, refactor**: display logo after successful build.(xicilion)
* [[`1825eecc81`](https://github.com/fibjs/fibjs/commit/1825eecc81)] - **build, refactor**: rewrite build.cmd, not depend on bash.(xicilion)
* [[`7923726a41`](https://github.com/fibjs/fibjs/commit/7923726a41)] - **installer, refactor**: use cmake to build installer.(xicilion)
* [[`a7da3447e0`](https://github.com/fibjs/fibjs/commit/a7da3447e0)] - **db, bugfix**: transaction error on mssql.(xicilion)
* [[`cfe298ce1e`](https://github.com/fibjs/fibjs/commit/cfe298ce1e)] - **db, bugfix**: syntax error on mssql.(xicilion)
* [[`f94547e46c`](https://github.com/fibjs/fibjs/commit/f94547e46c)] - **console, bugfix**: ansi color not enable on Windows 10.(xicilion)
* [[`550f917584`](https://github.com/fibjs/fibjs/commit/550f917584)] - **build, refactor**: compile with msvc on Windows.(xicilion)
* [[`76ad828f66`](https://github.com/fibjs/fibjs/commit/76ad828f66)] - **build, bugfix**: link error when compile fibjs_gui.(xicilion)
* [[`c8f6569ee2`](https://github.com/fibjs/fibjs/commit/c8f6569ee2)] - **watch, bugfix**: vs2017 compilation error.(xicilion)
* [[`5b0ad53b22`](https://github.com/fibjs/fibjs/commit/5b0ad53b22)] - **build, refactor**: build installer.sh in cmake.(xicilion)
* [[`7b7b4c3b51`](https://github.com/fibjs/fibjs/commit/7b7b4c3b51)] - **build, refactor**: refactor cmake build script, unify compilation flags.(xicilion)
* [[`a4dbd6ac54`](https://github.com/fibjs/fibjs/commit/a4dbd6ac54)] - **build, refactor**: query GIT_INFO in CMakeLists.txt.(xicilion)
* [[`4d138b2af8`](https://github.com/fibjs/fibjs/commit/4d138b2af8)] - **console, feat**: output ANSI colors directly on Windows 10.(xicilion)
* [[`b41016e491`](https://github.com/fibjs/fibjs/commit/b41016e491)] - **build, feat**: add `check_env` as cmake function(richardo2016)
* [[`8810264d45`](https://github.com/fibjs/fibjs/commit/8810264d45)] - **build, feat**: upgrade vender revision(richardo2016)
* [[`5e0b66b572`](https://github.com/fibjs/fibjs/commit/5e0b66b572)] - **build, refactor**: use cmake as workflow driver.(richardo2016)
* [[`841e15f6a9`](https://github.com/fibjs/fibjs/commit/841e15f6a9)] - **doc, feat**: upgrade BUILDING.md(richardo2016)
* [[`0ad49fa1dc`](https://github.com/fibjs/fibjs/commit/0ad49fa1dc)] - **build, refactor**: cmake build script.(xicilion)
* [[`a7b9dabe12`](https://github.com/fibjs/fibjs/commit/a7b9dabe12)] - **build, refactor**: refactor build script.(xicilion)
* [[`e169fba393`](https://github.com/fibjs/fibjs/commit/e169fba393)] - **gui, bugfix**: use inline function in include file.(xicilion)
* [[`2fb80bb2ff`](https://github.com/fibjs/fibjs/commit/2fb80bb2ff)] - **ChildProcess, bugfix**: remove unused variable.(xicilion)
* [[`4ee293ea51`](https://github.com/fibjs/fibjs/commit/4ee293ea51)] - **vender, feat**: adapt to v8 7.0.276.42. (#628)(Ray)
* [[`e3aa83d036`](https://github.com/fibjs/fibjs/commit/e3aa83d036)] - **ci, feat**: deprecate appveyor/travis, use github actions.(richardo2016)
* [[`d0d5880dd5`](https://github.com/fibjs/fibjs/commit/d0d5880dd5)] - **crypto, feat**: generate PKey directly in the crypto module.(xicilion)
* [[`a3d91f9ca0`](https://github.com/fibjs/fibjs/commit/a3d91f9ca0)] - **db, bugfix**: test error in mysql.(xicilion)
* [[`37214ba82c`](https://github.com/fibjs/fibjs/commit/37214ba82c)] - **db, feat**: support savepoint.(xicilion)
* [[`16f0705524`](https://github.com/fibjs/fibjs/commit/16f0705524)] - **db, feat**: pass conn as a parameter to the function.(xicilion)
* [[`46bca90fcd`](https://github.com/fibjs/fibjs/commit/46bca90fcd)] - **db, feat**: unify the parameters of order and index.(xicilion)
* [[`b316cf22de`](https://github.com/fibjs/fibjs/commit/b316cf22de)] - **db, bugfix**: skip/limit syntax error.(xicilion)
* [[`d902dd09e9`](https://github.com/fibjs/fibjs/commit/d902dd09e9)] - **db, bugfix**: use IsJSObject to test Object argument.(xicilion)
* [[`e42845e1de`](https://github.com/fibjs/fibjs/commit/e42845e1de)] - **db, feat**: support createIndex and dropIndex.(xicilion)
* [[`6e56270803`](https://github.com/fibjs/fibjs/commit/6e56270803)] - **db, feat**: support conn.create and conn.drop.(xicilion)
* [[`4d27dde3f3`](https://github.com/fibjs/fibjs/commit/4d27dde3f3)] - **msgpack, bugfix**: error when converting type to bigint.(xicilion)
* [[`93d0af82a1`](https://github.com/fibjs/fibjs/commit/93d0af82a1)] - **msgpack, feat**: support bigint pack.  (#632)(lhkzh)
* [[`7a13d23ea3`](https://github.com/fibjs/fibjs/commit/7a13d23ea3)] - **module, bugfix**: some require errors were not caught.(xicilion)
* [[`fdd0f9d155`](https://github.com/fibjs/fibjs/commit/fdd0f9d155)] - **UVStream, feat**: close fd before deleting the object.(xicilion)
* [[`5415a6bf1c`](https://github.com/fibjs/fibjs/commit/5415a6bf1c)] - **utils, bugfix**: correct local variable `s_errors` in `getResultMessage`. (#625)(Ray)
* [[`b0c58bbee9`](https://github.com/fibjs/fibjs/commit/b0c58bbee9)] - **UVStream, bugfix**: make fd of stdio work in blocking mode. (#623)(Ray)
* [[`1c1930f79c`](https://github.com/fibjs/fibjs/commit/1c1930f79c)] - **StatsWatcher, bugfix**: fixup unexpected thread holding occured on calling `fs.watchFile`. (#624)(Ray)
* [[`8905dcb8c9`](https://github.com/fibjs/fibjs/commit/8905dcb8c9)] - **http, feat**: add test cases for httpClient whose 'sslVerification' set.(Ray Chan)
* [[`03d95e8993`](https://github.com/fibjs/fibjs/commit/03d95e8993)] - **Stat, feat**: reduce members in Stat, support APIs about detecting device type.(richardo2016)
* [[`8e7da88825`](https://github.com/fibjs/fibjs/commit/8e7da88825)] - **Stat, feat**: use uv* api to normalize query to stats from file system.(Ray Chan)
* [[`06f7737a4a`](https://github.com/fibjs/fibjs/commit/06f7737a4a)] - **encoding, feat**: support msgpack encode in Message/HttpRequest/HttpResponse/WebSocketMessage/WorkerMessage.(xicilion)
* [[`973ba2eaa9`](https://github.com/fibjs/fibjs/commit/973ba2eaa9)] - **test, bugfix**: upgrade test cases in 'opt_tools_test/'(Ray Chan)
* [[`d1d73e1873`](https://github.com/fibjs/fibjs/commit/d1d73e1873)] - **child_process, bugfix**: correct environ string passed to child process.(Ray Chan)
* [[`8a0a10e724`](https://github.com/fibjs/fibjs/commit/8a0a10e724)] - **build, bugfix**: fixup compilation error on windows, use real uv's pipe fileno on windows.(Ray Chan)
* [[`f00ce8ecc7`](https://github.com/fibjs/fibjs/commit/f00ce8ecc7)] - **RangeStream, bugfix**: correct local `asyncStat` request for `RangeStream::stat`. (#614)(Ray)
* [[`8fd4f12a79`](https://github.com/fibjs/fibjs/commit/8fd4f12a79)] - **ssl, feat**: update certdata. (#613)(Ray)
* [[`3338549906`](https://github.com/fibjs/fibjs/commit/3338549906)] - **dgram, bugfix**: crash in dgram.send.(xicilion)
* [[`7af06513f8`](https://github.com/fibjs/fibjs/commit/7af06513f8)] - **http, bugfix**: missing queryString in http.Repeater.(xicilion)
* [[`91f112bd14`](https://github.com/fibjs/fibjs/commit/91f112bd14)] - **core, refactor**: inherit ValueHolder from obj_base to simplify object implementation.(xicilion)
* [[`bbf3052d4f`](https://github.com/fibjs/fibjs/commit/bbf3052d4f)] - **core, refactor**: support object::Delete.(xicilion)
* [[`f377b07d0d`](https://github.com/fibjs/fibjs/commit/f377b07d0d)] - **core, feat**: add new status code 'CALL_E_CLOSED', apply it for closable Stream. (#608)(Ray)
* [[`845a10d913`](https://github.com/fibjs/fibjs/commit/845a10d913)] - **process, feat**: test 'fd' property in process.std[in|out|err] (#607)(Ray)
* [[`aa5b886cc6`](https://github.com/fibjs/fibjs/commit/aa5b886cc6)] - **HttpFileHandler, feat**: support http partial content request.(Ray Chan)
* [[`d54968be94`](https://github.com/fibjs/fibjs/commit/d54968be94)] - **RangeStream, feat**: no check bytes unit token when parse range string.(Ray Chan)
* [[`4efd2e3bbf`](https://github.com/fibjs/fibjs/commit/4efd2e3bbf)] - **RangeStream, feat**: use `Long` type for arguments for begin/end position.(Ray Chan)
* [[`8662110b2b`](https://github.com/fibjs/fibjs/commit/8662110b2b)] - **gui, feat**: change property name in move event on osx.(xicilion)
* [[`d9084b6f6c`](https://github.com/fibjs/fibjs/commit/d9084b6f6c)] - **io, feat**: support io.RangeStream. (#603)(Ray)
* [[`2fd7b1ed67`](https://github.com/fibjs/fibjs/commit/2fd7b1ed67)] - **util, feat**: add `uv` version to vender information.(Ray Chan)
* [[`dd5cef54ef`](https://github.com/fibjs/fibjs/commit/dd5cef54ef)] - **core, refactor**: refactor uv_call to support return result.(xicilion)
* [[`3eaa3397bb`](https://github.com/fibjs/fibjs/commit/3eaa3397bb)] - **idl, feat**: support generate back `.idls` from its parsed results, normalize root idl source files(zh-cn). (#604)(Ray)
* [[`a830a3a09b`](https://github.com/fibjs/fibjs/commit/a830a3a09b)] - **process, feat**: use uv to implement stdio stream.(xicilion)
* [[`c0a4526904`](https://github.com/fibjs/fibjs/commit/c0a4526904)] - **child_process, feat**: add more test case.(xicilion)
* [[`08481d61f0`](https://github.com/fibjs/fibjs/commit/08481d61f0)] - **child_process, feat**: document encoding options.(xicilion)
* [[`c05fe9d144`](https://github.com/fibjs/fibjs/commit/c05fe9d144)] - **test, bugfix**: test error in process.run/process.open.(xicilion)
* [[`68845754cd`](https://github.com/fibjs/fibjs/commit/68845754cd)] - **SubProcess, feat**: remove pointless SubProcess::ppid. (#599)(Ray)
* [[`a9dc4f7e06`](https://github.com/fibjs/fibjs/commit/a9dc4f7e06)] - **docs, bugfix**: typo.(xicilion)
* [[`2fe7557da0`](https://github.com/fibjs/fibjs/commit/2fe7557da0)] - **child_process, feat**: more detailed documentation.(xicilion)
* [[`98b066630a`](https://github.com/fibjs/fibjs/commit/98b066630a)] - **child_process, feat**: support child_process module.(xicilion)
* [[`cba1f2987c`](https://github.com/fibjs/fibjs/commit/cba1f2987c)] - **asyncIO, bugfix**: compile error on windows.(xicilion)
* [[`b929559d50`](https://github.com/fibjs/fibjs/commit/b929559d50)] - **msgpack, feat**: fix bug int/uint decode to null (#598)(lhkzh)
* [[`a132a78f04`](https://github.com/fibjs/fibjs/commit/a132a78f04)] - **core, refactor**: fix compile warning in debug mode.(xicilion)
* [[`1f2ec9fd44`](https://github.com/fibjs/fibjs/commit/1f2ec9fd44)] - **util, feat**: support util.parseArgs.(xicilion)
* [[`8682d61e51`](https://github.com/fibjs/fibjs/commit/8682d61e51)] - **uv, feat**: support uv_call.(xicilion)
* [[`c135d97364`](https://github.com/fibjs/fibjs/commit/c135d97364)] - **core, refactor**: refactor the implementation of callbacks to support returning context.(xicilion)
* [[`8e9767d79b`](https://github.com/fibjs/fibjs/commit/8e9767d79b)] - **ssl, feat**: update root certs.(xicilion)
* [[`98114eab14`](https://github.com/fibjs/fibjs/commit/98114eab14)] - **smtp, bugfix**: new smtp protocol.(xicilion)
* [[`4725a27cbd`](https://github.com/fibjs/fibjs/commit/4725a27cbd)] - **option, feat**: support ssldump.(xicilion)
* [[`d633132ff4`](https://github.com/fibjs/fibjs/commit/d633132ff4)] - **msgpack, bugfix**: stringObject and BooleanObject are incorrectly encoded as Object (#596)(Ray)
* [[`97d521c4af`](https://github.com/fibjs/fibjs/commit/97d521c4af)] - **ci, feat**: upgrade to xcode 10.1 when TARGET_ARCH=i386 for os osx(Ray Chan)
* [[`125a2c0fbd`](https://github.com/fibjs/fibjs/commit/125a2c0fbd)] - **gui, feat**: use blocking-awake mode for NSAppMainRunLoopThread (#593)(Ray)
* [[`14e49d2d0d`](https://github.com/fibjs/fibjs/commit/14e49d2d0d)] - **doc, bugfix**: fix format of some `.idl` files, never replace special tokens when `gen_docs` from .idl.(Ray Chan)

## 2020-07-19, Version 0.31.0 
* **feature** :
    * build:
      - stop support for vsmake. (#561)(Ray)
      - use cmake as building tool by default.(richardo2016)
      - import explicitly llvm-about config for fibjslib msbuild(richardo2016)
      - support msgpack module on windows(richardo2016)
    * ci - support use built vender assets.(Richardo2016)
    * core:
      - make ev-based AsyncIO more reable.(Ray Chan)
      - make Fiber management more semantic.(Ray Chan)
      - SetDcheckErrorHandler for DEBUG mode.(Ray Chan)
      - use jemalloc to manage memory.(xicilion)
      - release js value immediately when ValueHolder is discarded.(xicilion)
      - initialize modules according to the order of import.(xicilion)
    * doc - update BUILDING.md.(Ray Chan)
    * docs - update readme.(xicilion)
    * fs:
      - hold `FSWatcher->start()` before uv binding finished.(Ray Chan)
      - support `fs.watchFile`/`fs.unwatchFile`.(Ray Chan)
      - support fs.watch(Ray Chan)
    * gui:
      - for darwin, don't display fibjs in dock by default, neither no menubar.(Ray Chan)
      - rename protocol 'fs:' to 'fs://' (#589)(Ray)
      - simplify implementation of WebView in darwin.(Ray Chan)
      - support WebView on darwin platform.(Ray Chan)
    * http - support delete/sort/keys/values on HttpCollection.(xicilion)
    * HttpClient - support `sslVerification` getter/setter on HttpClient.(Ray Chan)
    * module - add msgpack module.(xicilion)
    * path - support path.format/path.parse(richardo2016)
    * process - support process.binding.(xicilion)
    * tools - allow idl parser work on idl directory without `object.idl`.(Ray Chan)
    * url:
      - support url.URL.(xicilion)
      - support Url.get_searchParams.(xicilion)
    * util:
      - fake node version.(xicilion)
      - fake util.deprecate.(xicilion)
    * websocket - support perMessageDeflate/maxPayload in opts.(xicilion)
    * ws - report memory usage to v8 in WebSocket.(xicilion)

* **bugfix** :
    * build:
      - fixup `filter_cmake_build_type` on shell.(richardo2016)
      - fixup compilation error on windows.(richardo2016)
    * ci:
      - fix appveyor build config.(Ray Chan)
      - fixup compilation error on appveryor for i386 arch.(richardo2016)
    * coroutine - do not recycle fiber objects during GC.(xicilion)
    * docs - fix document error of EventEmitter.(xicilion)
    * events - crash when off function on new Emitter.(xicilion)
    * fs - robust change, avoid potential core-dump when calling `fs.watch()`.(Ray Chan)
    * jemalloc:
      - runtime error on i386.(xicilion)
      - jemalloc compile error on arm/mips.(xicilion)
    * ssl:
      - crash when close SslSocket.(xicilion)
      - socket stream not close in ssl.Socket.close.(xicilion)
    * util - crash when %d in util.format.(xicilion)

* **refactor** :
    * core - refactor jsTrigger, replace pointless subclass of AsyncEvent with call to `syncCall`.(richardo2016)

* **chore** :
    * ci - upgrade travis ci config.(richardo2016)

* **others** :
    * dev v0.31.0(richardo2016)
    * Release v0.30.0(richardo2016)

### Commits
* [[`6e216de42a`](https://github.com/fibjs/fibjs/commit/6e216de42a)] - **doc, feat**: update BUILDING.md.(Ray Chan)
* [[`8901d43345`](https://github.com/fibjs/fibjs/commit/8901d43345)] - **gui, feat**: for darwin, don't display fibjs in dock by default, neither no menubar.(Ray Chan)
* [[`63b20f7504`](https://github.com/fibjs/fibjs/commit/63b20f7504)] - **coroutine, bugfix**: do not recycle fiber objects during GC.(xicilion)
* [[`b614656c0c`](https://github.com/fibjs/fibjs/commit/b614656c0c)] - **gui, feat**: rename protocol 'fs:' to 'fs://' (#589)(Ray)
* [[`bf21223b9c`](https://github.com/fibjs/fibjs/commit/bf21223b9c)] - **gui, feat**: simplify implementation of WebView in darwin.(Ray Chan)
* [[`5b3d01ca51`](https://github.com/fibjs/fibjs/commit/5b3d01ca51)] - **gui, feat**: support WebView on darwin platform.(Ray Chan)
* [[`c36ab705ba`](https://github.com/fibjs/fibjs/commit/c36ab705ba)] - **fs, feat**: hold `FSWatcher->start()` before uv binding finished.(Ray Chan)
* [[`03bb2e0bca`](https://github.com/fibjs/fibjs/commit/03bb2e0bca)] - **fs, feat**: support `fs.watchFile`/`fs.unwatchFile`.(Ray Chan)
* [[`65d94ef2bf`](https://github.com/fibjs/fibjs/commit/65d94ef2bf)] - **fs, bugfix**: robust change, avoid potential core-dump when calling `fs.watch()`.(Ray Chan)
* [[`d11dbca547`](https://github.com/fibjs/fibjs/commit/d11dbca547)] - **ci, bugfix**: fix appveyor build config.(Ray Chan)
* [[`7783b831b0`](https://github.com/fibjs/fibjs/commit/7783b831b0)] - **fs, feat**: support fs.watch(Ray Chan)
* [[`0faf3599b0`](https://github.com/fibjs/fibjs/commit/0faf3599b0)] - **path, feat**: support path.format/path.parse(richardo2016)
* [[`f1e2fd8aea`](https://github.com/fibjs/fibjs/commit/f1e2fd8aea)] - **core, feat**: make ev-based AsyncIO more reable.(Ray Chan)
* [[`e3827f8537`](https://github.com/fibjs/fibjs/commit/e3827f8537)] - **core, feat**: make Fiber management more semantic.(Ray Chan)
* [[`35eda9cfaf`](https://github.com/fibjs/fibjs/commit/35eda9cfaf)] - **core, feat**: SetDcheckErrorHandler for DEBUG mode.(Ray Chan)
* [[`8e9af2748d`](https://github.com/fibjs/fibjs/commit/8e9af2748d)] - **core, refactor**: refactor jsTrigger, replace pointless subclass of AsyncEvent with call to `syncCall`.(richardo2016)
* [[`8338069131`](https://github.com/fibjs/fibjs/commit/8338069131)] - **HttpClient, feat**: support `sslVerification` getter/setter on HttpClient.(Ray Chan)
* [[`6372ddb70d`](https://github.com/fibjs/fibjs/commit/6372ddb70d)] - **tools, feat**: allow idl parser work on idl directory without `object.idl`.(Ray Chan)
* [[`bd7ba2979d`](https://github.com/fibjs/fibjs/commit/bd7ba2979d)] - **build, bugfix**: fixup `filter_cmake_build_type` on shell.(richardo2016)
* [[`0d39f89d8e`](https://github.com/fibjs/fibjs/commit/0d39f89d8e)] - **ci, chore**: upgrade travis ci config.(richardo2016)
* [[`af4e4a7f1f`](https://github.com/fibjs/fibjs/commit/af4e4a7f1f)] - **build, feat**: stop support for vsmake. (#561)(Ray)
* [[`afe22e51cf`](https://github.com/fibjs/fibjs/commit/afe22e51cf)] - **build, feat**: use cmake as building tool by default.(richardo2016)
* [[`7cb8cc97c2`](https://github.com/fibjs/fibjs/commit/7cb8cc97c2)] - **util, bugfix**: crash when %d in util.format.(xicilion)
* [[`86c7e0d75c`](https://github.com/fibjs/fibjs/commit/86c7e0d75c)] - **docs, feat**: update readme.(xicilion)
* [[`270f969dcc`](https://github.com/fibjs/fibjs/commit/270f969dcc)] - dev v0.31.0(richardo2016)
* [[`006645a00e`](https://github.com/fibjs/fibjs/commit/006645a00e)] - Release v0.30.0(richardo2016)
* [[`278289699e`](https://github.com/fibjs/fibjs/commit/278289699e)] - **ci, bugfix**: fixup compilation error on appveryor for i386 arch.(richardo2016)
* [[`298fe433a0`](https://github.com/fibjs/fibjs/commit/298fe433a0)] - **ssl, bugfix**: crash when close SslSocket.(xicilion)
* [[`b5bf883a3d`](https://github.com/fibjs/fibjs/commit/b5bf883a3d)] - **build, feat**: import explicitly llvm-about config for fibjslib msbuild(richardo2016)
* [[`14aed4a987`](https://github.com/fibjs/fibjs/commit/14aed4a987)] - **jemalloc, bugfix**: runtime error on i386.(xicilion)
* [[`e7386daea8`](https://github.com/fibjs/fibjs/commit/e7386daea8)] - **build, feat**: support msgpack module on windows(richardo2016)
* [[`60310b5f96`](https://github.com/fibjs/fibjs/commit/60310b5f96)] - **module, feat**: add msgpack module.(xicilion)
* [[`67b3af0e4e`](https://github.com/fibjs/fibjs/commit/67b3af0e4e)] - **build, bugfix**: fixup compilation error on windows.(richardo2016)
* [[`7839a4c787`](https://github.com/fibjs/fibjs/commit/7839a4c787)] - **jemalloc, bugfix**: jemalloc compile error on arm/mips.(xicilion)
* [[`201e52a2ee`](https://github.com/fibjs/fibjs/commit/201e52a2ee)] - **core, feat**: use jemalloc to manage memory.(xicilion)
* [[`13ce7d189a`](https://github.com/fibjs/fibjs/commit/13ce7d189a)] - **ws, feat**: report memory usage to v8 in WebSocket.(xicilion)
* [[`8afac317e6`](https://github.com/fibjs/fibjs/commit/8afac317e6)] - **core, feat**: release js value immediately when ValueHolder is discarded.(xicilion)
* [[`f6805e4360`](https://github.com/fibjs/fibjs/commit/f6805e4360)] - **ci, feat**: support use built vender assets.(Richardo2016)
* [[`975a56bbad`](https://github.com/fibjs/fibjs/commit/975a56bbad)] - **websocket, feat**: support perMessageDeflate/maxPayload in opts.(xicilion)
* [[`795f57157d`](https://github.com/fibjs/fibjs/commit/795f57157d)] - **docs, bugfix**: fix document error of EventEmitter.(xicilion)
* [[`bac0205c2f`](https://github.com/fibjs/fibjs/commit/bac0205c2f)] - **process, feat**: support process.binding.(xicilion)
* [[`445b43f9f4`](https://github.com/fibjs/fibjs/commit/445b43f9f4)] - **core, feat**: initialize modules according to the order of import.(xicilion)
* [[`1353a85d54`](https://github.com/fibjs/fibjs/commit/1353a85d54)] - **util, feat**: fake node version.(xicilion)
* [[`c6836d261c`](https://github.com/fibjs/fibjs/commit/c6836d261c)] - **util, feat**: fake util.deprecate.(xicilion)
* [[`60d1cefa3b`](https://github.com/fibjs/fibjs/commit/60d1cefa3b)] - **ssl, bugfix**: socket stream not close in ssl.Socket.close.(xicilion)
* [[`d0ad03147f`](https://github.com/fibjs/fibjs/commit/d0ad03147f)] - **url, feat**: support url.URL.(xicilion)
* [[`e38bfefa51`](https://github.com/fibjs/fibjs/commit/e38bfefa51)] - **url, feat**: support Url.get_searchParams.(xicilion)
* [[`a828a2f4a1`](https://github.com/fibjs/fibjs/commit/a828a2f4a1)] - **http, feat**: support delete/sort/keys/values on HttpCollection.(xicilion)
* [[`01e3ccd3e2`](https://github.com/fibjs/fibjs/commit/01e3ccd3e2)] - **events, bugfix**: crash when off function on new Emitter.(xicilion)

## 2020-05-01, Version 0.30.0 
* **feature** :
    * Buffer - support Buffer.set(xicilion)
    * build:
      - import explicitly llvm-about config for fibjslib msbuild(richardo2016)
      - support msgpack module on windows(richardo2016)
      - use all tags(including lightweight one) when building.(Richardo2016)
    * ci:
      - support use built vender assets.(Richardo2016)
      - use descriptive info as release.(Richardo2016)
    * console - configurable colored console within different isolate(Yuanhang)
    * core:
      - use jemalloc to manage memory.(xicilion)
      - release js value immediately when ValueHolder is discarded.(xicilion)
      - initialize modules according to the order of import.(xicilion)
    * crypto:
      - support X509Crl.next.(xicilion)
      - export X509Crl detailed properties.(xicilion)
      - support SM2, SM3 in X509(limingkun)
      - support SM3 in hash(limingkun)
      - support SM4 in Cipher(limingkun)
      - support SM2 in Pkey(limingkun)
    * fs - better Stat Object, better `fs.(l)stat`.(Ray Chan)
    * http:
      - support delete/sort/keys/values on HttpCollection.(xicilion)
      - support isolated client cert in HttpClient.(xicilion)
    * module - add msgpack module.(xicilion)
    * process - support process.binding.(xicilion)
    * ssl - support custom cert param in ssl.connect.(xicilion)
    * SubProcess - support stderr. (#538)(Ray)
    * url:
      - support url.URL.(xicilion)
      - support Url.get_searchParams.(xicilion)
    * util:
      - fake node version.(xicilion)
      - fake util.deprecate.(xicilion)
    * vender:
      - use vender in dev branch(limingkun)
      - use vender#dev-lang, replace msvc with clang++ as compiler on window.(richardo2016)
    * websocket - support perMessageDeflate/maxPayload in opts.(xicilion)
    * ws - report memory usage to v8 in WebSocket.(xicilion)

* **bugfix** :
    * base - exceptional crashes when json_replacer or json_object is null(Yuanhang)
    * build:
      - fixup compilation error on windows.(richardo2016)
      - remove hard dependency on vcruntime-about dll for windows.(richardo2016)
    * ci - fixup compilation error on appveryor for i386 arch.(richardo2016)
    * docs - fix document error of EventEmitter.(xicilion)
    * encoding - use input's reference in json_parser to keep it alive. (#540)(Ray)
    * events - crash when off function on new Emitter.(xicilion)
    * http - body will be lost when connection header of response is close.(xicilion)
    * jemalloc:
      - runtime error on i386.(xicilion)
      - jemalloc compile error on arm/mips.(xicilion)
    * ssl:
      - crash when close SslSocket.(xicilion)
      - socket stream not close in ssl.Socket.close.(xicilion)
    * websocket:
      - optimize memory usage in compressed mode.(xicilion)
      - the socket is not released when no event is bound on the websocket.(xicilion)

* **refactor** :
    * encoding - refactor json.decode, use internal api to increase speed.(xicilion)

* **fix** :
    * crypto - buffer mojibake. (#536)(Yuanhang Luo)
    * tools - install only one package if specified. (#537)(Ray)

### Commits
* [[`278289699e`](https://github.com/fibjs/fibjs/commit/278289699e)] - **ci, bugfix**: fixup compilation error on appveryor for i386 arch.(richardo2016)
* [[`298fe433a0`](https://github.com/fibjs/fibjs/commit/298fe433a0)] - **ssl, bugfix**: crash when close SslSocket.(xicilion)
* [[`b5bf883a3d`](https://github.com/fibjs/fibjs/commit/b5bf883a3d)] - **build, feat**: import explicitly llvm-about config for fibjslib msbuild(richardo2016)
* [[`14aed4a987`](https://github.com/fibjs/fibjs/commit/14aed4a987)] - **jemalloc, bugfix**: runtime error on i386.(xicilion)
* [[`e7386daea8`](https://github.com/fibjs/fibjs/commit/e7386daea8)] - **build, feat**: support msgpack module on windows(richardo2016)
* [[`60310b5f96`](https://github.com/fibjs/fibjs/commit/60310b5f96)] - **module, feat**: add msgpack module.(xicilion)
* [[`67b3af0e4e`](https://github.com/fibjs/fibjs/commit/67b3af0e4e)] - **build, bugfix**: fixup compilation error on windows.(richardo2016)
* [[`7839a4c787`](https://github.com/fibjs/fibjs/commit/7839a4c787)] - **jemalloc, bugfix**: jemalloc compile error on arm/mips.(xicilion)
* [[`201e52a2ee`](https://github.com/fibjs/fibjs/commit/201e52a2ee)] - **core, feat**: use jemalloc to manage memory.(xicilion)
* [[`13ce7d189a`](https://github.com/fibjs/fibjs/commit/13ce7d189a)] - **ws, feat**: report memory usage to v8 in WebSocket.(xicilion)
* [[`8afac317e6`](https://github.com/fibjs/fibjs/commit/8afac317e6)] - **core, feat**: release js value immediately when ValueHolder is discarded.(xicilion)
* [[`f6805e4360`](https://github.com/fibjs/fibjs/commit/f6805e4360)] - **ci, feat**: support use built vender assets.(Richardo2016)
* [[`975a56bbad`](https://github.com/fibjs/fibjs/commit/975a56bbad)] - **websocket, feat**: support perMessageDeflate/maxPayload in opts.(xicilion)
* [[`795f57157d`](https://github.com/fibjs/fibjs/commit/795f57157d)] - **docs, bugfix**: fix document error of EventEmitter.(xicilion)
* [[`bac0205c2f`](https://github.com/fibjs/fibjs/commit/bac0205c2f)] - **process, feat**: support process.binding.(xicilion)
* [[`445b43f9f4`](https://github.com/fibjs/fibjs/commit/445b43f9f4)] - **core, feat**: initialize modules according to the order of import.(xicilion)
* [[`1353a85d54`](https://github.com/fibjs/fibjs/commit/1353a85d54)] - **util, feat**: fake node version.(xicilion)
* [[`c6836d261c`](https://github.com/fibjs/fibjs/commit/c6836d261c)] - **util, feat**: fake util.deprecate.(xicilion)
* [[`60d1cefa3b`](https://github.com/fibjs/fibjs/commit/60d1cefa3b)] - **ssl, bugfix**: socket stream not close in ssl.Socket.close.(xicilion)
* [[`d0ad03147f`](https://github.com/fibjs/fibjs/commit/d0ad03147f)] - **url, feat**: support url.URL.(xicilion)
* [[`e38bfefa51`](https://github.com/fibjs/fibjs/commit/e38bfefa51)] - **url, feat**: support Url.get_searchParams.(xicilion)
* [[`a828a2f4a1`](https://github.com/fibjs/fibjs/commit/a828a2f4a1)] - **http, feat**: support delete/sort/keys/values on HttpCollection.(xicilion)
* [[`01e3ccd3e2`](https://github.com/fibjs/fibjs/commit/01e3ccd3e2)] - **events, bugfix**: crash when off function on new Emitter.(xicilion)
* [[`c54335d412`](https://github.com/fibjs/fibjs/commit/c54335d412)] - **Buffer, feat**: support Buffer.set(xicilion)
* [[`eff0aaab2d`](https://github.com/fibjs/fibjs/commit/eff0aaab2d)] - **encoding, refactor**: refactor json.decode, use internal api to increase speed.(xicilion)
* [[`b75d0d3fcc`](https://github.com/fibjs/fibjs/commit/b75d0d3fcc)] - **fs, feat**: better Stat Object, better `fs.(l)stat`.(Ray Chan)
* [[`96dc9a1216`](https://github.com/fibjs/fibjs/commit/96dc9a1216)] - **http, bugfix**: body will be lost when connection header of response is close.(xicilion)
* [[`6db5998446`](https://github.com/fibjs/fibjs/commit/6db5998446)] - **http, feat**: support isolated client cert in HttpClient.(xicilion)
* [[`94fc6157c9`](https://github.com/fibjs/fibjs/commit/94fc6157c9)] - **ssl, feat**: support custom cert param in ssl.connect.(xicilion)
* [[`db830f8e6c`](https://github.com/fibjs/fibjs/commit/db830f8e6c)] - **websocket, bugfix**: optimize memory usage in compressed mode.(xicilion)
* [[`959d584cba`](https://github.com/fibjs/fibjs/commit/959d584cba)] - **websocket, bugfix**: the socket is not released when no event is bound on the websocket.(xicilion)
* [[`fe8eeb090c`](https://github.com/fibjs/fibjs/commit/fe8eeb090c)] - **crypto, feat**: support X509Crl.next.(xicilion)
* [[`150d4cb9e8`](https://github.com/fibjs/fibjs/commit/150d4cb9e8)] - **crypto, feat**: export X509Crl detailed properties.(xicilion)
* [[`7d0a307da6`](https://github.com/fibjs/fibjs/commit/7d0a307da6)] - **vender, feat**: use vender in dev branch(limingkun)
* [[`455ebd55e6`](https://github.com/fibjs/fibjs/commit/455ebd55e6)] - **crypto, feat**: support SM2, SM3 in X509(limingkun)
* [[`21bde57c0c`](https://github.com/fibjs/fibjs/commit/21bde57c0c)] - **crypto, feat**: support SM3 in hash(limingkun)
* [[`152f9e5935`](https://github.com/fibjs/fibjs/commit/152f9e5935)] - **crypto, feat**: support SM4 in Cipher(limingkun)
* [[`eb43cb14c3`](https://github.com/fibjs/fibjs/commit/eb43cb14c3)] - **crypto, feat**: support SM2 in Pkey(limingkun)
* [[`63ab2dad0f`](https://github.com/fibjs/fibjs/commit/63ab2dad0f)] - **base, bugfix**: exceptional crashes when json_replacer or json_object is null(Yuanhang)
* [[`d6d1d80f31`](https://github.com/fibjs/fibjs/commit/d6d1d80f31)] - **console, feat**: configurable colored console within different isolate(Yuanhang)
* [[`a86cc346a8`](https://github.com/fibjs/fibjs/commit/a86cc346a8)] - **build, bugfix**: remove hard dependency on vcruntime-about dll for windows.(richardo2016)
* [[`2d3c9d0988`](https://github.com/fibjs/fibjs/commit/2d3c9d0988)] - **encoding, bugfix**: use input's reference in json_parser to keep it alive. (#540)(Ray)
* [[`8a356027f8`](https://github.com/fibjs/fibjs/commit/8a356027f8)] - **vender, feat**: use vender#dev-lang, replace msvc with clang++ as compiler on window.(richardo2016)
* [[`ea65280c85`](https://github.com/fibjs/fibjs/commit/ea65280c85)] - **SubProcess, feat**: support stderr. (#538)(Ray)
* [[`b29bf81d2e`](https://github.com/fibjs/fibjs/commit/b29bf81d2e)] - **ci, feat**: use descriptive info as release.(Richardo2016)
* [[`b5d04723e4`](https://github.com/fibjs/fibjs/commit/b5d04723e4)] - **tools, fix**: install only one package if specified. (#537)(Ray)
* [[`205994b18b`](https://github.com/fibjs/fibjs/commit/205994b18b)] - **crypto, fix**: buffer mojibake. (#536)(Yuanhang Luo)
* [[`d47e89414e`](https://github.com/fibjs/fibjs/commit/d47e89414e)] - **build, feat**: use all tags(including lightweight one) when building.(Richardo2016)

## 2019-11-06, Version 0.29.0 
* **feature** :
    * Buffer:
      - support static Buffer::compare (#532)(Ray)
      - support Int64 read/write.(xicilion)
    * ci:
      - use beta branch to release prerelase fibjs. (#523)(Ray)
      - use caches of `ccache` in travis.(Richardo2016)
      - add dockerfiles. (#510)(Ray)
    * console:
      - support styled output with ANSI color codes.(xicilion)
      - support console.getpass.(xicilion)
      - use editline on all posix platforms.(xicilion)
    * core:
      - enable concurrent_marking mode.(xicilion)
      - support convert string to BigInt in argument.(xicilion)
      - check the range of int64 data type parameters.(xicilion)
      - accept BigInt as a numeric parameter.(xicilion)
      - implement JSValue and JSArray to handle empty values ​​for exceptions.(xicilion)
      - include the module component name in the error message.(xicilion)
    * crypto:
      - support for constructing objects of the crypto module using parameters.(xicilion)
      - support aria.(xicilion)
    * db:
      - support sub query.(xicilion)
      - support alias and multi table.(xicilion)
      - support table.field.(xicilion)
      - support string in [keys] and [where] field.(xicilion)
      - pass the object directly in the argument of insert, return insertId.(xicilion)
      - support remove in DBConnection.(xicilion)
      - support count/insert/update in DBConnection.(xicilion)
      - support insert in db.format.(xicilion)
      - support update in db.format.(xicilion)
      - support count(*) in db.format.(xicilion)
      - support conn.find.(xicilion)
    * doc - translate the flowchart of require to english.(xicilion)
    * encoding - support decode base64 data to Buffer.(xicilion)
    * global - discard Int64.(xicilion)
    * gui - remove WebView.wait method.(xicilion)
    * http:
      - support for more MIME types.(xicilion)
      - share proxy connections between different domains.(xicilion)
      - not set the host header when the headers include host.(xicilion)
      - support http/https proxyAgent.(xicilion)
      - remove state from HttpHandler and HttpServer.(xicilion)
      - discard pre-zip function.(xicilion)
      - discard forceGZIP function.(xicilion)
      - do not disable client caching for options requests.(xicilion)
      - support Repeater.(xicilion)
      - support enableEncoding property.(xicilion)
    * HttpClient:
      - support for a set of headers with the same name.(xicilion)
      - do not send User-Agent when userAgent is empty.(xicilion)
      - support enableEncoding property.(xicilion)
      - do not send cookies when enableCookie is false.(xicilion)
    * HttpCollection:
      - support return all field values.(xicilion)
      - support add a set of values with the same name using an array.(xicilion)
    * HttpMessage - set the parameter type of the header function to string type.(xicilion)
    * io - improve payload size when processing async read in win32. (#507)(Ray)
    * json - support encode BigInt.(xicilion)
    * mbedtls - update to v2.7.12.(xicilion)
    * opt_tools:
      - recover some features of `--install`, aiming to non-invasive installation for `package.json` (#533)(Ray)
      - render a better looking flame graph.(xicilion)
    * option:
      - support tcpdump startup option.(xicilion)
      - better opt_tools/install, dedupe its structure, support installing package from github. (#515)(Ray)
      - skip package.json when the file does not exist.(xicilion)
    * os - return the mac address in networkInterfaces on windows.(xicilion)
    * process:
      - support `process.ppid` and `SubProcess::ppid`. (#524)(Ray)
      - change process.run to async mode.(xicilion)
      - clean up the terminal when exiting the process.(xicilion)
    * qstring - support type conversion to std::string.(xicilion)
    * Routing:
      - wildcard not match second-level domain names.(xicilion)
      - support virtual host routing.(xicilion)
    * smtp - support starttls mode when connecting to Smtp.(xicilion)
    * ssl:
      - update root cert.(xicilion)
      - Support for matching wildcard common name.(xicilion)
      - support SNI(Server Name Identification).(xicilion)
    * test:
      - do not run the opt_tools test case in the basic test.(xicilion)
      - basic test cases about io (#506)(Ray)
      - add path.resolve root test case(Henry Zhuang)
      - skip test when releasing. (#498)(Henry Zhuang)
    * tools - refactor `gen_code.js`, support Class having static methods/instance methods with same name. (#531)(Ray)
    * tty - use globally unified tty.isatty to detect if stdout is a terminal device.(xicilion)
    * url - accept Object in query.(xicilion)
    * util:
      - modify color to get better display on black background.(xicilion)
      - support util.isBigInt.(xicilion)
      - discard Stats.(xicilion)
      - output error stack when data type is Error.(xicilion)
    * Variant - support transform double to Variant. (#529)(Ray)
    * vender:
      - update vender.(xicilion)
      - upgrade vender. (#526)(Ray)
      - update mbedtls to v2.16.2.(xicilion)
    * Worker:
      - support load event.(xicilion)
      - support options.(xicilion)
      - support for error events for Worker object.(xicilion)

* **bugfix** :
    * assert - deepEqual crash on proxy object.(xicilion)
    * Buffer:
      - readInt/writeInt does not support length, and error when processing negative numbers.(xicilion)
      - bind isolate when creating a new Buffer(FiberMan)
    * ClassInfo - class id will be messy under multiple workers.(xicilion)
    * cmake - warning in cmake.(xicilion)
    * console - do not reset the terminal outside of console.readLine.(xicilion)
    * core:
      - compile warning on Windows.(xicilion)
      - constants module not imported.(xicilion)
      - use JSValue/JSArray to avoid exceptions caused by empty values. (#527)(Yuanhang Luo)
      - javascript getter throw in libs(assert, jsonformat, util, sandbox) (#511)(FiberMan)
    * db:
      - getter test case error.(xicilion)
      - field name encode error for "`".(xicilion)
      - error message issue.(xicilion)
      - compile warning on Windows.(xicilion)
      - redis test error.(xicilion)
    * gui - core dump on windows.(xicilion)
    * http:
      - memory leak occurs while browsing folders.(xicilion)
      - request error when the address is empty in fileHandler.(xicilion)
      - cookie not accept in upgrade reqponse.(xicilion)
      - https connection fails after two request in HttpClient.(xicilion)
      - compile warning on windows.(xicilion)
      - use empty body for HEAD request. (#522)(Ray)
    * HttpClient - error in custom getter function causes crash.(xicilion)
    * idl - document issue.(xicilion)
    * LruCache - memory leak.(xicilion)
    * mysql - multi-statement error of version 6 or higher.(xicilion)
    * option - allow install when from raw. (#520)(Ray)
    * os:
      - fix os.homedir() when USERPROFILE not set on Windows (#503)(Henry Zhuang)
      - os.homedir() fallback should work (#499)(Henry Zhuang)
    * path:
      - result error in path.resolve root test case on windows.(xicilion)
      - result error in path.resolve root test case.(xicilion)
    * process:
      - compile error on Windows.(xicilion)
      - do not set exitCode when result_t > 0;(xicilion)
      - compile error on windows.(xicilion)
      - use real pipe-like struct to initial stdio in process. (#501)(Ray)
    * Routing - compile error on windows.(xicilion)
    * SubProcess - fallback null/undefined to empty string when building envstr. (#534)(Ray)
    * test:
      - remove zmq test.(xicilion)
      - random error in coroutine_test.(xicilion)
      - gui_test error on windows.(xicilion)
      - ws_test test case error.(xicilion)
      - trigger test case error.(xicilion)
      - lock_test use case reports error with a small probability.(xicilion)
      - sometimes closed events cannot be triggered.(xicilion)
      - error occurs in process_test on a slow computer.(xicilion)
      - gui_test did not exit after testing.(xicilion)
      - enhance the stability of test cases to avoid random errors on slow computers.(xicilion)
      - time-related test case errors often occur on low-performance servers.(xicilion)
      - some time-related test cases throw errors because of the performance of the ci server.(xicilion)
      - fix undefined variable in test/http_test.js(Richardo2016)
      - normalize internal & opt_tools' test cases. (#518)(Ray)
      - deepEqual crash on proxy object. (#513)(FiberMan)
      - fix the arm64 test env (#504)(Henry Zhuang)
      - enable the full arm test env (#502)(Henry Zhuang)
    * Variant - compile warning on Windows.(xicilion)

* **refactor** :
    * console - rewrite ANSI color output on Windows.(xicilion)
    * core:
      - add intVal and longVal to Variant.(xicilion)
      - refactor EventInfo.(xicilion)
      - refactor AsyncState.(xicilion)
      - support BigInt in Variant.(xicilion)
      - convert Int64 variables using v8 BigInt api.(xicilion)
      - return BigInt as data type Long.(xicilion)
      - refactor AsyncEvent.(xicilion)
      - refactor the AsyncCall object and pass the isolate in cc mode.(xicilion)
      - refactoring the NObject and NArray.(xicilion)
    * coroutine - switch to fiber pool on windows.(xicilion)
    * crypto - refactor ecc algorithm name resolve.(xicilion)
    * db:
      - add method param in db.format.(xicilion)
      - optimization _escape_field.(xicilion)
      - move table name in to opts.(xicilion)
      - rewrite DBConnection function.(xicilion)
      - refactor query syntax.(xicilion)
    * exlib:
      - remove CondVar support for Windows XP.(xicilion)
      - rewrite exlib lock-free object using std::atomic.(xicilion)
    * Fiber - use syncCall to start a fiber.(xicilion)
    * handler - refactor JSHandler.(xicilion)
    * Isolate - use HttpClient to keep the default http session object.(xicilion)
    * json - use replacer to encode BigInt without changing the behavior of JSON.stringify.(xicilion)
    * mq - Support for automatic conversion of string to fileHandler or HttpRepeater.(xicilion)
    * os - use the same mac address format for posix on Windows.(xicilion)
    * process - SubProcess no longer inherits the Stream object.(xicilion)
    * test - use the test_util.cleanup method to close the server socket.(xicilion)
    * websocket - refactor asyncSend lock system.(xicilion)
    * zmq - discard zmq.(xicilion)

* **others** :
    * Merge branch 'dev' of https - //github.com/fibjs/fibjs into dev(xicilion)
    * Merge branch 'dev' into bigint(xicilion)
    * dev 0.29.0(richardo2016)
    * Release v0.28.0.(richardo2016)
    * Merge branch 'add_path_resolve_test' into dev(xicilion)

* **rector** :
    * TcpServer - discard run and asyncRun with start.(xicilion)

* **fix** :
    * process - make requried envs' kv fallback to the ones of parent process. (#516)(Ray)

### Commits
* [[`d699e56b0a`](https://github.com/fibjs/fibjs/commit/d699e56b0a)] - **SubProcess, bugfix**: fallback null/undefined to empty string when building envstr. (#534)(Ray)
* [[`045e446294`](https://github.com/fibjs/fibjs/commit/045e446294)] - **opt_tools, feat**: recover some features of `--install`, aiming to non-invasive installation for `package.json` (#533)(Ray)
* [[`77a048e146`](https://github.com/fibjs/fibjs/commit/77a048e146)] - **core, feat**: enable concurrent_marking mode.(xicilion)
* [[`210d3a0281`](https://github.com/fibjs/fibjs/commit/210d3a0281)] - **Buffer, feat**: support static Buffer::compare (#532)(Ray)
* [[`5b99e7ff46`](https://github.com/fibjs/fibjs/commit/5b99e7ff46)] - **tools, feat**: refactor `gen_code.js`, support Class having static methods/instance methods with same name. (#531)(Ray)
* [[`f1104fbdf0`](https://github.com/fibjs/fibjs/commit/f1104fbdf0)] - **db, bugfix**: getter test case error.(xicilion)
* [[`466b582a92`](https://github.com/fibjs/fibjs/commit/466b582a92)] - **db, feat**: support sub query.(xicilion)
* [[`ab8cf04823`](https://github.com/fibjs/fibjs/commit/ab8cf04823)] - **db, refactor**: add method param in db.format.(xicilion)
* [[`59635cabe4`](https://github.com/fibjs/fibjs/commit/59635cabe4)] - **db, feat**: support alias and multi table.(xicilion)
* [[`e5947bdde1`](https://github.com/fibjs/fibjs/commit/e5947bdde1)] - **db, feat**: support table.field.(xicilion)
* [[`1db1dc1241`](https://github.com/fibjs/fibjs/commit/1db1dc1241)] - **db, bugfix**: field name encode error for "`".(xicilion)
* [[`a7bd4ad728`](https://github.com/fibjs/fibjs/commit/a7bd4ad728)] - **db, refactor**: optimization _escape_field.(xicilion)
* [[`143083eb81`](https://github.com/fibjs/fibjs/commit/143083eb81)] - **db, refactor**: move table name in to opts.(xicilion)
* [[`8c6efcdd5b`](https://github.com/fibjs/fibjs/commit/8c6efcdd5b)] - **db, feat**: support string in [keys] and [where] field.(xicilion)
* [[`84f95ea4f4`](https://github.com/fibjs/fibjs/commit/84f95ea4f4)] - **db, feat**: pass the object directly in the argument of insert, return insertId.(xicilion)
* [[`ae812c75c0`](https://github.com/fibjs/fibjs/commit/ae812c75c0)] - **db, bugfix**: error message issue.(xicilion)
* [[`c4d6329e19`](https://github.com/fibjs/fibjs/commit/c4d6329e19)] - **db, refactor**: rewrite DBConnection function.(xicilion)
* [[`b672485bf9`](https://github.com/fibjs/fibjs/commit/b672485bf9)] - **Variant, feat**: support transform double to Variant. (#529)(Ray)
* [[`0e160e7781`](https://github.com/fibjs/fibjs/commit/0e160e7781)] - **mysql, bugfix**: multi-statement error of version 6 or higher.(xicilion)
* [[`de1da06508`](https://github.com/fibjs/fibjs/commit/de1da06508)] - **db, feat**: support remove in DBConnection.(xicilion)
* [[`4e91a5b3be`](https://github.com/fibjs/fibjs/commit/4e91a5b3be)] - **db, feat**: support count/insert/update in DBConnection.(xicilion)
* [[`953b58f775`](https://github.com/fibjs/fibjs/commit/953b58f775)] - **core, bugfix**: compile warning on Windows.(xicilion)
* [[`65e7d39103`](https://github.com/fibjs/fibjs/commit/65e7d39103)] - **core, refactor**: add intVal and longVal to Variant.(xicilion)
* [[`203fe0d139`](https://github.com/fibjs/fibjs/commit/203fe0d139)] - **test, bugfix**: remove zmq test.(xicilion)
* [[`b5b4e09e31`](https://github.com/fibjs/fibjs/commit/b5b4e09e31)] - **db, feat**: support insert in db.format.(xicilion)
* [[`9a10ac340e`](https://github.com/fibjs/fibjs/commit/9a10ac340e)] - **db, feat**: support update in db.format.(xicilion)
* [[`4e48a92200`](https://github.com/fibjs/fibjs/commit/4e48a92200)] - **db, feat**: support count(*) in db.format.(xicilion)
* [[`d8369eadd6`](https://github.com/fibjs/fibjs/commit/d8369eadd6)] - **db, refactor**: refactor query syntax.(xicilion)
* [[`086085cb98`](https://github.com/fibjs/fibjs/commit/086085cb98)] - **db, bugfix**: compile warning on Windows.(xicilion)
* [[`332babea45`](https://github.com/fibjs/fibjs/commit/332babea45)] - **db, feat**: support conn.find.(xicilion)
* [[`780df6583f`](https://github.com/fibjs/fibjs/commit/780df6583f)] - **zmq, refactor**: discard zmq.(xicilion)
* [[`0b5ce0b990`](https://github.com/fibjs/fibjs/commit/0b5ce0b990)] - **doc, feat**: translate the flowchart of require to english.(xicilion)
* [[`11520665d1`](https://github.com/fibjs/fibjs/commit/11520665d1)] - **Merge branch 'dev' of https**: //github.com/fibjs/fibjs into dev(xicilion)
* [[`c9fb688dbe`](https://github.com/fibjs/fibjs/commit/c9fb688dbe)] - **console, refactor**: rewrite ANSI color output on Windows.(xicilion)
* [[`77c9c2e492`](https://github.com/fibjs/fibjs/commit/77c9c2e492)] - **util, feat**: modify color to get better display on black background.(xicilion)
* [[`ae825ed694`](https://github.com/fibjs/fibjs/commit/ae825ed694)] - **console, feat**: support styled output with ANSI color codes.(xicilion)
* [[`f9ae544d1f`](https://github.com/fibjs/fibjs/commit/f9ae544d1f)] - **url, feat**: accept Object in query.(xicilion)
* [[`575e6c0fb9`](https://github.com/fibjs/fibjs/commit/575e6c0fb9)] - **http, feat**: support for more MIME types.(xicilion)
* [[`67b1399c04`](https://github.com/fibjs/fibjs/commit/67b1399c04)] - **core, bugfix**: constants module not imported.(xicilion)
* [[`a299cc81b8`](https://github.com/fibjs/fibjs/commit/a299cc81b8)] - **idl, bugfix**: document issue.(xicilion)
* [[`2f4fc4a9bd`](https://github.com/fibjs/fibjs/commit/2f4fc4a9bd)] - **http, bugfix**: memory leak occurs while browsing folders.(xicilion)
* [[`7bb9b5d1ac`](https://github.com/fibjs/fibjs/commit/7bb9b5d1ac)] - **http, bugfix**: request error when the address is empty in fileHandler.(xicilion)
* [[`91880416aa`](https://github.com/fibjs/fibjs/commit/91880416aa)] - **mq, refactor**: Support for automatic conversion of string to fileHandler or HttpRepeater.(xicilion)
* [[`f485ddbbaf`](https://github.com/fibjs/fibjs/commit/f485ddbbaf)] - **handler, refactor**: refactor JSHandler.(xicilion)
* [[`e3f8651c65`](https://github.com/fibjs/fibjs/commit/e3f8651c65)] - **smtp, feat**: support starttls mode when connecting to Smtp.(xicilion)
* [[`85536ef65e`](https://github.com/fibjs/fibjs/commit/85536ef65e)] - **http, bugfix**: cookie not accept in upgrade reqponse.(xicilion)
* [[`580c65e6d5`](https://github.com/fibjs/fibjs/commit/580c65e6d5)] - **http, bugfix**: https connection fails after two request in HttpClient.(xicilion)
* [[`17f3fae8c8`](https://github.com/fibjs/fibjs/commit/17f3fae8c8)] - **option, feat**: support tcpdump startup option.(xicilion)
* [[`1c99ea167a`](https://github.com/fibjs/fibjs/commit/1c99ea167a)] - **Routing, feat**: wildcard not match second-level domain names.(xicilion)
* [[`84735c4988`](https://github.com/fibjs/fibjs/commit/84735c4988)] - **exlib, refactor**: remove CondVar support for Windows XP.(xicilion)
* [[`df6f30b1b0`](https://github.com/fibjs/fibjs/commit/df6f30b1b0)] - **test, bugfix**: random error in coroutine_test.(xicilion)
* [[`eec1a4159d`](https://github.com/fibjs/fibjs/commit/eec1a4159d)] - **core, refactor**: refactor EventInfo.(xicilion)
* [[`ba314e0fe0`](https://github.com/fibjs/fibjs/commit/ba314e0fe0)] - **process, bugfix**: compile error on Windows.(xicilion)
* [[`14d7c731d2`](https://github.com/fibjs/fibjs/commit/14d7c731d2)] - **core, refactor**: refactor AsyncState.(xicilion)
* [[`0dce421317`](https://github.com/fibjs/fibjs/commit/0dce421317)] - **Variant, bugfix**: compile warning on Windows.(xicilion)
* [[`bafd68d176`](https://github.com/fibjs/fibjs/commit/bafd68d176)] - **Fiber, refactor**: use syncCall to start a fiber.(xicilion)
* [[`30bd40623d`](https://github.com/fibjs/fibjs/commit/30bd40623d)] - **websocket, refactor**: refactor asyncSend lock system.(xicilion)
* [[`9ef45336b2`](https://github.com/fibjs/fibjs/commit/9ef45336b2)] - **test, bugfix**: gui_test error on windows.(xicilion)
* [[`425dea2e58`](https://github.com/fibjs/fibjs/commit/425dea2e58)] - **http, feat**: share proxy connections between different domains.(xicilion)
* [[`ab1b3001cb`](https://github.com/fibjs/fibjs/commit/ab1b3001cb)] - **core, refactor**: support BigInt in Variant.(xicilion)
* [[`c559a632bc`](https://github.com/fibjs/fibjs/commit/c559a632bc)] - **process, refactor**: SubProcess no longer inherits the Stream object.(xicilion)
* [[`803fd86ad1`](https://github.com/fibjs/fibjs/commit/803fd86ad1)] - **http, feat**: not set the host header when the headers include host.(xicilion)
* [[`9988668843`](https://github.com/fibjs/fibjs/commit/9988668843)] - **http, feat**: support http/https proxyAgent.(xicilion)
* [[`b78990f32a`](https://github.com/fibjs/fibjs/commit/b78990f32a)] - **test, bugfix**: ws_test test case error.(xicilion)
* [[`fc20c74cfb`](https://github.com/fibjs/fibjs/commit/fc20c74cfb)] - **Buffer, bugfix**: readInt/writeInt does not support length, and error when processing negative numbers.(xicilion)
* [[`fb09dd45dc`](https://github.com/fibjs/fibjs/commit/fb09dd45dc)] - **core, refactor**: convert Int64 variables using v8 BigInt api.(xicilion)
* [[`3cb966f97b`](https://github.com/fibjs/fibjs/commit/3cb966f97b)] - **json, refactor**: use replacer to encode BigInt without changing the behavior of JSON.stringify.(xicilion)
* [[`d8ed7cb03f`](https://github.com/fibjs/fibjs/commit/d8ed7cb03f)] - **core, feat**: support convert string to BigInt in argument.(xicilion)
* [[`1e988e0923`](https://github.com/fibjs/fibjs/commit/1e988e0923)] - **test, bugfix**: trigger test case error.(xicilion)
* [[`98d7c8e8a9`](https://github.com/fibjs/fibjs/commit/98d7c8e8a9)] - Merge branch 'dev' into bigint(xicilion)
* [[`2e1f8f7d02`](https://github.com/fibjs/fibjs/commit/2e1f8f7d02)] - **Worker, feat**: support load event.(xicilion)
* [[`50d35ea6fe`](https://github.com/fibjs/fibjs/commit/50d35ea6fe)] - **json, feat**: support encode BigInt.(xicilion)
* [[`9467776c92`](https://github.com/fibjs/fibjs/commit/9467776c92)] - **encoding, feat**: support decode base64 data to Buffer.(xicilion)
* [[`84a2eb7932`](https://github.com/fibjs/fibjs/commit/84a2eb7932)] - **util, feat**: support util.isBigInt.(xicilion)
* [[`aa14983da7`](https://github.com/fibjs/fibjs/commit/aa14983da7)] - **crypto, refactor**: refactor ecc algorithm name resolve.(xicilion)
* [[`f09a638a40`](https://github.com/fibjs/fibjs/commit/f09a638a40)] - **Buffer, feat**: support Int64 read/write.(xicilion)
* [[`3954c3ff3d`](https://github.com/fibjs/fibjs/commit/3954c3ff3d)] - **core, refactor**: return BigInt as data type Long.(xicilion)
* [[`48b1973c57`](https://github.com/fibjs/fibjs/commit/48b1973c57)] - **core, feat**: check the range of int64 data type parameters.(xicilion)
* [[`be566db4c3`](https://github.com/fibjs/fibjs/commit/be566db4c3)] - **core, bugfix**: use JSValue/JSArray to avoid exceptions caused by empty values. (#527)(Yuanhang Luo)
* [[`e2f1c52c12`](https://github.com/fibjs/fibjs/commit/e2f1c52c12)] - **core, feat**: accept BigInt as a numeric parameter.(xicilion)
* [[`36ba1b8b80`](https://github.com/fibjs/fibjs/commit/36ba1b8b80)] - **exlib, refactor**: rewrite exlib lock-free object using std::atomic.(xicilion)
* [[`ba50ca7da1`](https://github.com/fibjs/fibjs/commit/ba50ca7da1)] - **util, feat**: discard Stats.(xicilion)
* [[`d373ae64fe`](https://github.com/fibjs/fibjs/commit/d373ae64fe)] - **test, bugfix**: lock_test use case reports error with a small probability.(xicilion)
* [[`68325a2e93`](https://github.com/fibjs/fibjs/commit/68325a2e93)] - **global, feat**: discard Int64.(xicilion)
* [[`213ef131c6`](https://github.com/fibjs/fibjs/commit/213ef131c6)] - **coroutine, refactor**: switch to fiber pool on windows.(xicilion)
* [[`206497b031`](https://github.com/fibjs/fibjs/commit/206497b031)] - **test, bugfix**: sometimes closed events cannot be triggered.(xicilion)
* [[`f6ba5449e1`](https://github.com/fibjs/fibjs/commit/f6ba5449e1)] - **LruCache, bugfix**: memory leak.(xicilion)
* [[`b79078364a`](https://github.com/fibjs/fibjs/commit/b79078364a)] - **test, bugfix**: error occurs in process_test on a slow computer.(xicilion)
* [[`26fca7f022`](https://github.com/fibjs/fibjs/commit/26fca7f022)] - **util, feat**: output error stack when data type is Error.(xicilion)
* [[`ac9f50ef7a`](https://github.com/fibjs/fibjs/commit/ac9f50ef7a)] - **test, refactor**: use the test_util.cleanup method to close the server socket.(xicilion)
* [[`ce3d328c44`](https://github.com/fibjs/fibjs/commit/ce3d328c44)] - **test, bugfix**: gui_test did not exit after testing.(xicilion)
* [[`ea0d6e0622`](https://github.com/fibjs/fibjs/commit/ea0d6e0622)] - **TcpServer, rector**: discard run and asyncRun with start.(xicilion)
* [[`f096b6c244`](https://github.com/fibjs/fibjs/commit/f096b6c244)] - **process, bugfix**: do not set exitCode when result_t > 0;(xicilion)
* [[`fcd9037725`](https://github.com/fibjs/fibjs/commit/fcd9037725)] - **gui, feat**: remove WebView.wait method.(xicilion)
* [[`eb525ce7b6`](https://github.com/fibjs/fibjs/commit/eb525ce7b6)] - **gui, bugfix**: core dump on windows.(xicilion)
* [[`ef8551f38a`](https://github.com/fibjs/fibjs/commit/ef8551f38a)] - **vender, feat**: update vender.(xicilion)
* [[`4bed7b3ca9`](https://github.com/fibjs/fibjs/commit/4bed7b3ca9)] - **process, bugfix**: compile error on windows.(xicilion)
* [[`1ff9a17166`](https://github.com/fibjs/fibjs/commit/1ff9a17166)] - **db, bugfix**: redis test error.(xicilion)
* [[`4aedfbef1b`](https://github.com/fibjs/fibjs/commit/4aedfbef1b)] - **core, refactor**: refactor AsyncEvent.(xicilion)
* [[`29fcd56d35`](https://github.com/fibjs/fibjs/commit/29fcd56d35)] - **http, feat**: remove state from HttpHandler and HttpServer.(xicilion)
* [[`d291d2c755`](https://github.com/fibjs/fibjs/commit/d291d2c755)] - **Worker, feat**: support options.(xicilion)
* [[`f142490923`](https://github.com/fibjs/fibjs/commit/f142490923)] - **Worker, feat**: support for error events for Worker object.(xicilion)
* [[`b9ffde13f4`](https://github.com/fibjs/fibjs/commit/b9ffde13f4)] - **http, feat**: discard pre-zip function.(xicilion)
* [[`5d0ade7180`](https://github.com/fibjs/fibjs/commit/5d0ade7180)] - **http, feat**: discard forceGZIP function.(xicilion)
* [[`86c15466eb`](https://github.com/fibjs/fibjs/commit/86c15466eb)] - **http, feat**: do not disable client caching for options requests.(xicilion)
* [[`aff8d73bc8`](https://github.com/fibjs/fibjs/commit/aff8d73bc8)] - **ssl, feat**: update root cert.(xicilion)
* [[`d1d50c0a69`](https://github.com/fibjs/fibjs/commit/d1d50c0a69)] - **crypto, feat**: support for constructing objects of the crypto module using parameters.(xicilion)
* [[`c6ae2ddf82`](https://github.com/fibjs/fibjs/commit/c6ae2ddf82)] - **tty, feat**: use globally unified tty.isatty to detect if stdout is a terminal device.(xicilion)
* [[`1bb938af56`](https://github.com/fibjs/fibjs/commit/1bb938af56)] - **test, bugfix**: enhance the stability of test cases to avoid random errors on slow computers.(xicilion)
* [[`9f06f03c7a`](https://github.com/fibjs/fibjs/commit/9f06f03c7a)] - **os, refactor**: use the same mac address format for posix on Windows.(xicilion)
* [[`5572e4267a`](https://github.com/fibjs/fibjs/commit/5572e4267a)] - **os, feat**: return the mac address in networkInterfaces on windows.(xicilion)
* [[`e0a0721630`](https://github.com/fibjs/fibjs/commit/e0a0721630)] - **core, refactor**: refactor the AsyncCall object and pass the isolate in cc mode.(xicilion)
* [[`a37ae1a656`](https://github.com/fibjs/fibjs/commit/a37ae1a656)] - **Isolate, refactor**: use HttpClient to keep the default http session object.(xicilion)
* [[`3f577f1d50`](https://github.com/fibjs/fibjs/commit/3f577f1d50)] - **http, bugfix**: compile warning on windows.(xicilion)
* [[`7c8aaaa29b`](https://github.com/fibjs/fibjs/commit/7c8aaaa29b)] - **core, refactor**: refactoring the NObject and NArray.(xicilion)
* [[`0922ef1b2f`](https://github.com/fibjs/fibjs/commit/0922ef1b2f)] - **ssl, feat**: Support for matching wildcard common name.(xicilion)
* [[`6cbabd9461`](https://github.com/fibjs/fibjs/commit/6cbabd9461)] - **ssl, feat**: support SNI(Server Name Identification).(xicilion)
* [[`95a1786cdd`](https://github.com/fibjs/fibjs/commit/95a1786cdd)] - **mbedtls, feat**: update to v2.7.12.(xicilion)
* [[`f2f2161a87`](https://github.com/fibjs/fibjs/commit/f2f2161a87)] - **test, bugfix**: time-related test case errors often occur on low-performance servers.(xicilion)
* [[`8be3892194`](https://github.com/fibjs/fibjs/commit/8be3892194)] - **qstring, feat**: support type conversion to std::string.(xicilion)
* [[`a241e2f054`](https://github.com/fibjs/fibjs/commit/a241e2f054)] - **test, bugfix**: some time-related test cases throw errors because of the performance of the ci server.(xicilion)
* [[`51604989d8`](https://github.com/fibjs/fibjs/commit/51604989d8)] - **opt_tools, feat**: render a better looking flame graph.(xicilion)
* [[`8b0a3d76d3`](https://github.com/fibjs/fibjs/commit/8b0a3d76d3)] - **vender, feat**: upgrade vender. (#526)(Ray)
* [[`9f2c8819f3`](https://github.com/fibjs/fibjs/commit/9f2c8819f3)] - **ClassInfo, bugfix**: class id will be messy under multiple workers.(xicilion)
* [[`b0fed7b013`](https://github.com/fibjs/fibjs/commit/b0fed7b013)] - **core, feat**: implement JSValue and JSArray to handle empty values ​​for exceptions.(xicilion)
* [[`a5a1597fd3`](https://github.com/fibjs/fibjs/commit/a5a1597fd3)] - **process, feat**: support `process.ppid` and `SubProcess::ppid`. (#524)(Ray)
* [[`0a20059fca`](https://github.com/fibjs/fibjs/commit/0a20059fca)] - **ci, feat**: use beta branch to release prerelase fibjs. (#523)(Ray)
* [[`4760c834e6`](https://github.com/fibjs/fibjs/commit/4760c834e6)] - **ci, feat**: use caches of `ccache` in travis.(Richardo2016)
* [[`004d78e0f3`](https://github.com/fibjs/fibjs/commit/004d78e0f3)] - **test, bugfix**: fix undefined variable in test/http_test.js(Richardo2016)
* [[`e03f90636c`](https://github.com/fibjs/fibjs/commit/e03f90636c)] - **http, bugfix**: use empty body for HEAD request. (#522)(Ray)
* [[`6d181aca39`](https://github.com/fibjs/fibjs/commit/6d181aca39)] - **http, feat**: support Repeater.(xicilion)
* [[`d7aa48a0fa`](https://github.com/fibjs/fibjs/commit/d7aa48a0fa)] - **option, bugfix**: allow install when from raw. (#520)(Ray)
* [[`efd6aef56a`](https://github.com/fibjs/fibjs/commit/efd6aef56a)] - **HttpClient, bugfix**: error in custom getter function causes crash.(xicilion)
* [[`489d52adc0`](https://github.com/fibjs/fibjs/commit/489d52adc0)] - **HttpCollection, feat**: support return all field values.(xicilion)
* [[`8c561431ab`](https://github.com/fibjs/fibjs/commit/8c561431ab)] - **HttpClient, feat**: support for a set of headers with the same name.(xicilion)
* [[`caafe1924e`](https://github.com/fibjs/fibjs/commit/caafe1924e)] - **HttpCollection, feat**: support add a set of values with the same name using an array.(xicilion)
* [[`723e85fc18`](https://github.com/fibjs/fibjs/commit/723e85fc18)] - **test, feat**: do not run the opt_tools test case in the basic test.(xicilion)
* [[`b615f6693a`](https://github.com/fibjs/fibjs/commit/b615f6693a)] - **test, bugfix**: normalize internal & opt_tools' test cases. (#518)(Ray)
* [[`fc07248316`](https://github.com/fibjs/fibjs/commit/fc07248316)] - **http, feat**: support enableEncoding property.(xicilion)
* [[`a10e9f50ec`](https://github.com/fibjs/fibjs/commit/a10e9f50ec)] - **HttpMessage, feat**: set the parameter type of the header function to string type.(xicilion)
* [[`1b0e3f1c81`](https://github.com/fibjs/fibjs/commit/1b0e3f1c81)] - **HttpClient, feat**: do not send User-Agent when userAgent is empty.(xicilion)
* [[`0e801dd60e`](https://github.com/fibjs/fibjs/commit/0e801dd60e)] - **HttpClient, feat**: support enableEncoding property.(xicilion)
* [[`ce22626983`](https://github.com/fibjs/fibjs/commit/ce22626983)] - **core, feat**: include the module component name in the error message.(xicilion)
* [[`b675bc17bc`](https://github.com/fibjs/fibjs/commit/b675bc17bc)] - **HttpClient, feat**: do not send cookies when enableCookie is false.(xicilion)
* [[`2b1ebc801b`](https://github.com/fibjs/fibjs/commit/2b1ebc801b)] - dev 0.29.0(richardo2016)
* [[`257ae16bd2`](https://github.com/fibjs/fibjs/commit/257ae16bd2)] - Release v0.28.0.(richardo2016)
* [[`6c8a8d0931`](https://github.com/fibjs/fibjs/commit/6c8a8d0931)] - **process, fix**: make requried envs' kv fallback to the ones of parent process. (#516)(Ray)
* [[`efa57bef37`](https://github.com/fibjs/fibjs/commit/efa57bef37)] - **option, feat**: better opt_tools/install, dedupe its structure, support installing package from github. (#515)(Ray)
* [[`ff4e9743cc`](https://github.com/fibjs/fibjs/commit/ff4e9743cc)] - **crypto, feat**: support aria.(xicilion)
* [[`1829d2471e`](https://github.com/fibjs/fibjs/commit/1829d2471e)] - **Routing, bugfix**: compile error on windows.(xicilion)
* [[`a0b4af9069`](https://github.com/fibjs/fibjs/commit/a0b4af9069)] - **vender, feat**: update mbedtls to v2.16.2.(xicilion)
* [[`330d1d049e`](https://github.com/fibjs/fibjs/commit/330d1d049e)] - **Routing, feat**: support virtual host routing.(xicilion)
* [[`612271ce54`](https://github.com/fibjs/fibjs/commit/612271ce54)] - **option, feat**: skip package.json when the file does not exist.(xicilion)
* [[`5820c65b1e`](https://github.com/fibjs/fibjs/commit/5820c65b1e)] - **cmake, bugfix**: warning in cmake.(xicilion)
* [[`75903b7fce`](https://github.com/fibjs/fibjs/commit/75903b7fce)] - **process, feat**: change process.run to async mode.(xicilion)
* [[`ce4af53d00`](https://github.com/fibjs/fibjs/commit/ce4af53d00)] - **console, bugfix**: do not reset the terminal outside of console.readLine.(xicilion)
* [[`0fee0ead6c`](https://github.com/fibjs/fibjs/commit/0fee0ead6c)] - **console, feat**: support console.getpass.(xicilion)
* [[`34b7e61501`](https://github.com/fibjs/fibjs/commit/34b7e61501)] - **process, feat**: clean up the terminal when exiting the process.(xicilion)
* [[`abf7897264`](https://github.com/fibjs/fibjs/commit/abf7897264)] - **console, feat**: use editline on all posix platforms.(xicilion)
* [[`f7c08817d7`](https://github.com/fibjs/fibjs/commit/f7c08817d7)] - **test, bugfix**: deepEqual crash on proxy object. (#513)(FiberMan)
* [[`be4efe6325`](https://github.com/fibjs/fibjs/commit/be4efe6325)] - **assert, bugfix**: deepEqual crash on proxy object.(xicilion)
* [[`453b78c6d6`](https://github.com/fibjs/fibjs/commit/453b78c6d6)] - **path, bugfix**: result error in path.resolve root test case on windows.(xicilion)
* [[`15b9de4517`](https://github.com/fibjs/fibjs/commit/15b9de4517)] - Merge branch 'add_path_resolve_test' into dev(xicilion)
* [[`83cc7399a4`](https://github.com/fibjs/fibjs/commit/83cc7399a4)] - **path, bugfix**: result error in path.resolve root test case.(xicilion)
* [[`750f23e084`](https://github.com/fibjs/fibjs/commit/750f23e084)] - **core, bugfix**: javascript getter throw in libs(assert, jsonformat, util, sandbox) (#511)(FiberMan)
* [[`c6fa2d78ae`](https://github.com/fibjs/fibjs/commit/c6fa2d78ae)] - **Buffer, bugfix**: bind isolate when creating a new Buffer(FiberMan)
* [[`3c46c38fb8`](https://github.com/fibjs/fibjs/commit/3c46c38fb8)] - **ci, feat**: add dockerfiles. (#510)(Ray)
* [[`965c955fd4`](https://github.com/fibjs/fibjs/commit/965c955fd4)] - **io, feat**: improve payload size when processing async read in win32. (#507)(Ray)
* [[`9f71c39695`](https://github.com/fibjs/fibjs/commit/9f71c39695)] - **test, feat**: basic test cases about io (#506)(Ray)
* [[`6e8e02c487`](https://github.com/fibjs/fibjs/commit/6e8e02c487)] - **test, feat**: add path.resolve root test case(Henry Zhuang)
* [[`babc961c5f`](https://github.com/fibjs/fibjs/commit/babc961c5f)] - **test, bugfix**: fix the arm64 test env (#504)(Henry Zhuang)
* [[`46da2f74a1`](https://github.com/fibjs/fibjs/commit/46da2f74a1)] - **os, bugfix**: fix os.homedir() when USERPROFILE not set on Windows (#503)(Henry Zhuang)
* [[`4272135dda`](https://github.com/fibjs/fibjs/commit/4272135dda)] - **process, bugfix**: use real pipe-like struct to initial stdio in process. (#501)(Ray)
* [[`aaf9f31263`](https://github.com/fibjs/fibjs/commit/aaf9f31263)] - **test, bugfix**: enable the full arm test env (#502)(Henry Zhuang)
* [[`6dd53e7ec0`](https://github.com/fibjs/fibjs/commit/6dd53e7ec0)] - **os, bugfix**: os.homedir() fallback should work (#499)(Henry Zhuang)
* [[`2c1cb15094`](https://github.com/fibjs/fibjs/commit/2c1cb15094)] - **test, feat**: skip test when releasing. (#498)(Henry Zhuang)

## 2019-09-03, Version 0.28.0 
* **feature** :
    * ci - add dockerfiles. (#510)(Ray)
    * console:
      - support console.getpass.(xicilion)
      - use editline on all posix platforms.(xicilion)
    * crypto - support aria.(xicilion)
    * io - improve payload size when processing async read in win32. (#507)(Ray)
    * option:
      - better opt_tools/install, dedupe its structure, support installing package from github. (#515)(Ray)
      - skip package.json when the file does not exist.(xicilion)
    * process:
      - change process.run to async mode.(xicilion)
      - clean up the terminal when exiting the process.(xicilion)
    * Routing - support virtual host routing.(xicilion)
    * test:
      - basic test cases about io (#506)(Ray)
      - add path.resolve root test case(Henry Zhuang)
      - skip test when releasing. (#498)(Henry Zhuang)
    * vender - update mbedtls to v2.16.2.(xicilion)

* **bugfix** :
    * assert - deepEqual crash on proxy object.(xicilion)
    * Buffer - bind isolate when creating a new Buffer(FiberMan)
    * cmake - warning in cmake.(xicilion)
    * console - do not reset the terminal outside of console.readLine.(xicilion)
    * core - javascript getter throw in libs(assert, jsonformat, util, sandbox) (#511)(FiberMan)
    * os:
      - fix os.homedir() when USERPROFILE not set on Windows (#503)(Henry Zhuang)
      - os.homedir() fallback should work (#499)(Henry Zhuang)
    * path:
      - result error in path.resolve root test case on windows.(xicilion)
      - result error in path.resolve root test case.(xicilion)
    * process - use real pipe-like struct to initial stdio in process. (#501)(Ray)
    * Routing - compile error on windows.(xicilion)
    * test:
      - deepEqual crash on proxy object. (#513)(FiberMan)
      - fix the arm64 test env (#504)(Henry Zhuang)
      - enable the full arm test env (#502)(Henry Zhuang)

* **fix** :
    * process - make requried envs' kv fallback to the ones of parent process. (#516)(Ray)

* **others** :
    * Merge branch 'add_path_resolve_test' into dev(xicilion)

### Commits
* [[`6c8a8d0931`](https://github.com/fibjs/fibjs/commit/6c8a8d0931)] - **process, fix**: make requried envs' kv fallback to the ones of parent process. (#516)(Ray)
* [[`efa57bef37`](https://github.com/fibjs/fibjs/commit/efa57bef37)] - **option, feat**: better opt_tools/install, dedupe its structure, support installing package from github. (#515)(Ray)
* [[`ff4e9743cc`](https://github.com/fibjs/fibjs/commit/ff4e9743cc)] - **crypto, feat**: support aria.(xicilion)
* [[`1829d2471e`](https://github.com/fibjs/fibjs/commit/1829d2471e)] - **Routing, bugfix**: compile error on windows.(xicilion)
* [[`a0b4af9069`](https://github.com/fibjs/fibjs/commit/a0b4af9069)] - **vender, feat**: update mbedtls to v2.16.2.(xicilion)
* [[`330d1d049e`](https://github.com/fibjs/fibjs/commit/330d1d049e)] - **Routing, feat**: support virtual host routing.(xicilion)
* [[`612271ce54`](https://github.com/fibjs/fibjs/commit/612271ce54)] - **option, feat**: skip package.json when the file does not exist.(xicilion)
* [[`5820c65b1e`](https://github.com/fibjs/fibjs/commit/5820c65b1e)] - **cmake, bugfix**: warning in cmake.(xicilion)
* [[`75903b7fce`](https://github.com/fibjs/fibjs/commit/75903b7fce)] - **process, feat**: change process.run to async mode.(xicilion)
* [[`ce4af53d00`](https://github.com/fibjs/fibjs/commit/ce4af53d00)] - **console, bugfix**: do not reset the terminal outside of console.readLine.(xicilion)
* [[`0fee0ead6c`](https://github.com/fibjs/fibjs/commit/0fee0ead6c)] - **console, feat**: support console.getpass.(xicilion)
* [[`34b7e61501`](https://github.com/fibjs/fibjs/commit/34b7e61501)] - **process, feat**: clean up the terminal when exiting the process.(xicilion)
* [[`abf7897264`](https://github.com/fibjs/fibjs/commit/abf7897264)] - **console, feat**: use editline on all posix platforms.(xicilion)
* [[`f7c08817d7`](https://github.com/fibjs/fibjs/commit/f7c08817d7)] - **test, bugfix**: deepEqual crash on proxy object. (#513)(FiberMan)
* [[`be4efe6325`](https://github.com/fibjs/fibjs/commit/be4efe6325)] - **assert, bugfix**: deepEqual crash on proxy object.(xicilion)
* [[`453b78c6d6`](https://github.com/fibjs/fibjs/commit/453b78c6d6)] - **path, bugfix**: result error in path.resolve root test case on windows.(xicilion)
* [[`15b9de4517`](https://github.com/fibjs/fibjs/commit/15b9de4517)] - Merge branch 'add_path_resolve_test' into dev(xicilion)
* [[`83cc7399a4`](https://github.com/fibjs/fibjs/commit/83cc7399a4)] - **path, bugfix**: result error in path.resolve root test case.(xicilion)
* [[`750f23e084`](https://github.com/fibjs/fibjs/commit/750f23e084)] - **core, bugfix**: javascript getter throw in libs(assert, jsonformat, util, sandbox) (#511)(FiberMan)
* [[`c6fa2d78ae`](https://github.com/fibjs/fibjs/commit/c6fa2d78ae)] - **Buffer, bugfix**: bind isolate when creating a new Buffer(FiberMan)
* [[`3c46c38fb8`](https://github.com/fibjs/fibjs/commit/3c46c38fb8)] - **ci, feat**: add dockerfiles. (#510)(Ray)
* [[`965c955fd4`](https://github.com/fibjs/fibjs/commit/965c955fd4)] - **io, feat**: improve payload size when processing async read in win32. (#507)(Ray)
* [[`9f71c39695`](https://github.com/fibjs/fibjs/commit/9f71c39695)] - **test, feat**: basic test cases about io (#506)(Ray)
* [[`6e8e02c487`](https://github.com/fibjs/fibjs/commit/6e8e02c487)] - **test, feat**: add path.resolve root test case(Henry Zhuang)
* [[`babc961c5f`](https://github.com/fibjs/fibjs/commit/babc961c5f)] - **test, bugfix**: fix the arm64 test env (#504)(Henry Zhuang)
* [[`46da2f74a1`](https://github.com/fibjs/fibjs/commit/46da2f74a1)] - **os, bugfix**: fix os.homedir() when USERPROFILE not set on Windows (#503)(Henry Zhuang)
* [[`4272135dda`](https://github.com/fibjs/fibjs/commit/4272135dda)] - **process, bugfix**: use real pipe-like struct to initial stdio in process. (#501)(Ray)
* [[`aaf9f31263`](https://github.com/fibjs/fibjs/commit/aaf9f31263)] - **test, bugfix**: enable the full arm test env (#502)(Henry Zhuang)
* [[`6dd53e7ec0`](https://github.com/fibjs/fibjs/commit/6dd53e7ec0)] - **os, bugfix**: os.homedir() fallback should work (#499)(Henry Zhuang)
* [[`2c1cb15094`](https://github.com/fibjs/fibjs/commit/2c1cb15094)] - **test, feat**: skip test when releasing. (#498)(Henry Zhuang)

## 2019-05-02, Version v0.27.0
* **feature** :
    * Buffer - support safe buffer mode.(xicilion)
    * ci - disable prof in ci.(xicilion)
    * core:
      - migrate compilation to clang on linux.(xicilion)
      - generate complete include path for a dependent module or object.(xicilion)
      - check the result of NewFunction.(xicilion)
      - get Utf8values using ToString.(xicilion)
      - init v8 option before main function.(xicilion)
      - support custom platform.(xicilion)
    * db - return null when connection is closed.(xicilion)
    * DgramSocket - prevent DgramSocket's js ref from being deleted (#478)(Asion)
    * event:
      - handling error  for the first trigger.(xicilion)
      - wait until all triggers are completed.(xicilion)
    * hash - use Buffer to encode the result of digest.(xicilion)
    * option - gen script script.(xicilion)
    * process - add property `pid` to get current process id. (#483)(Ray)
    * sandbox - add gc test for sandbox.refesh.(xicilion)
    * SandBox - not remove entry function when refreshing error.(xicilion)
    * sqlite - upgrade to v3.28.0.(xicilion)
    * test:
      - skip a process.run test case on Linux.(xicilion)
      - resume timer test case.(xicilion)
      - add loop test script.(xicilion)
      - add arm test env (#488)(Henry Zhuang)
      - only test util.format.(xicilion)
    * tools:
      - install g++-multilib.(xicilion)
      - migrate out tool for generating types.(richardo2016)
      - fix some literal mistake. (#466)(Ray)
      - mark all 'Object' as 'object' (#465)(Ray)
    * util - use NObject to collect build information.(xicilion)
    * v8 - upgrade to v6.9.454.(xicilion)
    * v8_api - support convert BigInt to int64_t.(xicilion)
    * websocket - support add customized http headers (#474)(Asion)

* **bugfix** :
    * Buffer - crash when method resize was invoked in async namespace (#491)(Asion)
    * build - clang build env (#486)(Henry Zhuang)
    * core:
      - link atomic to fix link error on i386 linux.(xicilion)
      - static linking to GLIBCXX causes failure on older versions of Linux.(xicilion)
      - compile error on ubuntu 18.04.(xicilion)
      - crash when starting on Windows.(xicilion)
      - compile warning on linux.(xicilion)
      - check value before ToLocalChecked.(xicilion)
      - compile warning on widows.(xicilion)
    * db:
      - fix index error on mongodb.(xicilion)
      - use obj_ptr instead of weak_ptr.(xicilion)
      - crash when releasing MongoDB connection before MongoCollection.(xicilion)
      - crash in mongodb.(xicilion)
      - fix crash in MongoCursor.(xicilion)
    * DgramSocket - crash when calling the send method of an unbound socket.(xicilion)
    * est - smaller time range for websocket use cases causes test failure on slow computers.(xicilion)
    * http:
      - can't read parent of server root path (#495)(FiberMan)
      - Allow yourself to parse the chunked body by setting maxBodySize = 0 (#471)(Mingliang Chen)
    * option - fix JSON parse problem for node modules information (#467)(Velen)
    * os - librt.so not found on ubuntu (#487)(Henry Zhuang)
    * SandBox - do not check result from SetIntegrityLevel.(xicilion)
    * TcpServer - return the holder isolate of TcpServer in AsyncInvoke.(xicilion)
    * test:
      - timer test case error on arm Linux.(xicilion)
      - process test error in debug mode.(xicilion)
      - HttpFileHandler test case run path dependencies(FiberMan)
      - restore the default value of http.timeout to avoid affecting other test cases.(xicilion)
      - smaller time range for use cases causes test failure on slow computers.(xicilion)
      - fix the qemu test env (#493)(Henry Zhuang)
    * timers - fix the timeout range.(xicilion)
    * Variant - memory leak when use js Object as params in worker a… (#489)(Asion)
    * websocket - when the websocket fails to connect very quickly, the process does not keep.(xicilion)

### Commits
* [[`c1e731d9ec`](https://github.com/fibjs/fibjs/commit/c1e731d9ec)] - **sqlite, feat**: upgrade to v3.28.0.(xicilion)
* [[`02ddbdf57f`](https://github.com/fibjs/fibjs/commit/02ddbdf57f)] - **ci, feat**: disable prof in ci.(xicilion)
* [[`8a8d2e6f6e`](https://github.com/fibjs/fibjs/commit/8a8d2e6f6e)] - **test, feat**: skip a process.run test case on Linux.(xicilion)
* [[`f7cbae9f06`](https://github.com/fibjs/fibjs/commit/f7cbae9f06)] - **test, bugfix**: timer test case error on arm Linux.(xicilion)
* [[`ca205e907b`](https://github.com/fibjs/fibjs/commit/ca205e907b)] - **test, feat**: resume timer test case.(xicilion)
* [[`dea79251f6`](https://github.com/fibjs/fibjs/commit/dea79251f6)] - **test, feat**: add loop test script.(xicilion)
* [[`df27565eff`](https://github.com/fibjs/fibjs/commit/df27565eff)] - **test, bugfix**: process test error in debug mode.(xicilion)
* [[`f2ebb2d94c`](https://github.com/fibjs/fibjs/commit/f2ebb2d94c)] - **est, bugfix**: smaller time range for websocket use cases causes test failure on slow computers.(xicilion)
* [[`7fbfa1fb16`](https://github.com/fibjs/fibjs/commit/7fbfa1fb16)] - **test, bugfix**: HttpFileHandler test case run path dependencies(FiberMan)
* [[`57dce849df`](https://github.com/fibjs/fibjs/commit/57dce849df)] - **test, bugfix**: restore the default value of http.timeout to avoid affecting other test cases.(xicilion)
* [[`6cb9d5fe37`](https://github.com/fibjs/fibjs/commit/6cb9d5fe37)] - **http, bugfix**: can't read parent of server root path (#495)(FiberMan)
* [[`ebdcce6eac`](https://github.com/fibjs/fibjs/commit/ebdcce6eac)] - **test, bugfix**: smaller time range for use cases causes test failure on slow computers.(xicilion)
* [[`0a97c2cc07`](https://github.com/fibjs/fibjs/commit/0a97c2cc07)] - **test, bugfix**: fix the qemu test env (#493)(Henry Zhuang)
* [[`0c5fb367f2`](https://github.com/fibjs/fibjs/commit/0c5fb367f2)] - **tools, feat**: install g++-multilib.(xicilion)
* [[`fb354b7da6`](https://github.com/fibjs/fibjs/commit/fb354b7da6)] - **tools, feat**: migrate out tool for generating types.(richardo2016)
* [[`2175af8acb`](https://github.com/fibjs/fibjs/commit/2175af8acb)] - **v8, feat**: upgrade to v6.9.454.(xicilion)
* [[`8498cb3f3e`](https://github.com/fibjs/fibjs/commit/8498cb3f3e)] - **Buffer, bugfix**: crash when method resize was invoked in async namespace (#491)(Asion)
* [[`98e88195d6`](https://github.com/fibjs/fibjs/commit/98e88195d6)] - **core, bugfix**: link atomic to fix link error on i386 linux.(xicilion)
* [[`e3355bc9aa`](https://github.com/fibjs/fibjs/commit/e3355bc9aa)] - **Variant, bugfix**: memory leak when use js Object as params in worker a… (#489)(Asion)
* [[`c5b1afb062`](https://github.com/fibjs/fibjs/commit/c5b1afb062)] - **test, feat**: add arm test env (#488)(Henry Zhuang)
* [[`c7ca4c69e3`](https://github.com/fibjs/fibjs/commit/c7ca4c69e3)] - **os, bugfix**: librt.so not found on ubuntu (#487)(Henry Zhuang)
* [[`0a565f3fec`](https://github.com/fibjs/fibjs/commit/0a565f3fec)] - **build, bugfix**: clang build env (#486)(Henry Zhuang)
* [[`80d823a2fd`](https://github.com/fibjs/fibjs/commit/80d823a2fd)] - **core, bugfix**: static linking to GLIBCXX causes failure on older versions of Linux.(xicilion)
* [[`aed20b5988`](https://github.com/fibjs/fibjs/commit/aed20b5988)] - **core, bugfix**: compile error on ubuntu 18.04.(xicilion)
* [[`5c3c59c447`](https://github.com/fibjs/fibjs/commit/5c3c59c447)] - **core, feat**: migrate compilation to clang on linux.(xicilion)
* [[`84a898122b`](https://github.com/fibjs/fibjs/commit/84a898122b)] - **websocket, bugfix**: when the websocket fails to connect very quickly, the process does not keep.(xicilion)
* [[`b545b0d41b`](https://github.com/fibjs/fibjs/commit/b545b0d41b)] - **process, feat**: add property `pid` to get current process id. (#483)(Ray)
* [[`628fb32369`](https://github.com/fibjs/fibjs/commit/628fb32369)] - **core, bugfix**: crash when starting on Windows.(xicilion)
* [[`02cb480f7a`](https://github.com/fibjs/fibjs/commit/02cb480f7a)] - **event, feat**: handling error  for the first trigger.(xicilion)
* [[`293487bd1f`](https://github.com/fibjs/fibjs/commit/293487bd1f)] - **event, feat**: wait until all triggers are completed.(xicilion)
* [[`e4b8a26b29`](https://github.com/fibjs/fibjs/commit/e4b8a26b29)] - **DgramSocket, bugfix**: crash when calling the send method of an unbound socket.(xicilion)
* [[`5eec5d66a7`](https://github.com/fibjs/fibjs/commit/5eec5d66a7)] - **DgramSocket, feat**: prevent DgramSocket's js ref from being deleted (#478)(Asion)
* [[`70ff4198a6`](https://github.com/fibjs/fibjs/commit/70ff4198a6)] - **websocket, feat**: support add customized http headers (#474)(Asion)
* [[`7a9ca2bcb3`](https://github.com/fibjs/fibjs/commit/7a9ca2bcb3)] - **SandBox, feat**: not remove entry function when refreshing error.(xicilion)
* [[`920d882a6a`](https://github.com/fibjs/fibjs/commit/920d882a6a)] - **db, bugfix**: fix index error on mongodb.(xicilion)
* [[`c269bd770e`](https://github.com/fibjs/fibjs/commit/c269bd770e)] - **core, bugfix**: compile warning on linux.(xicilion)
* [[`0c0eb1b0c6`](https://github.com/fibjs/fibjs/commit/0c0eb1b0c6)] - **core, feat**: generate complete include path for a dependent module or object.(xicilion)
* [[`02b2cba9cc`](https://github.com/fibjs/fibjs/commit/02b2cba9cc)] - **hash, feat**: use Buffer to encode the result of digest.(xicilion)
* [[`bee235f350`](https://github.com/fibjs/fibjs/commit/bee235f350)] - **Buffer, feat**: support safe buffer mode.(xicilion)
* [[`d1cf7fa0aa`](https://github.com/fibjs/fibjs/commit/d1cf7fa0aa)] - **core, feat**: check the result of NewFunction.(xicilion)
* [[`6c886d6133`](https://github.com/fibjs/fibjs/commit/6c886d6133)] - **http, bugfix**: Allow yourself to parse the chunked body by setting maxBodySize = 0 (#471)(Mingliang Chen)
* [[`999cf0762e`](https://github.com/fibjs/fibjs/commit/999cf0762e)] - **db, bugfix**: use obj_ptr instead of weak_ptr.(xicilion)
* [[`e7dc3cf767`](https://github.com/fibjs/fibjs/commit/e7dc3cf767)] - **db, bugfix**: crash when releasing MongoDB connection before MongoCollection.(xicilion)
* [[`17100aa1c9`](https://github.com/fibjs/fibjs/commit/17100aa1c9)] - **db, bugfix**: crash in mongodb.(xicilion)
* [[`9be8689cb9`](https://github.com/fibjs/fibjs/commit/9be8689cb9)] - **core, bugfix**: check value before ToLocalChecked.(xicilion)
* [[`e810e2062b`](https://github.com/fibjs/fibjs/commit/e810e2062b)] - **db, feat**: return null when connection is closed.(xicilion)
* [[`ded7be3595`](https://github.com/fibjs/fibjs/commit/ded7be3595)] - **db, bugfix**: fix crash in MongoCursor.(xicilion)
* [[`ebeacf3cc5`](https://github.com/fibjs/fibjs/commit/ebeacf3cc5)] - **sandbox, feat**: add gc test for sandbox.refesh.(xicilion)
* [[`2aa1b8c6b1`](https://github.com/fibjs/fibjs/commit/2aa1b8c6b1)] - **v8_api, feat**: support convert BigInt to int64_t.(xicilion)
* [[`11106559bd`](https://github.com/fibjs/fibjs/commit/11106559bd)] - **core, bugfix**: compile warning on widows.(xicilion)
* [[`545e0803e9`](https://github.com/fibjs/fibjs/commit/545e0803e9)] - **test, feat**: only test util.format.(xicilion)
* [[`74ebf67952`](https://github.com/fibjs/fibjs/commit/74ebf67952)] - **core, feat**: get Utf8values using ToString.(xicilion)
* [[`246e9687ae`](https://github.com/fibjs/fibjs/commit/246e9687ae)] - **core, fest**: support custom platform.(xicilion)
* [[`dfa60c80bb`](https://github.com/fibjs/fibjs/commit/dfa60c80bb)] - **util, feat**: use NObject to collect build information.(xicilion)
* [[`85bcb4a66d`](https://github.com/fibjs/fibjs/commit/85bcb4a66d)] - **tools, feat**: fix some literal mistake. (#466)(Ray)
* [[`414569521d`](https://github.com/fibjs/fibjs/commit/414569521d)] - **tools, feat**: mark all 'Object' as 'object' (#465)(Ray)
* [[`e84d08c4f1`](https://github.com/fibjs/fibjs/commit/e84d08c4f1)] - **option, feat**: gen script script.(xicilion)
* [[`3dba99da81`](https://github.com/fibjs/fibjs/commit/3dba99da81)] - Merge commit '31ca57cb9b0b16125f97a054c3e7667f608ac1df' into dev(xicilion)
* [[`f518636681`](https://github.com/fibjs/fibjs/commit/f518636681)] - **option, bugfix**: fix JSON parse problem for node modules information (#467)(Velen)
* [[`31ca57cb9b`](https://github.com/fibjs/fibjs/commit/31ca57cb9b)] - fix typo in doc (#464)(onceyoung)
* [[`ec9b7e67c1`](https://github.com/fibjs/fibjs/commit/ec9b7e67c1)] - **SandBox, bugfix**: do not check result from SetIntegrityLevel.(xicilion)
* [[`b2bc253c48`](https://github.com/fibjs/fibjs/commit/b2bc253c48)] - **core, feat**: init v8 option before main function.(xicilion)
* [[`26bf45e2d3`](https://github.com/fibjs/fibjs/commit/26bf45e2d3)] - **TcpServer, bugfix**: return the holder isolate of TcpServer in AsyncInvoke.(xicilion)
* [[`bc193ca039`](https://github.com/fibjs/fibjs/commit/bc193ca039)] - **timers, bugfix**: fix the timeout range.(xicilion)

## 2018-08-17, Version v0.26.0
* **feature** :
    * build:
      - fix ascii art.(xicilion)
      - display message for successfully built.(xicilion)
    * console:
      - only allow console config in master worker.(xicilion)
      - support for overloaded log behavior of logger.(xicilion)
    * core:
      - support isFrozen function.(xicilion)
      - change the error prompt capitalization.(xicilion)
      - support for top-level await operators.(xicilion)
    * Digest - supports encoding. (#445)(bengbengca)
    * docs - collect modules.(xicilion)
    * fs:
      - support file access switch.(xicilion)
      - add test for 'require' when calling `zip.open`. (#448)(Ray)
      - support custom zip fs.(xicilion)
    * http:
      - support keep-alive in HttpClient.(xicilion)
      - support http.STATUS_CODES.(xicilion)
    * LruCache - not emit the expire event until the event callback function has changed.(xicilion)
    * module - add module aliases, tls -> ssl, https -> http.(xicilion)
    * path - add `path.relative` which compats with nodejs. (#449)(Ray)
    * SandBox:
      - support for refreshing module data.(xicilion)
      - support freeze function to disable modification of global variables in sandbox.(xicilion)
      - support disable ext loader.(xicilion)
    * sandbox:
      - disable require.cache.(xicilion)
      - add test case to explain some side cases about 'SandBox::setModuleCompiler' (#460)(Ray)
      - normalize implementation of custom_loader with the other standard loaders, then rename 'SandBox::setModuleLoader' to 'SandBox::setModuleCompiler'. (#459)(Ray)
      - add 'Sandbox::modules' to get dict of modules installed in it. (#457)(Ray)
      - passout callbackArgs in 'SandBox::CustomExtLoader::run' (#455)(Ray)
      - remove 'internal/typescript' module and related loader. (#454)(Ray)
      - define appname.(xicilion)
    * test:
      - add test case of timers.call.(xicilion)
      - test for maxBodySize limit in the compressed body.(xicilion)
    * Timer - support result_t in TimeoutScope::result.(xicilion)
    * timers:
      - process script error in timeout function.(xicilion)
      - not interrupt script when hr_timer is stopped.(xicilion)
      - support script timeout.(xicilion)
      - Compatible with Nodejs' setTimeout function, the parameter timeout can be undefined. (#446)(bengbengca)
    * tools:
      - reorder module list.(xicilion)
      - add .github/PULL_REQUEST_TEMPLATE.md (#439)(Ray)
      - support multiple idl folders.(xicilion)
    * util:
      - display error message for hr first.(xicilion)
      - support deepFreeze.(xicilion)
      - add 'modules' into returnValue of  'util.buildInfo'. (#458)(Ray)
      - support using vector array to init OptArg.(xicilion)
    * utils - add error code CALL_E_TIMEOUT.(xicilion)
    * v8:
      - make snapshot data.(xicilion)
      - upgrade to 6.8.275.(xicilion)
    * vm - support Sandbox::registerExt, and enable it in rootModule's Sandbox. (#450)(Ray)
    * zlib:
      - reset dataSize when attaching to new stream.(xicilion)
      - supports maxSize when decompressing.(xicilion)

* **bugfix** :
    * core:
      - not reset TryCatch by default.(xicilion)
      - name is 'undefined' in operator function.(xicilion)
      - link error in debug mode on linux.(xicilion)
      - run microtask inside Fiber::scope.(xicilion)
      - deadlock in some promise case.(xicilion)
      - GLIBC dependency issues under Linux.(xicilion)
    * fs:
      - crash in debug mode.(xicilion)
      - setZipFS not working on windows.(xicilion)
    * HttpClient - compile warning in debug mode.(xicilion)
    * sandbox - sync build info about ts_loader/custom_loader for windows (#456)(Ray)
    * SandBox - remove unused variable.(xicilion)
    * timers - compile error on windows.(xicilion)
    * tools:
      - fix lack of `member_props` in module, and fix TypeMap. (#440)(Ray)
      - [tsdeclare] fix expression of exported-statically class. (#438)(Ray)
      - remove unnecessary `import` statement on top of module declartion file. (#436)(Ray)
    * util - correct validation about __GIT_INFO__ in `./test/util_test.js`. (#461)(Ray)
    * v8 - compile error on linux i386.(xicilion)

* **refactor** :
    * console - add addLogger function.(xicilion)
    * http:
      - rewrite HttpUploadCollection with std::pair.(xicilion)
      - rewrite HttpCollection with std::pair.(xicilion)
    * sandbox:
      - implement virtual compile function.(xicilion)
      - simplified parameter passing.(xicilion)
      - remove script code cache.(xicilion)
      - add virtual custom resolve function.(xicilion)
    * SandBox:
      - rewrite some of ExtLoader.(xicilion)
      - load json module by overloading run instead of run_module.(xicilion)
    * Timer - use the TimeoutScope class to implement timeout.(xicilion)
    * util - use namespace.(xicilion)
    * timers - move JSTimer to Timer.h.(xicilion)

* **others** :
    * Merge branch 'dev' of https - //github.com/fibjs/fibjs into dev(xicilion)
    * add function convert uint64 to BigInt.(xicilion)
    * add 'has' method in SandBox Module. (#442)(tapir)

### Commits
* [[`853700bbf7`](https://github.com/fibjs/fibjs/commit/853700bbf7)] - **util, feat**: display error message for hr first.(xicilion)
* [[`295d66b50a`](https://github.com/fibjs/fibjs/commit/295d66b50a)] - **SandBox, feat**: support for refreshing module data.(xicilion)
* [[`8abefb0a69`](https://github.com/fibjs/fibjs/commit/8abefb0a69)] - **sandbox, feat**: disable require.cache.(xicilion)
* [[`b8226c9c67`](https://github.com/fibjs/fibjs/commit/b8226c9c67)] - **util, bugfix**: correct validation about __GIT_INFO__ in `./test/util_test.js`. (#461)(Ray)
* [[`bf9d561464`](https://github.com/fibjs/fibjs/commit/bf9d561464)] - **sandbox, feat**: add test case to explain some side cases about 'SandBox::setModuleCompiler' (#460)(Ray)
* [[`c9fde181ed`](https://github.com/fibjs/fibjs/commit/c9fde181ed)] - **SandBox, feat**: support freeze function to disable modification of global variables in sandbox.(xicilion)
* [[`a1ec0af816`](https://github.com/fibjs/fibjs/commit/a1ec0af816)] - **util, feat**: support deepFreeze.(xicilion)
* [[`62ae2a17fc`](https://github.com/fibjs/fibjs/commit/62ae2a17fc)] - **core, feat**: support isFrozen function.(xicilion)
* [[`7da2020d90`](https://github.com/fibjs/fibjs/commit/7da2020d90)] - **sandbox, feat**: normalize implementation of custom_loader with the other standard loaders, then rename 'SandBox::setModuleLoader' to 'SandBox::setModuleCompiler'. (#459)(Ray)
* [[`926286d582`](https://github.com/fibjs/fibjs/commit/926286d582)] - **sandbox, refactor**: implement virtual compile function.(xicilion)
* [[`56806cddb1`](https://github.com/fibjs/fibjs/commit/56806cddb1)] - **timers, feat**: process script error in timeout function.(xicilion)
* [[`05e79951ef`](https://github.com/fibjs/fibjs/commit/05e79951ef)] - **timers, feat**: not interrupt script when hr_timer is stopped.(xicilion)
* [[`b68cfd55f4`](https://github.com/fibjs/fibjs/commit/b68cfd55f4)] - **core, bugfix**: not reset TryCatch by default.(xicilion)
* [[`85089cb702`](https://github.com/fibjs/fibjs/commit/85089cb702)] - **util, refactor**: use namespace.(xicilion)
* [[`9db5774ba3`](https://github.com/fibjs/fibjs/commit/9db5774ba3)] - **sandbox, refactor**: simplified parameter passing.(xicilion)
* [[`ab407ce914`](https://github.com/fibjs/fibjs/commit/ab407ce914)] - **sandbox, feat**: add 'Sandbox::modules' to get dict of modules installed in it. (#457)(Ray)
* [[`d59f2d3414`](https://github.com/fibjs/fibjs/commit/d59f2d3414)] - **util, feat**: add 'modules' into returnValue of  'util.buildInfo'. (#458)(Ray)
* [[`d1842dfdbd`](https://github.com/fibjs/fibjs/commit/d1842dfdbd)] - **sandbox, bugfix**: sync build info about ts_loader/custom_loader for windows (#456)(Ray)
* [[`8a1dc8cf33`](https://github.com/fibjs/fibjs/commit/8a1dc8cf33)] - **sandbox, feat**: passout callbackArgs in 'SandBox::CustomExtLoader::run' (#455)(Ray)
* [[`4ec046d4e4`](https://github.com/fibjs/fibjs/commit/4ec046d4e4)] - **sandbox, feat**: remove 'internal/typescript' module and related loader. (#454)(Ray)
* [[`9bb0435fa0`](https://github.com/fibjs/fibjs/commit/9bb0435fa0)] - **fs, bugfix**: crash in debug mode.(xicilion)
* [[`faf8198935`](https://github.com/fibjs/fibjs/commit/faf8198935)] - **vm, feat**: support Sandbox::registerExt, and enable it in rootModule's Sandbox. (#450)(Ray)
* [[`8aef38ed32`](https://github.com/fibjs/fibjs/commit/8aef38ed32)] - **fs, bugfix**: setZipFS not working on windows.(xicilion)
* [[`ac5a535b7d`](https://github.com/fibjs/fibjs/commit/ac5a535b7d)] - **Timer, feat**: support result_t in TimeoutScope::result.(xicilion)
* [[`d89e439f45`](https://github.com/fibjs/fibjs/commit/d89e439f45)] - **Timer, refactor**: use the TimeoutScope class to implement timeout.(xicilion)
* [[`70b6a8feab`](https://github.com/fibjs/fibjs/commit/70b6a8feab)] - **SandBox, feat**: support disable ext loader.(xicilion)
* [[`e54cf2e52e`](https://github.com/fibjs/fibjs/commit/e54cf2e52e)] - **fs, feat**: support file access switch.(xicilion)
* [[`6405bf7f59`](https://github.com/fibjs/fibjs/commit/6405bf7f59)] - **path, feat**: add `path.relative` which compats with nodejs. (#449)(Ray)
* [[`66f5f8d957`](https://github.com/fibjs/fibjs/commit/66f5f8d957)] - **fs, feat**: add test for 'require' when calling `zip.open`. (#448)(Ray)
* [[`4a18563fb7`](https://github.com/fibjs/fibjs/commit/4a18563fb7)] - **sandbox, feat**: define appname.(xicilion)
* [[`5cd28f6e5d`](https://github.com/fibjs/fibjs/commit/5cd28f6e5d)] - **timers, bugfix**: compile error on windows.(xicilion)
* [[`8b3835cde4`](https://github.com/fibjs/fibjs/commit/8b3835cde4)] - **util, feat**: support using vector array to init OptArg.(xicilion)
* [[`b6d44ff5e9`](https://github.com/fibjs/fibjs/commit/b6d44ff5e9)] - **test, feat**: add test case of timers.call.(xicilion)
* [[`973270c8e2`](https://github.com/fibjs/fibjs/commit/973270c8e2)] - **timers, feat**: support script timeout.(xicilion)
* [[`78a312a073`](https://github.com/fibjs/fibjs/commit/78a312a073)] - **utils, feat**: add error code CALL_E_TIMEOUT.(xicilion)
* [[`ec542b4109`](https://github.com/fibjs/fibjs/commit/ec542b4109)] - **timers, factor**: move JSTimer to Timer.h.(xicilion)
* [[`2d182cd223`](https://github.com/fibjs/fibjs/commit/2d182cd223)] - **build, feat**: fix ascii art.(xicilion)
* [[`39811342f6`](https://github.com/fibjs/fibjs/commit/39811342f6)] - **build, feat**: display message for successfully built.(xicilion)
* [[`7b72c34829`](https://github.com/fibjs/fibjs/commit/7b72c34829)] - **console, feat**: only allow console config in master worker.(xicilion)
* [[`ddc582ed21`](https://github.com/fibjs/fibjs/commit/ddc582ed21)] - **docs, feat**: collect modules.(xicilion)
* [[`5804005070`](https://github.com/fibjs/fibjs/commit/5804005070)] - **tools, feat**: reorder module list.(xicilion)
* [[`2e7e44fdc9`](https://github.com/fibjs/fibjs/commit/2e7e44fdc9)] - **sandbox, refactor**: remove script code cache.(xicilion)
* [[`4cd7e718d6`](https://github.com/fibjs/fibjs/commit/4cd7e718d6)] - **LruCache, feat**: not emit the expire event until the event callback function has changed.(xicilion)
* [[`a2d5f1782d`](https://github.com/fibjs/fibjs/commit/a2d5f1782d)] - **core, feat**: change the error prompt capitalization.(xicilion)
* [[`83ad511e9b`](https://github.com/fibjs/fibjs/commit/83ad511e9b)] - **core, bugfix**: name is 'undefined' in operator function.(xicilion)
* [[`b921417e0e`](https://github.com/fibjs/fibjs/commit/b921417e0e)] - **core, bugfix**: link error in debug mode on linux.(xicilion)
* [[`4916f30992`](https://github.com/fibjs/fibjs/commit/4916f30992)] - **SandBox, bugfix**: remove unused variable.(xicilion)
* [[`cd7faf1b07`](https://github.com/fibjs/fibjs/commit/cd7faf1b07)] - **HttpClient, bugfix**: compile warning in debug mode.(xicilion)
* [[`5d36247e31`](https://github.com/fibjs/fibjs/commit/5d36247e31)] - **Merge branch 'dev' of https**: //github.com/fibjs/fibjs into dev(xicilion)
* [[`70c117a692`](https://github.com/fibjs/fibjs/commit/70c117a692)] - **fs, feat**: support custom zip fs.(xicilion)
* [[`6a252e7351`](https://github.com/fibjs/fibjs/commit/6a252e7351)] - **timers, feat**: Compatible with Nodejs' setTimeout function, the parameter timeout can be undefined. (#446)(bengbengca)
* [[`7b1d7e2853`](https://github.com/fibjs/fibjs/commit/7b1d7e2853)] - **Digest, feat**: supports encoding. (#445)(bengbengca)
* [[`bd3a4b8d44`](https://github.com/fibjs/fibjs/commit/bd3a4b8d44)] - **SandBox, refactor**: rewrite some of ExtLoader.(xicilion)
* [[`03994507c9`](https://github.com/fibjs/fibjs/commit/03994507c9)] - **SandBox, refactor**: load json module by overloading run instead of run_module.(xicilion)
* [[`958a835b5d`](https://github.com/fibjs/fibjs/commit/958a835b5d)] - **http, refactor**: rewrite HttpUploadCollection with std::pair.(xicilion)
* [[`78cd60e5b4`](https://github.com/fibjs/fibjs/commit/78cd60e5b4)] - **http, refactor**: rewrite HttpCollection with std::pair.(xicilion)
* [[`16b20f129c`](https://github.com/fibjs/fibjs/commit/16b20f129c)] - **core, bugfix**: run microtask inside Fiber::scope.(xicilion)
* [[`986703fc48`](https://github.com/fibjs/fibjs/commit/986703fc48)] - **core, bugfix**: deadlock in some promise case.(xicilion)
* [[`d069cf7731`](https://github.com/fibjs/fibjs/commit/d069cf7731)] - add function convert uint64 to BigInt.(xicilion)
* [[`54f49bb7b0`](https://github.com/fibjs/fibjs/commit/54f49bb7b0)] - **console, feat**: support for overloaded log behavior of logger.(xicilion)
* [[`f19a2bfcab`](https://github.com/fibjs/fibjs/commit/f19a2bfcab)] - **console, refactor**: add addLogger function.(xicilion)
* [[`c56f754d37`](https://github.com/fibjs/fibjs/commit/c56f754d37)] - add 'has' method in SandBox Module. (#442)(tapir)
* [[`a8ad13614b`](https://github.com/fibjs/fibjs/commit/a8ad13614b)] - **zlib, feat**: reset dataSize when attaching to new stream.(xicilion)
* [[`502b087306`](https://github.com/fibjs/fibjs/commit/502b087306)] - **test, feat**: test for maxBodySize limit in the compressed body.(xicilion)
* [[`3d8c5e9c79`](https://github.com/fibjs/fibjs/commit/3d8c5e9c79)] - **v8, feat**: make snapshot data.(xicilion)
* [[`af14abd12b`](https://github.com/fibjs/fibjs/commit/af14abd12b)] - **zlib, feat**: supports maxSize when decompressing.(xicilion)
* [[`172c4ead9d`](https://github.com/fibjs/fibjs/commit/172c4ead9d)] - **sandbox, refactor**: add virtual custom resolve function.(xicilion)
* [[`637a9ef5d1`](https://github.com/fibjs/fibjs/commit/637a9ef5d1)] - **core, bugfix**: GLIBC dependency issues under Linux.(xicilion)
* [[`327b2d2da4`](https://github.com/fibjs/fibjs/commit/327b2d2da4)] - **v8, bugfix**: compile error on linux i386.(xicilion)
* [[`df941203f5`](https://github.com/fibjs/fibjs/commit/df941203f5)] - **v8, feat**: upgrade to 6.8.275.(xicilion)
* [[`1846a86dc0`](https://github.com/fibjs/fibjs/commit/1846a86dc0)] - **tools, bugfix**: fix lack of `member_props` in module, and fix TypeMap. (#440)(Ray)
* [[`ced78b5ac2`](https://github.com/fibjs/fibjs/commit/ced78b5ac2)] - **tools, feat**: add .github/PULL_REQUEST_TEMPLATE.md (#439)(Ray)
* [[`1adbf8dfb9`](https://github.com/fibjs/fibjs/commit/1adbf8dfb9)] - **http, feat**: support keep-alive in HttpClient.(xicilion)
* [[`d6b7d8a107`](https://github.com/fibjs/fibjs/commit/d6b7d8a107)] - **http, feat**: support http.STATUS_CODES.(xicilion)
* [[`e43fbf2c11`](https://github.com/fibjs/fibjs/commit/e43fbf2c11)] - **tools, bugfix**: [tsdeclare] fix expression of exported-statically class. (#438)(Ray)
* [[`8de2cfd0b8`](https://github.com/fibjs/fibjs/commit/8de2cfd0b8)] - **core, feat**: support for top-level await operators.(xicilion)
* [[`78ae3b135e`](https://github.com/fibjs/fibjs/commit/78ae3b135e)] - **module, feat**: add module aliases, tls -> ssl, https -> http.(xicilion)
* [[`3d7dc1dfe0`](https://github.com/fibjs/fibjs/commit/3d7dc1dfe0)] - **tools, bugfix**: remove unnecessary `import` statement on top of module declartion file. (#436)(Ray)
* [[`69b25bb8a5`](https://github.com/fibjs/fibjs/commit/69b25bb8a5)] - **tools, feat**: support multiple idl folders.(xicilion)

## 2018-06-11, Version v0.25.0
* **feature** :
    * console - add console.timeElapse() (#433)(gmxyb)
    * http - do not send Content-Length header in http request when body is empty.(xicilion)
    * sandbox:
      - upgrade typescript to 2.9.1 (#435)(Ray)
      - give default compilerOptions for internal typescript. (#425)(Ray)
      - add test cases for internal typescript. (#424)(Ray)
      - support typescript loader.(Ray)
    * tools:
      - normalize uglified internal class name. (#429)(Ray)
      - support generating *.d.ts by tools/tsdeclare.js based on idlc.js (#421)(Ray)

* **bugfix** :
    * core - compile warning on windows.(xicilion)
    * db - do not process the escape character '?' when the parameter is insufficient.(xicilion)
    * dns:
      - dns.resolve crash on Linux.(xicilion)
      - result error in dns.resolve and dns.lookup when host is unknown.(xicilion)
    * net - result error in net.resolve when host is unknown.(xicilion)
    * options - compile errors on Windows when embedding large script files.(xicilion)
    * os - os.userInfo().homedir include a terminal character.(xicilion)
    * sandbox:
      - [internal/typescript]set 'compilerOptions.module' as 'CommonJS', to make test/ts_test.ts valid. (#426)(Ray)
      - fix core dump when required ts in sub sandbox. (#422)(Ray)
      - high frequency require in new sandbox will fail.(xicilion)
      - application crashes when loading ts in an empty sandbox.(xicilion)
      - missing files in the vs project file.(xicilion)
    * tools:
      - correct exportance for reference to internal module in some module(such as encoding). (#434)(Ray)
      - fix lack of prop generation for internal class. (#432)(Ray)
      - [type.d.ts.txt]fix global members. (#430)(Ray)
      - correct exported static Class in some module(such as vm) (#428)(Ray)
      - correct tsdeclare.js, and correct geneartion of *.d.ts (#427)(Ray)

* **refactor** :
    * core:
      - separate fibjs library for reuse.(xicilion)
      - split the source code to simplify fibjs.cpp.(xicilion)
      - use static class to init module.(xicilion)
      - compress embed script module.(xicilion)
      - do not generate coverage report of non-absolute path files.(xicilion)

### Commits
* [[`312df05c58`](https://github.com/fibjs/fibjs/commit/312df05c58)] - **console, feat**: add console.timeElapse() (#433)(gmxyb)
* [[`27b5f17d5b`](https://github.com/fibjs/fibjs/commit/27b5f17d5b)] - **sandbox, feat**: upgrade typescript to 2.9.1 (#435)(Ray)
* [[`18b080f22b`](https://github.com/fibjs/fibjs/commit/18b080f22b)] - **tools, bugfix**: correct exportance for reference to internal module in some module(such as encoding). (#434)(Ray)
* [[`6cb8e61aa9`](https://github.com/fibjs/fibjs/commit/6cb8e61aa9)] - **tools, bugfix**: fix lack of prop generation for internal class. (#432)(Ray)
* [[`80c04a9015`](https://github.com/fibjs/fibjs/commit/80c04a9015)] - **tools, bugfix**: [type.d.ts.txt]fix global members. (#430)(Ray)
* [[`67024c4349`](https://github.com/fibjs/fibjs/commit/67024c4349)] - **tools, feat**: normalize uglified internal class name. (#429)(Ray)
* [[`652a0ac92c`](https://github.com/fibjs/fibjs/commit/652a0ac92c)] - **tools, bugfix**: correct exported static Class in some module(such as vm) (#428)(Ray)
* [[`d20292ab9c`](https://github.com/fibjs/fibjs/commit/d20292ab9c)] - **db, bugfix**: do not process the escape character '?' when the parameter is insufficient.(xicilion)
* [[`1975188359`](https://github.com/fibjs/fibjs/commit/1975188359)] - **http, feat**: do not send Content-Length header in http request when body is empty.(xicilion)
* [[`bf4c92ecd0`](https://github.com/fibjs/fibjs/commit/bf4c92ecd0)] - **tools, bugfix**: correct tsdeclare.js, and correct geneartion of *.d.ts (#427)(Ray)
* [[`4152310139`](https://github.com/fibjs/fibjs/commit/4152310139)] - **dns, bugfix**: dns.resolve crash on Linux.(xicilion)
* [[`85b3d19d2a`](https://github.com/fibjs/fibjs/commit/85b3d19d2a)] - **core, bugfix**: compile warning on windows.(xicilion)
* [[`4780cedb02`](https://github.com/fibjs/fibjs/commit/4780cedb02)] - **os, bugfix**: os.userInfo().homedir include a terminal character.(xicilion)
* [[`917fac2e2b`](https://github.com/fibjs/fibjs/commit/917fac2e2b)] - **net, bugfix**: result error in net.resolve when host is unknown.(xicilion)
* [[`0f37b624af`](https://github.com/fibjs/fibjs/commit/0f37b624af)] - **sandbox, bugfix**: [internal/typescript]set 'compilerOptions.module' as 'CommonJS', to make test/ts_test.ts valid. (#426)(Ray)
* [[`f1bb38002c`](https://github.com/fibjs/fibjs/commit/f1bb38002c)] - **dns, bugfix**: result error in dns.resolve and dns.lookup when host is unknown.(xicilion)
* [[`5c2dd77b42`](https://github.com/fibjs/fibjs/commit/5c2dd77b42)] - **sandbox, feat**: give default compilerOptions for internal typescript. (#425)(Ray)
* [[`29e3901637`](https://github.com/fibjs/fibjs/commit/29e3901637)] - **sandbox, feat**: add test cases for internal typescript. (#424)(Ray)
* [[`50555bebb9`](https://github.com/fibjs/fibjs/commit/50555bebb9)] - **tools, feat**: support generating *.d.ts by tools/tsdeclare.js based on idlc.js (#421)(Ray)
* [[`1ac350bcba`](https://github.com/fibjs/fibjs/commit/1ac350bcba)] - **sandbox, bugfix**: fix core dump when required ts in sub sandbox. (#422)(Ray)
* [[`545c9bed90`](https://github.com/fibjs/fibjs/commit/545c9bed90)] - **core, refactor**: separate fibjs library for reuse.(xicilion)
* [[`5111e70816`](https://github.com/fibjs/fibjs/commit/5111e70816)] - **sandbox, bugfix**: high frequency require in new sandbox will fail.(xicilion)
* [[`b23ef0f060`](https://github.com/fibjs/fibjs/commit/b23ef0f060)] - **sandbox, bugfix**: application crashes when loading ts in an empty sandbox.(xicilion)
* [[`4b138f8cc6`](https://github.com/fibjs/fibjs/commit/4b138f8cc6)] - **options, bugfix**: compile errors on Windows when embedding large script files.(xicilion)
* [[`73c9e2fc27`](https://github.com/fibjs/fibjs/commit/73c9e2fc27)] - **sandbox, bugfix**: missing files in the vs project file.(xicilion)
* [[`7b0f6e1331`](https://github.com/fibjs/fibjs/commit/7b0f6e1331)] - **sandbox, feat**: support typescript loader.(Ray)
* [[`aed8fd656a`](https://github.com/fibjs/fibjs/commit/aed8fd656a)] - **core, refactor**: split the source code to simplify fibjs.cpp.(xicilion)
* [[`e6058640c2`](https://github.com/fibjs/fibjs/commit/e6058640c2)] - **core, refactor**: use static class to init module.(xicilion)
* [[`f1a4589a11`](https://github.com/fibjs/fibjs/commit/f1a4589a11)] - **core, refactor**: compress embed script module.(xicilion)
* [[`47a5f79c6e`](https://github.com/fibjs/fibjs/commit/47a5f79c6e)] - **core, refactor**: do not generate coverage report of non-absolute path files.(xicilion)

## 2018-05-26, Version v0.24.0
* **feature** :
    * db:
      - add test case of trans result.(xicilion)
      - add multi-statements test case.(xicilion)
      - support multi-statements in mssql.(xicilion)
      - support multi-statements in sqlite.(xicilion)
      - support multi-statements in mysql.(xicilion)
      - add result to DbConnection.trans.(xicilion)
    * docs - add the --recursive option to the git command.(xicilion)
    * tools - adapt github's new authentication. (#416)(Ray)
    * util - support bigint in util.format.(xicilion)
    * v8 - upgrade to v6.7.288.20.(xicilion)

* **bugfix** :
    * core - fix string error.(xicilion)
    * db:
      - fix timeout error in sqlite.(xicilion)
      - compile warning in sqlite on windows.(xicilion)
      - fibjs crash when creating sqlite concurrently.(xicilion)
      - fix compile warning on linux in debug mode.(xicilion)
    * http:
      - crash when multipart form include a empty field.(xicilion)
      - fix capitalization of http header 'host'.(xicilion)
    * redis:
      - fix implement of `RedisSortedSet::add(OptArgs sms, int32_t& retVal)`. (#410)(Ray)
      - fix retVal computation in (#409)(Ray)
    * script - structural error in package.json generated by --init.(xicilion)
    * smtp - refactor source code of async connect, fix ssl connection errors.(xicilion)
    * ws - WebSocket object in the closure was incorrectly released.(xicilion)

* **refactor** :
    * core - move ValueHolder to fibjs domain.(xicilion)
    * db - Discard the unused version of execute.(xicilion)
    * gui - use the main thread to run the gui.(xicilion)

* **others** :
    * Merge branch 'master' into dev(xicilion)

### Commits
* [[`06bb4ee8dd`](https://github.com/fibjs/fibjs/commit/06bb4ee8dd)] - **script, bugfix**: structural error in package.json generated by --init.(xicilion)
* [[`f78492f4ea`](https://github.com/fibjs/fibjs/commit/f78492f4ea)] - **ws, bugfix**: WebSocket object in the closure was incorrectly released.(xicilion)
* [[`a3373d2462`](https://github.com/fibjs/fibjs/commit/a3373d2462)] - **core, refactor**: move ValueHolder to fibjs domain.(xicilion)
* [[`2722598b8b`](https://github.com/fibjs/fibjs/commit/2722598b8b)] - **db, feat**: add test case of trans result.(xicilion)
* [[`2de4206df4`](https://github.com/fibjs/fibjs/commit/2de4206df4)] - **db, bugfix**: fix timeout error in sqlite.(xicilion)
* [[`eddeca9896`](https://github.com/fibjs/fibjs/commit/eddeca9896)] - **db, feat**: add multi-statements test case.(xicilion)
* [[`e67c4857fa`](https://github.com/fibjs/fibjs/commit/e67c4857fa)] - **db, feat**: support multi-statements in mssql.(xicilion)
* [[`b0248329a6`](https://github.com/fibjs/fibjs/commit/b0248329a6)] - **db, bugfix**: compile warning in sqlite on windows.(xicilion)
* [[`a77c70d1c9`](https://github.com/fibjs/fibjs/commit/a77c70d1c9)] - **db, feat**: support multi-statements in sqlite.(xicilion)
* [[`c98878f7ed`](https://github.com/fibjs/fibjs/commit/c98878f7ed)] - **db, feat**: support multi-statements in mysql.(xicilion)
* [[`e665e1f772`](https://github.com/fibjs/fibjs/commit/e665e1f772)] - **db, bugfix**: fibjs crash when creating sqlite concurrently.(xicilion)
* [[`c6973ba110`](https://github.com/fibjs/fibjs/commit/c6973ba110)] - **db, feat**: add result to DbConnection.trans.(xicilion)
* [[`428064a078`](https://github.com/fibjs/fibjs/commit/428064a078)] - **db, bugfix**: fix compile warning on linux in debug mode.(xicilion)
* [[`e52d8fa4dd`](https://github.com/fibjs/fibjs/commit/e52d8fa4dd)] - **http, bugfix**: crash when multipart form include a empty field.(xicilion)
* [[`4c47e5659f`](https://github.com/fibjs/fibjs/commit/4c47e5659f)] - **http, bugfix**: fix capitalization of http header 'host'.(xicilion)
* [[`7dd3d90a15`](https://github.com/fibjs/fibjs/commit/7dd3d90a15)] - **tools, feat**: adapt github's new authentication. (#416)(Ray)
* [[`da53123a8d`](https://github.com/fibjs/fibjs/commit/da53123a8d)] - **util, feat**: support bigint in util.format.(xicilion)
* [[`c0fa624c82`](https://github.com/fibjs/fibjs/commit/c0fa624c82)] - **v8, feat**: upgrade to v6.7.288.20.(xicilion)
* [[`6a15dc5352`](https://github.com/fibjs/fibjs/commit/6a15dc5352)] - **docs, feat**: add the --recursive option to the git command.(xicilion)
* [[`87713e2211`](https://github.com/fibjs/fibjs/commit/87713e2211)] - **gui, refactor**: use the main thread to run the gui.(xicilion)
* [[`c33150e866`](https://github.com/fibjs/fibjs/commit/c33150e866)] - **redis, bugfix**: fix implement of `RedisSortedSet::add(OptArgs sms, int32_t& retVal)`. (#410)(Ray)
* [[`fd8e4b70d2`](https://github.com/fibjs/fibjs/commit/fd8e4b70d2)] - **db, refactor**: Discard the unused version of execute.(xicilion)
* [[`8d3866cfb0`](https://github.com/fibjs/fibjs/commit/8d3866cfb0)] - Merge branch 'master' into dev(xicilion)
* [[`1e1f5d8f9a`](https://github.com/fibjs/fibjs/commit/1e1f5d8f9a)] - **redis, bugfix**: fix retVal computation in (#409)(Ray)
* [[`1f87181354`](https://github.com/fibjs/fibjs/commit/1f87181354)] - **smtp, bugfix**: refactor source code of async connect, fix ssl connection errors.(xicilion)
* [[`aa1cf87685`](https://github.com/fibjs/fibjs/commit/aa1cf87685)] - **core, bugfix**: fix string error.(xicilion)

## 2018-04-11, Version v0.23.0
* **feature** :
    * core:
      - support use_thread mode.(xicilion)
      - disable parallel scavange.(xicilion)
    * mq:
      - save js value before switch to background worker.(xicilion)
      - Integrate js_invoke into the invoke.(xicilion)
    * sqlite - upgrade to v3.23.0(xicilion)
    * util - use CreateCodeCache to compile code.(xicilion)
    * v8 - upgrade to v6.7.192.(xicilion)
    * websocket - throw different error message.(xicilion)

* **bugfix** :
    * core:
      - disable concurrent marking to fix v8 deadlock in gc.(xicilion)
      - compile warning in debug mode.(xicilion)
    * coroutine - crash when querying the stack of dead fiber.(xicilion)
    * json - crash when json.encode circular structure.(xicilion)
    * sandbox - jsc loader crash when load error.(xicilion)

* **refactor** :
    * mq:
      - not switch fiber when invoke js handler in Chain.(xicilion)
      - Integrate invoke into the Chain.(xicilion)

### Commits
* [[`305adbac3e`](https://github.com/fibjs/fibjs/commit/305adbac3e)] - **core, bugfix**: disable concurrent marking to fix v8 deadlock in gc.(xicilion)
* [[`aaffa6095b`](https://github.com/fibjs/fibjs/commit/aaffa6095b)] - **mq, feat**: save js value before switch to background worker.(xicilion)
* [[`2d9b747482`](https://github.com/fibjs/fibjs/commit/2d9b747482)] - **mq, refactor**: not switch fiber when invoke js handler in Chain.(xicilion)
* [[`908656e964`](https://github.com/fibjs/fibjs/commit/908656e964)] - **coroutine, bugfix**: crash when querying the stack of dead fiber.(xicilion)
* [[`eec7f12ceb`](https://github.com/fibjs/fibjs/commit/eec7f12ceb)] - **mq, refactor**: Integrate invoke into the Chain.(xicilion)
* [[`e85831e980`](https://github.com/fibjs/fibjs/commit/e85831e980)] - **mq, feat**: Integrate js_invoke into the invoke.(xicilion)
* [[`62b6581e97`](https://github.com/fibjs/fibjs/commit/62b6581e97)] - **core, feat**: support use_thread mode.(xicilion)
* [[`24de807386`](https://github.com/fibjs/fibjs/commit/24de807386)] - **sqlite, feat**: upgrade to v3.23.0(xicilion)
* [[`23273aa91c`](https://github.com/fibjs/fibjs/commit/23273aa91c)] - **v8, feat**: upgrade to v6.7.192.(xicilion)
* [[`b9a80d2838`](https://github.com/fibjs/fibjs/commit/b9a80d2838)] - **sandbox, bugfix**: jsc loader crash when load error.(xicilion)
* [[`43d92facd1`](https://github.com/fibjs/fibjs/commit/43d92facd1)] - **util, feat**: use CreateCodeCache to compile code.(xicilion)
* [[`36197f785f`](https://github.com/fibjs/fibjs/commit/36197f785f)] - **json, bugfix**: crash when json.encode circular structure.(xicilion)
* [[`276ce295c8`](https://github.com/fibjs/fibjs/commit/276ce295c8)] - **core, bugfix**: compile warning in debug mode.(xicilion)
* [[`8d9656cc86`](https://github.com/fibjs/fibjs/commit/8d9656cc86)] - **core, feat**: disable parallel scavange.(xicilion)
* [[`28cfb8c27c`](https://github.com/fibjs/fibjs/commit/28cfb8c27c)] - **websocket, feat**: throw different error message.(xicilion)

## 2018-02-06, Version v0.22.0
* **feature** :
    * Buffer - support Buffer.join method.(xicilion)
    * core:
      - upgrade to new v8 api.(xicilion)
      - support require.main.(xicilion)
    * dgram:
      - implement method setBroadcast.(xicilion)
      - method send return data size.(xicilion)
      - add documents for dgram module.(xicilion)
      - add argument to event 'error'.(xicilion)
      - add dgram test case into main.js.(xicilion)
      - add test case for dgram.(xicilion)
      - implement send and message.(xicilion)
      - add dgram module and DgramSocket object.(xicilion)
    * dns - add dns.lookup.(xicilion)
    * module - not check param count in require.(xicilion)
    * option - simple package install tool.(xicilion)
    * options:
      - enable parallel scavenge.(xicilion)
      - support install package.(xicilion)
      - add init script.(xicilion)
      - generate embed scripts.(xicilion)
      - retry download when http error.(xicilion)
    * sqlite - change default synchronous mode to full.(xicilion)
    * timers:
      - allow null in clearTimeout.(xicilion)
      - support ref/unref in Timer object.(xicilion)
    * v8 - upgrade to v6.6.155.(xicilion)
    * ws - support ref/unref.(xicilion)
    * zlib - end inflate stream when data error.(xicilion)

* **bugfix** :
    * Buffer:
      - crash when Buffer.concat([])(xicilion)
      - new Buffer error when TypedArray offset is not zero.(xicilion)
    * dgram:
      - send error when addr is empty on windows.(xicilion)
      - test error on linux.(xicilion)
      - compile error on windows.(xicilion)
    * http - crash when HttpResponse.statusCode is too large.(xicilion)
    * option:
      - data error on some tgz file.(xicilion)
      - download error when '/' in package name.(xicilion)
    * options:
      - init error when package.json is not exists.(xicilion)
      - zero size file is not extracted.(xicilion)
    * path - compile warning in debug mode.(xicilion)
    * process - compile warning in debug mode.(xicilion)
    * stream - fix buffer type check.(xicilion)
    * util - app crash when clone a Map.(xicilion)

### Commits
* [[`be4e3b122f`](https://github.com/fibjs/fibjs/commit/be4e3b122f)] - **options, feat**: enable parallel scavenge.(xicilion)
* [[`a4ff03be02`](https://github.com/fibjs/fibjs/commit/a4ff03be02)] - **v8, feat**: upgrade to v6.6.155.(xicilion)
* [[`551bcfb693`](https://github.com/fibjs/fibjs/commit/551bcfb693)] - **util, bugfix**: app crash when clone a Map.(xicilion)
* [[`7d9222fbb0`](https://github.com/fibjs/fibjs/commit/7d9222fbb0)] - **core, feat**: upgrade to new v8 api.(xicilion)
* [[`3f12dfe7b6`](https://github.com/fibjs/fibjs/commit/3f12dfe7b6)] - **stream, bugfix**: fix buffer type check.(xicilion)
* [[`44a3e84013`](https://github.com/fibjs/fibjs/commit/44a3e84013)] - **ws, feat**: support ref/unref.(xicilion)
* [[`ff341edc49`](https://github.com/fibjs/fibjs/commit/ff341edc49)] - **dgram, feat**: implement method setBroadcast.(xicilion)
* [[`6f0ee079ae`](https://github.com/fibjs/fibjs/commit/6f0ee079ae)] - **module, feat**: not check param count in require.(xicilion)
* [[`a17b1835d5`](https://github.com/fibjs/fibjs/commit/a17b1835d5)] - **options, bugfix**: init error when package.json is not exists.(xicilion)
* [[`b9d53e2c08`](https://github.com/fibjs/fibjs/commit/b9d53e2c08)] - **dgram, feat**: method send return data size.(xicilion)
* [[`469d0d0e7c`](https://github.com/fibjs/fibjs/commit/469d0d0e7c)] - **core, feat**: support require.main.(xicilion)
* [[`44287c8558`](https://github.com/fibjs/fibjs/commit/44287c8558)] - **options, feat**: support install package.(xicilion)
* [[`a75a1b98d8`](https://github.com/fibjs/fibjs/commit/a75a1b98d8)] - **options, feat**: add init script.(xicilion)
* [[`4395512533`](https://github.com/fibjs/fibjs/commit/4395512533)] - **options, feat**: generate embed scripts.(xicilion)
* [[`416b7e1137`](https://github.com/fibjs/fibjs/commit/416b7e1137)] - **options, feat**: retry download when http error.(xicilion)
* [[`3e1bd98609`](https://github.com/fibjs/fibjs/commit/3e1bd98609)] - **options, bugfix**: zero size file is not extracted.(xicilion)
* [[`4625da4cbe`](https://github.com/fibjs/fibjs/commit/4625da4cbe)] - **dgram, feat**: add documents for dgram module.(xicilion)
* [[`1c81e1d84c`](https://github.com/fibjs/fibjs/commit/1c81e1d84c)] - **sqlite, feat**: change default synchronous mode to full.(xicilion)
* [[`ce138af65d`](https://github.com/fibjs/fibjs/commit/ce138af65d)] - **timers, feat**: allow null in clearTimeout.(xicilion)
* [[`781ab7427f`](https://github.com/fibjs/fibjs/commit/781ab7427f)] - **dgram, feat**: add argument to event 'error'.(xicilion)
* [[`ffc6cc69e3`](https://github.com/fibjs/fibjs/commit/ffc6cc69e3)] - **dgram, bugfix**: send error when addr is empty on windows.(xicilion)
* [[`8203c574b9`](https://github.com/fibjs/fibjs/commit/8203c574b9)] - **Buffer, feat**: support Buffer.join method.(xicilion)
* [[`d5e4bf1cb8`](https://github.com/fibjs/fibjs/commit/d5e4bf1cb8)] - **Buffer, bugfix**: crash when Buffer.concat([])(xicilion)
* [[`962c505310`](https://github.com/fibjs/fibjs/commit/962c505310)] - **dgram, bugfix**: test error on linux.(xicilion)
* [[`47abe8b7f6`](https://github.com/fibjs/fibjs/commit/47abe8b7f6)] - **dgram, feat**: add dgram test case into main.js.(xicilion)
* [[`4701be824b`](https://github.com/fibjs/fibjs/commit/4701be824b)] - **dgram, feat**: add test case for dgram.(xicilion)
* [[`dfd063c4ea`](https://github.com/fibjs/fibjs/commit/dfd063c4ea)] - **dgram, bugfix**: compile error on windows.(xicilion)
* [[`e4eb495b37`](https://github.com/fibjs/fibjs/commit/e4eb495b37)] - **dns, feat**: add dns.lookup.(xicilion)
* [[`8d54dd1aaa`](https://github.com/fibjs/fibjs/commit/8d54dd1aaa)] - **dgram, feat**: implement send and message.(xicilion)
* [[`1ae403550d`](https://github.com/fibjs/fibjs/commit/1ae403550d)] - **dgram, feat**: add dgram module and DgramSocket object.(xicilion)
* [[`45fcbb3bb3`](https://github.com/fibjs/fibjs/commit/45fcbb3bb3)] - **http, bugfix**: crash when HttpResponse.statusCode is too large.(xicilion)
* [[`868e455f2b`](https://github.com/fibjs/fibjs/commit/868e455f2b)] - **process, bugfix**: compile warning in debug mode.(xicilion)
* [[`20cf8c4f00`](https://github.com/fibjs/fibjs/commit/20cf8c4f00)] - **path, bugfix**: compile warning in debug mode.(xicilion)
* [[`64317ed84b`](https://github.com/fibjs/fibjs/commit/64317ed84b)] - **option, bugfix**: data error on some tgz file.(xicilion)
* [[`50a2673da0`](https://github.com/fibjs/fibjs/commit/50a2673da0)] - **zlib, feat**: end inflate stream when data error.(xicilion)
* [[`f3cedc796d`](https://github.com/fibjs/fibjs/commit/f3cedc796d)] - **option, bugfix**: download error when '/' in package name.(xicilion)
* [[`41db91f502`](https://github.com/fibjs/fibjs/commit/41db91f502)] - **option, feat**: simple package install tool.(xicilion)
* [[`7e046495d7`](https://github.com/fibjs/fibjs/commit/7e046495d7)] - **Buffer, bugfix**: new Buffer error when TypedArray offset is not zero.(xicilion)
* [[`94211628ec`](https://github.com/fibjs/fibjs/commit/94211628ec)] - **timers, feat**: support ref/unref in Timer object.(xicilion)

## 2017-12-28, Version v0.21.0
* **feature** :
    * core - disable code coverage for embed script module.(xicilion)
    * coroutine - use hrtime to implement sleep.(xicilion)
    * crypto - update root ca.(xicilion)
    * dns - add module dns, support dns.resolve.(xicilion)
    * expat - upgrade to v2.2.5(xicilion)
    * git - commit .jsc file as binary file.(xicilion)
    * repl - add 'Thown:' prefix in repl (#385)(Hengfei Zhuang)
    * stream - port script module stream from node.(xicilion)
    * util:
      - output Error object friendly.(xicilion)
      - support custom Promise object in util.syn.(xicilion)
    * v8:
      - upgrade to v6.5.108.(xicilion)
      - upgrade to v6.5.26.(xicilion)

* **bugfix** :
    * core:
      - refactor object manager, fix runtime error in debug mode.(xicilion)
      - fix compile waring in debug mode.(xicilion)
    * db - deadlock when multi fiber access in db.trans.(xicilion)
    * dns - fix ipv6 address error.(xicilion)
    * exlib - fix sleep time error.(xicilion)
    * test - compile new amd64 jsc test file.(xicilion)
    * v8:
      - fix compile error in debug mode on windows.(xicilion)
      - fix compile warning on windows.(xicilion)

* **refactor** :
    * core - move opt_tools script to sub folder.(xicilion)
    * mq - remove unused code.(xicilion)

* **others** :
    * change memcpy to memmove (#391)(zywww)
    * Merge branch 'master' into dev(xicilion)

### Commits
* [[`2e6be70555`](https://github.com/fibjs/fibjs/commit/2e6be70555)] - **v8, bugfix**: fix compile error in debug mode on windows.(xicilion)
* [[`2a1d13f2c4`](https://github.com/fibjs/fibjs/commit/2a1d13f2c4)] - **v8, feat**: upgrade to v6.5.108.(xicilion)
* [[`19763e6253`](https://github.com/fibjs/fibjs/commit/19763e6253)] - **dns, bugfix**: fix ipv6 address error.(xicilion)
* [[`02992c421b`](https://github.com/fibjs/fibjs/commit/02992c421b)] - **expat, feat**: upgrade to v2.2.5(xicilion)
* [[`4523884506`](https://github.com/fibjs/fibjs/commit/4523884506)] - **core, bugfix**: refactor object manager, fix runtime error in debug mode.(xicilion)
* [[`6de34423b4`](https://github.com/fibjs/fibjs/commit/6de34423b4)] - **mq, refactor**: remove unused code.(xicilion)
* [[`5b071a3987`](https://github.com/fibjs/fibjs/commit/5b071a3987)] - change memcpy to memmove (#391)(zywww)
* [[`5b694853b0`](https://github.com/fibjs/fibjs/commit/5b694853b0)] - **core, bugfix**: fix compile waring in debug mode.(xicilion)
* [[`3a8ba731d7`](https://github.com/fibjs/fibjs/commit/3a8ba731d7)] - **test, bugfix**: compile new amd64 jsc test file.(xicilion)
* [[`5d2d96baac`](https://github.com/fibjs/fibjs/commit/5d2d96baac)] - **git, feat**: commit .jsc file as binary file.(xicilion)
* [[`1288a3d8ed`](https://github.com/fibjs/fibjs/commit/1288a3d8ed)] - **crypto, feat**: update root ca.(xicilion)
* [[`97e25de6a3`](https://github.com/fibjs/fibjs/commit/97e25de6a3)] - **exlib, bugfix**: fix sleep time error.(xicilion)
* [[`6a105104b4`](https://github.com/fibjs/fibjs/commit/6a105104b4)] - **core, refactor**: move opt_tools script to sub folder.(xicilion)
* [[`4ded2bd6ca`](https://github.com/fibjs/fibjs/commit/4ded2bd6ca)] - **coroutine, feat**: use hrtime to implement sleep.(xicilion)
* [[`9abe80fe9d`](https://github.com/fibjs/fibjs/commit/9abe80fe9d)] - **core, feat**: disable code coverage for embed script module.(xicilion)
* [[`2e6e961dbb`](https://github.com/fibjs/fibjs/commit/2e6e961dbb)] - **util, feat**: output Error object friendly.(xicilion)
* [[`52b984cb66`](https://github.com/fibjs/fibjs/commit/52b984cb66)] - **dns, feat**: add module dns, support dns.resolve.(xicilion)
* [[`b85cc934d6`](https://github.com/fibjs/fibjs/commit/b85cc934d6)] - **stream, feat**: port script module stream from node.(xicilion)
* [[`29f5cb6fe4`](https://github.com/fibjs/fibjs/commit/29f5cb6fe4)] - **util, feat**: support custom Promise object in util.syn.(xicilion)
* [[`0c97518e05`](https://github.com/fibjs/fibjs/commit/0c97518e05)] - **v8, bugfix**: fix compile warning on windows.(xicilion)
* [[`782bd434fe`](https://github.com/fibjs/fibjs/commit/782bd434fe)] - **v8, feat**: upgrade to v6.5.26.(xicilion)
* [[`68a1cb5bc4`](https://github.com/fibjs/fibjs/commit/68a1cb5bc4)] - **db, bugfix**: deadlock when multi fiber access in db.trans.(xicilion)
* [[`4394b5e029`](https://github.com/fibjs/fibjs/commit/4394b5e029)] - Merge branch 'master' into dev(xicilion)
* [[`33f3c01fc4`](https://github.com/fibjs/fibjs/commit/33f3c01fc4)] - **repl, feat**: add 'Thown:' prefix in repl (#385)(Hengfei Zhuang)

## 2017-12-03, Version v0.20.0
* **feature** :
    * constants - support constants module.(xicilion)
    * coroutine - hold the process while at least one worker is working.(xicilion)
    * crypto - PKey constructor support parameters.(xicilion)
    * db:
      - support multi level array in db.format.(xicilion)
      - enable chinese fulltext search in SQLite.(xicilion)
    * event - support any type of custom field in EventInfo.(xicilion)
    * LruCache - support expire event.(xicilion)
    * mbedtls - upgrade to v2.6.1.(xicilion)
    * sandbox - support exports in main script.(xicilion)
    * test - add LruCache lock test.(xicilion)
    * tool - upgrade awesome sync tool.(xicilion)
    * v8:
      - update vender version.(xicilion)
      - upgrade v8 to v6.4.365.(xicilion)
      - upgrade to v6.4.309.(xicilion)
    * websocket - hold the process while websocket is not disconnected.(xicilion)

* **bugfix** :
    * core:
      - fix compile waring on windows.(xicilion)
      - fix compile error on windows.(xicilion)
    * LruCache - object locked in updater callback.(xicilion)
    * v8 - disable parallel_marking, fix crash in snapshot creator.(xicilion)

* **refactor** :
    * core:
      - uniform the two constructor of AsyncCallback.(xicilion)
      - support ref/unref in isolate, refactor the logic of holding process.(xicilion)
      - format JavaScript code.(xicilion)
    * mq - move Message.response to HttpRequest.response.(xicilion)

### Commits
* [[`a9a78dd7a6`](https://github.com/fibjs/fibjs/commit/a9a78dd7a6)] - **mq, refactor**: move Message.response to HttpRequest.response.(xicilion)
* [[`46dd85fec2`](https://github.com/fibjs/fibjs/commit/46dd85fec2)] - **LruCache, feat**: support expire event.(xicilion)
* [[`205cef37b7`](https://github.com/fibjs/fibjs/commit/205cef37b7)] - **event, feat**: support any type of custom field in EventInfo.(xicilion)
* [[`f2b6e1fe05`](https://github.com/fibjs/fibjs/commit/f2b6e1fe05)] - **test, feat**: add LruCache lock test.(xicilion)
* [[`8376932226`](https://github.com/fibjs/fibjs/commit/8376932226)] - **LruCache, bugfix**: object locked in updater callback.(xicilion)
* [[`66a518641b`](https://github.com/fibjs/fibjs/commit/66a518641b)] - **mbedtls, feat**: upgrade to v2.6.1.(xicilion)
* [[`d59b73839f`](https://github.com/fibjs/fibjs/commit/d59b73839f)] - **tool, feat**: upgrade awesome sync tool.(xicilion)
* [[`ac25be15bd`](https://github.com/fibjs/fibjs/commit/ac25be15bd)] - **core, bugfix**: fix compile waring on windows.(xicilion)
* [[`f6caafc9d4`](https://github.com/fibjs/fibjs/commit/f6caafc9d4)] - **core, bugfix**: fix compile error on windows.(xicilion)
* [[`5ac83f7b29`](https://github.com/fibjs/fibjs/commit/5ac83f7b29)] - **db, feat**: support multi level array in db.format.(xicilion)
* [[`e20a32ea10`](https://github.com/fibjs/fibjs/commit/e20a32ea10)] - **coroutine, feat**: hold the process while at least one worker is working.(xicilion)
* [[`38bdf89608`](https://github.com/fibjs/fibjs/commit/38bdf89608)] - **websocket, feat**: hold the process while websocket is not disconnected.(xicilion)
* [[`c73b24caaf`](https://github.com/fibjs/fibjs/commit/c73b24caaf)] - **core, refactor**: uniform the two constructor of AsyncCallback.(xicilion)
* [[`ff75686678`](https://github.com/fibjs/fibjs/commit/ff75686678)] - **core, refactor**: support ref/unref in isolate, refactor the logic of holding process.(xicilion)
* [[`b617bb877a`](https://github.com/fibjs/fibjs/commit/b617bb877a)] - **sandbox, feat**: support exports in main script.(xicilion)
* [[`9a240973b8`](https://github.com/fibjs/fibjs/commit/9a240973b8)] - **db, feat**: enable chinese fulltext search in SQLite.(xicilion)
* [[`7886dc4bac`](https://github.com/fibjs/fibjs/commit/7886dc4bac)] - **v8, bugfix**: disable parallel_marking, fix crash in snapshot creator.(xicilion)
* [[`62ca518a70`](https://github.com/fibjs/fibjs/commit/62ca518a70)] - **v8, feat**: update vender version.(xicilion)
* [[`aa2d8bbe86`](https://github.com/fibjs/fibjs/commit/aa2d8bbe86)] - **v8, feat**: upgrade v8 to v6.4.365.(xicilion)
* [[`8f0bc1f271`](https://github.com/fibjs/fibjs/commit/8f0bc1f271)] - **core, refactor**: format JavaScript code.(xicilion)
* [[`3f895d267b`](https://github.com/fibjs/fibjs/commit/3f895d267b)] - **v8, feat**: upgrade to v6.4.309.(xicilion)
* [[`076830eaa1`](https://github.com/fibjs/fibjs/commit/076830eaa1)] - **crypto, feat**: PKey constructor support parameters.(xicilion)
* [[`575deddaac`](https://github.com/fibjs/fibjs/commit/575deddaac)] - **constants, feat**: support constants module.(xicilion)

## 2017-11-15, Version v0.19.0
* **feature** :
    * build - update task.json to version 2.0.(xicilion)
    * core:
      - add full error type support (#381)(Hengfei Zhuang)
      - disable bigobj compile option on windows.(xicilion)
    * db - switch mysql to fiber worker.(xicilion)
    * path:
      - add path.toNamespacedPath  (#375)(Hengfei Zhuang)
      - add relative test case (not use).(xicilion)
      - add zero test case.(xicilion)
    * process:
      - use RegisterWaitForSingleObject to wait child process in real async mode on windows.(xicilion)
      - use ev to wait child process in real async mode.(xicilion)
      - only check exit code on linux.(xicilion)
    * repl - add all the builtin modules to the repl global (#377)(Hengfei Zhuang)

* **bugfix** :
    * core:
      - compile error on windows.(xicilion)
      - use posix_spawnp to check glibc_2.2, fix compile on i386.(xicilion)
      - use check_c_source_compiles to check glibc_2.2.5, fix alpine compile error.(xicilion)
    * fs - fix fs stat when path endsWith slash (#371)(Hengfei Zhuang)
    * gui - fix the gui testcase (#379)(Hengfei Zhuang)
    * http - parallel request in HttpClient will crash when response cookies.(xicilion)
    * path:
      - fix test case error on windows.(xicilion)
      - keep the disk no of the last path.(xicilion)
    * process:
      - SubProcess.wait return wrong status some times on linux.(xicilion)
      - process.wait not return while process is already exit.(xicilion)
      - compile error on windows i386.(xicilion)
      - process.run not throw error when exec file not exists on linux.(xicilion)
    * unzip - fix isZipFile error if filename is in unicode (#373)(王爱科)

* **refactor** :
    * core:
      - ThrowAssertionError use reference to avoid copy (#383)(Hengfei Zhuang)
      - more powerful error system (#378)(Hengfei Zhuang)
      - Refactor the asyncEv class.(xicilion)
    * net - remove no use argument in function AsyncIO::close.(xicilion)
    * path:
      - rewrite path.isAbsolute, more compatible with node.js(xicilion)
      - rewrite path.basename/extname/dirname, more compatible with node.js(xicilion)
      - rewrite path.resolve, more compatible with node.js (#374)(Hengfei Zhuang)
      - rewrite path.resolve, more compatible with node.js(xicilion)
      - rewrite path.join, more compatible with node.js(xicilion)
      - rewrite path.normalize, more compatible with node.js(xicilion)
    * process - use AsyncIO.close to close process pipe.(xicilion)
    * util - make inherits more compact with node.js (#380)(Hengfei Zhuang)

* **test** :
    * path - adjust path.basename test case (#376)(Hengfei Zhuang)

### Commits
* [[`7f5b2482fc`](https://github.com/fibjs/fibjs/commit/7f5b2482fc)] - Release v0.19.0(xicilion)
* [[`1aa840c663`](https://github.com/fibjs/fibjs/commit/1aa840c663)] - **process, bugfix**: SubProcess.wait return wrong status some times on linux.(xicilion)
* [[`3f19c1fac3`](https://github.com/fibjs/fibjs/commit/3f19c1fac3)] - **core, refactor**: ThrowAssertionError use reference to avoid copy (#383)(Hengfei Zhuang)
* [[`dbe3c74ebd`](https://github.com/fibjs/fibjs/commit/dbe3c74ebd)] - **core, feat**: add full error type support (#381)(Hengfei Zhuang)
* [[`89454b908a`](https://github.com/fibjs/fibjs/commit/89454b908a)] - **process, bugfix**: process.wait not return while process is already exit.(xicilion)
* [[`197375424c`](https://github.com/fibjs/fibjs/commit/197375424c)] - **util, refactor**: make inherits more compact with node.js (#380)(Hengfei Zhuang)
* [[`7b200e800e`](https://github.com/fibjs/fibjs/commit/7b200e800e)] - **gui, bugfix**: fix the gui testcase (#379)(Hengfei Zhuang)
* [[`b41dfd973e`](https://github.com/fibjs/fibjs/commit/b41dfd973e)] - **core, refactor**: more powerful error system (#378)(Hengfei Zhuang)
* [[`f5d12cdcfc`](https://github.com/fibjs/fibjs/commit/f5d12cdcfc)] - **build, feat**: update task.json to version 2.0.(xicilion)
* [[`4f7959a4af`](https://github.com/fibjs/fibjs/commit/4f7959a4af)] - **repl, feat**: add all the builtin modules to the repl global (#377)(Hengfei Zhuang)
* [[`c630e3b2b1`](https://github.com/fibjs/fibjs/commit/c630e3b2b1)] - **process, bugfix**: compile error on windows i386.(xicilion)
* [[`5f33537c67`](https://github.com/fibjs/fibjs/commit/5f33537c67)] - **db, feat**: switch mysql to fiber worker.(xicilion)
* [[`d89d4d96d6`](https://github.com/fibjs/fibjs/commit/d89d4d96d6)] - **process, feat**: use RegisterWaitForSingleObject to wait child process in real async mode on windows.(xicilion)
* [[`e71a1bf382`](https://github.com/fibjs/fibjs/commit/e71a1bf382)] - **net, refactor**: remove no use argument in function AsyncIO::close.(xicilion)
* [[`2dbe78cd29`](https://github.com/fibjs/fibjs/commit/2dbe78cd29)] - **process, feat**: use ev to wait child process in real async mode.(xicilion)
* [[`a4659645de`](https://github.com/fibjs/fibjs/commit/a4659645de)] - **core, refactor**: Refactor the asyncEv class.(xicilion)
* [[`b82e545c1c`](https://github.com/fibjs/fibjs/commit/b82e545c1c)] - **http, bugfix**: parallel request in HttpClient will crash when response cookies.(xicilion)
* [[`910b473727`](https://github.com/fibjs/fibjs/commit/910b473727)] - **process, refactor**: use AsyncIO.close to close process pipe.(xicilion)
* [[`8bff4df01c`](https://github.com/fibjs/fibjs/commit/8bff4df01c)] - **process, feat**: only check exit code on linux.(xicilion)
* [[`261ddfee1a`](https://github.com/fibjs/fibjs/commit/261ddfee1a)] - **process, bugfix**: process.run not throw error when exec file not exists on linux.(xicilion)
* [[`cb0ef916ba`](https://github.com/fibjs/fibjs/commit/cb0ef916ba)] - **core, bugfix**: compile error on windows.(xicilion)
* [[`ce343b409e`](https://github.com/fibjs/fibjs/commit/ce343b409e)] - **core, bugfix**: use posix_spawnp to check glibc_2.2, fix compile on i386.(xicilion)
* [[`c301b9085c`](https://github.com/fibjs/fibjs/commit/c301b9085c)] - **core, bugfix**: use check_c_source_compiles to check glibc_2.2.5, fix alpine compile error.(xicilion)
* [[`ad39cae7c9`](https://github.com/fibjs/fibjs/commit/ad39cae7c9)] - **path, test**: adjust path.basename test case (#376)(Hengfei Zhuang)
* [[`2bdd279eae`](https://github.com/fibjs/fibjs/commit/2bdd279eae)] - **fs, bugfix**: fix fs stat when path endsWith slash (#371)(Hengfei Zhuang)
* [[`e067af4a17`](https://github.com/fibjs/fibjs/commit/e067af4a17)] - **path, feat**: add path.toNamespacedPath  (#375)(Hengfei Zhuang)
* [[`fc7b7b974b`](https://github.com/fibjs/fibjs/commit/fc7b7b974b)] - **path, feat**: add relative test case (not use).(xicilion)
* [[`e5bb49aa20`](https://github.com/fibjs/fibjs/commit/e5bb49aa20)] - **unzip, bugfix**: fix isZipFile error if filename is in unicode (#373)(王爱科)
* [[`0f4adf5519`](https://github.com/fibjs/fibjs/commit/0f4adf5519)] - **path, bugfix**: fix test case error on windows.(xicilion)
* [[`c3ba036c2f`](https://github.com/fibjs/fibjs/commit/c3ba036c2f)] - **path, refactor**: rewrite path.isAbsolute, more compatible with node.js(xicilion)
* [[`780ba6be1e`](https://github.com/fibjs/fibjs/commit/780ba6be1e)] - **path, feat**: add zero test case.(xicilion)
* [[`eee418d9f4`](https://github.com/fibjs/fibjs/commit/eee418d9f4)] - **path, refactor**: rewrite path.basename/extname/dirname, more compatible with node.js(xicilion)
* [[`bf6a56159b`](https://github.com/fibjs/fibjs/commit/bf6a56159b)] - **path, refactor**: rewrite path.resolve, more compatible with node.js (#374)(Hengfei Zhuang)
* [[`402f7727d1`](https://github.com/fibjs/fibjs/commit/402f7727d1)] - **path, bugfix**: keep the disk no of the last path.(xicilion)
* [[`ddd6eaa1dd`](https://github.com/fibjs/fibjs/commit/ddd6eaa1dd)] - **path, refactor**: rewrite path.resolve, more compatible with node.js(xicilion)
* [[`4afd2903a2`](https://github.com/fibjs/fibjs/commit/4afd2903a2)] - **path, refactor**: rewrite path.join, more compatible with node.js(xicilion)
* [[`6c7aaa7c8c`](https://github.com/fibjs/fibjs/commit/6c7aaa7c8c)] - **path, refactor**: rewrite path.normalize, more compatible with node.js(xicilion)
* [[`887ac99e4b`](https://github.com/fibjs/fibjs/commit/887ac99e4b)] - **core, feat**: disable bigobj compile option on windows.(xicilion)

## 2017-11-3, Version v0.18.0

* **feature** :
    * core:
      - support --cov=filename to specify the cov filename (#368)(Hengfei Zhuang)
      - support --cov-process tool to generate code coverage analysis report.(xicilion)
      - support collecting code coverage information.(xicilion)
      - support v8 code coverage.(xicilion)
      - support OnEventEmit in Trigger.(xicilion)
    * http - check option items, throw unknown option.(xicilion)
    * process:
      - add test case of kill.(xicilion)
      - process.exit support return 0;(xicilion)
    * v8 - upgrade to 6.4.185.(xicilion)
    * websocket:
      - add come documents.(xicilion)
      - change readyState to CLOSED in js thread.(xicilion)
      - close a closed socket not throw error.(xicilion)
      - ws.upgrade add req as the second argument in callback.(xicilion)

* **breakchange** :
    * collection:
      - deprecated collection module and Map object.(xicilion)
      - deprecated  Queue.(xicilion)
      - deprecated List object.(xicilion)
    * console - deprecated TextColor object.(xicilion)
    * core - deprecated object.dispose(xicilion)
    * coroutine - deprecated BlockedQueue.(xicilion)
    * http - deprecated http.find.(xicilion)
    * mongodb - deprecated GridFS.(xicilion)
    * mq - deprecated mq.await.(xicilion)
    * websocket - deprecated ws.connect.(xicilion)
    * zip - deprecated ZipInfo object.(xicilion)

* **bugfix** :
    * assert - compile error on Linux.(xicilion)
    * core:
      - closesocket before canceling io operation.(xicilion)
      - ensure the coverage report could be generated successfully. (#369)(Hengfei Zhuang)
      - ensure the coverage report could be generated successfully. (#369)(Hengfei Zhuang)
      - compile error on Linux and windows.(xicilion)
    * docs - fix wrong “.(xicilion)
    * fs - compile error on FreeBSD.(xicilion)
    * gb - fix hsb2rgb algorithm error.(xicilion)
    * mq - params lost in asynchronous js handler.(xicilion)
    * SubProcess - SubProcess not allow reenter.(xicilion)
    * websocket - not compress control message.(xicilion)
    * WebView - compile error on windows.(xicilion)

* **refactor** :
    * core:
      - use JavaScript property to implement const.(xicilion)
      - add trace_tcp option.(xicilion)
      - remove equals from object to Buffer and Int64.(xicilion)
      - revert to the previous code (v8 fixed the deadlock error).(xicilion)
      - add options.h to define extern options variable.(xicilion)
    * events - save the wrapper function into data object to avoid using Callee.(xicilion)
    * websocket - remove nouse variable.(xicilion)
    * zlib - remove nouse variable.(xicilion)

* **others** :
    * Merge branch 'dev' of https - //github.com/fibjs/fibjs into dev(xicilion)
    * typo.(xicilion)
    * Merge branch 'master' into dev(响马)

* **chore** :
    * doc - remove unused file (#370)(Hengfei Zhuang)

### Commits
* [[`414adf4074`](https://github.com/fibjs/fibjs/commit/414adf4074)] - **v8, feat**: upgrade to 6.4.185.(xicilion)
* [[`5da1a51ad2`](https://github.com/fibjs/fibjs/commit/5da1a51ad2)] - **mq, break**: deprecated mq.await.(xicilion)
* [[`4fc8482a99`](https://github.com/fibjs/fibjs/commit/4fc8482a99)] - **mq, bugfix**: params lost in asynchronous js handler.(xicilion)
* [[`25c6e682e1`](https://github.com/fibjs/fibjs/commit/25c6e682e1)] - **Merge branch 'dev' of https**: //github.com/fibjs/fibjs into dev(xicilion)
* [[`7f3d5742d8`](https://github.com/fibjs/fibjs/commit/7f3d5742d8)] - **doc, chore**: remove unused file (#370)(Hengfei Zhuang)
* [[`6a2b51e03c`](https://github.com/fibjs/fibjs/commit/6a2b51e03c)] - **process, feat**: add test case of kill.(xicilion)
* [[`f551793d42`](https://github.com/fibjs/fibjs/commit/f551793d42)] - **events, refactor**: save the wrapper function into data object to avoid using Callee.(xicilion)
* [[`d860ada40f`](https://github.com/fibjs/fibjs/commit/d860ada40f)] - **core, refactor**: use JavaScript property to implement const.(xicilion)
* [[`00440c1632`](https://github.com/fibjs/fibjs/commit/00440c1632)] - **core, bugfix**: closesocket before canceling io operation.(xicilion)
* [[`98e4d2e06c`](https://github.com/fibjs/fibjs/commit/98e4d2e06c)] - **fs, bugfix**: compile error on FreeBSD.(xicilion)
* [[`5c42bd478a`](https://github.com/fibjs/fibjs/commit/5c42bd478a)] - **core, bugfix**: ensure the coverage report could be generated successfully. (#369)(Hengfei Zhuang)
* [[`7d5f6d3019`](https://github.com/fibjs/fibjs/commit/7d5f6d3019)] - **core, bugfix**: ensure the coverage report could be generated successfully. (#369)(Hengfei Zhuang)
* [[`95cf94caa8`](https://github.com/fibjs/fibjs/commit/95cf94caa8)] - **core, feat**: support --cov=filename to specify the cov filename (#368)(Hengfei Zhuang)
* [[`c8ac686ee9`](https://github.com/fibjs/fibjs/commit/c8ac686ee9)] - **gb, bugfix**: fix hsb2rgb algorithm error.(xicilion)
* [[`f4be9559eb`](https://github.com/fibjs/fibjs/commit/f4be9559eb)] - **core, refactor**: add trace_tcp option.(xicilion)
* [[`0fe6b96a54`](https://github.com/fibjs/fibjs/commit/0fe6b96a54)] - **http, break**: deprecated http.find.(xicilion)
* [[`a3e91bb949`](https://github.com/fibjs/fibjs/commit/a3e91bb949)] - **core, break**: deprecated object.dispose(xicilion)
* [[`a1ef84dd74`](https://github.com/fibjs/fibjs/commit/a1ef84dd74)] - **core, refactor**: remove equals from object to Buffer and Int64.(xicilion)
* [[`d8113504db`](https://github.com/fibjs/fibjs/commit/d8113504db)] - **http, feat**: check option items, throw unknown option.(xicilion)
* [[`b6f1aefc5f`](https://github.com/fibjs/fibjs/commit/b6f1aefc5f)] - **assert, bugfix**: compile error on Linux.(xicilion)
* [[`7c56f7f95b`](https://github.com/fibjs/fibjs/commit/7c56f7f95b)] - **WebView, bugfix**: compile error on windows.(xicilion)
* [[`e3df9ee921`](https://github.com/fibjs/fibjs/commit/e3df9ee921)] - **docs, bugfix**: fix wrong “.(xicilion)
* [[`2290e365d4`](https://github.com/fibjs/fibjs/commit/2290e365d4)] - **mongodb, break**: deprecated GridFS.(xicilion)
* [[`c445485c98`](https://github.com/fibjs/fibjs/commit/c445485c98)] - **zip, break**: deprecated ZipInfo object.(xicilion)
* [[`590b76a47f`](https://github.com/fibjs/fibjs/commit/590b76a47f)] - **collection, break**: deprecated collection module and Map object.(xicilion)
* [[`1f62211b25`](https://github.com/fibjs/fibjs/commit/1f62211b25)] - **console, break**: deprecated TextColor object.(xicilion)
* [[`3e13010e35`](https://github.com/fibjs/fibjs/commit/3e13010e35)] - **core, bugfix**: compile error on Linux and windows.(xicilion)
* [[`0ef8e161b6`](https://github.com/fibjs/fibjs/commit/0ef8e161b6)] - **collection, break**: deprecated  Queue.(xicilion)
* [[`7b8797fbf6`](https://github.com/fibjs/fibjs/commit/7b8797fbf6)] - **coroutine, break**: deprecated BlockedQueue.(xicilion)
* [[`aaa56a6bd9`](https://github.com/fibjs/fibjs/commit/aaa56a6bd9)] - **collection, break**: deprecated List object.(xicilion)
* [[`bfe47e8bed`](https://github.com/fibjs/fibjs/commit/bfe47e8bed)] - **SubProcess, bugfix**: SubProcess not allow reenter.(xicilion)
* [[`b4cd3c1bfd`](https://github.com/fibjs/fibjs/commit/b4cd3c1bfd)] - **core, refactor**: revert to the previous code (v8 fixed the deadlock error).(xicilion)
* [[`6ddc436f19`](https://github.com/fibjs/fibjs/commit/6ddc436f19)] - **core, feat**: support --cov-process tool to generate code coverage analysis report.(xicilion)
* [[`e83d0b1a09`](https://github.com/fibjs/fibjs/commit/e83d0b1a09)] - typo.(xicilion)
* [[`b385d6939f`](https://github.com/fibjs/fibjs/commit/b385d6939f)] - **core, feat**: support collecting code coverage information.(xicilion)
* [[`600764b2da`](https://github.com/fibjs/fibjs/commit/600764b2da)] - **core, refactor**: add options.h to define extern options variable.(xicilion)
* [[`c4be76a406`](https://github.com/fibjs/fibjs/commit/c4be76a406)] - **process, feat**: process.exit support return 0;(xicilion)
* [[`04f0b5dcb2`](https://github.com/fibjs/fibjs/commit/04f0b5dcb2)] - **core, feat**: support v8 code coverage.(xicilion)
* [[`fce9a81732`](https://github.com/fibjs/fibjs/commit/fce9a81732)] - **zlib, refactor**: remove nouse variable.(xicilion)
* [[`a36cdd9e69`](https://github.com/fibjs/fibjs/commit/a36cdd9e69)] - **websocket, feat**: add come documents.(xicilion)
* [[`5e90fb993b`](https://github.com/fibjs/fibjs/commit/5e90fb993b)] - **websocket, break**: deprecated ws.connect.(xicilion)
* [[`44e7657727`](https://github.com/fibjs/fibjs/commit/44e7657727)] - **websocket, feat**: change readyState to CLOSED in js thread.(xicilion)
* [[`3240d9dd37`](https://github.com/fibjs/fibjs/commit/3240d9dd37)] - **core, feat**: support OnEventEmit in Trigger.(xicilion)
* [[`1f02198883`](https://github.com/fibjs/fibjs/commit/1f02198883)] - **websocket, refactor**: remove nouse variable.(xicilion)
* [[`8bdf4ccb04`](https://github.com/fibjs/fibjs/commit/8bdf4ccb04)] - **websocket, bugfix**: not compress control message.(xicilion)
* [[`e033057f5c`](https://github.com/fibjs/fibjs/commit/e033057f5c)] - **websocket, feat**: close a closed socket not throw error.(xicilion)
* [[`353d9a7490`](https://github.com/fibjs/fibjs/commit/353d9a7490)] - **websocket, feat**: ws.upgrade add req as the second argument in callback.(xicilion)
* [[`0a6acf69f3`](https://github.com/fibjs/fibjs/commit/0a6acf69f3)] - Merge branch 'master' into dev(响马)

## 2017-10-27, Version v0.17.0

* **feature** :
    * ci - test --prof.(xicilion)
    * core:
      - support async locker in state machine.(响马)
      - save the status of isolate.(xicilion)
      - exit application directly while v8 is not alive.(响马)
    * docs:
      - change diagram style.(响马)
      - add process signal docs.(xicilion)
    * EventEmitter - save method name in emit.(xicilion)
    * Fiber:
      - not trace internal function in stack.(xicilion)
      - support Fiber.id.(响马)
    * process:
      - interrupt isolate in async mode.(xicilion)
      - support signal.(xicilion)
      - support Event exit.(xicilion)
      - support Event beforeExit.(xicilion)
      - support process.exitCode.(xicilion)
    * profiler:
      - support command line option: --prof and --prof-interval.(xicilion)
      - not log empty sample.(xicilion)
      - profiler.start(name, -1) will profile for ever.(xicilion)
      - support process tool.(xicilion)
    * test:
      - test.run set result to process.exitCode.(xicilion)
      - change the test mode according to the startup mode.(xicilion)
    * util:
      - add underscore test case.(响马)
      - save sync function name to fiber stack.(xicilion)
    * v8 - upgrade to v6.4.146.(xicilion)
    * websocket:
      - support context takeover.(响马)
      - lock the Buffer individually to send the buffer as soon as possible.(xicilion)
      - Send multiple websocket packets together.(响马)
      - use locker to keep the message sequence.(响马)
      - new WebSocket support compress.(响马)
      - support compress handshake in ws.upgrade.(响马)
      - support compress in WebSocketMessage.sendTo.(响马)
      - WebSocketMessage.readFrom support compress message.(xicilion)
    * zlib - support zlib stream.(xicilion)

* **breakchange** :
    * build - remove support of vs2015.(xicilion)
    * websocket:
      - delete nouse test case.(xicilion)
      - deprecated WebSocketHandler.(xicilion)

* **bugfix** :
    * ci:
      - fix windows build (#367)(Hengfei Zhuang)
      - fix windows build (#366)(Hengfei Zhuang)
    * fs:
      - fix crash when read empty file with codec use fs.readFile.(响马)
      - change fs.copy to async mode.(xicilion)
    * MemoryStream - fix MemoryStrem.seek error on windows.(xicilion)
    * net - safely close socket to repair socket reuse errors.(xicilion)
    * process - ctrl_c will cause the program to crash during startup.(响马)
    * profiler - log file parse error on windows.(xicilion)
    * socket - closing a socket twice will cause a crash.(响马)
    * test:
      - change tcp port.(xicilion)
      - clear root ca after test.(xicilion)
    * timers - fix v8 deadlock in setHrInterval.(xicilion)
    * websocket - end async recv worker after close stream.(响马)
    * zlib:
      - compile error on windows.(xicilion)
      - compile warning in debug mode.(响马)
      - asynchronous operation may cause access to illegal memory.(响马)

* **refactor** :
    * core:
      - define v8 api in v8_api.h.(xicilion)
      - AsyncEvent base on Task_base.(响马)
      - call interrupt callback function directly if possible.(响马)
      - move RequestInterrupt into isolate.(xicilion)
      - optimize the startup process.(xicilion)
    * io - move method flush to Interface Stream.(响马)
    * net - remove unused event from libev.(响马)
    * timers - reuse variable isolate.(xicilion)
    * zlib - move ZlibStream to include file.(xicilion)

* **doc** :
    * gui - add gui english doc (#365)(Hengfei Zhuang)

### Commits
* [[`0260298dd4`](https://github.com/fibjs/fibjs/commit/0260298dd4)] - **core, refactor**: define v8 api in v8_api.h.(xicilion)
* [[`bfdedd0835`](https://github.com/fibjs/fibjs/commit/bfdedd0835)] - **v8, feat**: upgrade to v6.4.146.(xicilion)
* [[`0334b8a375`](https://github.com/fibjs/fibjs/commit/0334b8a375)] - **zlib, bugfix**: compile error on windows.(xicilion)
* [[`e96f23e9fa`](https://github.com/fibjs/fibjs/commit/e96f23e9fa)] - **websocket, feat**: support context takeover.(响马)
* [[`8b31858bba`](https://github.com/fibjs/fibjs/commit/8b31858bba)] - **ci, bugfix**: fix windows build (#367)(Hengfei Zhuang)
* [[`7bbbb143ec`](https://github.com/fibjs/fibjs/commit/7bbbb143ec)] - **zlib, refactor**: move ZlibStream to include file.(xicilion)
* [[`49aa9975c6`](https://github.com/fibjs/fibjs/commit/49aa9975c6)] - **zlib, feat**: support zlib stream.(xicilion)
* [[`feac71466c`](https://github.com/fibjs/fibjs/commit/feac71466c)] - **io, refactor**: move method flush to Interface Stream.(响马)
* [[`666ae9f38d`](https://github.com/fibjs/fibjs/commit/666ae9f38d)] - **net, refactor**: remove unused event from libev.(响马)
* [[`f0459a34b8`](https://github.com/fibjs/fibjs/commit/f0459a34b8)] - **socket, bugfix**: closing a socket twice will cause a crash.(响马)
* [[`64e9abaf99`](https://github.com/fibjs/fibjs/commit/64e9abaf99)] - **net, bugfix**: safely close socket to repair socket reuse errors.(xicilion)
* [[`2986202089`](https://github.com/fibjs/fibjs/commit/2986202089)] - **websocket, feat**: lock the Buffer individually to send the buffer as soon as possible.(xicilion)
* [[`dbff1aa286`](https://github.com/fibjs/fibjs/commit/dbff1aa286)] - **websocket, feat**: Send multiple websocket packets together.(响马)
* [[`d69b32c6ec`](https://github.com/fibjs/fibjs/commit/d69b32c6ec)] - **websocket, feat**: use locker to keep the message sequence.(响马)
* [[`344f0ae6aa`](https://github.com/fibjs/fibjs/commit/344f0ae6aa)] - **process, bugfix**: ctrl_c will cause the program to crash during startup.(响马)
* [[`418d2a8dc5`](https://github.com/fibjs/fibjs/commit/418d2a8dc5)] - **websocket, bugfix**: end async recv worker after close stream.(响马)
* [[`3637d39a95`](https://github.com/fibjs/fibjs/commit/3637d39a95)] - **zlib, bugfix**: compile warning in debug mode.(响马)
* [[`0fd19ee721`](https://github.com/fibjs/fibjs/commit/0fd19ee721)] - **MemoryStream, bugfix**: fix MemoryStrem.seek error on windows.(xicilion)
* [[`6563d2c665`](https://github.com/fibjs/fibjs/commit/6563d2c665)] - **gui, doc**: add gui english doc (#365)(Hengfei Zhuang)
* [[`a24b4b404e`](https://github.com/fibjs/fibjs/commit/a24b4b404e)] - **ci, bugfix**: fix windows build (#366)(Hengfei Zhuang)
* [[`ec8362f662`](https://github.com/fibjs/fibjs/commit/ec8362f662)] - **build, break**: remove support of vs2015.(xicilion)
* [[`42b69ff4c2`](https://github.com/fibjs/fibjs/commit/42b69ff4c2)] - **test, feat**: test.run set result to process.exitCode.(xicilion)
* [[`77e64585d1`](https://github.com/fibjs/fibjs/commit/77e64585d1)] - **docs, feat**: change diagram style.(响马)
* [[`6147c17aaf`](https://github.com/fibjs/fibjs/commit/6147c17aaf)] - **core, feat**: support async locker in state machine.(响马)
* [[`51e88700ad`](https://github.com/fibjs/fibjs/commit/51e88700ad)] - **core, refactor**: AsyncEvent base on Task_base.(响马)
* [[`39ed71a85c`](https://github.com/fibjs/fibjs/commit/39ed71a85c)] - **fs, bugfix**: fix crash when read empty file with codec use fs.readFile.(响马)
* [[`07e705e8e0`](https://github.com/fibjs/fibjs/commit/07e705e8e0)] - **zlib, bugfix**: asynchronous operation may cause access to illegal memory.(响马)
* [[`122bc6dbb2`](https://github.com/fibjs/fibjs/commit/122bc6dbb2)] - **websocket, feat**: new WebSocket support compress.(响马)
* [[`76efe05aa1`](https://github.com/fibjs/fibjs/commit/76efe05aa1)] - **websocket, feat**: support compress handshake in ws.upgrade.(响马)
* [[`e2662049c5`](https://github.com/fibjs/fibjs/commit/e2662049c5)] - **websocket, feat**: support compress in WebSocketMessage.sendTo.(响马)
* [[`2e17b82fad`](https://github.com/fibjs/fibjs/commit/2e17b82fad)] - **websocket, feat**: WebSocketMessage.readFrom support compress message.(xicilion)
* [[`4fe56e695a`](https://github.com/fibjs/fibjs/commit/4fe56e695a)] - **websocket, break**: delete nouse test case.(xicilion)
* [[`c39d7037f0`](https://github.com/fibjs/fibjs/commit/c39d7037f0)] - **websocket, break**: deprecated WebSocketHandler.(xicilion)
* [[`8d00946b50`](https://github.com/fibjs/fibjs/commit/8d00946b50)] - **test, bugfix**: change tcp port.(xicilion)
* [[`6c625f5446`](https://github.com/fibjs/fibjs/commit/6c625f5446)] - **util, feat**: add underscore test case.(响马)
* [[`ff90700a11`](https://github.com/fibjs/fibjs/commit/ff90700a11)] - **ci, feat**: test --prof.(xicilion)
* [[`138b59b221`](https://github.com/fibjs/fibjs/commit/138b59b221)] - **profiler, bugfix**: log file parse error on windows.(xicilion)
* [[`9f6bad2138`](https://github.com/fibjs/fibjs/commit/9f6bad2138)] - **profiler, feat**: support command line option: --prof and --prof-interval.(xicilion)
* [[`21425c9eae`](https://github.com/fibjs/fibjs/commit/21425c9eae)] - **profiler, feat**: not log empty sample.(xicilion)
* [[`7b42a50f6b`](https://github.com/fibjs/fibjs/commit/7b42a50f6b)] - **profiler, feat**: profiler.start(name, -1) will profile for ever.(xicilion)
* [[`c79d4bd26f`](https://github.com/fibjs/fibjs/commit/c79d4bd26f)] - **docs, feat**: add process signal docs.(xicilion)
* [[`d80d83060f`](https://github.com/fibjs/fibjs/commit/d80d83060f)] - **test, feat**: change the test mode according to the startup mode.(xicilion)
* [[`106639b788`](https://github.com/fibjs/fibjs/commit/106639b788)] - **test, bugfix**: clear root ca after test.(xicilion)
* [[`6253b8a13d`](https://github.com/fibjs/fibjs/commit/6253b8a13d)] - **fs, bugfix**: change fs.copy to async mode.(xicilion)
* [[`880f894dc9`](https://github.com/fibjs/fibjs/commit/880f894dc9)] - **process, feat**: interrupt isolate in async mode.(xicilion)
* [[`4520bb3a85`](https://github.com/fibjs/fibjs/commit/4520bb3a85)] - **timers, bugfix**: fix v8 deadlock in setHrInterval.(xicilion)
* [[`838295b4be`](https://github.com/fibjs/fibjs/commit/838295b4be)] - **core, feat**: save the status of isolate.(xicilion)
* [[`5b2c83f57c`](https://github.com/fibjs/fibjs/commit/5b2c83f57c)] - **core, feat**: exit application directly while v8 is not alive.(响马)
* [[`4ec77e3241`](https://github.com/fibjs/fibjs/commit/4ec77e3241)] - **core, refactor**: call interrupt callback function directly if possible.(响马)
* [[`c62738774c`](https://github.com/fibjs/fibjs/commit/c62738774c)] - **process, feat**: support signal.(xicilion)
* [[`8d6271866d`](https://github.com/fibjs/fibjs/commit/8d6271866d)] - **EventEmitter, feat**: save method name in emit.(xicilion)
* [[`dc1089eefe`](https://github.com/fibjs/fibjs/commit/dc1089eefe)] - **Fiber, feat**: not trace internal function in stack.(xicilion)
* [[`dd0c0611df`](https://github.com/fibjs/fibjs/commit/dd0c0611df)] - **process, feat**: support Event exit.(xicilion)
* [[`08cf7066e4`](https://github.com/fibjs/fibjs/commit/08cf7066e4)] - **process, feat**: support Event beforeExit.(xicilion)
* [[`b6ec6558ef`](https://github.com/fibjs/fibjs/commit/b6ec6558ef)] - **process, feat**: support process.exitCode.(xicilion)
* [[`7c9a6cba3d`](https://github.com/fibjs/fibjs/commit/7c9a6cba3d)] - **core, refactor**: move RequestInterrupt into isolate.(xicilion)
* [[`eb4d6bce05`](https://github.com/fibjs/fibjs/commit/eb4d6bce05)] - **profiler, feat**: support process tool.(xicilion)
* [[`159b2275f2`](https://github.com/fibjs/fibjs/commit/159b2275f2)] - **core, refactor**: optimize the startup process.(xicilion)
* [[`39145217bc`](https://github.com/fibjs/fibjs/commit/39145217bc)] - **util, feat**: save sync function name to fiber stack.(xicilion)
* [[`c3092d0476`](https://github.com/fibjs/fibjs/commit/c3092d0476)] - **Fiber, feat**: support Fiber.id.(响马)
* [[`41e402b5d2`](https://github.com/fibjs/fibjs/commit/41e402b5d2)] - **timers, refactor**: reuse variable isolate.(xicilion)

## 2017-10-14, Version v0.16.0

* **feature** :
    * core:
      - save method name before lock the object, support recursive native call.(xicilion)
      - treat NaN as zero in argumets when require number (#362)(Hengfei Zhuang)
      - use exlib::string::Buffer as ArrayBuffer allocator.(xicilion)
    * docs - sort .idl file before parse.(响马)
    * Fiber:
      - include native function name in Fiber.stack.(xicilion)
      - support Fiber.stack to trace JavaScript stack frame.(xicilion)
    * fs - access string data safely.(xicilion)
    * gd - change Image.affine to async to free v8 runtime.(xicilion)
    * http:
      - request support query in opts.(响马)
      - reset body when store json data.(xicilion)
    * profiler - support cpu profiler.(xicilion)
    * test:
      - add jsc async callback test case.(响马)
      - use Function.length to check callback function.(响马)
    * timers:
      - support property stopped to detect if the Timer has stopped.(xicilion)
      - Use => rewrite blank function.(xicilion)
      - support setHrInterval/clearHrInternal.(xicilion)
      - support param (#358)(Hengfei Zhuang)
    * tools - changelog script support type alias.(xicilion)
    * util - remove nouse variable.(xicilion)
    * v8 - upgrade to v6.3.296.(xicilion)

* **bugfix** :
    * ci - lock the ruby version to 2.4 to fix homebrew error (#364)(Hengfei Zhuang)
    * docs - fix process.stdout document.(xicilion)
    * Fiber - Fiber.stack not break line.(xicilion)
    * SQLite - use coroutine.sleep release worker thread.(xicilion)
    * timers:
      - setHrInterval delay sometimes.(xicilion)
      - fix wrong timeout (#359)(Hengfei Zhuang)
    * Url - compile in debug mode.(xicilion)
    * url - compile warning on windows.(xicilion)
    * vm - fix the sandbox.require base dir (#361)(Hengfei Zhuang)

* **refactor** :
    * Buffer - If possible, use ArrayBuffer to create Buffer.(xicilion)
    * core - use same api to trace stack.(xicilion)
    * coroutine - sleep with 0ms return directly.(xicilion)
    * encoding - rewrite json.encode use new v8 json api.(xicilion)
    * exlib - split source code.(xicilion)
    * SQLite - Optimize the sleep algorithm when the database is busy.(xicilion)
    * timers - use v8 internal api to invoke interrupt callback directly.(xicilion)

### Commits
* [[`3b925b7de6`](https://github.com/fibjs/fibjs/commit/3b925b7de6)] - **core, refactor**: use same api to trace stack.(xicilion)
* [[`48bbcc6699`](https://github.com/fibjs/fibjs/commit/48bbcc6699)] - **v8, feat**: upgrade to v6.3.296.(xicilion)
* [[`9c82a02f28`](https://github.com/fibjs/fibjs/commit/9c82a02f28)] - **timers, refactor**: use v8 internal api to invoke interrupt callback directly.(xicilion)
* [[`6155b8dbee`](https://github.com/fibjs/fibjs/commit/6155b8dbee)] - **Fiber, bugfix**: Fiber.stack not break line.(xicilion)
* [[`4673b38448`](https://github.com/fibjs/fibjs/commit/4673b38448)] - **timers, feat**: support property stopped to detect if the Timer has stopped.(xicilion)
* [[`89bf1893a3`](https://github.com/fibjs/fibjs/commit/89bf1893a3)] - **core, feat**: save method name before lock the object, support recursive native call.(xicilion)
* [[`d2550f5bc6`](https://github.com/fibjs/fibjs/commit/d2550f5bc6)] - **Url, bugfix**: compile in debug mode.(xicilion)
* [[`e09d3b56ba`](https://github.com/fibjs/fibjs/commit/e09d3b56ba)] - **util, feat**: remove nouse variable.(xicilion)
* [[`2ec5980ab5`](https://github.com/fibjs/fibjs/commit/2ec5980ab5)] - **profiler, feat**: support cpu profiler.(xicilion)
* [[`7443033c29`](https://github.com/fibjs/fibjs/commit/7443033c29)] - **SQLite, refactor**: Optimize the sleep algorithm when the database is busy.(xicilion)
* [[`dbd3c63fd7`](https://github.com/fibjs/fibjs/commit/dbd3c63fd7)] - **coroutine, refactor**: sleep with 0ms return directly.(xicilion)
* [[`5a5e7658a3`](https://github.com/fibjs/fibjs/commit/5a5e7658a3)] - **timers, feat**: Use => rewrite blank function.(xicilion)
* [[`d1c64dc5bf`](https://github.com/fibjs/fibjs/commit/d1c64dc5bf)] - **Fiber, feat**: include native function name in Fiber.stack.(xicilion)
* [[`612ac63127`](https://github.com/fibjs/fibjs/commit/612ac63127)] - **tools, feat**: changelog script support type alias.(xicilion)
* [[`125bcd348b`](https://github.com/fibjs/fibjs/commit/125bcd348b)] - **ci, fixbug**: lock the ruby version to 2.4 to fix homebrew error (#364)(Hengfei Zhuang)
* [[`7ac34e97c0`](https://github.com/fibjs/fibjs/commit/7ac34e97c0)] - **url, bugfix**: compile warning on windows.(xicilion)
* [[`921f9d47fa`](https://github.com/fibjs/fibjs/commit/921f9d47fa)] - **SQLite, bugfix**: use coroutine.sleep release worker thread.(xicilion)
* [[`cc3a032a07`](https://github.com/fibjs/fibjs/commit/cc3a032a07)] - **gd, feat**: change Image.affine to async to free v8 runtime.(xicilion)
* [[`b0fba8d60e`](https://github.com/fibjs/fibjs/commit/b0fba8d60e)] - **timers, bugfix**: setHrInterval delay sometimes.(xicilion)
* [[`75d8c55d74`](https://github.com/fibjs/fibjs/commit/75d8c55d74)] - **docs, feat**: sort .idl file before parse.(响马)
* [[`751d1f9269`](https://github.com/fibjs/fibjs/commit/751d1f9269)] - **http, feat**: request support query in opts.(响马)
* [[`1fa3bbf1c9`](https://github.com/fibjs/fibjs/commit/1fa3bbf1c9)] - **test, feat**: add jsc async callback test case.(响马)
* [[`82aa0f4e2f`](https://github.com/fibjs/fibjs/commit/82aa0f4e2f)] - **test, feat**: use Function.length to check callback function.(响马)
* [[`0bf90f4ced`](https://github.com/fibjs/fibjs/commit/0bf90f4ced)] - **http, feat**: reset body when store json data.(xicilion)
* [[`c0d4be1fa1`](https://github.com/fibjs/fibjs/commit/c0d4be1fa1)] - **core, feat**: treat NaN as zero in argumets when require number (#362)(Hengfei Zhuang)
* [[`3a92d0e6db`](https://github.com/fibjs/fibjs/commit/3a92d0e6db)] - **encoding, refactor**: rewrite json.encode use new v8 json api.(xicilion)
* [[`94e0ee98fc`](https://github.com/fibjs/fibjs/commit/94e0ee98fc)] - **fs, feat**: access string data safely.(xicilion)
* [[`d04963c97a`](https://github.com/fibjs/fibjs/commit/d04963c97a)] - **core, feat**: use exlib::string::Buffer as ArrayBuffer allocator.(xicilion)
* [[`3312d9d567`](https://github.com/fibjs/fibjs/commit/3312d9d567)] - **Buffer, refactor**: If possible, use ArrayBuffer to create Buffer.(xicilion)
* [[`efbfdeb65e`](https://github.com/fibjs/fibjs/commit/efbfdeb65e)] - **vm, fixbug**: fix the sandbox.require base dir (#361)(Hengfei Zhuang)
* [[`b5cb1cb732`](https://github.com/fibjs/fibjs/commit/b5cb1cb732)] - **timers, feat**: support setHrInterval/clearHrInternal.(xicilion)
* [[`ebcb904574`](https://github.com/fibjs/fibjs/commit/ebcb904574)] - **timers, fixbug**: fix wrong timeout (#359)(Hengfei Zhuang)
* [[`7be90a7a4f`](https://github.com/fibjs/fibjs/commit/7be90a7a4f)] - **Fiber, feat**: support Fiber.stack to trace JavaScript stack frame.(xicilion)
* [[`aa55e2bb6f`](https://github.com/fibjs/fibjs/commit/aa55e2bb6f)] - **exlib, refactor**: split source code.(xicilion)
* [[`0281ce9aad`](https://github.com/fibjs/fibjs/commit/0281ce9aad)] - **timers, feat**: support param (#358)(Hengfei Zhuang)
* [[`3a2ca55c09`](https://github.com/fibjs/fibjs/commit/3a2ca55c09)] - **docs, bugfix**: fix process.stdout document.(xicilion)

## 2017-09-30, Version v0.15.0

* **feature** :
    * docs:
      - remove github token.(xicilion)
      - add awesome sync tool.(xicilion)
    * http:
      - request support json any type.(xicilion)
      - HttpResponse parse statusMessage.(xicilion)
      - HttpResopnse support any statusCode.(xicilion)
      - support find method.(xicilion)
      - support statusCode, statusMessage, writeHeaders.(xicilion)
    * process:
      - support process.versions.(xicilion)
      - support process.stdin, process.stdout, process.stderr.(xicilion)
    * timer - support beyond 2^31 delay (#357)(Hengfei Zhuang)
    * util:
      - support util.inspect.(xicilion)
      - support util._extend.(xicilion)
    * v8 - upgrade to v6.3.228.(xicilion)

* **breakchange** :
    * http - deprecated property crossDomain, add method enableCrossOrigin.(xicilion)

* **bugfix** :
    * core - fix compile warning on windows.(xicilion)
    * http:
      - compile warning on windows.(xicilion)
      - HttpResponse.statusMessage encode error.(xicilion)
    * timer - compile warning on windows.(xicilion)
    * websocket - compatible with new http api.(xicilion)

* **refactor** :
    * core - use WriteUtf8 to get better performance (#356)(Hengfei Zhuang)
    * http:
      - use opts to pass body and headers, support urlencode and json encode.(xicilion)
      - use Object to pass headers.(xicilion)
    * idlc - use GetArgumentValue to convert property.(xicilion)
    * path - use getArgumentValue.(xicilion)
    * Variant - use GetArgumentValue.(xicilion)

### Commits
* [[`4167a08687`](https://github.com/fibjs/fibjs/commit/4167a08687)] - **v8, feat**: upgrade to v6.3.228.(xicilion)
* [[`55d21b5045`](https://github.com/fibjs/fibjs/commit/55d21b5045)] - **timer, bugfix**: compile warning on windows.(xicilion)
* [[`875654e4f0`](https://github.com/fibjs/fibjs/commit/875654e4f0)] - **timer, feat**: support beyond 2^31 delay (#357)(Hengfei Zhuang)
* [[`bab35312b3`](https://github.com/fibjs/fibjs/commit/bab35312b3)] - **http, bugfix**: compile warning on windows.(xicilion)
* [[`881a7c7636`](https://github.com/fibjs/fibjs/commit/881a7c7636)] - **http, feat**: request support json any type.(xicilion)
* [[`c258ae4129`](https://github.com/fibjs/fibjs/commit/c258ae4129)] - **websocket, bugfix**: compatible with new http api.(xicilion)
* [[`c66498fe7a`](https://github.com/fibjs/fibjs/commit/c66498fe7a)] - **http, refactor**: use opts to pass body and headers, support urlencode and json encode.(xicilion)
* [[`8538dc249d`](https://github.com/fibjs/fibjs/commit/8538dc249d)] - **http, feat**: HttpResponse parse statusMessage.(xicilion)
* [[`f8e5511b2a`](https://github.com/fibjs/fibjs/commit/f8e5511b2a)] - **http, feat**: HttpResopnse support any statusCode.(xicilion)
* [[`91915c0842`](https://github.com/fibjs/fibjs/commit/91915c0842)] - **http, bugfix**: HttpResponse.statusMessage encode error.(xicilion)
* [[`b7f14b1288`](https://github.com/fibjs/fibjs/commit/b7f14b1288)] - **http, feat**: support find method.(xicilion)
* [[`1429a5f7df`](https://github.com/fibjs/fibjs/commit/1429a5f7df)] - **http, feat**: support statusCode, statusMessage, writeHeaders.(xicilion)
* [[`731c1fdb9d`](https://github.com/fibjs/fibjs/commit/731c1fdb9d)] - **http, refactor**: use Object to pass headers.(xicilion)
* [[`a3cfcc5e89`](https://github.com/fibjs/fibjs/commit/a3cfcc5e89)] - **docs, feat**: remove github token.(xicilion)
* [[`ec4958dfc9`](https://github.com/fibjs/fibjs/commit/ec4958dfc9)] - **docs, feat**: add awesome sync tool.(xicilion)
* [[`d5d1196ac9`](https://github.com/fibjs/fibjs/commit/d5d1196ac9)] - **http, break**: deprecated property crossDomain, add method enableCrossOrigin.(xicilion)
* [[`ca05229cb2`](https://github.com/fibjs/fibjs/commit/ca05229cb2)] - **util, feat**: support util.inspect.(xicilion)
* [[`d93ca533c7`](https://github.com/fibjs/fibjs/commit/d93ca533c7)] - **util, feat**: support util._extend.(xicilion)
* [[`f97d881da0`](https://github.com/fibjs/fibjs/commit/f97d881da0)] - **process, feat**: support process.versions.(xicilion)
* [[`b3f68688b0`](https://github.com/fibjs/fibjs/commit/b3f68688b0)] - **process, feat**: support process.stdin, process.stdout, process.stderr.(xicilion)
* [[`8085d429da`](https://github.com/fibjs/fibjs/commit/8085d429da)] - **Variant, refactor**: use GetArgumentValue.(xicilion)
* [[`ad9f7dbc0d`](https://github.com/fibjs/fibjs/commit/ad9f7dbc0d)] - **path, refactor**: use getArgumentValue.(xicilion)
* [[`7765c2402a`](https://github.com/fibjs/fibjs/commit/7765c2402a)] - **idlc, refactor**: use GetArgumentValue to convert property.(xicilion)
* [[`8cc030841e`](https://github.com/fibjs/fibjs/commit/8cc030841e)] - **core, bugfix**: fix compile warning on windows.(xicilion)
* [[`4ce374f000`](https://github.com/fibjs/fibjs/commit/4ce374f000)] - **core, refactor**: use WriteUtf8 to get better performance (#356)(Hengfei Zhuang)

## 2017-09-21, Version v0.14.0

* **feature** :
    * punycode - support toUnicode and toASCII methods (#351)(王爱科)
    * v8 - upgrade to v6.3.179.(响马)

* **bugfix** :
    * LruCache - data error when update element in updater function.(xicilion)

* **refactor** :
    * LruCache - use result of insert to check the element in map.(响马)
    * Service - modify service control function to static function.(xicilion)
    * url - standardize url.parse behavior (#355)(王爱科)

### Commits
* [[`06b98f80f2`](https://github.com/fibjs/fibjs/commit/06b98f80f2)] - **url, refactor**: standardize url.parse behavior (#355)(王爱科)
* [[`0018f2d86c`](https://github.com/fibjs/fibjs/commit/0018f2d86c)] - **v8, feat**: upgrade to v6.3.179.(响马)
* [[`2de4dbae9f`](https://github.com/fibjs/fibjs/commit/2de4dbae9f)] - **Service, refactor**: modify service control function to static function.(xicilion)
* [[`a286b7be6f`](https://github.com/fibjs/fibjs/commit/a286b7be6f)] - **LruCache, refactor**: use result of insert to check the element in map.(响马)
* [[`d27eb0099a`](https://github.com/fibjs/fibjs/commit/d27eb0099a)] - **LruCache, bugfix**: data error when update element in updater function.(xicilion)
* [[`a4b70743a9`](https://github.com/fibjs/fibjs/commit/a4b70743a9)] - **punycode, feat**: support toUnicode and toASCII methods (#351)(王爱科)

## 2017-09-12, Version v0.13.0

* **feature** :
    * Buffer:
      - Buffer.write* return new offset, compatible with node.js.(响马)
      - add the lost desc (#342)(Hengfei Zhuang)
    * core:
      - support tuple return type.(xicilion)
      - support ucs2 string convert.(响马)
      - SimpleObject support Array.(响马)
      - Implement SimpleObject to build simple JavaScript Object from native.(响马)
      - not ignore nan in arguments.(响马)
    * crypto - support crypto.createHmac.(响马)
    * db:
      - query result NULL is converted to null in MySQL and SQLite (#334)(blingz)
      - undefined / null are converted to NULL (#333)(blingz)
    * docs - add a release step.(响马)
    * http - agent in custum headers will replace default agent.(响马)
    * HttpCookie - path=/ as default value in cookie (#332)(blingz)
    * iconv:
      - support ucs4 codec.(响马)
      - support ucs2, utf16le codec.(响马)
    * idlc - support NObject/NArray type.(响马)
    * Message:
      - method json check content-type charset.(xicilion)
      - method json support decode body.(xicilion)
      - support method json.(xicilion)
    * punycode - support native module punycode.(响马)
    * string_decoder - add string_decoder module (#340)(Hengfei Zhuang)
    * test:
      - add v8 crash test case.(xicilion)
      - support this in test function.(响马)
    * v8:
      - upgrade v8 to v6.3.92.(响马)
      - upgrade to v6.2.377.(响马)
    * vs - generate vc proj file.(响马)

* **breakchange** :
    * Buffer - compat with node toString (#338)(Hengfei Zhuang)
    * core - deprecated mem_dump in debug.mode.(xicilion)
    * Int64 - deprecated valueOf.(响马)
    * net - deprecated method net.conect with host/port arguments.(响马)
    * object - deprecated valueOf.(响马)
    * re - deprecated module re.(响马)

* **bugfix** :
    * Buffer:
      - Buffer.write codec string size error.(xicilion)
      - fix the buffer test (#339)(Hengfei Zhuang)
    * core:
      - compile warning on windows.(xicilion)
      - disable inlining in TurboFan, fix crash on multi fiber.(xicilion)
      - disable parallel scavenge, fix gc deadlock.(响马)
      - compile warning on windows debug.(响马)
      - bugfix: method count error in class info of  object.(响马)
    * db - fix typo.(响马)
    * HttpResponse - response header missing after method redirect.(响马)
    * iconv:
      - multi char utf-16 decode error.(xicilion)
      - unicode 0xd800 convert error.(响马)
    * io - compile warning on linux debug mode.(响马)
    * Message - method json error when content-type has charset.(xicilion)
    * os:
      - compile error on osx.(xicilion)
      - compile warning on linux debug mode.(响马)
    * punycode:
      - compile warning on windows x86.(响马)
      - compile error on linux.(响马)
    * sandbox - jsc test file load error.(xicilion)
    * SandBox:
      - object type argument error in standalone global.(xicilion)
      - delete default console object in global.(xicilion)
      - function member is missing in standalone global.(xicilion)
    * string_decoder:
      - fix compile warning on windows (#343)(Hengfei Zhuang)
      - fix encoding error on windows (#341)(Hengfei Zhuang)
    * test - callback hungup when execute return error.(响马)

* **refactor** :
    * core:
      - refactor the GC system of native object.(xicilion)
      - use NObject/NArray return SimpleObject.(响马)
      - use new NewString convert string to v8 Value, fix v8 utf8 issue.(响马)
      - rename utf8 api, support wchar32.(响马)
      - use valueOf to get the wrap of native object.(响马)
    * db - use simpleObject to return the query result of execute.(响马)
    * http - deprecated cross domain response for flash.(xicilion)
    * idlc - not refer object_base.(响马)
    * net - use SimpleObject to build the result of method recvfrom.(响马)
    * timer - hold the handler function until the timer ends.(xicilion)
    * util - method format check native object first.(响马)
    * Variant - use valueOf to convert object_base to JavaScript Value.(响马)

### Commits
* [[`dc5d816ece`](https://github.com/fibjs/fibjs/commit/dc5d816ece)] - **test, feat**: add v8 crash test case.(xicilion)
* [[`9dc6d62633`](https://github.com/fibjs/fibjs/commit/9dc6d62633)] - **v8, feat**: upgrade v8 to v6.3.92.(响马)
* [[`3c9e67b38a`](https://github.com/fibjs/fibjs/commit/3c9e67b38a)] - **http, refactor**: deprecated cross domain response for flash.(xicilion)
* [[`f46945b746`](https://github.com/fibjs/fibjs/commit/f46945b746)] - **core, refactor**: refactor the GC system of native object.(xicilion)
* [[`b59aeee7f3`](https://github.com/fibjs/fibjs/commit/b59aeee7f3)] - **timer, refactor**: hold the handler function until the timer ends.(xicilion)
* [[`5ca1044e6c`](https://github.com/fibjs/fibjs/commit/5ca1044e6c)] - **core, break**: deprecated mem_dump in debug.mode.(xicilion)
* [[`f4223f190e`](https://github.com/fibjs/fibjs/commit/f4223f190e)] - **core, bugfix**: compile warning on windows.(xicilion)
* [[`5936b4ed31`](https://github.com/fibjs/fibjs/commit/5936b4ed31)] - **core, bugfix**: disable inlining in TurboFan, fix crash on multi fiber.(xicilion)
* [[`ee7d899107`](https://github.com/fibjs/fibjs/commit/ee7d899107)] - **os, bugfix**: compile error on osx.(xicilion)
* [[`ffdf5d332b`](https://github.com/fibjs/fibjs/commit/ffdf5d332b)] - **os, bugfix**: compile warning on linux debug mode.(响马)
* [[`019f74dceb`](https://github.com/fibjs/fibjs/commit/019f74dceb)] - **io, bugfix**: compile warning on linux debug mode.(响马)
* [[`d3267297d2`](https://github.com/fibjs/fibjs/commit/d3267297d2)] - **net, break**: deprecated method net.conect with host/port arguments.(响马)
* [[`e1a52c83d6`](https://github.com/fibjs/fibjs/commit/e1a52c83d6)] - **HttpResponse, bugfix**: response header missing after method redirect.(响马)
* [[`8ef70c5273`](https://github.com/fibjs/fibjs/commit/8ef70c5273)] - **core, feat**: support tuple return type.(xicilion)
* [[`8035a3e56f`](https://github.com/fibjs/fibjs/commit/8035a3e56f)] - **core, refactor**: use NObject/NArray return SimpleObject.(响马)
* [[`2dc326c688`](https://github.com/fibjs/fibjs/commit/2dc326c688)] - **idlc, feat**: support NObject/NArray type.(响马)
* [[`72e1d1e23d`](https://github.com/fibjs/fibjs/commit/72e1d1e23d)] - **SandBox, bugfix**: object type argument error in standalone global.(xicilion)
* [[`a2919a9d50`](https://github.com/fibjs/fibjs/commit/a2919a9d50)] - **SandBox, bugfix**: delete default console object in global.(xicilion)
* [[`def11fc0cf`](https://github.com/fibjs/fibjs/commit/def11fc0cf)] - **SandBox, bugfix**: function member is missing in standalone global.(xicilion)
* [[`84a31dda38`](https://github.com/fibjs/fibjs/commit/84a31dda38)] - Merge remote-tracking branch 'origin/dev' into dev(xicilion)
* [[`a043b439ad`](https://github.com/fibjs/fibjs/commit/a043b439ad)] - **string_decoder, bugfix**: fix compile warning on windows (#343)(Hengfei Zhuang)
* [[`4287d0d71f`](https://github.com/fibjs/fibjs/commit/4287d0d71f)] - **string_decoder, doc**: add the lost desc (#342)(Hengfei Zhuang)
* [[`a459d4f647`](https://github.com/fibjs/fibjs/commit/a459d4f647)] - **string_decoder, bugfix**: fix encoding error on windows (#341)(Hengfei Zhuang)
* [[`5d704e918b`](https://github.com/fibjs/fibjs/commit/5d704e918b)] - **Message, feat**: method json check content-type charset.(xicilion)
* [[`fa6420eaa2`](https://github.com/fibjs/fibjs/commit/fa6420eaa2)] - **Message, bugfix**: method json error when content-type has charset.(xicilion)
* [[`f3b6e61572`](https://github.com/fibjs/fibjs/commit/f3b6e61572)] - **Message, feat**: method json support decode body.(xicilion)
* [[`abef2fba5e`](https://github.com/fibjs/fibjs/commit/abef2fba5e)] - **string_decoder, feat**: add string_decoder module (#340)(Hengfei Zhuang)
* [[`c4a7069e59`](https://github.com/fibjs/fibjs/commit/c4a7069e59)] - **Message, feat**: support method json.(xicilion)
* [[`456cd3e5e2`](https://github.com/fibjs/fibjs/commit/456cd3e5e2)] - **http, feat**: agent in custum headers will replace default agent.(响马)
* [[`81d5221f09`](https://github.com/fibjs/fibjs/commit/81d5221f09)] - **docs, feat**: add a release step.(响马)
* [[`19bc86ead3`](https://github.com/fibjs/fibjs/commit/19bc86ead3)] - **Buffer, test**: fix the buffer test (#339)(Hengfei Zhuang)
* [[`c2c1f98878`](https://github.com/fibjs/fibjs/commit/c2c1f98878)] - **Buffer, break**: compat with node toString (#338)(Hengfei Zhuang)
* [[`3fe7074cc5`](https://github.com/fibjs/fibjs/commit/3fe7074cc5)] - **Buffer, bugfix**: Buffer.write codec string size error.(xicilion)
* [[`814e3a5f1d`](https://github.com/fibjs/fibjs/commit/814e3a5f1d)] - dev v0.13.0-dev(xicilion)
* [[`c7a6d2565c`](https://github.com/fibjs/fibjs/commit/c7a6d2565c)] - Release v0.12.0(xicilion)
* [[`8d729e1a9d`](https://github.com/fibjs/fibjs/commit/8d729e1a9d)] - **sandbox, bugfix**: jsc test file load error.(xicilion)
* [[`7ffc201fae`](https://github.com/fibjs/fibjs/commit/7ffc201fae)] - **iconv, bugfix**: multi char utf-16 decode error.(xicilion)
* [[`29f63c319e`](https://github.com/fibjs/fibjs/commit/29f63c319e)] - **punycode, bugfix**: compile warning on windows x86.(响马)
* [[`5e24e08983`](https://github.com/fibjs/fibjs/commit/5e24e08983)] - **v8, feat**: upgrade to v6.2.377.(响马)
* [[`dc9d0afa70`](https://github.com/fibjs/fibjs/commit/dc9d0afa70)] - **iconv, feat**: support ucs4 codec.(响马)
* [[`195314e86c`](https://github.com/fibjs/fibjs/commit/195314e86c)] - **iconv, bugfix**: unicode 0xd800 convert error.(响马)
* [[`e359be21f5`](https://github.com/fibjs/fibjs/commit/e359be21f5)] - **core, refactor**: use new NewString convert string to v8 Value, fix v8 utf8 issue.(响马)
* [[`b0f49372f2`](https://github.com/fibjs/fibjs/commit/b0f49372f2)] - **iconv, feat**: support ucs2, utf16le codec.(响马)
* [[`d235fc204f`](https://github.com/fibjs/fibjs/commit/d235fc204f)] - **re, break**: deprecated module re.(响马)
* [[`6a02c5201d`](https://github.com/fibjs/fibjs/commit/6a02c5201d)] - **core, bugfix**: disable parallel scavenge, fix gc deadlock.(响马)
* [[`4ff74b2b22`](https://github.com/fibjs/fibjs/commit/4ff74b2b22)] - **punycode, bugfix**: compile error on linux.(响马)
* [[`f2fb96a312`](https://github.com/fibjs/fibjs/commit/f2fb96a312)] - **docs**: remove old docs.(响马)
* [[`d53df147e1`](https://github.com/fibjs/fibjs/commit/d53df147e1)] - **punycode, feat**: support native module punycode.(响马)
* [[`f52f2dedc3`](https://github.com/fibjs/fibjs/commit/f52f2dedc3)] - **util, refactor**: method format check native object first.(响马)
* [[`d3587e7fe0`](https://github.com/fibjs/fibjs/commit/d3587e7fe0)] - **db, feat**: query result NULL is converted to null in MySQL and SQLite (#334)(blingz)
* [[`c1a79a0004`](https://github.com/fibjs/fibjs/commit/c1a79a0004)] - **db, feat**: undefined / null are converted to NULL (#333)(blingz)
* [[`51f58f3578`](https://github.com/fibjs/fibjs/commit/51f58f3578)] - **core, feat**: support ucs2 string convert.(响马)
* [[`350a328ca0`](https://github.com/fibjs/fibjs/commit/350a328ca0)] - **core, refactor**: rename utf8 api, support wchar32.(响马)
* [[`82a9924bc4`](https://github.com/fibjs/fibjs/commit/82a9924bc4)] - **bugfix**: compile warning in debug mode.(响马)
* [[`8f9d6450f9`](https://github.com/fibjs/fibjs/commit/8f9d6450f9)] - **db, bugfix**: fix typo.(响马)
* [[`5b67d542a9`](https://github.com/fibjs/fibjs/commit/5b67d542a9)] - **db, refactor**: use simpleObject to return the query result of execute.(响马)
* [[`e5a98ede0d`](https://github.com/fibjs/fibjs/commit/e5a98ede0d)] - **core, feat**: SimpleObject support Array.(响马)
* [[`ee9b215c57`](https://github.com/fibjs/fibjs/commit/ee9b215c57)] - **vs, feat**: generate vc proj file.(响马)
* [[`9f76fa8627`](https://github.com/fibjs/fibjs/commit/9f76fa8627)] - **core**: bugfix: method count error in class info of  object.(响马)
* [[`97cfa51b53`](https://github.com/fibjs/fibjs/commit/97cfa51b53)] - **core, bugfix**: compile warning on windows debug.(响马)
* [[`ce2963d1f1`](https://github.com/fibjs/fibjs/commit/ce2963d1f1)] - **test, bugfix**: callback hungup when execute return error.(响马)
* [[`9ef7ae593d`](https://github.com/fibjs/fibjs/commit/9ef7ae593d)] - **net, refactor**: use SimpleObject to build the result of method recvfrom.(响马)
* [[`354f580471`](https://github.com/fibjs/fibjs/commit/354f580471)] - **idlc, refactor**: not refer object_base.(响马)
* [[`731e7de9da`](https://github.com/fibjs/fibjs/commit/731e7de9da)] - **Variant, refactor**: use valueOf to convert object_base to JavaScript Value.(响马)
* [[`62698ce857`](https://github.com/fibjs/fibjs/commit/62698ce857)] - **core, feat**: Implement SimpleObject to build simple JavaScript Object from native.(响马)
* [[`789d30f24a`](https://github.com/fibjs/fibjs/commit/789d30f24a)] - **core, refactor**: use valueOf to get the wrap of native object.(响马)
* [[`def3f5fab6`](https://github.com/fibjs/fibjs/commit/def3f5fab6)] - **object, break**: deprecated valueOf.(响马)
* [[`43c42740cf`](https://github.com/fibjs/fibjs/commit/43c42740cf)] - **Int64, break**: deprecated valueOf.(响马)
* [[`95c2e5aaa6`](https://github.com/fibjs/fibjs/commit/95c2e5aaa6)] - **test, feat**: support this in test function.(响马)
* [[`1f43374a7c`](https://github.com/fibjs/fibjs/commit/1f43374a7c)] - **crypto, feat**: support crypto.createHmac.(响马)
* [[`754a0ffe7f`](https://github.com/fibjs/fibjs/commit/754a0ffe7f)] - delete unused file.(响马)
* [[`9424db39a3`](https://github.com/fibjs/fibjs/commit/9424db39a3)] - **core, feat**: not ignore nan in arguments.(响马)
* [[`0f3f0ee885`](https://github.com/fibjs/fibjs/commit/0f3f0ee885)] - **Buffer, feat**: Buffer.write* return new offset, compatible with node.js.(响马)
* [[`f990110958`](https://github.com/fibjs/fibjs/commit/f990110958)] - **HttpCookie, feat**: path=/ as default value in cookie (#332)(blingz)

## 2017-08-27, Version v0.12.0

* **feature** :
    * Buffer - Buffer.write* return new offset, compatible with node.js.(响马)
    * core:
      - support ucs2 string convert.(响马)
      - SimpleObject support Array.(响马)
      - Implement SimpleObject to build simple JavaScript Object from native.(响马)
      - not ignore nan in arguments.(响马)
    * crypto - support crypto.createHmac.(响马)
    * db:
      - query result NULL is converted to null in MySQL and SQLite (#334)(blingz)
      - undefined / null are converted to NULL (#333)(blingz)
    * HttpCookie - path=/ as default value in cookie (#332)(blingz)
    * iconv:
      - support ucs4 codec.(响马)
      - support ucs2, utf16le codec.(响马)
    * punycode - support native module punycode.(响马)
    * test - support this in test function.(响马)
    * v8 - upgrade to v6.2.377.(响马)
    * vs - generate vc proj file.(响马)

* **breakchange** :
    * Int64 - deprecated valueOf.(响马)
    * object - deprecated valueOf.(响马)
    * re - deprecated module re.(响马)

* **bugfix** :
    * core:
      - disable parallel scavenge, fix gc deadlock.(响马)
      - compile warning on windows debug.(响马)
      - method count error in class info of  object.(响马)
    * db - fix typo.(响马)
    * iconv:
      - multi char utf-16 decode error.(xicilion)
      - unicode 0xd800 convert error.(响马)
    * punycode:
      - compile warning on windows x86.(响马)
      - compile error on linux.(响马)
    * sandbox - jsc test file load error.(xicilion)
    * test - callback hungup when execute return error.(响马)

* **refactor** :
    * core:
      - use new NewString convert string to v8 Value, fix v8 utf8 issue.(响马)
      - rename utf8 api, support wchar32.(响马)
      - use valueOf to get the wrap of native object.(响马)
    * db - use simpleObject to return the query result of execute.(响马)
    * idlc - not refer object_base.(响马)
    * net - use SimpleObject to build the result of method recvfrom.(响马)
    * util - method format check native object first.(响马)
    * Variant - use valueOf to convert object_base to JavaScript Value.(响马)

### Commits
* [[`8d729e1a9d`](https://github.com/fibjs/fibjs/commit/8d729e1a9d)] - **sandbox, bugfix**: jsc test file load error.(xicilion)
* [[`7ffc201fae`](https://github.com/fibjs/fibjs/commit/7ffc201fae)] - **iconv, bugfix**: multi char utf-16 decode error.(xicilion)
* [[`29f63c319e`](https://github.com/fibjs/fibjs/commit/29f63c319e)] - **punycode, bugfix**: compile warning on windows x86.(响马)
* [[`5e24e08983`](https://github.com/fibjs/fibjs/commit/5e24e08983)] - **v8, feat**: upgrade to v6.2.377.(响马)
* [[`dc9d0afa70`](https://github.com/fibjs/fibjs/commit/dc9d0afa70)] - **iconv, feat**: support ucs4 codec.(响马)
* [[`195314e86c`](https://github.com/fibjs/fibjs/commit/195314e86c)] - **iconv, bugfix**: unicode 0xd800 convert error.(响马)
* [[`e359be21f5`](https://github.com/fibjs/fibjs/commit/e359be21f5)] - **core, refactor**: use new NewString convert string to v8 Value, fix v8 utf8 issue.(响马)
* [[`b0f49372f2`](https://github.com/fibjs/fibjs/commit/b0f49372f2)] - **iconv, feat**: support ucs2, utf16le codec.(响马)
* [[`d235fc204f`](https://github.com/fibjs/fibjs/commit/d235fc204f)] - **re, break**: deprecated module re.(响马)
* [[`6a02c5201d`](https://github.com/fibjs/fibjs/commit/6a02c5201d)] - **core, bugfix**: disable parallel scavenge, fix gc deadlock.(响马)
* [[`4ff74b2b22`](https://github.com/fibjs/fibjs/commit/4ff74b2b22)] - **punycode, bugfix**: compile error on linux.(响马)
* [[`f2fb96a312`](https://github.com/fibjs/fibjs/commit/f2fb96a312)] - **docs**: remove old docs.(响马)
* [[`d53df147e1`](https://github.com/fibjs/fibjs/commit/d53df147e1)] - **punycode, feat**: support native module punycode.(响马)
* [[`f52f2dedc3`](https://github.com/fibjs/fibjs/commit/f52f2dedc3)] - **util, refactor**: method format check native object first.(响马)
* [[`d3587e7fe0`](https://github.com/fibjs/fibjs/commit/d3587e7fe0)] - **db, feat**: query result NULL is converted to null in MySQL and SQLite (#334)(blingz)
* [[`c1a79a0004`](https://github.com/fibjs/fibjs/commit/c1a79a0004)] - **db, feat**: undefined / null are converted to NULL (#333)(blingz)
* [[`51f58f3578`](https://github.com/fibjs/fibjs/commit/51f58f3578)] - **core, feat**: support ucs2 string convert.(响马)
* [[`350a328ca0`](https://github.com/fibjs/fibjs/commit/350a328ca0)] - **core, refactor**: rename utf8 api, support wchar32.(响马)
* [[`82a9924bc4`](https://github.com/fibjs/fibjs/commit/82a9924bc4)] - **bugfix**: compile warning in debug mode.(响马)
* [[`8f9d6450f9`](https://github.com/fibjs/fibjs/commit/8f9d6450f9)] - **db, bugfix**: fix typo.(响马)
* [[`5b67d542a9`](https://github.com/fibjs/fibjs/commit/5b67d542a9)] - **db, refactor**: use simpleObject to return the query result of execute.(响马)
* [[`e5a98ede0d`](https://github.com/fibjs/fibjs/commit/e5a98ede0d)] - **core, feat**: SimpleObject support Array.(响马)
* [[`ee9b215c57`](https://github.com/fibjs/fibjs/commit/ee9b215c57)] - **vs, feat**: generate vc proj file.(响马)
* [[`9f76fa8627`](https://github.com/fibjs/fibjs/commit/9f76fa8627)] - **core**: bugfix: method count error in class info of  object.(响马)
* [[`97cfa51b53`](https://github.com/fibjs/fibjs/commit/97cfa51b53)] - **core, bugfix**: compile warning on windows debug.(响马)
* [[`ce2963d1f1`](https://github.com/fibjs/fibjs/commit/ce2963d1f1)] - **test, bugfix**: callback hungup when execute return error.(响马)
* [[`9ef7ae593d`](https://github.com/fibjs/fibjs/commit/9ef7ae593d)] - **net, refactor**: use SimpleObject to build the result of method recvfrom.(响马)
* [[`354f580471`](https://github.com/fibjs/fibjs/commit/354f580471)] - **idlc, refactor**: not refer object_base.(响马)
* [[`731e7de9da`](https://github.com/fibjs/fibjs/commit/731e7de9da)] - **Variant, refactor**: use valueOf to convert object_base to JavaScript Value.(响马)
* [[`62698ce857`](https://github.com/fibjs/fibjs/commit/62698ce857)] - **core, feat**: Implement SimpleObject to build simple JavaScript Object from native.(响马)
* [[`789d30f24a`](https://github.com/fibjs/fibjs/commit/789d30f24a)] - **core, refactor**: use valueOf to get the wrap of native object.(响马)
* [[`def3f5fab6`](https://github.com/fibjs/fibjs/commit/def3f5fab6)] - **object, break**: deprecated valueOf.(响马)
* [[`43c42740cf`](https://github.com/fibjs/fibjs/commit/43c42740cf)] - **Int64, break**: deprecated valueOf.(响马)
* [[`95c2e5aaa6`](https://github.com/fibjs/fibjs/commit/95c2e5aaa6)] - **test, feat**: support this in test function.(响马)
* [[`1f43374a7c`](https://github.com/fibjs/fibjs/commit/1f43374a7c)] - **crypto, feat**: support crypto.createHmac.(响马)
* [[`754a0ffe7f`](https://github.com/fibjs/fibjs/commit/754a0ffe7f)] - delete unused file.(响马)
* [[`9424db39a3`](https://github.com/fibjs/fibjs/commit/9424db39a3)] - **core, feat**: not ignore nan in arguments.(响马)
* [[`0f3f0ee885`](https://github.com/fibjs/fibjs/commit/0f3f0ee885)] - **Buffer, feat**: Buffer.write* return new offset, compatible with node.js.(响马)
* [[`f990110958`](https://github.com/fibjs/fibjs/commit/f990110958)] - **HttpCookie, feat**: path=/ as default value in cookie (#332)(blingz)

## 2017-08-19, Version v0.11.0

* **feature** :
    * Buffer:
      - add Buffer.entries() (#326)(Hengfei Zhuang)
      - remove Buffer.Compare.(响马)
      - support Buffer.Compare and Buffer.isEncoding (#322)(tapir)
      - support new Buffer(DataView);(响马)
      - Buffer.from support byteOffset and length.(响马)
      - add keys and values method in Buffer Class. (#312)(tapir)
      - support Buffer.reverse.(响马)
      - support Buffer.allocUnsafe and  Buffer.allocUnsafeSlow method(响马)
      - support Buffer.alloc method. (#319)(tapir)
      - support Buffer.byteLength method. (#317)(tapir)
      - support require('buffer').Buffer.(响马)
    * build - disable parallel compile in Windows Debug mode.(响马)
    * ci - upgrade xcode version.(响马)
    * console - in Windows gui mode, call console.log popup console.(响马)
    * core:
      - ignore nan arguments.(响马)
      - continue js default process when _named_setter return NULL.(响马)
      - enable modify the built-in object in strict mode (#311)(Hengfei Zhuang)
    * crypto - support crypto.createHash.(响马)
    * db - allow modify the propertis of DBRow.(响马)
    * Digest - Digest.update return Digest object itself.(响马)
    * doc - warning about postMessage may lose messages.(响马)
    * docs - fix doc error.(响马)
    * idlc - support ...args syntax, Use Array to pass variable-length arguments.(响马)
    * Int64 - add multi & div (#309)(Hengfei Zhuang)
    * list - return null when index out of range.(响马)
    * mq - add 2 cases about memory leak.(响马)
    * PKey:
      - PKey.verify support algo.(响马)
      - importKey docs.(响马)
      - support import/export jwe format json.(响马)
    * process - use SIGINT to stop child process.(响马)
    * Routing:
      - sub routing document.(响马)
      - support sub routing.(响马)
      - support method chaining.(响马)
      - support express compatible path template.(响马)
    * TcpServer:
      - hold the server until all connection closed.(响马)
      - server holder not wrap js object.(响马)
    * test - add async execute test.(响马)
    * tools - automatically generate changelog.(响马)
    * v8 - upgrade to v6.2.219.(响马)
    * WebSocket - add sample code.(响马)
    * WebView:
      - document new api.(响马)
      - async open webview in gui.open.(响马)
      - add test case.(响马)
      - disable console.log when debug option set to false. the debug option defaults to true.(响马)
      - redirect the webview console to the fibjs log system.(响马)
      - set the default version to the highest version.(响马)
      - log web script error to console.error.(响马)
      - support window.close.(响马)

* **breakchange** :
    * Buffer - compact with Uint8Array setter (#330)(Hengfei Zhuang)
    * core:
      - compact with node index getter (#329)(Hengfei Zhuang)
      - not catch ctrl-c.(响马)
    * Routing:
      - remove method Routing.append(method, map);(响马)
      - msg.value is not modified when no child is matched.(响马)
    * WebView - emit onclose event instead of onmessage('close').(响马)

* **bugfix** :
    * Buffer:
      - compile warning on windows.(响马)
      - unused variable.(响马)
      - fix idl error.(响马)
    * core - do not skip undefined args in ...args mode.(响马)
    * event - app crash when emit an event on a no-js object.(响马)
    * fiber - compile error in debug mode.(响马)
    * HttpRequest - the cookie is not processed when the request object is reused.(响马)
    * mongo - lock the database when the cursor is destroyed asynchronously.(响马)
    * mssql - fix memory leak in mssql.execute (#310)(onceyoung)
    * PKey - compile warning on windows.(响马)
    * redis - fix test case error.(响马)
    * sanbox - fix error when require('.') and require('..').(响马)
    * SandBox - require('..') is not equal require('../') on Windows XP;(响马)
    * TcpServer - hold the js object during the execution of the server.run method.(响马)
    * test - restore env in windows, fix WebView test crash.(响马)
    * v8 - enable bigobj, fix compile error on windows debug mode.(响马)
    * WebSocket - on('message', func) not emit in ws.upgrade.(响马)
    * WebView:
      - console not inject in IE8.(响马)
      - remove unused output.(响马)
      - app crash when error source is null.(响马)
      - app crash when close an alert dialog box.(响马)
      - html document is not ready when the NavigateComplete2 event fired.(响马)
      - not trigger 'load' event when iframe loaded.(响马)

* **refactor** :
    * Buffer:
      - use ByteLength function to get length.(响马)
      - use the Buffer constructor conversion type.(响马)
      - format code.(响马)
    * console - switch to ...args syntax.(响马)
    * core:
      - not ref/unref when obj pointer not changed.(响马)
      - rewrite naked_ptr, change the pointer access mode.(响马)
      - declare OptArgs to process ...args.(响马)
      - use std::vector to transfer ...args.(响马)
    * coroutine - switch to ...args syntax.(响马)
    * db:
      - change execute(fmt, ...args) to real async mode.(响马)
      - switch to ...args syntax.(响马)
    * event - switch to ...args syntax.(响马)
    * events - support onEventTrigger virtual method.(响马)
    * http:
      - store the error handler separately.(响马)
      - change http.request to real async mode.(响马)
    * List - switch to ...args syntax.(响马)
    * mongo - remove useless code (#325)(Hengfei Zhuang)
    * mq:
      - use getArgumentValue to convert handler from value.(响马)
      - use obj_ptr to save handler poinger.(响马)
    * path - switch to ...args syntax.(响马)
    * redis - switch to ...args syntax.(响马)
    * SandBox - Unify the code used to detect relative paths.(响马)
    * util:
      - switch to ...args syntax.(响马)
      - util.extend switch to ...args syntax.(响马)

### Commits
* [[`fce451eb6d`](https://github.com/fibjs/fibjs/commit/fce451eb6d)] - **Buffer, break**: compact with Uint8Array setter (#330)(Hengfei Zhuang)
* [[`9d65e24eae`](https://github.com/fibjs/fibjs/commit/9d65e24eae)] - **core, break**: compact with node index getter (#329)(Hengfei Zhuang)
* [[`ba4c6197db`](https://github.com/fibjs/fibjs/commit/ba4c6197db)] - **tools, feat**: automatically generate changelog.(响马)
* [[`b1234a74ad`](https://github.com/fibjs/fibjs/commit/b1234a74ad)] - **Routing, feat**: sub routing document.(响马)
* [[`bc84cc78d9`](https://github.com/fibjs/fibjs/commit/bc84cc78d9)] - **Routing, feat**: support sub routing.(响马)
* [[`37da2d21ba`](https://github.com/fibjs/fibjs/commit/37da2d21ba)] - **Buffer, feat**: add Buffer.entries() (#326)(Hengfei Zhuang)
* [[`6d13eafe60`](https://github.com/fibjs/fibjs/commit/6d13eafe60)] - **Routing, break**: remove method Routing.append(method, map);(响马)
* [[`0e47076fc4`](https://github.com/fibjs/fibjs/commit/0e47076fc4)] - **mongo, refactor**: remove useless code (#325)(Hengfei Zhuang)
* [[`8caa3366e8`](https://github.com/fibjs/fibjs/commit/8caa3366e8)] - **mq, refactor**: use getArgumentValue to convert handler from value.(响马)
* [[`78c458c9df`](https://github.com/fibjs/fibjs/commit/78c458c9df)] - **WebSocket, feat**: add sample code.(响马)
* [[`2855a51c00`](https://github.com/fibjs/fibjs/commit/2855a51c00)] - **WebSocket, bugfix**: on('message', func) not emit in ws.upgrade.(响马)
* [[`88a8b021fc`](https://github.com/fibjs/fibjs/commit/88a8b021fc)] - **events, refactor**: support onEventTrigger virtual method.(响马)
* [[`43759997be`](https://github.com/fibjs/fibjs/commit/43759997be)] - **docs, feat**: fix doc error.(响马)
* [[`25cdcee4f3`](https://github.com/fibjs/fibjs/commit/25cdcee4f3)] - **Routing, feat**: support method chaining.(响马)
* [[`79d9856a0c`](https://github.com/fibjs/fibjs/commit/79d9856a0c)] - **WebView, feat**: document new api.(响马)
* [[`174a39d39b`](https://github.com/fibjs/fibjs/commit/174a39d39b)] - **Buffer, feat**: remove Buffer.Compare.(响马)
* [[`cc2fd7be17`](https://github.com/fibjs/fibjs/commit/cc2fd7be17)] - **ci, feat**: upgrade xcode version.(响马)
* [[`be9b9830aa`](https://github.com/fibjs/fibjs/commit/be9b9830aa)] - **Buffer, feat**: support Buffer.Compare and Buffer.isEncoding (#322)(tapir)
* [[`87eb352358`](https://github.com/fibjs/fibjs/commit/87eb352358)] - **Buffer, bugfix**: compile warning on windows.(响马)
* [[`8759232b1c`](https://github.com/fibjs/fibjs/commit/8759232b1c)] - **v8, feat**: upgrade to v6.2.219.(响马)
* [[`92d0c6a6f6`](https://github.com/fibjs/fibjs/commit/92d0c6a6f6)] - **Buffer, refactor**: use ByteLength function to get length.(响马)
* [[`b5d66ec92e`](https://github.com/fibjs/fibjs/commit/b5d66ec92e)] - **Buffer, refactor**: use the Buffer constructor conversion type.(响马)
* [[`0350d36e18`](https://github.com/fibjs/fibjs/commit/0350d36e18)] - **Buffer, feat**: support new Buffer(DataView);(响马)
* [[`e90a53e704`](https://github.com/fibjs/fibjs/commit/e90a53e704)] - **HttpRequest, bugfix**: the cookie is not processed when the request object is reused.(响马)
* [[`4240334ddd`](https://github.com/fibjs/fibjs/commit/4240334ddd)] - **Buffer, feat**: Buffer.from support byteOffset and length.(响马)
* [[`cd5ca14d76`](https://github.com/fibjs/fibjs/commit/cd5ca14d76)] - **Buffer, feat**: support Buffer.reverse.(响马)
* [[`6e9f705482`](https://github.com/fibjs/fibjs/commit/6e9f705482)] - **core, feat**: ignore nan arguments.(响马)
* [[`353d9ca9e4`](https://github.com/fibjs/fibjs/commit/353d9ca9e4)] - **crypto, feat**: support crypto.createHash.(响马)
* [[`91ce2f2220`](https://github.com/fibjs/fibjs/commit/91ce2f2220)] - **Digest, feat**: Digest.update return Digest object itself.(响马)
* [[`afc7d34c29`](https://github.com/fibjs/fibjs/commit/afc7d34c29)] - **Buffer, feat**: support Buffer.allocUnsafe and  Buffer.allocUnsafeSlow method(响马)
* [[`bcefc365de`](https://github.com/fibjs/fibjs/commit/bcefc365de)] - **mq, refactor**: use obj_ptr to save handler poinger.(响马)
* [[`6de04d0d93`](https://github.com/fibjs/fibjs/commit/6de04d0d93)] - **mq, feat**: add 2 cases about memory leak.(响马)
* [[`7d93938bf9`](https://github.com/fibjs/fibjs/commit/7d93938bf9)] - **TcpServer, feat**: hold the server until all connection closed.(响马)
* [[`53cd55304d`](https://github.com/fibjs/fibjs/commit/53cd55304d)] - **docs**: fix param error.(响马)
* [[`4abd7caf3c`](https://github.com/fibjs/fibjs/commit/4abd7caf3c)] - **Buffer, feat**: support Buffer.alloc method. (#319)(tapir)
* [[`938b7003df`](https://github.com/fibjs/fibjs/commit/938b7003df)] - **TcpServer, feat**: server holder not wrap js object.(响马)
* [[`1d807d52a4`](https://github.com/fibjs/fibjs/commit/1d807d52a4)] - **PKey, feat**: PKey.verify support algo.(响马)
* [[`c472d32407`](https://github.com/fibjs/fibjs/commit/c472d32407)] - **TcpServer, bugfix**: hold the js object during the execution of the server.run method.(响马)
* [[`4d57776396`](https://github.com/fibjs/fibjs/commit/4d57776396)] - **http, refactor**: store the error handler separately.(响马)
* [[`444d00e486`](https://github.com/fibjs/fibjs/commit/444d00e486)] - **core, refactor**: not ref/unref when obj pointer not changed.(响马)
* [[`88b760b636`](https://github.com/fibjs/fibjs/commit/88b760b636)] - **vender**: update vender version.(响马)
* [[`96f6a34f4d`](https://github.com/fibjs/fibjs/commit/96f6a34f4d)] - **Buffer, feat**: support Buffer.byteLength method. (#317)(tapir)
* [[`53636a9347`](https://github.com/fibjs/fibjs/commit/53636a9347)] - **core, refactor**: rewrite naked_ptr, change the pointer access mode.(响马)
* [[`ffd9dc4673`](https://github.com/fibjs/fibjs/commit/ffd9dc4673)] - **WebView, feat**: async open webview in gui.open.(响马)
* [[`b1828ada4e`](https://github.com/fibjs/fibjs/commit/b1828ada4e)] - **SandBox, bugfix**: require('..') is not equal require('../') on Windows XP;(响马)
* [[`c977e4849d`](https://github.com/fibjs/fibjs/commit/c977e4849d)] - **SandBox, refactor**: Unify the code used to detect relative paths.(响马)
* [[`7474b3f275`](https://github.com/fibjs/fibjs/commit/7474b3f275)] - **test, bugfix**: restore env in windows, fix WebView test crash.(响马)
* [[`7dff9943f1`](https://github.com/fibjs/fibjs/commit/7dff9943f1)] - **WebView, feat**: add test case.(响马)
* [[`63e8f87198`](https://github.com/fibjs/fibjs/commit/63e8f87198)] - **WebView, bugfix**: console not inject in IE8.(响马)
* [[`99a3d14160`](https://github.com/fibjs/fibjs/commit/99a3d14160)] - **WebView, feat**: disable console.log when debug option set to false. the debug option defaults to true.(响马)
* [[`6959f5674e`](https://github.com/fibjs/fibjs/commit/6959f5674e)] - **WebView, bugfix**: remove unused output.(响马)
* [[`2e2fcfb5dd`](https://github.com/fibjs/fibjs/commit/2e2fcfb5dd)] - **WebView, feat**: redirect the webview console to the fibjs log system.(响马)
* [[`ad37384c40`](https://github.com/fibjs/fibjs/commit/ad37384c40)] - **event, bugfix**: app crash when emit an event on a no-js object.(响马)
* [[`be85001b58`](https://github.com/fibjs/fibjs/commit/be85001b58)] - **WebView, bugfix**: app crash when error source is null.(响马)
* [[`ba52c7830f`](https://github.com/fibjs/fibjs/commit/ba52c7830f)] - **WebView, feat**: set the default version to the highest version.(响马)
* [[`c6a06404ab`](https://github.com/fibjs/fibjs/commit/c6a06404ab)] - **build, feat**: disable parallel compile in Windows Debug mode.(响马)
* [[`74ffaea233`](https://github.com/fibjs/fibjs/commit/74ffaea233)] - **WebView, bugfix**: app crash when close an alert dialog box.(响马)
* [[`72a942ebac`](https://github.com/fibjs/fibjs/commit/72a942ebac)] - **vender**: update vender version.(响马)
* [[`6da1126a78`](https://github.com/fibjs/fibjs/commit/6da1126a78)] - **v8, bugfix**: enable bigobj, fix compile error on windows debug mode.(响马)
* [[`4825ac82a6`](https://github.com/fibjs/fibjs/commit/4825ac82a6)] - **WebView, bugfix**: html document is not ready when the NavigateComplete2 event fired.(响马)
* [[`41642f44d0`](https://github.com/fibjs/fibjs/commit/41642f44d0)] - **WebView, feat**: log web script error to console.error.(响马)
* [[`4093dbb6cc`](https://github.com/fibjs/fibjs/commit/4093dbb6cc)] - **console, feat**: in Windows gui mode, call console.log popup console.(响马)
* [[`b953f0351b`](https://github.com/fibjs/fibjs/commit/b953f0351b)] - **Buffer, refactor**: format code.(响马)
* [[`0753f74164`](https://github.com/fibjs/fibjs/commit/0753f74164)] - **Buffer, bugfix**: unused variable.(响马)
* [[`9bf02c751f`](https://github.com/fibjs/fibjs/commit/9bf02c751f)] - **PKey, bugfix**: compile warning on windows.(响马)
* [[`a31745cfa3`](https://github.com/fibjs/fibjs/commit/a31745cfa3)] - **PKey, feat**: importKey docs.(响马)
* [[`30d38fee20`](https://github.com/fibjs/fibjs/commit/30d38fee20)] - **Buffer, bugfix**: fix idl error.(响马)
* [[`be727204db`](https://github.com/fibjs/fibjs/commit/be727204db)] - **PKey, feat**: support import/export jwe format json.(响马)
* [[`1b8f0b10e4`](https://github.com/fibjs/fibjs/commit/1b8f0b10e4)] - **Buffer, feat**: support require('buffer').Buffer.(响马)
* [[`8858e823ee`](https://github.com/fibjs/fibjs/commit/8858e823ee)] - **mongo, bugfix**: lock the database when the cursor is destroyed asynchronously.(响马)
* [[`bd12bbd2f7`](https://github.com/fibjs/fibjs/commit/bd12bbd2f7)] - **Routing, feat**: support express compatible path template.(响马)
* [[`50b55bc37c`](https://github.com/fibjs/fibjs/commit/50b55bc37c)] - add keys and values method in Buffer Class. (#312)(tapir)
* [[`33db04d4b4`](https://github.com/fibjs/fibjs/commit/33db04d4b4)] - **process, feat**: use SIGINT to stop child process.(响马)
* [[`8222ba0eff`](https://github.com/fibjs/fibjs/commit/8222ba0eff)] - **core, break**: not catch ctrl-c.(响马)
* [[`28fb345af6`](https://github.com/fibjs/fibjs/commit/28fb345af6)] - **WebView, break**: emit onclose event instead of onmessage('close').(响马)
* [[`3ad67e0574`](https://github.com/fibjs/fibjs/commit/3ad67e0574)] - **db, feat**: allow modify the propertis of DBRow.(响马)
* [[`92d90cbc8c`](https://github.com/fibjs/fibjs/commit/92d90cbc8c)] - **list, feat**: return null when index out of range.(响马)
* [[`91497973d0`](https://github.com/fibjs/fibjs/commit/91497973d0)] - **core, feat**: continue js default process when _named_setter return NULL.(响马)
* [[`a517cb1345`](https://github.com/fibjs/fibjs/commit/a517cb1345)] - **sanbox, bugfix**: fix error when require('.') and require('..').(响马)
* [[`6369fcc019`](https://github.com/fibjs/fibjs/commit/6369fcc019)] - **http, refactor**: change http.request to real async mode.(响马)
* [[`485f218bac`](https://github.com/fibjs/fibjs/commit/485f218bac)] - **test, feat**: add async execute test.(响马)
* [[`5d3e99e6e0`](https://github.com/fibjs/fibjs/commit/5d3e99e6e0)] - **db, refactor**: change execute(fmt, ...args) to real async mode.(响马)
* [[`bacf979fb8`](https://github.com/fibjs/fibjs/commit/bacf979fb8)] - **core, refactor**: declare OptArgs to process ...args.(响马)
* [[`cf5e8828b2`](https://github.com/fibjs/fibjs/commit/cf5e8828b2)] - **redis, refactor**: switch to ...args syntax.(响马)
* [[`c412a6f05e`](https://github.com/fibjs/fibjs/commit/c412a6f05e)] - **fiber, bugfix**: compile error in debug mode.(响马)
* [[`eae39d2f22`](https://github.com/fibjs/fibjs/commit/eae39d2f22)] - **core, refactor**: use std::vector to transfer ...args.(响马)
* [[`9fdf8181ce`](https://github.com/fibjs/fibjs/commit/9fdf8181ce)] - **core, feat**: enable modify the built-in object in strict mode (#311)(Hengfei Zhuang)
* [[`445be030e1`](https://github.com/fibjs/fibjs/commit/445be030e1)] - **redis, bugfix**: fix test case error.(响马)
* [[`e920013038`](https://github.com/fibjs/fibjs/commit/e920013038)] - **event, refactor**: switch to ...args syntax.(响马)
* [[`525f6e5984`](https://github.com/fibjs/fibjs/commit/525f6e5984)] - **db, refactor**: switch to ...args syntax.(响马)
* [[`868daf45b8`](https://github.com/fibjs/fibjs/commit/868daf45b8)] - **path, refactor**: switch to ...args syntax.(响马)
* [[`87519007fe`](https://github.com/fibjs/fibjs/commit/87519007fe)] - **List, refactor**: switch to ...args syntax.(响马)
* [[`9148441329`](https://github.com/fibjs/fibjs/commit/9148441329)] - **console, refactor**: switch to ...args syntax.(响马)
* [[`4175472893`](https://github.com/fibjs/fibjs/commit/4175472893)] - **core, bugfix**: do not skip undefined args in ...args mode.(响马)
* [[`886fd8b99c`](https://github.com/fibjs/fibjs/commit/886fd8b99c)] - **coroutine, refactor**: switch to ...args syntax.(响马)
* [[`5347b405a3`](https://github.com/fibjs/fibjs/commit/5347b405a3)] - **util, refactor**: switch to ...args syntax.(响马)
* [[`bb5d8b5141`](https://github.com/fibjs/fibjs/commit/bb5d8b5141)] - Merge branch 'master' into dev(响马)
* [[`7ab0252bff`](https://github.com/fibjs/fibjs/commit/7ab0252bff)] - fix memory leak in mssql.execute (#310)(onceyoung)
* [[`67451f6574`](https://github.com/fibjs/fibjs/commit/67451f6574)] - **util, refactor**: util.extend switch to ...args syntax.(响马)
* [[`fd5a746377`](https://github.com/fibjs/fibjs/commit/fd5a746377)] - **idlc, feat**: support ...args syntax, Use Array to pass variable-length arguments.(响马)
* [[`88d2ede145`](https://github.com/fibjs/fibjs/commit/88d2ede145)] - **WebView, bugfix**: not trigger 'load' event when iframe loaded.(响马)
* [[`86baa1177b`](https://github.com/fibjs/fibjs/commit/86baa1177b)] - **WebView, feat**: support window.close.(响马)
* [[`c6c5b549ba`](https://github.com/fibjs/fibjs/commit/c6c5b549ba)] - **doc, feat**: warning about postMessage may lose messages.(响马)
* [[`0e2b30ad96`](https://github.com/fibjs/fibjs/commit/0e2b30ad96)] - **Int64, feat**: add multi & div (#309)(Hengfei Zhuang)
* [[`e76778caa0`](https://github.com/fibjs/fibjs/commit/e76778caa0)] - **Routing, break**: msg.value is not modified when no child is matched.(响马)
* [[`88b21e314a`](https://github.com/fibjs/fibjs/commit/88b21e314a)] - update vscode setting.(响马)

## 2017-07-31, Version v0.10.0

* **refactor** :
    * fiber:
      - switch worker back to thread mode in windows. (xicilion)
      - use fiber worker in windows, enable full feature of multi thread fiber. (xicilion)
      - abstract fiber api. (xicilion)
    * async - move the result checker into the class to reconstruct the source code. (xicilion)
    * core - use ac->isAsync to test async mode. (xicilion)
    * console - use cc_ function instead of ac. (xicilion)
    * sanbox - not clone the module return by callback. (xicilion)
    * fs - cache files until the zip package is changed. (xicilion)
    * test - use path.join to build file name. (xicilion)

* **bugfix** :
    * sandbox:
      - remove unused variable. (xicilion)
      - resolve search root folder twice on windows. (xicilion)
      - circular dependency error when module.exports is changed.. (xicilion)
    * leveldb - db.between not include the begin key. (xicilion)
    * mongodb - ensureIndex error on mongodb v3.0+ . (xicilion)
    * net - compile warning in debug mode. (xicilion)

* **breakchange** :
    * core - only use the args before entry script as the system options. (xicilion)

* **deps** :
    * v8 - v6.2.52. (xicilion)

### Commits

* [[`f3a5386cc3`](https://github.com/fibjs/fibjs/commit/f3a5386cc3)] - **async, refactor**: move the result checker into the class to reconstruct the source code. (xicilion)
* [[`76a2bd5567`](https://github.com/fibjs/fibjs/commit/76a2bd5567)] - **fiber, refactor**: switch worker back to thread mode in windows. (xicilion)
* [[`d5304df12f`](https://github.com/fibjs/fibjs/commit/d5304df12f)] - **fiber, refactor**: use fiber worker in windows, enable full feature of multi thread fiber. (xicilion)
* [[`7c4a5bd368`](https://github.com/fibjs/fibjs/commit/7c4a5bd368)] - **fiber, refactor**: abstract fiber api. (xicilion)
* [[`a29757fd58`](https://github.com/fibjs/fibjs/commit/a29757fd58)] - **sandbox,  bugfix**: remove unused variable. (xicilion)
* [[`fe384087a0`](https://github.com/fibjs/fibjs/commit/fe384087a0)] - **core, refactor**: use ac->isAsync to test async mode. (xicilion)
* [[`be97c97879`](https://github.com/fibjs/fibjs/commit/be97c97879)] - **console, refactor**: use cc_ function instead of ac. (xicilion)
* [[`8ea02b7ba7`](https://github.com/fibjs/fibjs/commit/8ea02b7ba7)] - **v8, upgrade**: v6.2.52. (xicilion)
* [[`13072368f5`](https://github.com/fibjs/fibjs/commit/13072368f5)] - **sanbox, refactor**: not clone the module return by callback. (xicilion)
* [[`694659486c`](https://github.com/fibjs/fibjs/commit/694659486c)] - **core: enable** strip option in release mode. (xicilion)
* [[`0cf26f2cce`](https://github.com/fibjs/fibjs/commit/0cf26f2cce)] - **fs, refactor**: cache files until the zip package is changed. (xicilion)
* [[`9dd77c284c`](https://github.com/fibjs/fibjs/commit/9dd77c284c)] - **sandbox, bugfix**: resolve search root folder twice on windows. (xicilion)
* [[`c961d71173`](https://github.com/fibjs/fibjs/commit/c961d71173)] - **leveldb, bugfix**: db.between not include the begin key. (xicilion)
* [[`3420200ecb`](https://github.com/fibjs/fibjs/commit/3420200ecb)] - **mongodb, bugfix**: ensureIndex error on mongodb v3.0+ . (xicilion)
* [[`9e99a7a92a`](https://github.com/fibjs/fibjs/commit/9e99a7a92a)] - **sandbox, bugfix**: circular dependency error when module.exports is changed.. (xicilion)
* [[`61acfb512c`](https://github.com/fibjs/fibjs/commit/61acfb512c)] - **test, refactor**: use path.join to build file name. (xicilion)
* [[`5f56491d76`](https://github.com/fibjs/fibjs/commit/5f56491d76)] - **core, break**: only use the args before entry script as the system options. (xicilion)
* [[`1a04db5488`](https://github.com/fibjs/fibjs/commit/1a04db5488)] - **net, bugfix**: compile warning in debug mode. (xicilion)
* [[`b7ee5c809f`](https://github.com/fibjs/fibjs/commit/b7ee5c809f)] - **v8: upgrade** to v6.1.539 (xicilion)
* [[`348c1b0476`](https://github.com/fibjs/fibjs/commit/348c1b0476)] - **test: add** v8 hash seed case. (xicilion)

## 2017-07-19, Version v0.9.0

* **feature** :
  * assert: add assert.ifError (#303) (Hengfei Zhuang)
  * db: support trans method to auto control transaction. (xicilion)
  * encoding: base64 support url mode. (xicilion)
  * fs:
    - compatible with windows XP. (xicilion)
    - complete fs test case, complete fs english doc (#307) (Hengfei Zhuang)
    - complete symlink realpath readlink methods on windows (#305) (Hengfei Zhuang 
    - add fs.fchmod fs.fchown fs.fdatasync fs.fsync (#292) (Hengfei Zhuang)
  * gui: WebView support close method and event. (xicilion)
  * http:
    - sort file in index page. (xicilion)
    - fileHandler support autoIndex. (xicilion)
    - unlimited download size, support http.maxDownloadSize to change it. (xicilion)
  * net: add isIP, isIPv4, isIPv6 (#301) (Hengfei Zhuang)
  * module: add require.cache (#300) (Hengfei Zhuang)
  * process: support hrtime. (xicilion)
  * sandbox: resolve the realpath of symlink file. (xicilion)
  * process: process.exit defaults to 0 (#298) (Hengfei Zhuang)
  * tty: add tty module (#296) (Hengfei Zhuang)
  * util: feat: add isAsyncFunction (#295) (Hengfei Zhuang)
  * v8:
    - upgrade to v6.1.500 (xicilion)
    - share ia64 snapshot between posix and windows. (xicilion)
    - upgrade to 6.1.435, enable snapshot at bootstrap Snapshot. (xicilion)

* **breakchange** :
  * core: remove the default harmony & use_strict flag (#299) (Hengfei Zhuang)
  * gui: rename WebView close event to closed. (xicilion)

* **bugfix** :
  * db: fix compile error on freebsd. (xicilion)
  * http:
    - fix compile warning on windows. (xicilion)
    - test: add index.html test. (xicilion)
    - maxDownloadSize cannot modify. rename maxDownloadSize to maxBodySize. (xicilion)
  * net: fix comiple error on windows. (xicilion)
  * v8: fix crash on windows x86. (xicilion)
  * xml: fix document error. (xicilion)

* **deps** :
  * v8: upgrade v8 to v6.1.500


### Commits

* [[`72589ad38b`](https://github.com/fibjs/fibjs/commit/72589ad38b)] - **gui, break**: rename WebView close event to closed. (xicilion)
* [[`14283edc8c`](https://github.com/fibjs/fibjs/commit/14283edc8c)] - **fs, feat**: compatible with windows XP. (xicilion)
* [[`50c130983d`](https://github.com/fibjs/fibjs/commit/50c130983d)] - **fs, refactor**: move init_fs function. (xicilion)
* [[`f2aadf38cd`](https://github.com/fibjs/fibjs/commit/f2aadf38cd)] - **fs, refactor**: format source code. (xicilion)
* [[`20698d6545`](https://github.com/fibjs/fibjs/commit/20698d6545)] - **ci, chore**: delete useless config (#308) (Hengfei Zhuang)
* [[`4a3ec408d7`](https://github.com/fibjs/fibjs/commit/4a3ec408d7)] - **gui, feat**: WebView support close method and event. (xicilion)
* [[`55ab9a3eaa`](https://github.com/fibjs/fibjs/commit/55ab9a3eaa)] - **core, break**: remove the default harmony & use_strict flag (#299) (Hengfei Zhuang)
* [[`7fb6beba84`](https://github.com/fibjs/fibjs/commit/7fb6beba84)] - **v8, bugfix**: fix crash on windows x86. (xicilion)
* [[`8e79b9e09f`](https://github.com/fibjs/fibjs/commit/8e79b9e09f)] - **fs, feat**: complete fs test case, complete fs english doc (#307) (Hengfei Zhuang)
* [[`967b602953`](https://github.com/fibjs/fibjs/commit/967b602953)] - **v8, feat**: upgrade to v6.1.500 (xicilion)
* [[`f6db24bb49`](https://github.com/fibjs/fibjs/commit/f6db24bb49)] - **net, bugfix**: fix comiple error on windows. (xicilion)
* [[`83513660e4`](https://github.com/fibjs/fibjs/commit/83513660e4)] - **fs, feat**: complete symlink realpath readlink methods on windows (#305) (Hengfei Zhuang 
* [[`c57323d131`](https://github.com/fibjs/fibjs/commit/c57323d131)] - **net, feat**: add isIP, isIPv4, isIPv6 (#301) (Hengfei Zhuang)
* [[`d34a3beeae`](https://github.com/fibjs/fibjs/commit/d34a3beeae)] - **module, feat**: add require.cache (#300) (Hengfei Zhuang)
* [[`29326433e6`](https://github.com/fibjs/fibjs/commit/29326433e6)] - **fs, feat**: add fs.fchmod fs.fchown fs.fdatasync fs.fsync (#292) (Hengfei Zhuang)
* [[`28c2cb07e8`](https://github.com/fibjs/fibjs/commit/28c2cb07e8)] - **assert, feat**: add assert.ifError (#303) (Hengfei Zhuang)
* [[`5df852888d`](https://github.com/fibjs/fibjs/commit/5df852888d)] - **assert, break**: allow undefined (#302) (Hengfei Zhuang)
* [[`da2378cad0`](https://github.com/fibjs/fibjs/commit/da2378cad0)] - **sandbox, feat**: resolve the realpath of symlink file. (xicilion)
* [[`a747a46eaf`](https://github.com/fibjs/fibjs/commit/a747a46eaf)] - **process, feat**: process.exit defaults to 0 (#298) (Hengfei Zhuang)
* [[`befdb45ff1`](https://github.com/fibjs/fibjs/commit/befdb45ff1)] - **tty, feat**: add tty module (#296) (Hengfei Zhuang)
* [[`d332acb156`](https://github.com/fibjs/fibjs/commit/d332acb156)] - **db, bugfix**: fix compile error on freebsd. (xicilion)
* [[`7ec6c04dde`](https://github.com/fibjs/fibjs/commit/7ec6c04dde)] - **v8, feat**: share ia64 snapshot between posix and windows. (xicilion)
* [[`56060e9201`](https://github.com/fibjs/fibjs/commit/56060e9201)] - **v8, feat**: upgrade to 6.1.435, enable snapshot at bootstrap Snapshot. (xicilion)
* [[`d224743bc4`](https://github.com/fibjs/fibjs/commit/d224743bc4)] - **process, feat**: support hrtime. (xicilion)
* [[`f64415dfe4`](https://github.com/fibjs/fibjs/commit/f64415dfe4)] - **util, feat**, feat: add isAsyncFunction (#295) (Hengfei Zhuang)
* [[`9736723003`](https://github.com/fibjs/fibjs/commit/9736723003)] - **encoding, feat**: base64 support url mode. (xicilion)
* [[`856aaf660e`](https://github.com/fibjs/fibjs/commit/856aaf660e)] - **db, feat**: support trans method to auto control transaction. (xicilion)
* [[`7e5933621f`](https://github.com/fibjs/fibjs/commit/7e5933621f)] - **xml, bugfix**: fix document error. (xicilion)
* [[`8a381a2786`](https://github.com/fibjs/fibjs/commit/8a381a2786)] - **http, bugfix**: fix compile warning on windows. (xicilion)
* [[`364827698c`](https://github.com/fibjs/fibjs/commit/364827698c)] - **crypto, refactor**: use the alias to implement the pbkdf2Sync (#294) (Hengfei Zhuang)
* [[`9f37e2fb46`](https://github.com/fibjs/fibjs/commit/9f37e2fb46)] - **http, feat**: sort file in index page. (xicilion)
* [[`5f6d41b09f`](https://github.com/fibjs/fibjs/commit/5f6d41b09f)] - **http, feat**: fileHandler support autoIndex. (xicilion)
* [[`60c36574fb`](https://github.com/fibjs/fibjs/commit/60c36574fb)] - **http, bugfix**: test: add index.html test. (xicilion)
* [[`f05b605fd2`](https://github.com/fibjs/fibjs/commit/f05b605fd2)] - **http, bugfix**: bug: maxDownloadSize cannot modify. rename maxDownloadSize to maxBodySize. (xicilion)
* [[`ff0c6f4147`](https://github.com/fibjs/fibjs/commit/ff0c6f4147)] - **http, feat**: unlimited download size, support http.maxDownloadSize to change it. (xicilion)

## 2017-07-08, Version v0.8.0

* **feature** :
  * crypto: support RSA PUBLIC KEY format pem file.
  * ssl: update root certs.
  * installer: use sudo&runas to install as administrator.
  * fs: implement fs.copy on freebsd.

* **breakchange** :
  * ws: deprecated WebSocketHandler soon.

* **bugfix** :
  * http: check http cookies validity (#285)

* **deps** :
  * v8: upgrade v8 to v6.1.394

### Commits

* [[`1e9a40bcdb`](https://github.com/fibjs/fibjs/commit/1e9a40bcdb)] - **v8, feat**: upgrade to v6.1.394.. (xicilion)
* [[`f61b52f3ab`](https://github.com/fibjs/fibjs/commit/f61b52f3ab)] - **crypto, feat**: : support RSA PUBLIC KEY format pem file. (xicilion)
* [[`1927fbec79`](https://github.com/fibjs/fibjs/commit/1927fbec79)] - **ssl, feat**: update root certs. (xicilion)
* [[`12e655871d`](https://github.com/fibjs/fibjs/commit/12e655871d)] - **ws, break**: deprecated WebSocketHandler soon. (xicilion)
* [[`aaf66d5e07`](https://github.com/fibjs/fibjs/commit/aaf66d5e07)] - **installer, feat**: use sudo&runas to install as administrator. (xicilion)
* [[`08c6d0b205`](https://github.com/fibjs/fibjs/commit/08c6d0b205)] - **fs, feat**: implement fs.copy on freebsd. (xicilion)
* [[`8c1e42b8bf`](https://github.com/fibjs/fibjs/commit/8c1e42b8bf)] - **http, bugfix**: check http cookies validity (asionius)

## 2017-07-03, Version v0.7.0 @ngot

* **feature** :
  * xml: 
    - support el.getElementsByClassName.
    - support el.getElementById.
  * sandbox: 
    - support switch to .js mode when filename does not have ext.
    - support add version mark in .jsc file.
  * http: output fibjs version in http header.
  * core: all Sync alias to  all async apis.
* **breakchange** :
  * sandbox: remove --root and --approot option.
* **bugfix** :
  * v8: disable icu, fix toLocaleDateString error.
* **deps** :
  * v8: upgrade to v6.1.344

* [[`67fee618cc`](https://github.com/fibjs/fibjs/commit/67fee618cc)] - **core, fixbug**: fix freebsd compile error. (xicilion)
* [[`0e01161d4f`](https://github.com/fibjs/fibjs/commit/0e01161d4f)] - **core, chore**: fix compile warning. (xicilion)
* [[`a8467666aa`](https://github.com/fibjs/fibjs/commit/a8467666aa)] - **path, refactor**: remove unused variable. (xicilion)
* [[`1a013416fc`](https://github.com/fibjs/fibjs/commit/1a013416fc)] - **deps, refactor**: remove spidermonkey from vc project. (xicilion)
* [[`5ec1a58a80`](https://github.com/fibjs/fibjs/commit/5ec1a58a80)] - **deps, refactor**: remove unused library. (xicilion)
* [[`bb0584f4f3`](https://github.com/fibjs/fibjs/commit/bb0584f4f3)] - **sandbox, break**: deprecate --root and --approot option. (xicilion)
* [[`5fabc2a337`](https://github.com/fibjs/fibjs/commit/5fabc2a337)] - **core, fixbug**: fix build error on windows. (xicilion)
* [[`b8c388d61a`](https://github.com/fibjs/fibjs/commit/b8c388d61a)] - **cmake, feat**: enable ccache. (xicilion)
* [[`9e8ff1d755`](https://github.com/fibjs/fibjs/commit/9e8ff1d755)] - **deps, upgrade**: upgrade to v6.1.344 (xicilion)
* [[`a022bdf5e6`](https://github.com/fibjs/fibjs/commit/a022bdf5e6)] - **test, fixbug**: fix typo. (xicilion)
* [[`2d360557d0`](https://github.com/fibjs/fibjs/commit/2d360557d0)] - **core, refactor**: use internal flag variable to change v8 options. (xicilion)
* [[`93a9df5835`](https://github.com/fibjs/fibjs/commit/93a9df5835)] - **v8, fixbug**: disable icu, fix toLocaleDateString error. (xicilion)
* [[`d843532424`](https://github.com/fibjs/fibjs/commit/d843532424)] - **http, refactor**: change output compression limit to 64M. (xicilion)
* [[`272bd7752e`](https://github.com/fibjs/fibjs/commit/272bd7752e)] - **http, feat**: output fibjs version in http header. (xicilion)
* [[`739d633be7`](https://github.com/fibjs/fibjs/commit/739d633be7)] - **test, feat**: throw the case when network is disconnected. (xicilion)
* [[`91c342449c`](https://github.com/fibjs/fibjs/commit/91c342449c)] - **sandbox, feat**: switch to .js mode when filename does not have ext. (xicilion)
* [[`aa16d9b35f`](https://github.com/fibjs/fibjs/commit/aa16d9b35f)] - **doc, feat**: docs about function source code is not available in .jsc mode. (xicilion)
* [[`86b57a93f8`](https://github.com/fibjs/fibjs/commit/86b57a93f8)] - **fs, refactor**: split fs code (#284) (ngot)
* [[`f8b63086cb`](https://github.com/fibjs/fibjs/commit/f8b63086cb)] - **test, fixbug**: fix hangup in .jsc mode. (xicilion)
* [[`3a989b79b2`](https://github.com/fibjs/fibjs/commit/3a989b79b2)] - **SandBox, feat**: add version mark in .jsc file. (xicilion)
* [[`e74bcaa994`](https://github.com/fibjs/fibjs/commit/e74bcaa994)] - **coroutine, refactor**: use DiscardThreadSpecificMetadata to free thread data in v8. (xicilion)
* [[`cd20493916`](https://github.com/fibjs/fibjs/commit/cd20493916)] - **core, feat**: all Sync alias to  all async apis. (#282) (ngot)
* [[`1b31d1b706`](https://github.com/fibjs/fibjs/commit/1b31d1b706)] - **xml, feat**: support el.getElementsByClassName. (xicilion)
* [[`ca3862497b`](https://github.com/fibjs/fibjs/commit/ca3862497b)] - **xml, refactor**: use get_id to query el.id in el.getElementById. (xicilion)
* [[`01d3156db4`](https://github.com/fibjs/fibjs/commit/01d3156db4)] - **xml, feat**: el.id & el.className test case. (xicilion)
* [[`8089d2e4b0`](https://github.com/fibjs/fibjs/commit/8089d2e4b0)] - **xml, feat**: support el.getElementById. (xicilion)
* [[`3076b629bb`](https://github.com/fibjs/fibjs/commit/3076b629bb)] - **docs, refactor**: format dot output. (xicilion)
* [[`d7643ab285`](https://github.com/fibjs/fibjs/commit/d7643ab285)] - **docs, refactor**: change dot syntax. (xicilion)
* [[`cbc5e4ea9d`](https://github.com/fibjs/fibjs/commit/cbc5e4ea9d)] - **sandbox, feat**: report line number in jsc. (xicilion)
* [[`6a393e1dad`](https://github.com/fibjs/fibjs/commit/6a393e1dad)] - **util, refactor**: split source code. (xicilion)
* [[`24843e4f2e`](https://github.com/fibjs/fibjs/commit/24843e4f2e)] - **idl, refactor**: move idl to idl dir & move en idl to this repo (#281) (ngot)

## 2017-06-26, Version v0.6.1 @ngot

* **bugfix** :
  * fs: fix the fs.read zero.

### Commits

* [[`a34b53c4bb`](https://github.com/fibjs/fibjs/commit/a34b53c4bb)] - **fs, fixbug**: fix the fs.read zero (#277) (ngot) 

## 2017-06-26, Version v0.6.0 @ngot

* **feature** :
  * test: 
    - support async or callback case.
    - support it.only, it.skip, describe.skip, describe.only.
  * util: 
    - util.sync support async/await.
    - util.sync support promise microtask.
    - util.sync support specify async mode function manually.
  * fs: 
    - add fs.open & fs.openSync & fs.close & fs.closeSync to open and close the file descriptor.
    - readFile support encoding.
    - Stat add uid and gid property, add fs test case.
    - add fs.read & fs.readSync to read content from the file descriptor.
  * path: more compatible with nodejs path module.

* **breakchange** :
  * util: util.compile must specify srcname.
  * test: deprecate setup TDD mode.
  * vm: sandbox remove main script mode.
  * module: fix resolve typo from resovle to resolve.

* **bugfix** :
  * module: fix require error when entry of package.json is a folder.
  * fs: fix compile error on windows.
  * io: fix build warning on windows x86.
  * util: util.sync throw error.

* **deps** :
    - upgrade v8 to v6.1.266
    - upgrade sqlite to v3.19.3

### Commits
* [[`68142c7250`](https://github.com/fibjs/fibjs/commit/68142c7250)] - **fs, fixbug**: fix compile error on windows. (xicilion) 
* [[`496a5648c8`](https://github.com/fibjs/fibjs/commit/496a5648c8)] - **fs, feat**: add fs.read to read content from the file descriptor (#274) (ngot) 
* [[`6a00f0f413`](https://github.com/fibjs/fibjs/commit/6a00f0f413)] - **core, refactor**: use header file to define version information. (xicilion) 
* [[`3ce5162f5c`](https://github.com/fibjs/fibjs/commit/3ce5162f5c)] - **test, feat**: support async or callback case. (xicilion) 
* [[`f51019f869`](https://github.com/fibjs/fibjs/commit/f51019f869)] - **internal, downgrade**: downgrade expat. (xicilion) 
* [[`22710a7eff`](https://github.com/fibjs/fibjs/commit/22710a7eff)] - **module, fixbug**: fix require error when entry of package.json is a folder. (xicilion) 
* [[`2c59dd5be7`](https://github.com/fibjs/fibjs/commit/2c59dd5be7)] - **docs, feat**: update util.sync manual. (xicilion) 
* [[`32c151a4b2`](https://github.com/fibjs/fibjs/commit/32c151a4b2)] - **test, refactor**: rewrite wasm test case. (xicilion) 
* [[`419f63ea27`](https://github.com/fibjs/fibjs/commit/419f63ea27)] - **util, test**: util.sync test case. (xicilion) 
* [[`3b47b19bac`](https://github.com/fibjs/fibjs/commit/3b47b19bac)] - **util, feat**: util.sync: support specify async mode function manually. (xicilion) 
* [[`fc429016a8`](https://github.com/fibjs/fibjs/commit/fc429016a8)] - **test, refactor**: rewrite wasm case using util.sync. (xicilion) 
* [[`d31e484a1a`](https://github.com/fibjs/fibjs/commit/d31e484a1a)] - **test, feat**: support it.only, it.skip, describe.skip, describe.only. (xicilion) 
* [[`1856e6eade`](https://github.com/fibjs/fibjs/commit/1856e6eade)] - **internal, upgrade**: upgrade v8&sqlite&expart. (xicilion) 
* [[`7bd0fd3c15`](https://github.com/fibjs/fibjs/commit/7bd0fd3c15)] - **io, fixbug**: fix build warning on windows x86. (xicilion) 
* [[`4e3cf824fa`](https://github.com/fibjs/fibjs/commit/4e3cf824fa)] - **core, bug**: v8 x86 bug test. (xicilion) 
* [[`c7d91f6608`](https://github.com/fibjs/fibjs/commit/c7d91f6608)] - **path, feat**: more compatible with nodejs path module. (xicilion) 
* [[`301164a3ed`](https://github.com/fibjs/fibjs/commit/301164a3ed)] - **util, break**: util.compile must specify srcname. (xicilion) 
* [[`65c727f07b`](https://github.com/fibjs/fibjs/commit/65c727f07b)] - **docs, refactor**: use relative path. (xicilion) 
* [[`363527274b`](https://github.com/fibjs/fibjs/commit/363527274b)] - **test, break**: deprecate setup TDD mode. (xicilion) 
* [[`19c4e4134a`](https://github.com/fibjs/fibjs/commit/19c4e4134a)] - **docs, fixbug**: typo. (xicilion) 
* [[`4cf9687691`](https://github.com/fibjs/fibjs/commit/4cf9687691)] - **fs, fixbug**: fix build error in windows & linux (#272) (ngot) 
* [[`e634d4fe94`](https://github.com/fibjs/fibjs/commit/e634d4fe94)] - **docs, feat**: utils.sync demo. (xicilion) 
* [[`95a87427ba`](https://github.com/fibjs/fibjs/commit/95a87427ba)] - **util, feat**: util.sync: support async/await. (xicilion) 
* [[`c7bf148657`](https://github.com/fibjs/fibjs/commit/c7bf148657)] - **util, test**: test error in callback (xicilion) 
* [[`fa47702585`](https://github.com/fibjs/fibjs/commit/fa47702585)] - **util, fixbug**: util.sync: throw error test. (xicilion) 
* [[`68cdaf838f`](https://github.com/fibjs/fibjs/commit/68cdaf838f)] - **util, feat**: sync support promise microtask. (xicilion) 
* [[`5eb83d5559`](https://github.com/fibjs/fibjs/commit/5eb83d5559)] - **test, feat**: use repl to test main script. (xicilion) 
* [[`dbc3257993`](https://github.com/fibjs/fibjs/commit/dbc3257993)] - **vm, break**: sandbox remove main script mode. (xicilion) 
* [[`c6be2fc750`](https://github.com/fibjs/fibjs/commit/c6be2fc750)] - **docs, feat**: missing docs. (xicilion) 
* [[`0497ee39b4`](https://github.com/fibjs/fibjs/commit/0497ee39b4)] - **docs, feat**: missing docs. (xicilion) 
* [[`1db39afa01`](https://github.com/fibjs/fibjs/commit/1db39afa01)] - **fs, feat**: add fs.open & fs.openSync & fs.close & fs.closeSync to open and close the file descriptor (#271) (ngot) 
* [[`03bc345e07`](https://github.com/fibjs/fibjs/commit/03bc345e07)] - **docs, feat**: auto format javascript code. (xicilion) 
* [[`8acd9a649c`](https://github.com/fibjs/fibjs/commit/8acd9a649c)] - **docs, feat**: fix language. (xicilion) 
* [[`9899967fad`](https://github.com/fibjs/fibjs/commit/9899967fad)] - **fs, feat**: readFile support encoding. (xicilion) 
* [[`ebe3d5e802`](https://github.com/fibjs/fibjs/commit/ebe3d5e802)] - **module, break**: fix resolve typo. (xicilion) 
* [[`7fc08a4a52`](https://github.com/fibjs/fibjs/commit/7fc08a4a52)] - **docs, feat**: use css. (xicilion)
* [[`84f7576d83`](https://github.com/fibjs/fibjs/commit/84f7576d83)] - **docs, feat**: gegerate inherit graph. (xicilion) 
* [[`33388b8be2`](https://github.com/fibjs/fibjs/commit/33388b8be2)] - **idlc, feat**: not generate extend of object. (xicilion) 
* [[`54608ce37b`](https://github.com/fibjs/fibjs/commit/54608ce37b)] - **deps, chore**: set to master (#269) (ngot) 
* [[`b539f109a5`](https://github.com/fibjs/fibjs/commit/b539f109a5)] - **fs, chore**: regenerate Stat.h (#270) (ngot) 
* [[`928bccfe5f`](https://github.com/fibjs/fibjs/commit/928bccfe5f)] - **fs, feat**: Stat add uid and gid property, add fs test case (#268) (asionius) 
* [[`b5ac68161c`](https://github.com/fibjs/fibjs/commit/b5ac68161c)] - **docs, feat**: change style of method descript. (xicilion) 

## 2017-06-21, Version v0.5.0 @ngot

* **feature** :
  * ssl: add ssl.loadRootCerts.
  * fs: File add fd property.
  * util: add isNativeError, isPrimitive, isSymbol, isDataView, isExternal, isMap, isMapIterator, isPromise, isSet, isSetIterator, isTypedArray, isUint8Array.
  * events: add setMaxListeners & getMaxListeners & defaultMaxListers support.
  * core: add -v, --version, -h command line option.
  * SandBox: use snapshot to speed up the creation of context.
  * SandBox: support standalone global.

* **breakchange** :
   * fs: remove the fs.openSync method.
   * fs: rename fs.open to fs.openFile.
   * expect: remove expect module.If you still want to use these module, you can find some similar module on npm.
   * Sandbox: disable --noroot option, enable --root option.The root directly feature has been disabled by default now. You can use --root to enable it.
   * events: more compatible with nodejs events module.

* **bugfix** :
  * zip: fix crash when read a empty file.
  * fs: fix lchmod warning on linux.
  * ssl: fix crash when get stream.
  * zip: fix compile warning.

### Commits

* [[`1171c9376`](https://github.com/fibjs/fibjs/commit/1171c9376)] - **console, feat**:console.add support s%. (xicilion)
* [[`56f836e61b`](https://github.com/fibjs/fibjs/commit/56f836e61b)] - **ci, fixbug**: move fullsrc to darwin (#266) (ngot)
* [[`a5d1ce9d40`](https://github.com/fibjs/fibjs/commit/a5d1ce9d40)] - **ci, fixbug**: fix Permission error (#265) (ngot)
* [[`176969d599`](https://github.com/fibjs/fibjs/commit/176969d599)] - **test, feat**: enable single run directly (#264) (ngot)
* [[`ef7beeb13c`](https://github.com/fibjs/fibjs/commit/ef7beeb13c)] - **test, feat**: enable single run directly (ngot)
* [[`eb92d481ff`](https://github.com/fibjs/fibjs/commit/eb92d481ff)] - **doc, feats**: add type. (xicilion)
* [[`da643dc4a9`](https://github.com/fibjs/fibjs/commit/da643dc4a9)] - **ssl, feat**: add ssl.loadRootCerts. (xicilion)
* [[`af1f95e389`](https://github.com/fibjs/fibjs/commit/af1f95e389)] - **ci, chore**: bring forward the x64 ci (#263) (ngot)
* [[`f48354b22c`](https://github.com/fibjs/fibjs/commit/f48354b22c)] - **ci, chore**: only run x64 test on linux (#262) (ngot)
* [[`31953e5682`](https://github.com/fibjs/fibjs/commit/31953e5682)] - **zip, fixbug**: fix crash when read a empty file. (xicilion)
* [[`1fa88f43bb`](https://github.com/fibjs/fibjs/commit/1fa88f43bb)] - **core, feat**: utils.h check optional parameter. (xicilion)
* [[`f49f184c7d`](https://github.com/fibjs/fibjs/commit/f49f184c7d)] - **core, feat**: util.h ignore extra undefined in parameters. (xicilion)
* [[`46e4e48086`](https://github.com/fibjs/fibjs/commit/46e4e48086)] - **core, fixbug**: fix gen windows installer.exe (#261) (ngot)
* [[`276fc52ef8`](https://github.com/fibjs/fibjs/commit/276fc52ef8)] - **fs, break**: remove the fs.openSync method (#260) (ngot)
* [[`2759406fc6`](https://github.com/fibjs/fibjs/commit/2759406fc6)] - **test, doc**: add test docs (#259) (ngot)
* [[`9ed5946b51`](https://github.com/fibjs/fibjs/commit/9ed5946b51)] - **fs, feat**: File add fd property (#256) (ngot)
* [[`18cad502f0`](https://github.com/fibjs/fibjs/commit/18cad502f0)] - **fs, break**: rename fs.open to fs.openFile (#258) (ngot)
* [[`021560eedd`](https://github.com/fibjs/fibjs/commit/021560eedd)] - **docs, feat**: group static function and property. (xicilion)
* [[`eb04aaed5d`](https://github.com/fibjs/fibjs/commit/eb04aaed5d)] - **doc, chore**: update links (#255) (ngot)
* [[`9d2faf03a8`](https://github.com/fibjs/fibjs/commit/9d2faf03a8)] - **fs, fixbug**: fix lchmod warning on linux. (xicilion)
* [[`f44cfe2f54`](https://github.com/fibjs/fibjs/commit/f44cfe2f54)] - **util, fixbug**: fix warning on windows. (xicilion)
* [[`b5f8cca194`](https://github.com/fibjs/fibjs/commit/b5f8cca194)] - **internal, upgrade**: upgrade v8 to 6.1.201. (xicilion)
* [[`5dd2ca75de`](https://github.com/fibjs/fibjs/commit/5dd2ca75de)] - **ci, chore**: remove then windows ssh release (#253) (ngot)
* [[`40bcea3ee5`](https://github.com/fibjs/fibjs/commit/40bcea3ee5)] - **test, feat**: add i386 test runner (#252) (ngot)
* [[`26e2f98b51`](https://github.com/fibjs/fibjs/commit/26e2f98b51)] - **ci, feat**: add fullsrc.zip release (#250) (ngot)
* [[`f65738cd54`](https://github.com/fibjs/fibjs/commit/f65738cd54)] - **ci, feat**: add osx x86  build & release (#249) (ngot)
* [[`2505a5f753`](https://github.com/fibjs/fibjs/commit/2505a5f753)] - **ci, chore**: remove ssh deploy (#248) (ngot)
* [[`912fe25a2f`](https://github.com/fibjs/fibjs/commit/912fe25a2f)] - **encodin, fixbugg**: fix: hex_decode length error. (xicilion)
* [[`0c25a611a2`](https://github.com/fibjs/fibjs/commit/0c25a611a2)] - **ssl, fixbug**: fix crash when get stream. (xicilion)
* [[`5955c033a4`](https://github.com/fibjs/fibjs/commit/5955c033a4)] - **zip, fixbug**: fix compile warning. (xicilion)
* [[`06a3efbce2`](https://github.com/fibjs/fibjs/commit/06a3efbce2)] - **fs, , fixbug**: fix compile warning on mac. (xicilion)
* [[`5787c34ab0`](https://github.com/fibjs/fibjs/commit/5787c34ab0)] - **docs, fixbug**: fix style. (xicilion)
* [[`ae185dfa9c`](https://github.com/fibjs/fibjs/commit/ae185dfa9c)] - **docs, feat**: insert hr between methods. (xicilion)
* [[`9c9b6ee7ae`](https://github.com/fibjs/fibjs/commit/9c9b6ee7ae)] - **docs, feat**: generate operator method. (xicilion)
* [[`70d39f9fdc`](https://github.com/fibjs/fibjs/commit/70d39f9fdc)] - **docs, fixbug**: fix readme link error. (xicilion)
* [[`cbdc55f95d`](https://github.com/fibjs/fibjs/commit/cbdc55f95d)] - **docs, fixbug**: fix markdown link error. (xicilion)
* [[`ddfe959ceb`](https://github.com/fibjs/fibjs/commit/ddfe959ceb)] - **core, chore**: util.h format code. (xicilion)
* [[`5a645ae1d4`](https://github.com/fibjs/fibjs/commit/5a645ae1d4)] - **docs, feat**: auto link to other module. (xicilion)
* [[`c30ef7a3e7`](https://github.com/fibjs/fibjs/commit/c30ef7a3e7)] - **docs, fixbug**: fix const default value; (xicilion)
* [[`4b5dede844`](https://github.com/fibjs/fibjs/commit/4b5dede844)] - **docs, feat**: not encode message. (xicilion)
* [[`5d8fd217e2`](https://github.com/fibjs/fibjs/commit/5d8fd217e2)] - **docs, feat**: readme (xicilion)
* [[`eca569b8ea`](https://github.com/fibjs/fibjs/commit/eca569b8ea)] - **docs, feat**: check  document  of return. (xicilion)
* [[`7528fed61f`](https://github.com/fibjs/fibjs/commit/7528fed61f)] - **docs, feat**: check the comment. (xicilion)
* [[`cd44aa977d`](https://github.com/fibjs/fibjs/commit/cd44aa977d)] - **docs, feat**: 文档输出修饰, 输出对象 (xicilion)
* [[`9aacc04bad`](https://github.com/fibjs/fibjs/commit/9aacc04bad)] - **docs, fixbug**: fix style. (xicilion)
* [[`1d2f525021`](https://github.com/fibjs/fibjs/commit/1d2f525021)] - **docs, feat**: rewrite with markdown. (xicilion)
* [[`1f7bf9a673`](https://github.com/fibjs/fibjs/commit/1f7bf9a673)] - **docs, feat**: group members of the same name (xicilion)
* [[`da7c05105e`](https://github.com/fibjs/fibjs/commit/da7c05105e)] - **idlc, fixbug**: fix bold style in github. (xicilion)
* [[`eb3ad4699c`](https://github.com/fibjs/fibjs/commit/eb3ad4699c)] - **encoding, revert**: revert the hex modify (#247) (ngot)
* [[`b1da4a35b0`](https://github.com/fibjs/fibjs/commit/b1da4a35b0)] - **core, fixbug**: remove unused files (#246) (ngot)
* [[`b97fa6d7c1`](https://github.com/fibjs/fibjs/commit/b97fa6d7c1)] - **core, refactor**: move vsmake.js to tools dir (#245) (ngot)
* [[`0a30826889`](https://github.com/fibjs/fibjs/commit/0a30826889)] - **idlc, feat**: generate markdown manual. (xicilion)
* [[`7b198566a2`](https://github.com/fibjs/fibjs/commit/7b198566a2)] - **util, feat**: add isNativeError, isPrimitive, isSymbol, isDataView, isExternal, isMap, isMapIterator, isPromise, isSet, isSetIterator, isTypedArray, isUint8Array (#243) (ngot)
* [[`bc58e63620`](https://github.com/fibjs/fibjs/commit/bc58e63620)] - **idlc, feat**: parser doxygen comment. (xicilion)
* [[`5aa4d7a64e`](https://github.com/fibjs/fibjs/commit/5aa4d7a64e)] - **events, feat**: add setMaxListeners & getMaxListeners & defaultMaxListers support (#240) (ngot)
* [[`a88f9f8c67`](https://github.com/fibjs/fibjs/commit/a88f9f8c67)] - **idlc, fixbug**: fix parser error. (xicilion)
* [[`f0941d7f11`](https://github.com/fibjs/fibjs/commit/f0941d7f11)] - **core, feat**: add -v, --version, -h command line option (#241) (ngot)
* [[`8e870a8154`](https://github.com/fibjs/fibjs/commit/8e870a8154)] - **expect, break**: remove expect module (#242) (ngot)
* [[`31f285fe5b`](https://github.com/fibjs/fibjs/commit/31f285fe5b)] - **idlc, reactor**: split code. (xicilion)
* [[`64f775b7bb`](https://github.com/fibjs/fibjs/commit/64f775b7bb)] - **Sandbox, break**: disable root option. (xicilion)
* [[`62bfd01362`](https://github.com/fibjs/fibjs/commit/62bfd01362)] - **event, refactor**: remove ev list directly. (xicilion)
* [[`47369bda81`](https://github.com/fibjs/fibjs/commit/47369bda81)] - **events, break**: more compatible with nodejs events module (#232) (ngot)
* [[`a3e044b2e`](https://github.com/fibjs/fibjs/commit/a3e044b2e)] - **util, fixbug**: typo. (xicilion)
* [[`6b606fa7b`](https://github.com/fibjs/fibjs/commit/6b606fa7b)] - **ci, fixbug**:: windows build error. (xicilion)
* [[`188ba79ae`](https://github.com/fibjs/fibjs/commit/188ba79ae)] - **test, process****: using PATH environment variable viemacs (emacguo)
* [[`9ae359a14`](https://github.com/fibjs/fibjs/commit/9ae359a14)] - **SandBox, feat**: use snapshot to speed up the creation of context. (xicilion)
* [[`1c839c416`](https://github.com/fibjs/fibjs/commit/1c839c416)] - **memorystream, refactor**: flush is always success asionius (asionius)
* [[`d5ed8a8e7`](https://github.com/fibjs/fibjs/commit/d5ed8a8e7)] - **seekableStream, refactor**: move 'truncate' 'eof' and 'flush' interface from File to seekableStream asionius (asionius)
* [[`d9119beec`](https://github.com/fibjs/fibjs/commit/d9119beec)] - **SandBox, refactor**: Enhance the performance of require in standalone global. (xicilion)
* [[`8485dca41`](https://github.com/fibjs/fibjs/commit/8485dca41)] - **SandBox, feat**: support standalone global. (xicilion)
* [[`9a98eb117`](https://github.com/fibjs/fibjs/commit/9a98eb117)] - **test, selfzip**: add jsc test case. (xicilion)
* [[`950e996b1`](https://github.com/fibjs/fibjs/commit/950e996b1)] - **Buffer, break**: Compatible with nodejs hex encode format. (xicilion)

## 2017-06-13, Version v0.4.1 @ngot

* **bugfix** :
  * global: fix require error in repl.
  * process: fix run error when using PATH environment variable on linux.

### Commits

* [[`877fb216e1`](https://github.com/fibjs/fibjs/commit/877fb216e1)] - **global, fixbug**: fix require error in repl. (ngot)
* [[`4f55d674d8`](https://github.com/fibjs/fibjs/commit/4f55d674d8)] - **core, chore**: set the vender branch to 0.4.x (ngot)
* [[`c37c460f94`](https://github.com/fibjs/fibjs/commit/c37c460f94)] - **process, fixbug**: fix run error when using PATH environment variable on linux. (ngot)

## 2017-06-10, Version v0.4.0 @ngot

* **feature** :
  * wasm: Add wasm extension demo.Now you can use WebAssembly to write extention of fibjs!
  * util: format support TypedArray.
  * module:
    - support auto exec selfzip file. Now you can zip your application to an executable file and distribute it easily!
    - add --noroot options to disable application root directory. Application root directory will be removed in 0.5.0, so please pay attention to this.
    - add require.resovle
    - implement .ext loader.
  * zlip: date_t support getdate.
  * vm: Sandbox.run support extension search and package.json.
  * fs: add access, accessSync, appendFile, appendFileSync, chown, chownSync, lchmod, lchmodSync, lchown, lchownSync, link, linkSync, lstat, lstatSync, readlink, readlinkSync, realpath, realpathSync, symlink, symlinkSync, truncate, truncateSync, F_OK, R_OK, W_OK, X_OK & constants
  * util: util.compile support bash style comment.
  * path: 
    - support path.isAbsolute.
    - enable path.win32 & path.posix both works on win32 & posix
  * os: 
    - add os.homedir()
    - add os.release()
    - add os.endianness()
    - add os.userInfo()
  * events: 
    now it is possible create EventEmit object just from `require('events')`.
  * timers: add timers module

* **breakchange** :
  * os: normalize execPath.
  * vm: disable relative path in sanbox.run.
  * global: move global.sync to util.sync.
  * os: replace os.version with os.release()
  * os: change os.type to os.type()
  * os: change os.hostname to os.hostname()
  * os: rename os.CPUInfo() to os.cpus() & rename os.CPUs() to os.cpuNumbers()
  * os: change os.arch to os.arch()
  * os: rename os.networkInfo() to os.networkInterfaces
  * core: reorder module wrap arguments.
  * gui: disable drag file to gui webbrowser.

* **bugfix** :
  * process: fix process on Linux, not throw when process.run failed.
  * core: fix GLIBC_2.7 not found. disable eventfd.
  * gui: fix gui windows visible&maxmize bug.
  * gui: fix maximize mode of gui window not worked in shortcut.
  * gui: fix windows gui input control ctrl-v delete error.
  * module: change path .zip?/file to .zip$/file, fix windows gui url error.
* **internal** :
  * upgrade V8 to 6.1.64

### Commits

* [[`4cd3e6c7d4`](https://github.com/fibjs/fibjs/commit/4cd3e6c7d4)] - **wasm, feat**: add wasm test (ngot) 
* [[`80c1837f8b`](https://github.com/fibjs/fibjs/commit/80c1837f8b)] - **util, feat**: format support TypedArray. (xicilion) 
* [[`e9831314eb`](https://github.com/fibjs/fibjs/commit/e9831314eb)] - **module, refactor**: not register id into module cache. (xicilion) 
* [[`efec83bfc0`](https://github.com/fibjs/fibjs/commit/efec83bfc0)] - **module, chore**: check module id. (xicilion) 
* [[`032835643b`](https://github.com/fibjs/fibjs/commit/032835643b)] - **test, chore**: move temp file to test folder. (xicilion) 
* [[`92fee00865`](https://github.com/fibjs/fibjs/commit/92fee00865)] - **module, feat**: auto exec selfzip file. (xicilion) 
* [[`f11f666176`](https://github.com/fibjs/fibjs/commit/f11f666176)] - **os, break**: normalize execPath. (xicilion) 
* [[`bff9a9f33d`](https://github.com/fibjs/fibjs/commit/bff9a9f33d)] - **process, fixbug**: process on Linux, not throw when process.run failed. (xicilion) 
* [[`a6421df39a`](https://github.com/fibjs/fibjs/commit/a6421df39a)] - **core, fixbug**: GLIBC_2.7 not found. disable eventfd. (xicilion) 
* [[`dd437b2831`](https://github.com/fibjs/fibjs/commit/dd437b2831)] - **module, break**: add --noroot options to disable application root directory. (xicilion) 
* [[`ca3951c1b2`](https://github.com/fibjs/fibjs/commit/ca3951c1b2)] - **test, fixbug**: fix module_test, disable absolute identifiers test. (xicilion) 
* [[`33f800ff08`](https://github.com/fibjs/fibjs/commit/33f800ff08)] - **module, refactor**: reuse variable. (xicilion) 
* [[`6e6ee02be4`](https://github.com/fibjs/fibjs/commit/6e6ee02be4)] - **module, refactor**: Organize source code. (xicilion) 
* [[`be1a651d8a`](https://github.com/fibjs/fibjs/commit/be1a651d8a)] - **module, feat**: implement require.resovle (xicilion) 
* [[`be71bb05ff`](https://github.com/fibjs/fibjs/commit/be71bb05ff)] - **module, fixbug**: normalize id, fix error on windows. (xicilion) 
* [[`7ac814c7dc`](https://github.com/fibjs/fibjs/commit/7ac814c7dc)] - **module, feat**: implement requireModule. (xicilion) 
* [[`9bfea8d064`](https://github.com/fibjs/fibjs/commit/9bfea8d064)] - **module, refactor**: use ZipFile.date as the date of zip virtual file. (xicilion) 
* [[`693b015c01`](https://github.com/fibjs/fibjs/commit/693b015c01)] - **ZipFile**: add date test case. (xicilion) 
* [[`01cd70605f`](https://github.com/fibjs/fibjs/commit/01cd70605f)] - **ZipFile**: support date while zip a file. (xicilion) 
* [[`4f6330cda4`](https://github.com/fibjs/fibjs/commit/4f6330cda4)] - **zlip, feat**: date_t support getdate. (xicilion) 
* [[`fe52e70f6f`](https://github.com/fibjs/fibjs/commit/fe52e70f6f)] - **fs, feat**: enable zip cache timeout. (xicilion) 
* [[`e85d504ed1`](https://github.com/fibjs/fibjs/commit/e85d504ed1)] - **vm, feat**: implement requireFile, use locateFile to load module file. (xicilion) 
* [[`ac68fc8432`](https://github.com/fibjs/fibjs/commit/ac68fc8432)] - **vm, refactor**: split source code of SandBox. (xicilion) 
* [[`c5351420cb`](https://github.com/fibjs/fibjs/commit/c5351420cb)] - **test, fixbug**: fix websocket test on windows. (xicilion) 
* [[`bf49dcaf5c`](https://github.com/fibjs/fibjs/commit/bf49dcaf5c)] - **vm, feat**: Sandbox.run support extension search and package.json. (xicilion) 
* [[`d87bcc6960`](https://github.com/fibjs/fibjs/commit/d87bcc6960)] - **vm, break**: disable relative path in sanbox.run. (xicilion) 
* [[`e3fa7060de`](https://github.com/fibjs/fibjs/commit/e3fa7060de)] - **vm, refactor**: share script cache in isolate. (xicilion) 
* [[`a155c2133c`](https://github.com/fibjs/fibjs/commit/a155c2133c)] - **vm, refactor**: use LruCache to cache script file. (xicilion) 
* [[`391b467618`](https://github.com/fibjs/fibjs/commit/391b467618)] - **vm, feat**: enable script file cache. (xicilion) 
* [[`c5ae89255c`](https://github.com/fibjs/fibjs/commit/c5ae89255c)] - **gui, fixbug**: gui windows visible&maxmize bug. (xicilion) 
* [[`f56ff6185a`](https://github.com/fibjs/fibjs/commit/f56ff6185a)] - **gui, fixbug**: maximize mode of gui window not worked in shortcut. (xicilion) 
* [[`e759bf6270`](https://github.com/fibjs/fibjs/commit/e759bf6270)] - **fs, chore**: set fs.constants readonly attribute (asionius) 
* [[`2e9b597470`](https://github.com/fibjs/fibjs/commit/2e9b597470)] - **fs, chore**: remove method access return value (asionius) 
* [[`02a9f33024`](https://github.com/fibjs/fibjs/commit/02a9f33024)] - **fs, fixbug**: fix windows compile error (asionius) 
* [[`aa34b7d23f`](https://github.com/fibjs/fibjs/commit/aa34b7d23f)] - **fs, feat**: some fs apis to compat to node fs api (asionius) 
* [[`9a864d3773`](https://github.com/fibjs/fibjs/commit/9a864d3773)] - **internal, upgrade**: upgrade v8 to 6.1.64 (xicilion) 
* [[`b0e003bcee`](https://github.com/fibjs/fibjs/commit/b0e003bcee)] - **iconv, chore**: delete unused variable. (xicilion) 
* [[`032ccc2a97`](https://github.com/fibjs/fibjs/commit/032ccc2a97)] - **vm, feat**: implement .ext loader. (xicilion) 
* [[`29717ea64e`](https://github.com/fibjs/fibjs/commit/29717ea64e)] - **os, chore**: simplify os.usereInfo (ngot) 
* [[`4ce4e3ee73`](https://github.com/fibjs/fibjs/commit/4ce4e3ee73)] - **os, fixbug**: fix crash error (ngot) 
* [[`e2b2454fa2`](https://github.com/fibjs/fibjs/commit/e2b2454fa2)] - **os, refactor**: remove useless userInfo code (ngot) 
* [[`d941e05375`](https://github.com/fibjs/fibjs/commit/d941e05375)] - **test, remove**: useless code (ngot) 
* [[`bca9d01961`](https://github.com/fibjs/fibjs/commit/bca9d01961)] - **Buffer, chore**: format (ngot) 
* [[`f8732d14a7`](https://github.com/fibjs/fibjs/commit/f8732d14a7)] - **encoding, feat**: iconv.encode & iconv.dcode support binary encoding (ngot) 
* [[`dc4e7dfca9`](https://github.com/fibjs/fibjs/commit/dc4e7dfca9)] - **encoding, revert**: remove iconv.encode & iconv.dcode support base64 & hex (ngot) 
* [[`1a833967b8`](https://github.com/fibjs/fibjs/commit/1a833967b8)] - **encoding, feat**: iconv.encode & iconv.dcode support base64 & hex (ngot) 
* [[`62e1d88cf2`](https://github.com/fibjs/fibjs/commit/62e1d88cf2)] - **os, refactor**: simplify & better performance (ngot) 
* [[`f9a8f140dc`](https://github.com/fibjs/fibjs/commit/f9a8f140dc)] - **encoding, feat**: add iconv::decode(String) & hex.encode(String) & base64.encode(String) (ngot) 
* [[`00ef954745`](https://github.com/fibjs/fibjs/commit/00ef954745)] - **os,fixbug**: fix build error (ngot) 
* [[`303f42d958`](https://github.com/fibjs/fibjs/commit/303f42d958)] - **os, feat**: implement os.userInfo() encoding options (ngot) 
* [[`d394a179d5`](https://github.com/fibjs/fibjs/commit/d394a179d5)] - **os, feat**: impement os.userInfo on windows (ngot) 
* [[`016b535735`](https://github.com/fibjs/fibjs/commit/016b535735)] - **os, feat**: add os.userInfo() (ngot) 
* [[`61fc723cfd`](https://github.com/fibjs/fibjs/commit/61fc723cfd)] - **core, chore**: remove fibjs namespace. (xicilion) 
* [[`dd0f99f062`](https://github.com/fibjs/fibjs/commit/dd0f99f062)] - **vm, refactor**: rewrite sanbox.run. (xicilion) 
* [[`ec616ea050`](https://github.com/fibjs/fibjs/commit/ec616ea050)] - **vm, refactor**: rewrite addScript. (xicilion) 
* [[`c07fd32936`](https://github.com/fibjs/fibjs/commit/c07fd32936)] - **util, feat**: util.compile support bash style comment. (xicilion) 
* [[`71f5916562`](https://github.com/fibjs/fibjs/commit/71f5916562)] - **global, break**: move global.sync to util.sync. (xicilion) 
* [[`6bd3ff3f7e`](https://github.com/fibjs/fibjs/commit/6bd3ff3f7e)] - **path, feat**: support path.isAbsolute. (xicilion) 
* [[`7c5084af38`](https://github.com/fibjs/fibjs/commit/7c5084af38)] - **path, refactor**: use Runtime::setError to report error. (xicilion) 
* [[`2f1b2a4aef`](https://github.com/fibjs/fibjs/commit/2f1b2a4aef)] - **test, fixbug**: update arm/arm64 jsc test file. (xicilion) 
* [[`5532d31ec4`](https://github.com/fibjs/fibjs/commit/5532d31ec4)] - **internal, upgrade**: upgrade v8 to 6.1.24 (xicilion) 
* [[`73088ef4ec`](https://github.com/fibjs/fibjs/commit/73088ef4ec)] - **core, chore**: remove docs folder. (xicilion) 
* [[`cb7800f342`](https://github.com/fibjs/fibjs/commit/cb7800f342)] - **core, chore**: remove submodule docs. (xicilion) 
* [[`6ac737f3e9`](https://github.com/fibjs/fibjs/commit/6ac737f3e9)] - **path, refactor**: rewrite path/path.posix/path.win32. (xicilion) 
* [[`05d344448f`](https://github.com/fibjs/fibjs/commit/05d344448f)] - **path, fixbug**: fix os_win GetVersion2 compile error. (xicilion) 
* [[`049ebb6ff7`](https://github.com/fibjs/fibjs/commit/049ebb6ff7)] - **core, feat**: support module renaming. (xicilion) 
* [[`8dd5d5d46c`](https://github.com/fibjs/fibjs/commit/8dd5d5d46c)] - **os, break**: replace os.version with os.release() (ngot) 
* [[`b4220d94f5`](https://github.com/fibjs/fibjs/commit/b4220d94f5)] - **os, chore**: update comment (ngot) 
* [[`0381452de3`](https://github.com/fibjs/fibjs/commit/0381452de3)] - **os, fixbug**: fix error check (ngot) 
* [[`8b08c7e608`](https://github.com/fibjs/fibjs/commit/8b08c7e608)] - **os, fixbug**: throw detail error & mem leak (ngot) 
* [[`67b594cff9`](https://github.com/fibjs/fibjs/commit/67b594cff9)] - **test, fixbug**: fix vm test on windows (ngot) 
* [[`d2e908c89e`](https://github.com/fibjs/fibjs/commit/d2e908c89e)] - **test, feat**: add os.homedir() test case (ngot) 
* [[`955f6e9ab2`](https://github.com/fibjs/fibjs/commit/955f6e9ab2)] - **os, feat**: implememt os.homedir() on windows (ngot) 
* [[`9196a756f5`](https://github.com/fibjs/fibjs/commit/9196a756f5)] - **os, feat**: add os.homedir() (ngot) 
* [[`d80e88a0c1`](https://github.com/fibjs/fibjs/commit/d80e88a0c1)] - **test, feat**: add os.release test case (ngot) 
* [[`c40e82df7a`](https://github.com/fibjs/fibjs/commit/c40e82df7a)] - **os, feat**: add os.release() (ngot) 
* [[`623bb542a8`](https://github.com/fibjs/fibjs/commit/623bb542a8)] - **os, feat**: add os.endianness() (ngot) 
* [[`378d0a0fae`](https://github.com/fibjs/fibjs/commit/378d0a0fae)] - **os, break**: change os.type to os.type() (ngot) 
* [[`bf34081629`](https://github.com/fibjs/fibjs/commit/bf34081629)] - **os, break**: change os.hostname to os.hostname() (ngot) 
* [[`e2b8983df8`](https://github.com/fibjs/fibjs/commit/e2b8983df8)] - **os, break**: rename os.CPUInfo() to os.cpus() & rename os.CPUs() to os.cpuNumbers() (ngot) 
* [[`74154a42fb`](https://github.com/fibjs/fibjs/commit/74154a42fb)] - **os, break**: change os.arch to os.arch() (ngot) 
* [[`f618afa24f`](https://github.com/fibjs/fibjs/commit/f618afa24f)] - **os, break**: rename os.networkInfo() to os.networkInterfaces (ngot) 
* [[`06fe572b72`](https://github.com/fibjs/fibjs/commit/06fe572b72)] - **test, chore**: fix test on windows (ngot) 
* [[`1fafaad796`](https://github.com/fibjs/fibjs/commit/1fafaad796)] - **test, chore**: ignore single test runner (ngot) 
* [[`2145bfdbc0`](https://github.com/fibjs/fibjs/commit/2145bfdbc0)] - **test, feat**: add path.win32 & path.posix test case (ngot) 
* [[`03820c7680`](https://github.com/fibjs/fibjs/commit/03820c7680)] - **path, feat**: enable path.win32 & path.posix both works on win32 & posix (ngot) 
* [[`d97c82eb41`](https://github.com/fibjs/fibjs/commit/d97c82eb41)] - **path, fixbug**: fix posix path sep (ngot) 
* [[`c3e3de463e`](https://github.com/fibjs/fibjs/commit/c3e3de463e)] - **core, fixbug**: fix build error (ngot) 
* [[`35e715ab48`](https://github.com/fibjs/fibjs/commit/35e715ab48)] - **core, chore**: update vcxproj (ngot) 
* [[`3b8ba008df`](https://github.com/fibjs/fibjs/commit/3b8ba008df)] - **path, refactor**: simplify path implementation (ngot) 
* [[`78afbfb026`](https://github.com/fibjs/fibjs/commit/78afbfb026)] - **path, feat**: more compatibility to Node.js path module (ngot) 
* [[`524a241146`](https://github.com/fibjs/fibjs/commit/524a241146)] - **events, chore**: remove unuseful code. (xicilion) 
* [[`b7033a6f9d`](https://github.com/fibjs/fibjs/commit/b7033a6f9d)] - **events, feat**: more compatibility to Node.js events module (xicilion) 
* [[`7c82f03f23`](https://github.com/fibjs/fibjs/commit/7c82f03f23)] - **core, break**: reorder module wrap arguments. (xicilion) 
* [[`9b5e96e3a8`](https://github.com/fibjs/fibjs/commit/9b5e96e3a8)] - **test, fixbug**: enable ignored test case. (xicilion) 
* [[`278d44c7ee`](https://github.com/fibjs/fibjs/commit/278d44c7ee)] - **test, chore**: remove single tester (ngot) 
* [[`f238e16207`](https://github.com/fibjs/fibjs/commit/f238e16207)] - **timers, feat**: add timers module (ngot) 
* [[`c5cd73a116`](https://github.com/fibjs/fibjs/commit/c5cd73a116)] - **gui, break**: disable drag file to gui webbrowser. (xicilion) 
* [[`aabebe6f6b`](https://github.com/fibjs/fibjs/commit/aabebe6f6b)] - **gui, fixbug**: windows gui input control ctrl-v delete error. (xicilion) 
* [[`58c368087f`](https://github.com/fibjs/fibjs/commit/58c368087f)] - **test, chore**: support relative path. (xicilion) 
* [[`46e30cad9a`](https://github.com/fibjs/fibjs/commit/46e30cad9a)] - **doc, chore**: update download link (ngot) 
* [[`37ffd771c1`](https://github.com/fibjs/fibjs/commit/37ffd771c1)] - **module, fixbug**: change path .zip?/file to .zip$/file, fix windows gui url error. (xicilion) 
* [[`5adb9780cf`](https://github.com/fibjs/fibjs/commit/5adb9780cf)] - **ci, fixbug**: ci test (#220) (ngot) 
* [[`2044869df2`](https://github.com/fibjs/fibjs/commit/2044869df2)] - **doc, chore**: update downloads url (ngot) 
* [[`087194a32b`](https://github.com/fibjs/fibjs/commit/087194a32b)] - **fs, feat**: cache *.zip?/ file data. (xicilion) 

## 2017-05-20, Version v0.3.1 @ngot

* **bugfix** :
  * util.compile function export error.
  * fix Timer.clear release error.
* **feature** :
  * HttpClient: enable parallel query
* **internal** :
  * upgrade V8 to 6.0.252

### Commits

* [[`02426d5371`](https://github.com/fibjs/fibjs/commit/02426d5371)] - **ci, feat**: add ssh deploy (#218) (ngot)
* [[`59d743dacc`](https://github.com/fibjs/fibjs/commit/59d743dacc)] - **util, bugfix**: util.compile function export error. (xicilion)
* [[`51af1f60d7`](https://github.com/fibjs/fibjs/commit/51af1f60d7)] - **ci, fix**: osx lost xz deps (ngot)
* [[`0c055cd114`](https://github.com/fibjs/fibjs/commit/0c055cd114)] - **ci, fix**: osx build (ngot)
* [[`82b0aad977`](https://github.com/fibjs/fibjs/commit/82b0aad977)] - **ci, refacor**: rename gui (ngot)
* [[`64b5d53a81`](https://github.com/fibjs/fibjs/commit/64b5d53a81)] - **ci, fix**: add env param (ngot)
* [[`0edf3dcdb9`](https://github.com/fibjs/fibjs/commit/0edf3dcdb9)] - **ci, refactor**: only ci env run the xz compress (ngot)
* [[`4529e4ba0d`](https://github.com/fibjs/fibjs/commit/4529e4ba0d)] - **ci, chore**:output build step message. (xicilion)
* [[`a4e84fd00f`](https://github.com/fibjs/fibjs/commit/a4e84fd00f)] - **http, test**:HttpClient parallel query test. (xicilion)
* [[`53946382d9`](https://github.com/fibjs/fibjs/commit/53946382d9)] - **http, feat**: enable parallel query (xicilion)
* [[`7285222e6e`](https://github.com/fibjs/fibjs/commit/7285222e6e)] - **ci, feat**: enable overwrite when build failed (ngot)
* [[`ff0db46997`](https://github.com/fibjs/fibjs/commit/ff0db46997)] - **ci, fix**: windows x86 cab release (ngot)
* [[`f339104932`](https://github.com/fibjs/fibjs/commit/f339104932)] - **ci, feat**: windows cab files (ngot)
* [[`9bcc013036`](https://github.com/fibjs/fibjs/commit/9bcc013036)] - **ci, feat**: release compress files (ngot)
* [[`3a05b3199b`](https://github.com/fibjs/fibjs/commit/3a05b3199b)] - **deps, feat**: upgrade to v8::Global interface. (xicilion)
* [[`d29ca964f3`](https://github.com/fibjs/fibjs/commit/d29ca964f3)] - **internal, deps**: upgrade v8 to 6.0.252 (xicilion)
* [[`2c6b793304`](https://github.com/fibjs/fibjs/commit/2c6b793304)] - **test, bugfix**: Wait for the timer to release (xicilion)
* [[`0903f95dff`](https://github.com/fibjs/fibjs/commit/0903f95dff)] - **test, refactor**: rewrite GC test case. (xicilion)
* [[`82f0041590`](https://github.com/fibjs/fibjs/commit/82f0041590)] - **timer, bugfix**: fix Timer.clear release error. (xicilion)
* [[`29a8389ca6`](https://github.com/fibjs/fibjs/commit/29a8389ca6)] - **internal, deps**: upgrade v8 (xicilion)
* [[`6168c1ecf2`](https://github.com/fibjs/fibjs/commit/6168c1ecf2)] - **doc, feat**: add gitter badge (ngot)
* [[`3046566b2b`](https://github.com/fibjs/fibjs/commit/3046566b2b)] - **chore, badge**: change build image (#208) (ngot)

## 2017-05-13, Version v0.3.0 @ngot

Good news, we will land the ES6 Module support in the 1.0.0. Before that, we still have a lot of work to do.
### Notable Changes

v0.3.0 is a pre-release update version of fibjs. There are many exciting features in this release such as multi-thread Worker Mode, built-in WebSocket, arm & mip arch support, better compatibility to npm. We recommend you to try these new features. 

* **module**:
  * support `node_modules` directory.
  * remove `.module` directory support.
  * remove `__sbname` support.
  * add `util.compile` method. JavaScript code can be built into ByteCode with `.jsc` extension and it can be required like `require('mod.jsc')`. This is very useful to ship production and protect you code.
  * support virtual zip path. You can pacck you code into a zip file and just require it like this: `require('./test.zip?/b.js'))`
  * syntax check after load error to speed the require.
  * SandBox.require adding base argv, set the start query dir
  * package.json support directory.
  * sandbox add --approot to set the run path.
  * remove the sandbox name from the source path
* **mq**:
  * remove mq.jsHandler
* **rpc**:
  * remove rpc module. Please use coroutine.Worker instead.
* **events**:
  * remove Trigger Object, use events.EventEmitter instead.
* **http**:
  * remove Message.result property
  * add HttpMessage.socket
  * add httpClient
* **coroutine**:
  * add multi-thread Worker support.
* **process**:
  * process extends EventEmitter.
  * add process.nextTick
* **ws**:
  * add WebSocket module.
* **querystring**:
  * add querystring module.
* **zmq**:
  * add zmq module.
* **gui**:
  * add gui module on windows in purpose to support webview.
* **db**:
  * add MSSQL support
### Commits

* [[`233254d`](https://github.com/fibjs/fibjs/commit/233254d)] - **ws, fix**: fix the close error. (xicilion)
* [[`66e4367`](https://github.com/fibjs/fibjs/commit/66e4367)] - **http, feat**: add HttpMessage.socket (xicilion)
* [[`15a430e`](https://github.com/fibjs/fibjs/commit/15a430e)] - **module, remove**: remove .module support (xicilion)
* [[`1ca59b2`](https://github.com/fibjs/fibjs/commit/1ca59b2)] - **module, remove**: remove  Sandbox.compile, moved to util.compile (xicilion)
* [[`f1b89d3`](https://github.com/fibjs/fibjs/commit/f1b89d3)] - **http, refactor**: reuse request.cookies (xicilion)
* [[`3624e39`](https://github.com/fibjs/fibjs/commit/3624e39)] - **mq, remove**: remove mq.jsHandler (xicilion)
* [[`b7d5efd`](https://github.com/fibjs/fibjs/commit/b7d5efd)] - **rpc, remove**: remove rpc module, use coroutine.Worker instead. (xicilion)
* [[`059e771`](https://github.com/fibjs/fibjs/commit/059e771)] - **http, refactor**: reuse request, avoid too many objects created (xicilion)
* [[`298530f`](https://github.com/fibjs/fibjs/commit/298530f)] - **coroutine, feat**: implement native object passing (xicilion)
* [[`4436f62`](https://github.com/fibjs/fibjs/commit/4436f62)] - **coroutine, feat**: implement Worker message passing (xicilion)
* [[`ddc13b8`](https://github.com/fibjs/fibjs/commit/ddc13b8)] - **coroutine, feat**: implement Worker basic message passing, onopen event. (xicilion)
* [[`326a677`](https://github.com/fibjs/fibjs/commit/326a677)] - **os, feat**: add mac address & mask (ngot)
* [[`0796c51`](https://github.com/fibjs/fibjs/commit/0796c51)] - **mq, remove**: remove mq.await, please use sync instead. (xicilion)
* [[`a1219dc`](https://github.com/fibjs/fibjs/commit/a1219dc)] - **module, refactor**: sandbox.run support different mod, add compile argv, compile different target. (xicilion)
* [[`642ddcb`](https://github.com/fibjs/fibjs/commit/642ddcb)] - **zip, fix**: ZipFile  add entry check (xicilion)
* [[`3773f1a`](https://github.com/fibjs/fibjs/commit/3773f1a)] - **coroutine, feat**: add Worker (xicilion)
* [[`7e9db7d`](https://github.com/fibjs/fibjs/commit/7e9db7d)] - **net, fix**: fix remotePort ntohs remotePort (#200) (Hengfei)
* [[`61bd021`](https://github.com/fibjs/fibjs/commit/61bd021)] - **global, fix**: fix repl error (xicilion)
* [[`c5a4786`](https://github.com/fibjs/fibjs/commit/c5a4786)] - **internal, deps**: upgrade SQLlite (xicilion)
* [[`108a180`](https://github.com/fibjs/fibjs/commit/108a180)] - **internal, deps**: upgrade libgd (xicilion)
* [[`d18f338`](https://github.com/fibjs/fibjs/commit/d18f338)] - **core, remove**: remove ppc arch support. (xicilion)
* [[`a0f78f2`](https://github.com/fibjs/fibjs/commit/a0f78f2)] - **util, feat**: LruCache support modifies timeout when invoked. (xicilion)
* [[`0be9fc3`](https://github.com/fibjs/fibjs/commit/0be9fc3)] - **db, fix**: redis pubsub avoid reentry. (xicilion)
* [[`3911558`](https://github.com/fibjs/fibjs/commit/3911558)] - **ws, refactor**: dalay web socket at background read, avoid miss event. (xicilion)
* [[`9437cfc`](https://github.com/fibjs/fibjs/commit/9437cfc)] - **fs, fix**: fix file.stat on windows (ngot)
* [[`3480a0c`](https://github.com/fibjs/fibjs/commit/3480a0c)] - **ssl, feat**: add SslSocket.stream, to query the socket (xicilion)
* [[`cbd4480`](https://github.com/fibjs/fibjs/commit/cbd4480)] - **collection, feat**: add List.lastIndexOf (onc3young)
* [[`17393ee`](https://github.com/fibjs/fibjs/commit/17393ee)] - **http, remove**: remove Message.result (xicilion)
* [[`f72bcb7`](https://github.com/fibjs/fibjs/commit/f72bcb7)] - **rpc, remove**: remove rpc.json (xicilion)
* [[`da0d86f`](https://github.com/fibjs/fibjs/commit/da0d86f)] - **ws, fix**: fix error throw when no error handler. (xicilion)
* [[`214ed13`](https://github.com/fibjs/fibjs/commit/214ed13)] - **collection, feat**: collection.List add indexOf. (zmq)
* [[`000b41f`](https://github.com/fibjs/fibjs/commit/000b41f)] - **gui, refactor**: change WebView event args (xicilion)
* [[`b9d0cce`](https://github.com/fibjs/fibjs/commit/b9d0cce)] - **ws, refactor**: rename WebSocketEvent to EventInfo (xicilion)
* [[`9eaaf7d`](https://github.com/fibjs/fibjs/commit/9eaaf7d)] - **http, feat**: Message add type and data property (xicilion)
* [[`2baf90e`](https://github.com/fibjs/fibjs/commit/2baf90e)] - **util, fix**: fix LruCache logic (xicilion)
* [[`a5582a5`](https://github.com/fibjs/fibjs/commit/a5582a5)] - **mq, refactor**: jsHandler remove method map support, only support [] and {}. (xicilion)
* [[`1df7977`](https://github.com/fibjs/fibjs/commit/1df7977)] - **mq, feat**: add mq.await  (xicilion)
* [[`c796fe9`](https://github.com/fibjs/fibjs/commit/c796fe9)] - **gui, feat**: add edge CONST (ngot)
* [[`b9ceb7f`](https://github.com/fibjs/fibjs/commit/b9ceb7f)] - **util, refactor**: LRUCache updater return undefined not cache. (xicilion)
* [[`7bf0a8b`](https://github.com/fibjs/fibjs/commit/7bf0a8b)] - **net, fix**: fix localPort double ntohs port (ngot)
* [[`30dd890`](https://github.com/fibjs/fibjs/commit/30dd890)] - **registry, fix**: fix a logic error. (xicilion)
* [[`2301a94`](https://github.com/fibjs/fibjs/commit/2301a94)] - **gui, feat**: add gui.setVersion to chose the webview version. (xicilion)
* [[`325b498`](https://github.com/fibjs/fibjs/commit/325b498)] - **collection. feat**: add Map.set (xicilion)
* [[`26a8c1b`](https://github.com/fibjs/fibjs/commit/26a8c1b)] - **crypto, feat**: modify pbkdf2 , compat nodejs (xicilion)
* [[`b61b9d9`](https://github.com/fibjs/fibjs/commit/b61b9d9)] - **http, feat**: Add Message.end to terminate chain transaction. (xicilion)
* [[`232657c`](https://github.com/fibjs/fibjs/commit/232657c)] - **http, refactor**: reuse Message.response, refactor httpHandler creates new instance by every request. (xicilion)
* [[`bac5eb3`](https://github.com/fibjs/fibjs/commit/bac5eb3)] - **module, refactor**: syntax check after load error to speed the require. (xicilion)
* [[`47ee1ae`](https://github.com/fibjs/fibjs/commit/47ee1ae)] - **process, feat**: process extends EventEmitter (xicilion)
* [[`538f16f`](https://github.com/fibjs/fibjs/commit/538f16f)] - **ws, feat**: complete error handles logic. (xicilion)
* [[`f5505cf`](https://github.com/fibjs/fibjs/commit/f5505cf)] - **db, fix**: fix a SQLite backup error. (xicilion)
* [[`a7fb229`](https://github.com/fibjs/fibjs/commit/a7fb229)] - **ws, feat**: add WebSocketEvent for Object Event. (xicilion)
* [[`8083561`](https://github.com/fibjs/fibjs/commit/8083561)] - **registry, feat**: add registry module to operate the Windows registry. (xicilion)
* [[`2735db2`](https://github.com/fibjs/fibjs/commit/2735db2)] - **path, fix**: fix path.basename error. (xicilion)
* [[`6fad8ac`](https://github.com/fibjs/fibjs/commit/6fad8ac)] - **ws, feat**: complete close logic. (xicilion)
* [[`4113654`](https://github.com/fibjs/fibjs/commit/4113654)] - **ws, feat**: add close & response protocol (xicilion)
* [[`77ae331`](https://github.com/fibjs/fibjs/commit/77ae331)] - **ws, refactor**: WebSocket.close default code to 1000 (xicilion)
* [[`1568ee0`](https://github.com/fibjs/fibjs/commit/1568ee0)] - **io, refactor**: bridge use async post start worker flow. (xicilion)
* [[`267defa`](https://github.com/fibjs/fibjs/commit/267defa)] - **ws, feat**: add ws.upgrade, implement the Event-Driver ws server. (xicilion)
* [[`ce3bcbb`](https://github.com/fibjs/fibjs/commit/ce3bcbb)] - **querystring, feat**: add querystring module. (xicilion)
* [[`b5acc55`](https://github.com/fibjs/fibjs/commit/b5acc55)] - **gui, feat**: Webview add setHtml & print. (xicilion)
* [[`9155774`](https://github.com/fibjs/fibjs/commit/9155774)] - **gui, refactor**: Webview set the init window size. (xicilion)
* [[`344a76b`](https://github.com/fibjs/fibjs/commit/344a76b)] - **gui, feat**: Webview adds visible property to control the window hide or show. (xicilion)
* [[`f560347`](https://github.com/fibjs/fibjs/commit/f560347)] - **gui, feat**: Webview add the onload event (xicilion)
* [[`11e7f01`](https://github.com/fibjs/fibjs/commit/11e7f01)] - **ws, feat**: complete send/onmessage & more test case (xicilion)
* [[`5f01c29`](https://github.com/fibjs/fibjs/commit/5f01c29)] - **ws, feat**: implement WebSocket (xicilion)
* [[`05c865e`](https://github.com/fibjs/fibjs/commit/05c865e)] - **events, feat**: implement events.EventEmitter.call (xicilion)
* [[`e56a75c`](https://github.com/fibjs/fibjs/commit/e56a75c)] - **fs, fix**: fix fs.stat mod logic error. (xicilion)
* [[`8206d37`](https://github.com/fibjs/fibjs/commit/8206d37)] - **fs, fix**: fix the error Linux fs.open never throw the error. (xicilion)
* [[`4d96ebd`](https://github.com/fibjs/fibjs/commit/4d96ebd)] - **ws, refactor**: rename websocket to ws (xicilion)
* [[`e631090`](https://github.com/fibjs/fibjs/commit/e631090)] - **db, refactor**: redis change onxxxx to property. (xicilion)
* [[`b76d1a9`](https://github.com/fibjs/fibjs/commit/b76d1a9)] - **events, remove**: remove Trigger Object, use EventEmitter instead. (xicilion)
* [[`9b76ee6`](https://github.com/fibjs/fibjs/commit/9b76ee6)] - **module, remove**: remove __sbname support (xicilion)
* [[`5b8f29a`](https://github.com/fibjs/fibjs/commit/5b8f29a)] - **util, feat**: info add zmq version (xicilion)
* [[`995e54a`](https://github.com/fibjs/fibjs/commit/995e54a)] - **zmq, feat**: add zmq module (xicilion)
* [[`40cdcdd`](https://github.com/fibjs/fibjs/commit/40cdcdd)] - **collection, feat**: add List.reduce (xicilion)
* [[`815e2d9`](https://github.com/fibjs/fibjs/commit/815e2d9)] - **uuid, feat**: add uuid.snowflake get the unique global id. (xicilion)
* [[`b892c3d`](https://github.com/fibjs/fibjs/commit/b892c3d)] - **os, feat**: support os.tmpdir. (xicilion)
* [[`24f4fdb`](https://github.com/fibjs/fibjs/commit/24f4fdb)] - **assert, feat**: assert support invoked a s a function. (xicilion)
* [[`5b2eb19`](https://github.com/fibjs/fibjs/commit/5b2eb19)] - **path, feat**: add path.resolve. (ngot)
* [[`da1656c`](https://github.com/fibjs/fibjs/commit/da1656c)] - **process, feat**: add process.umask() (ngot)
* [[`d1a8bcd`](https://github.com/fibjs/fibjs/commit/d1a8bcd)] - **coroutine, feat**: lock adds count to query task info. (xicilion)
* [[`ff3c494`](https://github.com/fibjs/fibjs/commit/ff3c494)] - **process, feat**: add process.uptime (ngot)
* [[`8134e68`](https://github.com/fibjs/fibjs/commit/8134e68)] - **db, fix**: mongodb change mongodb m_conn struct, avoid out of bounds errors. (xicilion)
* [[`1584c81`](https://github.com/fibjs/fibjs/commit/1584c81)] - **core, refactor**: exit wait all the async invoke & timer. (xicilion)
* [[`b3023ca`](https://github.com/fibjs/fibjs/commit/b3023ca)] - **coroutine, refactor**: coroutine.sleep use async way. (xicilion)
* [[`7c9e1b7`](https://github.com/fibjs/fibjs/commit/7c9e1b7)] - **core, refactor**: exit before all the fibers exit. (xicilion)
* [[`88e43a5`](https://github.com/fibjs/fibjs/commit/88e43a5)] - **module, fix**: fix .js dir can't be loaded error. (xicilion)
* [[`0e86ed9`](https://github.com/fibjs/fibjs/commit/0e86ed9)] - **console, refactor**: change console flush policy. (xicilion)
* [[`8b76da5`](https://github.com/fibjs/fibjs/commit/8b76da5)] - **fs, refactor**: POSIX init umask to 0 (xicilion)
* [[`93bf249`](https://github.com/fibjs/fibjs/commit/93bf249)] - **fs, feat**: more Sync API. (xicilion)
* [[`0b094f0`](https://github.com/fibjs/fibjs/commit/0b094f0)] - **fs, refactor**: change windows readdir. (xicilion)
* [[`013ac91`](https://github.com/fibjs/fibjs/commit/013ac91)] - **fs, refactor**: change the fs.readdir result, add readdirSync. (xicilion)
* [[`edcc5ca`](https://github.com/fibjs/fibjs/commit/edcc5ca)] - **collection, feat**: List support sort (xicilion)
* [[`d332d58`](https://github.com/fibjs/fibjs/commit/d332d58)] - **collection, feat**: List support callback args (xicilion)
* [[`95663b8`](https://github.com/fibjs/fibjs/commit/95663b8)] - **url, refactor**: Url property can be modified. (xicilion)
* [[`722fff1`](https://github.com/fibjs/fibjs/commit/722fff1)] - **db, refactor**: SQLite use the Object async lock instead of it's custom lock. (xicilion)
* [[`5f951c1`](https://github.com/fibjs/fibjs/commit/5f951c1)] - **core, feat**: callback supports async lock. (xicilion)
* [[`a48fada`](https://github.com/fibjs/fibjs/commit/a48fada)] - **global, refactor**: sync throw error to outside. (xicilion)
* [[`66b0e0b`](https://github.com/fibjs/fibjs/commit/66b0e0b)] - **db, fix**: SQLite execute add lock avoid a crash. (xicilion)
* [[`72a058f`](https://github.com/fibjs/fibjs/commit/72a058f)] - **db, refactor**: DBResult fields, insertId, affected return the default value without throw error. (xicilion)
* [[`d55ae30`](https://github.com/fibjs/fibjs/commit/d55ae30)] - **module, feat**: SandBox.require adding base argv, set the start query dir. (xicilion)
* [[`7f72bea`](https://github.com/fibjs/fibjs/commit/7f72bea)] - **process, feat**: add process.nextTick (xicilion)
* [[`8909cdc`](https://github.com/fibjs/fibjs/commit/8909cdc)] - **global, fix**: fix sync when err is null the mistake throw. (xicilion)
* [[`6999331`](https://github.com/fibjs/fibjs/commit/6999331)] - **url, feat**: url.parse add parseQueryString,  (xicilion)
* [[`a443e76`](https://github.com/fibjs/fibjs/commit/a443e76)] - **db, feat**: SQLite add DBConnection type to detect the current connection. (xicilion)
* [[`4d2a6f1`](https://github.com/fibjs/fibjs/commit/4d2a6f1)] - **process, feat**: add process.version (ngot)
* [[`423c1ea`](https://github.com/fibjs/fibjs/commit/423c1ea)] - **net, refactor**: restore the net.UrlObject to net.Url (xicilion)
* [[`99706bd`](https://github.com/fibjs/fibjs/commit/99706bd)] - **events, feat**: add EventEmitter (xicilion)
* [[`508347b`](https://github.com/fibjs/fibjs/commit/508347b)] - **buffer, feat**: add buffer module. (xicilion)
* [[`d545164`](https://github.com/fibjs/fibjs/commit/d545164)] - **util, feat**: add util.inherits (xicilion)
* [[`d2d5cea`](https://github.com/fibjs/fibjs/commit/d2d5cea)] - **net, refactor**: change socket.bind background thread. (xicilion)
* [[`32d0d28`](https://github.com/fibjs/fibjs/commit/32d0d28)] - **process, feat**: add process global & some method. (xicilion)
* [[`f1ebb86`](https://github.com/fibjs/fibjs/commit/f1ebb86)] - **util, fix**: fix format error. (xicilion)
* [[`de5e5b3`](https://github.com/fibjs/fibjs/commit/de5e5b3)] - **module, feat**: package.json support directory. (xicilion)
* [[`0a20b2d`](https://github.com/fibjs/fibjs/commit/0a20b2d)] - **console, fix**: fix osx ESC. (xicilion)
* [[`b72efaa`](https://github.com/fibjs/fibjs/commit/b72efaa)] - **http, feat**: httpClient add more method. (xicilion)
* [[`cb25286`](https://github.com/fibjs/fibjs/commit/cb25286)] - **core, fix**: release callback function, avoid memory leak. (xicilion)
* [[`750cdf0`](https://github.com/fibjs/fibjs/commit/750cdf0)] - **io, feat**: add io.bridge for stream forward both direction. (xicilion)
* [[`059bab9`](https://github.com/fibjs/fibjs/commit/059bab9)] - **io, feat**: add io.copyStream (xicilion)
* [[`b4e95fe`](https://github.com/fibjs/fibjs/commit/b4e95fe)] - **http, feat**: httpClient add default userAgent. (xicilion)
* [[`7d61d13`](https://github.com/fibjs/fibjs/commit/7d61d13)] - **url: Add**:url module. (xicilion)
* [[`50a5d35`](https://github.com/fibjs/fibjs/commit/50a5d35)] - **net, refactor**: rename net.Url to net.UrlObject (xicilion)
* [[`18591b7`](https://github.com/fibjs/fibjs/commit/18591b7)] - **net, feat**: Socket support UDP. (xicilion)
* [[`7122959`](https://github.com/fibjs/fibjs/commit/7122959)] - **global, feat**: add global, compat Node.js (xicilion)
* [[`7fe69e6`](https://github.com/fibjs/fibjs/commit/7fe69e6)] - **db, feat**: SQLite add SQLITE_BUSY support. (xicilion)
* [[`cbde0fb`](https://github.com/fibjs/fibjs/commit/cbde0fb)] - **db, fix**: sqlite prepare retry, avoid error. (xicilion)
* [[`6f3e634`](https://github.com/fibjs/fibjs/commit/6f3e634)] - **coroutine, feat**: parallel add a new mode. (xicilion)
* [[`30b8a87`](https://github.com/fibjs/fibjs/commit/30b8a87)] - **mq, refactor**: adjust Routing match sequeue, add put method. (xicilion)
* [[`5e22575`](https://github.com/fibjs/fibjs/commit/5e22575)] - **http, fix**: fix httphandler zip error. (xicilion)
* [[`9fd0ce4`](https://github.com/fibjs/fibjs/commit/9fd0ce4)] - **gui, feat**: webview support DPI. (xicilion)
* [[`1ef9a62`](https://github.com/fibjs/fibjs/commit/1ef9a62)] - **gui, feat**: webview on HD display auto scale. (xicilion)
* [[`05c9357`](https://github.com/fibjs/fibjs/commit/05c9357)] - **module: support**:node_modules (xicilion)
* [[`27d092c`](https://github.com/fibjs/fibjs/commit/27d092c)] - **module, fix**: fix when require folder/index error can't be throw error. (xicilion)
* [[`4b5b358`](https://github.com/fibjs/fibjs/commit/4b5b358)] - **core fix**: fix socket error canceled on Window XP. (xicilion)
* [[`43832a7`](https://github.com/fibjs/fibjs/commit/43832a7)] - **fs, feat**: fs.open cache the zip file, speed require. (xicilion)
* [[`d6c4b71`](https://github.com/fibjs/fibjs/commit/d6c4b71)] - **fs, fix**: fix fs.open zip logic error on windows. (xicilion)
* [[`e1a0fdf`](https://github.com/fibjs/fibjs/commit/e1a0fdf)] - **encodeing, fix**: fix utf16 encoding error. (xicilion)
* [[`c30506c`](https://github.com/fibjs/fibjs/commit/c30506c)] - **gui, feat**: webview handle PARSE_SECURITY_DOMAIN, support xmlhttp make a request. (xicilion)
* [[`cb8df8b`](https://github.com/fibjs/fibjs/commit/cb8df8b)] - **fs, fix**:  fix fs.stat & File.stat error on window xp. (xicilion)
* [[`a941e5f`](https://github.com/fibjs/fibjs/commit/a941e5f)] - **module, feat**: sandbox add --approot to set the run path. (xicilion)
* [[`e192bf0`](https://github.com/fibjs/fibjs/commit/e192bf0)] - **gui, refactor**: webview close the javascript error report. (xicilion)
* [[`9bf89dd`](https://github.com/fibjs/fibjs/commit/9bf89dd)] - **gui, refactor**: webview disable the right click menu. (xicilion)
* [[`85b78fb`](https://github.com/fibjs/fibjs/commit/85b78fb)] - **gui, feat**: add gui.open window option. (xicilion)
* [[`7373d75`](https://github.com/fibjs/fibjs/commit/7373d75)] - **gui, feat**: add gui.open and move , size event. (xicilion)
* [[`530f80d`](https://github.com/fibjs/fibjs/commit/530f80d)] - **gui, feat**: webview add postMessage/onmessage. (xicilion)
* [[`edeb50e`](https://github.com/fibjs/fibjs/commit/edeb50e)] - **gui, feat**: WebView add wait and move load function logic to open. (xicilion)
* [[`71d2b57`](https://github.com/fibjs/fibjs/commit/71d2b57)] - **gui, fix**: fix the relative path error on Window XP. (xicilion)
* [[`21e3dab`](https://github.com/fibjs/fibjs/commit/21e3dab)] - **gui, feat**: support fs path. (xicilion)
* [[`d6f9e30`](https://github.com/fibjs/fibjs/commit/d6f9e30)] - **net, feat**: add info, get the result of os.networkInfo. (xicilion)
* [[`a811253`](https://github.com/fibjs/fibjs/commit/a811253)] - **os, feat**: add printerInfo get the printer info. (xicilion)
* [[`47ed32e`](https://github.com/fibjs/fibjs/commit/47ed32e)] - **gui, feat**: set windows to HD. (xicilion)
* [[`86282fd`](https://github.com/fibjs/fibjs/commit/86282fd)] - **gui, feat**: add webview event Handler. (xicilion)
* [[`13d0451`](https://github.com/fibjs/fibjs/commit/13d0451)] - **gui, fix**: fix webview open page very slow and the printer problem. (xicilion)
* [[`443d8e0`](https://github.com/fibjs/fibjs/commit/443d8e0)] - **gui, refactor**: remove the 3D border. (xicilion)
* [[`b57767b`](https://github.com/fibjs/fibjs/commit/b57767b)] - **db, refactor**: MySQL set command timeout 0. (xicilion)
* [[`9f7b01a`](https://github.com/fibjs/fibjs/commit/9f7b01a)] - **db, refactor**: when SQL query return null, length is 0, not throw an error. (xicilion)
* [[`6c05f87`](https://github.com/fibjs/fibjs/commit/6c05f87)] - **gui, feat**: add gui.open. (xicilion)
* [[`1936d6f`](https://github.com/fibjs/fibjs/commit/1936d6f)] - **db, feat**: MySQL support affected (xicilion)
* [[`4823ac6`](https://github.com/fibjs/fibjs/commit/4823ac6)] - **gui, feat**: webview support close function. (xicilion)
* [[`ed14cb1`](https://github.com/fibjs/fibjs/commit/ed14cb1)] - **module, feat**: require supprt .zip? extension. (xicilion)
* [[`db8e099`](https://github.com/fibjs/fibjs/commit/db8e099)] - **fs, feat**: fs.open support virtual zip path. (xicilion)
* [[`f32d777`](https://github.com/fibjs/fibjs/commit/f32d777)] - **fs, refactor**:  fs.open return SeekableStream type. (xicilion)
* [[`e2b3f4b`](https://github.com/fibjs/fibjs/commit/e2b3f4b)] - **gui, feat**: add gui mode, add windows mode entry. (xicilion)
* [[`11d999e`](https://github.com/fibjs/fibjs/commit/11d999e)] - **gui, feat**: webview logo (xicilion)
* [[`9f6f9bf`](https://github.com/fibjs/fibjs/commit/9f6f9bf)] - **module, remove**: remove the sandbox name from the source path. (xicilion)
* [[`1f09d6f`](https://github.com/fibjs/fibjs/commit/1f09d6f)] - **fs, refactor**: fs.readFile return Buffer Object and add fs.readTextFile for txt read. (xicilion)
* [[`ee14ea1`](https://github.com/fibjs/fibjs/commit/ee14ea1)] - **encoding, fix**: fix sometimes parse error. (xicilion)
* [[`9682aa9`](https://github.com/fibjs/fibjs/commit/9682aa9)] - **console, fix**: fix big string output error on Window XP. (xicilion)
* [[`6dfdc20`](https://github.com/fibjs/fibjs/commit/6dfdc20)] - **db, feat**: MySQL support null & decimal. (xicilion)
* [[`ee4930e`](https://github.com/fibjs/fibjs/commit/ee4930e)] - **db, feat**: add MSSQL support. (xicilion)
* [[`b1c68ef`](https://github.com/fibjs/fibjs/commit/b1c68ef)] - **db, refactor**: SQLite default to wal mode. (xicilion)
* [[`62af5f0`](https://github.com/fibjs/fibjs/commit/62af5f0)] - **os, feat**: Add Service Object on Windows. (xicilion)
* [[`0e24bc9`](https://github.com/fibjs/fibjs/commit/0e24bc9)] - **http, fix**: fix the message starts with '0' cut off when transferred by chunk. (xicilion)
* [[`340fcd9`](https://github.com/fibjs/fibjs/commit/340fcd9)] - **mq, feat**: Routing add all/get/post (xicilion)
* [[`116d751`](https://github.com/fibjs/fibjs/commit/116d751)] - **console, feat**: support simulates the mouse. (xicilion)
* [[`123869f`](https://github.com/fibjs/fibjs/commit/123869f)] - **fs, feat**: add copy function. (xicilion)
* [[`2fa93ab`](https://github.com/fibjs/fibjs/commit/2fa93ab)] - **console, fix**: fix the fn keyboard support. (xicilion)
* [[`a4cf360`](https://github.com/fibjs/fibjs/commit/a4cf360)] - **gui, refactor**: rename hasWindow to findWindow & return the rect on Windows. (xicilion)
* [[`7812ca9`](https://github.com/fibjs/fibjs/commit/7812ca9)] - **gui, fix**: hasWindow ignore the hidden window. (xicilion)
* [[`9ea564f`](https://github.com/fibjs/fibjs/commit/9ea564f)] - **console, feat**: support simulates keyboard input for an automated task. (xicilion)
* [[`19885a3`](https://github.com/fibjs/fibjs/commit/19885a3)] - **SubProcess, feat**: add hasWindow. (xicilion)
* [[`201218f`](https://github.com/fibjs/fibjs/commit/201218f)] - **gui, feat**: add Windows gui convert tool. (xicilion)
* [[`7f4aeea`](https://github.com/fibjs/fibjs/commit/7f4aeea)] - **gui, feat**: add gui module on windows in purpose to support webview. (xicilion)
* [[`80f1463`](https://github.com/fibjs/fibjs/commit/80f1463)] - **SubProcess, refactor**: use TerminateProcess to terminate process on Windows. (xicilion)
* [[`6ef637a`](https://github.com/fibjs/fibjs/commit/6ef637a)] - **SubProcess, refactor**: directly invoke the process on windows without cmd. (xicilion)
* [[`328d121`](https://github.com/fibjs/fibjs/commit/328d121)] - **smtp, feat**: add timeout & ssl connection support. (xicilion)
* [[`9e894ee`](https://github.com/fibjs/fibjs/commit/9e894ee)] - **ssl, feat**: ssl.connect support timeout (xicilion)
* [[`30c905e`](https://github.com/fibjs/fibjs/commit/30c905e)] - **module, feat**: Sandbox support compile method and require/addScript/run support jsc. (xicilion)
* [[`bd52b4f`](https://github.com/fibjs/fibjs/commit/bd52b4f)] - **fs, feat**: fs.writeFile support binary data. (xicilion)
* [[`137a9e0`](https://github.com/fibjs/fibjs/commit/137a9e0)] - **core, fix**: fix nonascii char on windows. (xicilion)
* [[`b07c2bc`](https://github.com/fibjs/fibjs/commit/b07c2bc)] - **console, feat**: add event log output on windows. (xicilion)
* [[`d470614`](https://github.com/fibjs/fibjs/commit/d470614)] - **console, feat**: add moveTo, hideCursor, showCursor, clear (xicilion)
* [[`0596f18`](https://github.com/fibjs/fibjs/commit/0596f18)] - **console, fix**: fix console.timeEnd interger overflow error (asionius)
* [[`09ed0fc`](https://github.com/fibjs/fibjs/commit/09ed0fc)] - **SubProcess, fix**: fix the timer create an error of SubProcess on windows. (asionius)
* [[`c0f17ec`](https://github.com/fibjs/fibjs/commit/c0f17ec)] - **console, feat**: add width, height for query or set the console size. (xicilion)
* [[`94cecb3`](https://github.com/fibjs/fibjs/commit/94cecb3)] - **http, feat**: add httpClient (asionius)
* [[`f259bcc`](https://github.com/fibjs/fibjs/commit/f259bcc)] - **core, feat**: support mips arch (xicilion)
* [[`f94b0ee`](https://github.com/fibjs/fibjs/commit/f94b0ee)] - **Socket, feat**: socket add timeout (xicilion)
* [[`ef9577d`](https://github.com/fibjs/fibjs/commit/ef9577d)] - **internal, deps**: upgrade gd (xicilion)
